#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, m;
vector <int> num, tree;
set <int> all;

void upd(int v, int tl, int tr, int pos, int x) {
    if (tl + 1 == tr) {
        tree[v] = x;
        num[tl] = x;
        return;
    }
    else {
        int tm = (tl + tr) / 2;
        if (pos < tm) upd(v * 2, tl,tm, pos, x);
        else upd(v * 2 + 1, tm, tr, pos, x);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
}

int get(int v, int tl, int tr,int l, int r) {
    if (l >= tr || tl >= r) return 1e9;
    else if (l <= tl && r >= tr) return tree[v];
    else {
        int tm = (tl + tr) / 2;
        return min(get(v * 2, tl, tm, l, r), get(v * 2 + 1, tm, tr, l, r));
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> n >> m >> q;
    num.resize(n);
    tree.resize(4 * n);
    for (int i = 0; i < n; i++) num[i] = 1e9;
    for (int i = 0; i < 4 * n; i++) tree[i] = 1e9;
    for (int i = 0; i < n; i++) all.insert(i);
    int sh = -1;
    while (q--) {
        sh++;
        int req;
        cin >> req;
        if (req == 1) {
            int x;
            cin >> x;
            x--;
            upd(1, 0, n, x, sh);
            if (all.find(x) != all.end()) all.erase(x);
        }
        else {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            if (k >= sh + 1) {
                cout << abs(x1- x2) + abs(y1- y2) << "\n";
                continue;
            }
            x1--;
            y1--;
            x2--;
            y2--;
            if (*all.lower_bound(min(x1, x2)) <= max(x1, x2)) {
                cout << "-1\n";
                continue;
            }
            int kek = get(1, 0, n, min(x1, x2), max(x1, x2) + 1);
            int need = sh - kek;
            if (k >= need) {
                cout << abs(x1- x2) + abs(y1- y2) << "\n";
                continue;
            }
            cout << "-1\n";
        }
    }
    return 0;
}
