#include <bits/stdc++.h>
using namespace std;

#define INF 1000000010
#define MOD 1000000007
#define pb push_back
#define f first
#define s second

using vi = vector <int>;
using ll = long long;
using pii = pair <int, int>;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 3 * 1e5 + 10;

int n, m, a[MAXN];
vector <vi> pos;
int to[MAXN];
bool was[MAXN];

int main(){
 	fastIO();
 	cin >> n >> m;
 	pos.resize(m);
 	for(int i = 0; i < n; i++){
 		cin >> a[i];
 		a[i]--;
 		pos[a[i]].pb(i);
 	}	
 	fill(to, to + n, -1);
 	for(int i = 0; i < m; i++){
 		for(int j = 0; j < pos[i].size(); j++){
 			if(j < pos[i].size() - 1)
 				to[pos[i][j]] = pos[i][j + 1];
 		}
 	}
 	multiset <int> st;
 	for(int i = 0; i < n; i++){
 		if(st.size() > 0 && *st.begin() == i)
 			st.erase(st.begin());
 		if(st.size() > 0 && to[i] > *st.begin()){
			cout << -1;
			return 0;
 	 	}
 	 	if(to[i] != -1)
 	 		st.insert(to[i]);
 	}
 	vector <pair <int, pii> > ans;
 	for(int i = 0; i < n; i++){
 		if(was[a[i]] == 0){
 			was[a[i]] = 1;
 			ans.pb({a[i] + 1, {i + 1, pos[a[i]].back() + 1}});
 		}
 	}
 	cout << ans.size() << endl;
 	for(int i = 0; i < ans.size(); i++){
 		cout << ans[i].f << ' ' << ans[i].s.f << ' ' << ans[i].s.s << '\n';
 	}
 	
 	return 0;
}