#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stack>
#include <set>
#include <vector>
#include <cmath>
#include <bitset>
#include <algorithm>

#define mp make_pair
#define pb push_back
using namespace std;
typedef long long ll;
typedef long double ld;

struct edge
{
	int to;
	ll w;
	edge() {}
	edge(int _to, ll _w)
	{
		to = _to;
		w = _w;
	}
};

int t, n, m, q;
ll p;
vector <edge> gr[5000];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> t;
	while (t--)
	{
		cin >> n >> m >> q >> p;
		for (int i = 0; i < n; i++)
			gr[i].clear();
		bitset <10000> b[5000];
		while (m--)
		{
			int v, u;
			ll d;
			cin >> v >> u >> d;
			gr[u - 1].pb(edge(v - 1, d));
		}
		ll maw = p * 10000 / (p - 1);
		b[0][0] = true;
		for (int i = 1; i < n; i++)
			for (auto e : gr[i])
				b[i] |= (b[e.to] << e.w);
		while (q--)
		{
			int f;
			ll r;
			cin >> f >> r;
			ll mar = r * p / (p - 1);
			bool ch = false;
			for (int i = r; i <= mar; i++)
			{
				ch |= b[f - 1][i];
				//if (ch && r == 43)
					//cout << ' ' << i << ' ';
			}
			cout << ch;
		}
		cout << '\n';
	}
	return 0;
}