﻿#include <iostream>
#include <algorithm>
#include <vector>

#define x first
#define y second

using namespace std;

struct st
{
	int c, l, r;
	st()
	{
		c = l = r = -1;
	}
	st(int C, int L, int R)
	{
		c = C;
		l = L;
		r = R;
	}
};

int main()
{
	int m, n;
	cin >> m >> n;
	vector<int> left(n, -1), right(n, -1), a(m);
	vector<st> ans;
	vector<pair<int, int>> colors;
	vector<char> used(n, false);
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < m; i++)
	{
		if (left[a[i]] == -1) left[a[i]] = i;
		right[a[i]] = i;
	}
	for (int i = m - 1; i >= 0; i--)
	{
		while (!colors.empty())
		{
			if (colors.back().y > i)
			{
				colors.pop_back();
			}
			else break;
		}
		if (colors.size() == 0)
		{
			if (used[a[i]])
			{
				cout << -1;
				return 0;
			}
			used[a[i]] = true;
			colors.push_back({ a[i], left[a[i]] });
			ans.push_back(st(a[i] + 1, left[a[i]] + 1, right[a[i]] + 1));
			continue;
		}
		if (colors.back().x == a[i]) continue;
		if (used[a[i]])
		{
			cout << -1;
			return 0;
		}
		used[a[i]] = true;
		colors.push_back({ a[i], left[a[i]] });
		ans.push_back(st(a[i] + 1, left[a[i]] + 1, right[a[i]] + 1)); //right не нужен
	}

	cout << ans.size() << '\n';
	for (auto i : ans)
	{
		cout << i.c << " " << i.l << " " << i.r << '\n';
	}

	system("pause");
	return 0;
}