﻿#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define x first
#define y second
#define int long long

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")

vector<vector<pair<int, int>>> a(100, vector<pair<int, int>>(0));
int f, p, r;
bool flag = false;


void dfs(int v, int cost)
{
	if (flag) return;
	if (v == f)
	{
		if(r <= cost && cost <= r * p / (p - 1)) flag = true;
		return;
	}
	if (v > f) return;
	for (auto i : a[v])
	{
		dfs(i.x, cost + i.y);
	}
}

void solve()
{
	int n, m, q, v, u, d;
	cin >> n >> m >> q >> p;
	for (int i = 0; i < 100; i++) a[i].clear();
	for (int i = 0; i < m; i++)
	{
		cin >> v >> u >> d;
		v--;
		u--;
		a[v].push_back({ u, d });
	}
	string ans = "";
	for (int i = 0; i < q; i++)
	{
		cin >> f >> r;
		f--;
		flag = false;
		dfs(0, 0);
		if (flag) ans += "1";
		else ans += "0";
	}
	cout << ans << '\n';
}

int32_t main()
{
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) solve();
	system("pause");
	return 0;
}