#include <bits/stdc++.h>
using namespace std;
const int MAXN = 3e5 + 7;
int a[MAXN];
int l[MAXN];
int r[MAXN];
int vis[MAXN];
struct seg { int l, r, id; };
bool cmp(seg a, seg b) {
	return a.r - a.l < b.r - b.l;
}
int t[4 * MAXN];
void push(int v, int tl, int tr) {
	if (tl == tr)
		return;
	if (t[v] != -1) {
		t[v << 1] = t[v];
		t[v << 1 ^ 1] = t[v];
	}
	t[v] = -1;
}
void put(int v, int tl, int tr, int l, int r, int x) {
	push(v, tl, tr);
	if (tl > r || l > tr)
		return;
	else if (l <= tl && tr <= r) {
		t[v] = x;
		push(v, tl, tr);
	} else {
		int tm = (tl + tr) >> 1;
		put(v << 1, tl, tm, l, r, x);
		put(v << 1 ^ 1, tm + 1, tr, l, r, x);
	}
}
int get(int v, int tl, int tr, int p) {
	push(v, tl, tr);
	if (tl == tr)
		return t[v];
	else {
		int tm = (tl + tr) >> 1;
		if (p <= tm)
			return get(v << 1, tl, tm, p);
		else
			return get(v << 1 ^ 1, tm + 1, tr, p);
	}
}
void solve() {
	int m, n;
	cin >> m >> n;
	for (int i = 0; i < m; ++i) {
		cin >> a[i];
		--a[i];
		if (!vis[a[i]]) {
			vis[a[i]] = 1;
			l[a[i]] = r[a[i]] = i;
		} else
			r[a[i]] = i;
	}
	vector<seg> s;
	for (int i = 0; i < n; ++i)
		if (vis[i])
			s.push_back(seg{l[i], r[i], i});
	sort(s.begin(), s.end(), cmp);
	reverse(s.begin(), s.end());
	for (seg sg : s) 
		put(1, 0, m - 1, sg.l, sg.r, sg.id);
	bool ok = 1;
	for (int i = 0; i < m; ++i)
		if (a[i] != get(1, 0, m - 1, i))
			ok = 0;
	if (!ok) {
		cout << -1;
		return;
	}
	cout << s.size() << endl;
	for (seg sg : s)
		cout << sg.id + 1 << " " << sg.l + 1 << " " << sg.r + 1 << "\n";
	return;
}
signed main() {
	ios_base::sync_with_stdio(false);

	solve();

	return 0;
}