#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

int inf = 1e6;
int dist[51][51];
int v[51][51];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    for (int o = 0; o < q; ++o) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                ++v[i][j];
                //cout << v[i][j] << " ";
            }
            //cout << "\n";
        }
        //cout << "\n\n";
        int c;
        cin >> c;
        if (c == 1) {
            int a;
            cin >> a;
            --a;
            for (int j = 0; j < m; ++j) {
                v[a][j] = 0;
            }
        } else if (c == 2) {
            int a;
            cin >> a;
            --a;
            for (int i = 0; i < n; ++i) {
                v[i][a] = 0;
            }
        } else {
            int r1, c1, r2, c2, k;

            cin >> r1 >> c1 >> r2 >> c2 >> k;
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < m; ++j) {
                    dist[i][j] = inf;
                }
            }
            --r1;
            --r2;
            --c1;
            --c2;
            dist[r1][c1] = 0;
            queue<pii> s;
            s.push({r1, c1});
            if (v[r1][c1] > k || v[r2][c2] > k) {
                cout << -1 << "\n";
                continue;
            }
            while (s.size() > 0) {
                pii curr = s.front();
                s.pop();
                int a = curr.ft, b = curr.sd;
                if (a + 1 >= 0 && a + 1 < n && b >= 0 && b < m && v[a + 1][b] <= k && dist[a + 1][b] > dist[a][b] + 1) {
                    dist[a + 1][b] = dist[a][b] + 1;
                    s.push({a + 1, b});
                }
                if (a - 1 >= 0 && a - 1 < n && b >= 0 && b < m && v[a - 1][b] <= k && dist[a - 1][b] > dist[a][b] + 1) {
                    dist[a - 1][b] = dist[a][b] + 1;
                    s.push({a - 1, b});
                }
                if (a >= 0 && a < n && b + 1 >= 0 && b + 1 < m && v[a][b + 1] <= k && dist[a][b + 1] > dist[a][b] + 1) {
                    dist[a][b + 1] = dist[a][b] + 1;
                    s.push({a, b + 1});
                }
                if (a >= 0 && a < n && b - 1 >= 0 && b - 1 < m && v[a][b - 1] <= k && dist[a][b - 1] > dist[a][b] + 1) {
                    dist[a][b - 1] = dist[a][b] + 1;
                    s.push({a, b - 1});
                }
            }
            if (dist[r2][c2] == inf) {
                cout << -1 << "\n";
            } else {
                cout << dist[r2][c2] << "\n";
            }
        }
    }
    return 0;
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6*/
