#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 1000, INF = 1e9 + 228;

int a[N][N], d[N][N];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	for (int it = 0; it < q; ++it) {
		int t;
		cin >> t;
		for (int i = 1; i <= n; ++i) {
			for (int j = 1; j <= m; ++j) {
				++a[i][j];
			}
		}
		if (t == 1) {
			int r;
			cin >> r;
			for (int i = 1; i <= m; ++i) {
				a[r][i] = 0;
			}
		} else if (t == 2) {
			int c;
			cin >> c;
			for (int i = 1; i <= n; ++i) {
				a[i][c] = 0;
			}
		} else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			if (a[x1][y1] > k || a[x2][y2] > k) {
				cout << -1 << endl;
				continue;
			}
			
			for (int i = 1; i <= n; ++i) {
				for (int j = 1; j <= m; ++j) {
					d[i][j] = INF;
				}
			}
			vector< pair<int, int> > q;
			q.push_back({x1, y1});
			d[x1][y1] = 0;
			for (int i = 0; i < (int)q.size(); ++i) {
				int x = q[i].first, y = q[i].second;
				for (int dx = -1; dx <= 1; ++dx) {
					for (int dy = -1; dy <= 1; ++dy) {
						if (abs(dx) == abs(dy)) continue;
						int nx = x + dx, ny = y + dy;
						if (1 <= nx && nx <= n && 1 <= ny && ny <= m && a[nx][ny] <= k && d[x][y] + 1 < d[nx][ny]) {
							d[nx][ny] = d[x][y] + 1;
							q.push_back({nx, ny});
						}
					}
				}
			}
			if (d[x2][y2] == INF) cout << -1 << endl;
			else cout << d[x2][y2] << endl;
		}
	}
	return 0;
}