#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}

template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 5005;

int n, m, q, p;

vector< pair<int, int> > g[N];
vector<int> can[N];

void gen(int v, int d = 0) {
	can[v].push_back(d);
	for (pair<int, int> to : g[v]) {
		gen(to.first, d + to.second);
	}
}

void solve() {
	cin >> n >> m >> q >> p;
	for (int i = 1; i <= n; ++i) {
		g[i].clear();
		can[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int u, v, d;
		cin >> u >> v >> d;
		g[u].push_back({v, d * (p - 1)});
	}
	gen(1);
	for (int i = 1; i <= n; ++i) {
		sort(can[i].begin(), can[i].end());
	}
	for (int it = 0; it < q; ++it) {
		int f, r;
		cin >> f >> r;
		int x = lower_bound(can[f].begin(), can[f].end(), p * r - r) - can[f].begin();
		// cout << "f=" << f << " r=" << r << " (" << p * r - r << " " << p * r << ") " << can[f][x] << endl;
		if (x < (int)can[f].size() && can[f][x] <= p * r) {
			cout << 1;
		} else {
			cout << 0;
		}
	}
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	for (int iter = 0; iter < t; ++iter) {
		solve();
	}
	return 0;
}