#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
const int S = 1024 * 1024;
vector<int> Do1(S * 2, -1);
vector<int> Do2(S * 2, -1);

void reb1(int zn, int a, int x, int l, int r){
    if (l > a || r <= a)
        return;
    if (r - l == 1){
        Do1[x] = zn;
        return;
    }
    reb1(zn, a, x * 2, l, (l + r) / 2);
    reb1(zn, a, x * 2 + 1, (l + r) / 2, r);
    Do1[x] = max(Do1[x * 2], Do1[x * 2 + 1]);
}

void reb2(int zn, int a, int x, int l, int r){
    if (l > a)
        return;
    if (r - l == 1){
        Do2[x] = zn;
        return;
    }
    reb2(zn, a, x * 2, l, (l + r) / 2);
    reb2(zn, a, x * 2 + 1, (l + r) / 2, r);
    Do2[x] = max(Do2[x * 2], Do2[x * 2 + 1]);
}

int ma1(int st, int fn, int x, int l, int r){
    if (st >= r || l >= fn)
        return -1;
    if (fn >= r && l >= st)
        return Do1[x];
    return max(ma1(st, fn, x * 2, l, (l + r) / 2), ma1(st, fn, x * 2 + 1, (l + r) / 2, r));
}

int ma2(int st, int fn, int x, int l, int r){
    if (st >= r || l >= fn)
        return -1;
    if (fn >= r && l >= st)
        return Do2[x];
    return max(ma2(st, fn, x * 2, l, (l + r) / 2), ma2(st, fn, x * 2 + 1, (l + r) / 2, r));
}



int main()
{
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> str(n, -1);
    vector<int> stl(m, -1);
    for (int t = 0; t < q; t++){
        int k, nb, x1, y1, x2, y2, a;
        cin >> nb;
        if (nb == 2){
            cin >> a;
            reb1(t, a - 1, 1, 0, S);
            str[a - 1] = t;
            continue;
        }
        if (nb == 1){
            cin >> a;
            reb2(t, a - 1, 1, 0, S);
            stl[a - 1] = t;
            continue;
        }
        cin >> x1 >> y1 >> x2 >> y2 >> k;
        x1 -= 1;
        x2 -= 1;
        y1 -= 1;
        y2 -= 1;
        if ((t - stl[y1] > k && t - str[x1] > k) || (t - stl[y2] > k && t - str[x2] > k)){
            cout << -1 << endl;
            continue;
        }
        bool sx1, sx2, sy1, sy2;
        sx1 = false;
        sy1 = false;
        sx2 = false;
        sy2 = false;
        if (t - stl[y1] <= k)
            sy1 = true;
        if (t - str[x1] <= k)
            sx1 = true;
        if (t - str[x2] <= k)
            sx2 = true;
        if (t - stl[y2] <= k)
            sy2 = true;
        if ((sy1 && sx2) || (sx1 && sy2)){
            cout << max(x1 - x2, x2 - x1) + max(y2 - y1, y1 - y2) << endl;
            continue;
        }
        if (sx1 && sx2){
            bool c = true;
            for (int i = min(x1, x2); i <= max(x1, x2); i++){
                if (t - str[i] > k){
                    c = false;
                    break;
                }
            }
            if (c){
                cout << max(x1 - x2, x2 - x1) + max(y2 - y1, y1 - y2) << endl;
                continue;
            }
            if (t - ma2(x1, x2, 1, 0, S) >= k){
                cout << max(x1 - x2, x2 - x1) + max(y2 - y1, y1 - y2) << endl;
                continue;
            }
            int l = 0, r = x1;
            int z = -1;
            if (t - ma2(l, r, 1, 0, S) <= k){
                while (r - l > 1){
                    int M = (l + r) / 2;
                    if (t - ma2(M, r, 1, 0, S) <= k)
                        l = M;
                    else
                        r = M;
                }
                int i = l;
                z = (max(i - y1, y1 - i) + max(i - y2, y2 - i));
            }
            l = x2, r = m;
            if (t - ma2(l, r, 1, 0, S) <= k){
                while (r - l > 1){
                    int M = (l + r) / 2;
                    if (t - ma2(M, r, 1, 0, S) <= k)
                        l = M;
                    else
                        r = M;
                }
                int i = l;
                if (z == -1)
                    z = max(i - y1, y1 - i) + max(i - y2, y2 - i);
                z = min(max(i - y1, y1 - i) + max(i - y2, y2 - i), z);
            }
            if (z == -1){
                cout << -1;
                continue;
            }
            cout << max(x2 - x1, x1 - x2) + z << endl;
            continue;
        }
        bool c = true;
        for (int i = min(y1, y2); i < max(y1, y2); i++){
            if (t - stl[i] > k){
                c = false;
                break;
            }
        }
        if (c){
            cout << max(x1 - x2, x2 - x1) + max(y2 - y1, y1 - y2) << endl;
            continue;
        }
        if (t - ma2(x1, x2, 1, 0, S) >= k){
                cout << max(x1 - x2, x2 - x1) + max(y2 - y1, y1 - y2) << endl;
                continue;
            }
            int l = 0, r = x1;
            int z = -1;
            if (t - ma2(l, r, 1, 0, S) <= k){
                while (r - l > 1){
                    int M = (l + r) / 2;
                    if (t - ma2(M, r, 1, 0, S) <= k)
                        l = M;
                    else
                        r = M;
                }
                int i = l;
                z = (max(i - y1, y1 - i) + max(i - y2, y2 - i));
            }
            l = x2, r = m;
            if (t - ma2(l, r, 1, 0, S) <= k){
                while (r - l > 1){
                    int M = (l + r) / 2;
                    if (t - ma2(M, r, 1, 0, S) <= k)
                        l = M;
                    else
                        r = M;
                }
                int i = l;
                if (z == -1)
                    z = max(i - y1, y1 - i) + max(i - y2, y2 - i);
                z = min(max(i - y1, y1 - i) + max(i - y2, y2 - i), z);
            }
            if (z == -1){
                cout << -1;
                continue;
            }
            cout << max(x2 - x1, x1 - x2) + z << endl;
            continue;
    }
    return 0;
}
