#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

struct edge {
    int to;
    ll w;
};

const int MAXN = 1e6 + 5;
int n, m, q, p;
vector<edge> g[MAXN];
vector<edge> gr[MAXN];
set<pair<ll, ll>> a[MAXN];

void add(set<pair<ll, ll>> &s, pair<ll, ll> seg) {
    seg.f = max<ll>(seg.f, 0);
    if (seg.f > seg.s) return;
    auto t = s.insert(seg);
    if (!t.s) return;
    auto it = t.f;
    if (next(it) != s.end() && next(it)->f <= seg.s) {
        seg.s = next(it)->s;
        s.erase(next(it));
        s.erase(it);

        t = s.insert(seg);
        if (!t.s) return;
        it = t.f;
    }
    if (it != s.begin() && prev(it)->s >= seg.f) {
        seg.f = prev(it)->f;
        s.erase(prev(it));
        s.erase(it);
        s.insert(seg);
    }
}

bool ans[MAXN];
vector<pair<int, ll>> qe;

void solve() {
    cin >> n >> m >> q >> p;
    qe.clear();
    rep(i, n) {
        g[i].clear();
        gr[i].clear();
        ans[i] = false;
    }
    rep(i, m) {
        int p, q;
        ll w;
        cin >> p >> q >> w;
        p--; q--;
        g[p].push_back({q, w});
        gr[q].push_back({p, w});
    }

    if (q == 0) return;

    rep(i, q) {
        int vv;
        ll c;
        cin >> vv >> c;
        qe.push_back({vv, c});
    }

    rep(vv, n) {
        ll c = qe.back().s;
        rep(i, n) {
            a[i].clear();
        }

        a[vv].insert({c, c * p / (p - 1)});
        for (int v = vv; v >= 0; --v) {
            for (auto it : gr[v]) {
                int to = it.to;
                ll w = it.w;

                for (auto &seg : a[v]) {
                    add(a[to], {seg.f - w, seg.s - w});
                }
            }
        }

        if (!a[0].empty() && a[0].begin()->f == 0) {
            ans[vv] = true;
        }
    }

    string res(q, '0');
    rep(i, q) {
        int vv;
        ll c;
        cin >> vv >> c;
        vv--;

        res[i] = ('0' + ans[vv]);
    }
    cout << res << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int tt;
    cin >> tt;
    rep(ttt, tt) {
        solve();
    }
}