#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);
int n;
int main() {
    int test_count = 100000000;
    scanf("%d", &n);
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
    $ printf("\n");
}

using ll = long long;

bool query(int x) {
    printf("? %d\n", x);
    fflush(stdout);
    char reply[4];
    scanf("%s", reply);
    return reply[0] == 'Y';
}

void finish(int x) {
    printf("! %d\n", x);
    fflush(stdout);
    char reply[8];
    scanf("%s", reply);
    if (reply[0] == 'D') exit(0);
}

void entry(int test_id) {
    int lb = 1;
    int rb = n+1;
    while (rb - lb > 1) {
        int m1 = (lb+lb+rb)/3;
        int m2 = (lb+rb+rb)/3;
        bool t1 = query(m1);
        bool t2 = query(m2);
        if (!t1 && t2) continue;
        if (t2) {
            lb=m2;
        } else if (t1) {
            lb = m1;
            rb = m2;
        } else {
            rb = m1;
        }
    }
    finish(lb);
}