
#include <iostream>
#include <vector>
#include <queue>
#include <utility>
using namespace std;

typedef long long ll;

vector <pair<ll, ll>> g[15];
ll o, fl, pp;

void dfs(ll u, ll len, ll to) {
	if (u == to) {
		bool is = 1;
		is &= (o <= len);
		is &= (len * (pp - 1) <= pp * o);
		fl |= is;
		return;
	}
	// o = r, pp = p
	if (len * (pp - 1) > pp * o) return;
	for (auto v : g[u]) {
		dfs(v.first, len + v.second, to);
	}
}


void run() {
	ll n, m, q, p;
	cin >> n >> m >> q >> p;

	pp = p;
	for (ll i = 1; i <= n; ++i) g[i].clear();
	while (m--) {
		ll u, v, l;
		cin >> u >> v >> l;
		g[u].push_back({ v, l });
	}
	while (q--) {
		ll f, r;
		cin >> f >> r;
		o = r;
		fl = 0;
		dfs(1, 0, f);
		cout << fl;
	}
}

void solve() {
	ll t;
	cin >> t;
	while (t--) {
		run();
		cout << '\n';
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	//freopen("true.txt", "r", stdin);
	solve();
	return 0;
}