#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

#define endl '\n'
#define int long long

bool rec(int v, int x, vector<vector<pair<int, int> > >& grph, int r, int p) {
	if (v == 0) {
		if (r * p - r <= x * p - x && x * p - x <= p * r) {
			return 1;
		}
		return 0;
	}
	for (auto u : grph[v]) {
		if (rec(u.first, x + u.second, grph, r, p)) return 1;
	}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		vector<vector<pair<int, int> > > grph(n);
		for (int i = 0; i < m; i++) {
			int a, b, d;
			cin >> a >> b >> d;
			--a; --b;
			if (a > b) swap(a, b);
			grph[b].push_back({ a, d });
		}

		string ans;
		for (int i = 0; i < q; i++) {
			int f, r;
			cin >> f >> r;
			if (rec(--f, 0, grph, r, p)) {
				ans += '1';
			}
			else {
				ans += '0';
			}
		}
		cout << ans << endl;
	}
}