#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n;
    cin >> m >> n;

    vector<int> num(m);
    vector<int> left(n, 1e9);
    vector<int> right(n, -1e9);
    for (int i = 0; i < m; i++)
    {
        cin >> num[i];
        num[i]--;
        left[num[i]] = min(left[num[i]], i);
        right[num[i]] = max(right[num[i]], i);
    }

    unordered_set<int> big;
    vector<int> bigv;
    unordered_set<int> small;
    for (int i = 0; i < n; i++)
    {
        if (left[i] != 1e9 && left[i] != right[i])
        {
            big.insert(i);
            bigv.push_back(i);
        }
        else if (left[i] == right[i])
            small.insert(i);
    }

    sort(bigv.begin(), bigv.end(), [&left, &right](int a, int b)
    {
        return right[a] - left[a] > right[b] - left[b];
    });

    vector<int> open;
    for (int i = 0; i < m; i++)
    {
        if (small.count(num[i]) == 1)
            continue;

        if (i == left[num[i]])
            open.push_back(num[i]);
        else if (i == right[num[i]])
        {
            if (open.back() == num[i])
                open.pop_back();
            else
                return cout << "-1" << endl, 0;
        }
        else
        {
            if (open.back() != num[i])
                return cout << "-1" << endl, 0;
        }
    }

    cout << bigv.size() + small.size() << endl;
    for (int x : bigv)
        cout << x + 1 << " " << left[x] + 1 << " " << right[x] + 1 << endl;
    for (int x : small)
        cout << x + 1 << " " << left[x] + 1 << " " << right[x] + 1 << endl;

    return 0;
}