#include <bits/stdc++.h>

using namespace std;

const int INF = 2e9;

bool correct(int x, int y, int n, int m) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    vector <vector <int> > f(n, vector <int>(m));
    for (int iq = 0; iq < q; iq++) {
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                f[i][j]++;
        int type; cin >> type;
        if (type == 1) {
            int i; cin >> i; i--;
            for (int j = 0; j < m; j++)
                f[i][j] = 0;
        } else if (type == 2){
            int j; cin >> j; j--;
            for (int i = 0; i < n; i++)
                f[i][j] = 0;
        } else {
            int i1, j1, i2, j2, k;
            cin >> i1 >> j1 >> i2 >> j2 >> k;
            i1--; j1--; i2--; j2--;
            vector <vector <int> > d(n, vector <int> (m, INF));
            d[i1][j1] = 0;
            queue <pair <int, int> > q;
            if (f[i1][j1] <= k)
                q.push(make_pair(i1, j1));
            while (!q.empty()) {
                auto p = q.front();
                q.pop();
                vector <pair <int, int> > turns = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
                for (auto turn : turns) {
                    int x = p.first + turn.first;
                    int y = p.second + turn.second;
                    if (correct(x, y, n, m) && f[x][y] <= k && d[x][y] > d[p.first][p.second] + 1) {
                        d[x][y] = d[p.first][p.second] + 1;
                        q.push(make_pair(x, y));
                    }
                }
            }
            if (d[i2][j2] == INF) {
                cout << -1 << "\n";
            } else {
                cout << d[i2][j2] << "\n";
            }
        }
    }
    return 0;
}
