#pragma GCC optimize("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <bitset>
using namespace std;

typedef long long ll;

#define x first
#define y second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()

const ll MAXN = 10005;


bitset<MAXN + 5> dp[MAXN];
bitset<MAXN + 5> emp;
vector<pair<int, ll>> g[MAXN];

int n, m, q, p;
int last;

void solve() {
	for (int i = 0; i < last; i++) {
		dp[i] &= emp;
		g[i].clear();
	}
	cin >> n >> m >> q >> p;
	last = n;
	for (int i = 0; i < m; i++) {
		int u, v;
		ll d;
		cin >> u >> v >> d;
		--u; --v;
		g[u].pb(v, d);
	}
	dp[0][0] = 1;
	for (int i = 0; i < n; i++) {
		for (auto to : g[i]) {
			if (to.y <= MAXN)
				dp[to.x] |= (dp[i] << to.y);
		}
	}
	while (q--) {
		int f;
		ll r;
		cin >> f >> r;
		--f;
		ll tp = (double(p) / double(p - 1)) * double(r);
		bool can = 0;
		for (ll i = r; i <= MAXN && i <= tp; i++) {
			if (dp[f][i]) {
				can = 1;
				break;
			}
		}
		cout << char(can + '0');
	}
	cout << '\n';
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	int tt;
	cin >> tt;
	while (tt--) {
		solve();
	}
}