#include<iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<iomanip>
#include<random>
using namespace std;
#define x first
#define y second
#define pb push_back
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define ll long long
mt19937 rng(time(NULL));
int a[51][51], head, tail, w[51][51];
pair<int, int> q[3000];
bool used[51][51];
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, Q;
	cin >> n >> m >> Q;
	for (int i = 0; i < Q; i++) {
		int t, x;
		cin >> t;
		if (t == 1) {
			cin >> x;
			for (int j = 1; j <= m; j++)
				a[x][j] = i + 1;
		}
		if (t == 2) {
			cin >> x;
			for (int j = 1; j <= n; j++)
				a[j][x] = i + 1;
		}
		if (t == 3) {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			if (i + 1 - a[x1][y1] > k) {
				cout << -1 << endl;
				continue;
			}
			used[x1][y1] = true;
			q[head++] = { x1, y1 };
			while (head > tail) {
				int x = q[tail].x, y = q[tail].y;
				tail++;
				if (x > 1 && !used[x - 1][y] && i + 1 - a[x - 1][y] <= k) {
					used[x - 1][y] = true;
					w[x - 1][y] = w[x][y] + 1;
					q[head++] = { x - 1, y };
				}
				if (x < n && !used[x + 1][y] && i + 1 - a[x + 1][y] <= k) {
					used[x + 1][y] = true;
					w[x + 1][y] = w[x][y] + 1;
					q[head++] = { x + 1, y };
				}
				if (y > 1 && !used[x][y - 1] && i + 1 - a[x][y - 1] <= k) {
					used[x][y - 1] = true;
					w[x][y - 1] = w[x][y] + 1;
					q[head++] = { x, y - 1 };
				}
				if (y < m && !used[x][y + 1] && i + 1 - a[x][y + 1] <= k) {
					used[x][y + 1] = true;
					w[x][y + 1] = w[x][y] + 1;
					q[head++] = { x, y + 1 };
				}
			}
			if (!used[x2][y2])
				cout << -1 << endl;
			else
				cout << w[x2][y2] << endl;
			for (int i = 1; i <= n; i++)
				for (int j = 1; j <= m; j++) {
					used[i][j] = false;
					w[i][j] = 0;
				}
		}
	}
	return 0;
}