import java.io.PrintWriter;
import java.util.*;
public class Main {
    static int inf = (int) 1e9;
    static int n, m;
    static ArrayList<Integer> gr[];
    static ArrayList<Integer> cost[];
    static int cnt[];
    static boolean dp[][];
    static boolean used[];
    static void dfs1(int v) {
        if (used[v]) return;
        used[v] = true;
        for(int i : gr[v]) {
            cnt[i]++;
            dfs1(i);
        }
    }
    static void dfs2(int v) {
        if (cnt[v] != 0) return;
        for(int i = 0;i < gr[v].size();i++) {
            int to = gr[v].get(i);
            int cs = cost[v].get(i);
            try {
                for (int j = 0; j < dp[v].length; j++) {
                    if (dp[v][j] && j + cs < 10000) dp[to][j + cs] = true;
                }
            }catch (Exception e) {
                while(true);
            }
            cnt[to]--;
            dfs2(to);
        }
    }
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for(int test = 0;test < t;test++) {
            n = sc.nextInt();
            m = sc.nextInt();
            int q = sc.nextInt();
            int p = sc.nextInt();
            gr = new ArrayList[n];
            cost = new ArrayList[n];
            cnt = new int [n];
            dp = new boolean[n][11000];
            used = new boolean[n];
            for(int i = 0;i < n;i++) {
                gr[i] = new ArrayList<>();
                cost[i] = new ArrayList<>();
            }
            for(int i = 0;i < m;i++) {
                int from = sc.nextInt() - 1;
                int to = sc.nextInt() - 1;
                int c = sc.nextInt();
                gr[from].add(to);
                cost[from].add(c);
            }
            dfs1(0);
            dp[0][0] = true;
            dfs2(0);
            char ans[] = new char[q];
            for(int i = 0;i < q;i++) {
                int to = sc.nextInt() - 1;
                int r = sc.nextInt();
                ans[i] = '0';
                for(int j = r;j <= p * r / (p - 1);j++) {
                    if (dp[to][j]) ans[i] = '1';
                }
            }
            for(char i : ans) pw.print(i);
            pw.println();
        }
        pw.close();
    }

    static PrintWriter pw = new PrintWriter(System.out);
}
