#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

struct node
{
	vector <int > al;
};

void build(node* &root, int l, int r)
{
	root = new node();
	root->al.resize(r);
}

int get(node* &root, int l, int r, int id)
{
	return root->al[id];
}

int getmax(node* &root, int l, int r, int l1, int r1)
{
	int mx = -2;
	for (int i = l1; i < r1; i++)
		mx = max(mx, get(root, l, r, i));
	return mx;
}

int getmin(node* &root, int l, int r, int l1, int r1)
{
	int mn = 1e9;
	for (int i = l1; i < r1; i++)
		mn = min(mn, get(root, l, r, i));
	return mn;
}


void inc(node* &root, int l, int r, int id, int x)
{
	root->al[id] = x;
}

int tp, x, y, x2, y2, k, tx, ty, tx2, ty2;

int more(node* root, int l, int r, int id, int &tmt)
{
	for (int i = id; i < r; i++)
		if (get(root, l, r, i) >= k)
		{
			tmt = (i - id) * 2;
			return 1;
		}
	return 0;
}

int les(node* root, int l, int r, int id, int &tmt)
{
	for (int i = id; i >= 0; i--)
		if (get(root, l, r, i) >= k)
		{
			tmt = (id - i) * 2;
			return 1;
		}
	return 0;
}

node* sb;
node* sr;

int n, m;

int chstr()
{
	int norm = abs(x - x2) + abs(y - y2);
	if (getmax(sb, 0, m, y, y2 + 1) >= k || getmin(sr, 0, n, x, x2 + 1) >= k)
		return norm;

	int mn = 1e9, mn1, mn2;
	bool q1 = more(sb, 0, m, max(y, y2), mn1);
	bool q2 = les(sb, 0, m, min(y, y2), mn2);
	if (q1)
		mn = min(mn, mn1);
	if (q2)
		mn = min(mn, mn2);
	return mn + norm;
}

int chstlb()
{
	int norm = abs(x - x2) + abs(y - y2);
	if (getmax(sr, 0, n, x, x2 + 1) >= k || getmin(sb, 0, m, y, y2 + 1) >= k)
		return norm;

	int mn = 1e9, mn1, mn2;
	bool q1 = more(sr, 0, n, max(x, x2), mn1);
	bool q2 = les(sr, 0, n, min(x, x2), mn2);
	if (q1)
		mn = min(mn, mn1);
	if (q2)
		mn = min(mn, mn2);
	return mn + norm;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0);
	cin >> n >> m;
	build(sr, 0, n);
	build(sb, 0, m);
	int q;
	cin >> q;
	for (int i = 1; i <= q; i++)
	{
		cin >> tp;
		if (tp == 1)
		{
			cin >> x;
			inc(sr, 0, n, x - 1, i);
		}
		else if (tp == 2)
		{
			cin >> x;
			inc(sb, 0, m, x - 1, i);
		}
		else
		{
			cin >> x >> y >> x2 >> y2 >> k;
			k = i - k;
			x--, y--, x2--, y2--;
			tx = get(sr, 0, n, x), ty = get(sb, 0, m, y), tx2 = get(sr, 0, n, x2), ty2 = get(sb, 0, m, y2);
			if (tx < k && ty < k || tx2 < k && ty2 < k)
				cout << -1 << "\n";
			else if (tx >= k && ty2 >= k || ty >= k && tx2 >= k)
				cout << abs(x - x2) + abs(y - y2) << "\n";
			else
			{
				int mn = 1e9;
				if (tx >= k && tx2 >= k)
					mn = min(mn, chstr());
				if (ty >= k && ty2 >= k)
					mn = min(mn, chstlb());
				mn = (mn == 1e9 ? -1 : mn);
				cout << mn << "\n";
			}
		}
	}
	cin >> n;

	return 0;
}