#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int maxn = 1e6;
const int INF = 2e9;

int n, m, q, type;
pair <int, int> t1[4 * maxn], t2[4 * maxn];

void change1(int v, int tl, int tr, int pos, int val) {
    if(tl == tr)
        t1[v].first = t1[v].second = val;
    else {
        int tm = (tl + tr) >> 1;
        if(pos <= tm)
            change1(2 * v, tl, tm, pos, val);
        else
            change1(2 * v + 1, tm + 1, tr, pos, val);
        t1[v].first = min(t1[2 * v].first, t1[2 * v + 1].first);
        t1[v].second = max(t1[2 * v].second, t1[2 * v + 1].second);
    }
}

void change2(int v, int tl, int tr, int pos, int val) {
    if(tl == tr)
        t2[v].first = t2[v].second = val;
    else {
        int tm = (tl + tr) >> 1;
        if(pos <= tm)
            change2(2 * v, tl, tm, pos, val);
        else
            change2(2 * v + 1, tm + 1, tr, pos, val);
        t2[v].first = min(t2[2 * v].first, t2[2 * v + 1].first);
        t2[v].second = max(t2[2 * v].second, t2[2 * v + 1].second);
    }
}

pair <int, int> get1(int v, int tl, int tr, int l, int r) {
    if(l > r) return { INF, -INF };
    if(tl == l && tr == r) return t1[v];
    int tm = (tl + tr) >> 1;
    pair <int, int> h1 = get1(2 * v, tl, tm, l, min(tm, r));
    pair <int, int> h2 = get1(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
    return {min(h1.first, h2.first), max(h1.second, h2.second)};
}

pair <int, int> get2(int v, int tl, int tr, int l, int r) {
    if(l > r) return { INF, -INF };
    if(tl == l && tr == r) return t2[v];
    int tm = (tl + tr) >> 1;
    pair <int, int> h1 = get2(2 * v, tl, tm, l, min(tm, r));
    pair <int, int> h2 = get2(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
    return {min(h1.first, h2.first), max(h1.second, h2.second)};
}

/*void res(int x1, int y1, int x2, int y2, int k, int cur) {
    queue <pair <int, pair <int, int> > > qq;
    map <pair <int, int>, int> used;
    qq.push( { 0, { x1, y1 } } );
    used[{x1, y1}] = 1;
    while(!qq.empty()) {
        pair <int, pair <int, int> > p = qq.front();
        qq.pop();
        int dist = p.first, x = p.second.first, y = p.second.second;
        if(x == x2 && y == y2) {
            cout << dist << '\n';
            return;
        }
        if(x - 1 >= 0 && used[{x - 1, y}] == 0 && max(get1(1, 0, n - 1, x - 1, x - 1), get2(1, 0, m - 1, y, y)) >= cur - k) {
            qq.push( { dist + 1, { x - 1, y } } );
            used[{x - 1, y}] = 1;
        }
        if(x + 1 < n && used[{x + 1, y}] == 0 && max(get1(1, 0, n - 1, x + 1, x + 1), get2(1, 0, m - 1, y, y)) >= cur - k) {
            qq.push( { dist + 1, { x + 1, y } } );
            used[{x + 1, y}] = 1;
        }
        if(y - 1 >= 0 && used[{x, y - 1}] == 0 && max(get1(1, 0, n - 1, x, x), get2(1, 0, m - 1, y - 1, y - 1)) >= cur - k) {
            qq.push( { dist + 1, { x, y - 1 } } );
            used[{x, y - 1}] = 1;
        }
        if(y + 1 < m && used[{x, y + 1}] == 0 && max(get1(1, 0, n - 1, x, x), get2(1, 0, m - 1, y + 1, y + 1)) >= cur - k) {
            qq.push( { dist + 1, { x, y + 1 } } );
            used[{x, y + 1}] = 1;
        }
    }
    cout << -1 << '\n';
    return;
}*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n >> m >> q;
    int x1, y1, x2, y2, k, cur = 0;
    for(int i = 0; i < q; i++) {
        cur++;
        cin >> type;
        if(type == 1) {
            cin >> k;
            k--;
            change1(1, 0, n - 1, k, cur);
        }
        if(type == 2) {
            cin >> k;
            k--;
            change2(1, 0, m - 1, k, cur);
        }
        if(type == 3) {
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--; y1--; x2--; y2--;
            int str1 = get1(1, 0, n - 1, x1, x1).first;
            int st1 = get2(1, 0, m - 1, y1, y1).first;
            int str2 = get1(1, 0, n - 1, x2, x2).first;
            int st2 = get2(1, 0, m - 1, y2, y2).first;
            if(str1 < cur - k && st1 < cur - k) {
                cout << -1 << '\n';
                continue;
            }
            if(str2 < cur - k && st2 < cur - k) {
                cout << -1 << '\n';
                continue;
            }
            if(str1 >= cur - k && st2 >= cur - k) {
                cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
                continue;
            }
            if(st1 >= cur - k && str2 >= cur - k) {
                cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
                continue;
            }
            if(str1 >= cur - k && str2 >= cur - k) {
                int ans = INF;
                int b = get1(1, 0, n - 1, min(x1, x2), max(x1, x2)).first;
                if(b >= cur - k) {
                    cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
                    continue;
                }
                if(y1 > y2) {
                    swap(y1, y2);
                    swap(x1, x2);
                }
                int l = 0, r = y1;
                while(r - l > 1) {
                    int mid = (l + r) >> 1;
                    if(get2(1, 0, m - 1, mid, y1).second >= cur - k)
                        l = mid;
                    else
                        r = mid;
                }
                for(int j = r; j >= l; j--) {
                    if(get2(1, 0, m - 1, j, y1).second >= cur - k)
                        ans = min(ans, abs(y1 - j) + abs(x1 - x2) + abs(y2 - j));
                }
                l = y2, r = m - 1;
                while(r - l > 1) {
                    int mid = (l + r) >> 1;
                    if(get2(1, 0, m - 1, y2, mid).second >= cur - k)
                        r = mid;
                    else
                        l = mid;
                }
                for(int j = l; j <= r; j++) {
                    if(get2(1, 0, m - 1, y2, j).second >= cur - k)
                        ans = min(ans, abs(y1 - j) + abs(x1 - x2) + abs(y2 - j));
                }
                if(get2(1, 0, m - 1, y1, y2).second >= cur - k)
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                if(ans == INF)
                    ans = -1;
                cout << ans << '\n';
                continue;
            }
            if(st1 >= cur - k && st2 >= cur - k) {
                int ans = INF;
                if(get2(1, 0, m - 1, min(y1, y2), max(y1, y2)).first >= cur - k) {
                    cout << abs(x1 - x2) + abs(y1 - y2) << '\n';
                    continue;
                }
                if(x1 > x2) {
                    swap(y1, y2);
                    swap(x1, x2);
                }
                int l = 0, r = x1;
                while(r - l > 1) {
                    int mid = (l + r) >> 1;
                    if(get1(1, 0, n - 1, mid, x1).second >= cur - k)
                        l = mid;
                    else
                        r = mid;
                }
                for(int j = r; j >= l; j--) {
                    if(get1(1, 0, n - 1, j, x1).second >= cur - k)
                        ans = min(ans, abs(x1 - j) + abs(y1 - y2) + abs(x2 - j));
                }
                l = x2, r = n - 1;
                while(r - l > 1) {
                    int mid = (l + r) >> 1;
                    if(get1(1, 0, n - 1, x2, mid).second >= cur - k)
                        r = mid;
                    else
                        l = mid;
                }
                for(int j = l; j <= r; j++) {
                    if(get1(1, 0, n - 1, x2, j).second >= cur - k)
                        ans = min(ans, abs(x1 - j) + abs(y1 - y2) + abs(x2 - j));
                }
                if(get1(1, 0, n - 1, x1, x2).second >= cur - k)
                    ans = min(ans, abs(x1 - x2) + abs(y1 - y2));
                /*for(int j = 0; j < n; j++) {
                    if(max(get1(1, 0, n - 1, j, j).first, get2(1, 0, m - 1, min(y1, y2), max(y1, y2)).first) >= cur - k) {
                        ans = min(ans, abs(x1 - j) + abs(y1 - y2) + abs(x2 - j));
                    }
                }*/
                if(ans == INF)
                    ans = -1;
                cout << ans << '\n';
                continue;
            }
        }
    }
    return 0;
}
