#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define next mynext
#define prev myprev
#define x first
#define y second
#define int long long

const int inf = 1e15;

pii cuts[300009];
int a[300009];
vector<int> ins[300009];

char used[300009];
vector<int> tops;
int n, m;
int next[300009];
int prev[300009];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    //int n, m;
    cin >> m >> n;

    for (int i = 0; i < m; i ++) {
        cin >> a[i];
        a[i]--;

        next[i] = i + 1;
        prev[i] = i - 1;
    }

    for (int i = 0; i < n; i++) {
        cuts[i].x = -1;
        cuts[i].y = -1;
    }

    for (int i = 0; i < m; i ++) {
        if (cuts[a[i]].x == -1) {
            cuts[a[i]].x = i;
        }

        cuts[a[i]].y = i;
        ins[a[i]].push_back(i);
    }

    set<int> line;
    set<int> unused;
    int c = a[0];
    int currl = 0;
    for (int i = 1; i < m; i ++) {
        if (a[i] != c) {
            if (cuts[c].x == currl && cuts[c].y == i - 1) {
                line.insert(c);
            }

            c = a[i];
            currl = i;
        }
    }

    for (int i = 0; i < n; i ++) {
        if (cuts[i].x != -1 && line.find(i) == line.end()) {
            unused.insert(i);
        }
    }

    vector<int> order;
    while (line.size()) {
        auto c = *line.begin();
        line.erase(c);
        order.push_back(c);

        int i1 = prev[cuts[c].x], i2 = next[cuts[c].y];
        if (i1 == -1 || i2 == m) {
            if (i1 == -1 && i2 == m) continue;
            else if (i1 == -1) {
                prev[i2] = -1;
            }

            else {
                next[i1] = m;
            }

            continue;
        }

        if (a[i1] == a[i2]) {
            int j1 = i1, j2 = i2;
            while (prev[j1] != -1 && a[prev[j1]] == a[i1]) {
                j1 = prev[j1];
            }

            while (next[j2] != -1 && a[next[j2]] == a[i1]) {
                j2 = next[j2];
            }

            if (j1 == cuts[a[i1]].x && j2 == cuts[a[i2]].y) {
                line.insert(a[i1]);
                unused.erase(a[i1]);
            }

            next[i1] = i2;
            prev[i2] = i1;
        }

        else {
            next[i1] = i2;
            prev[i2] = i1;
        }
    }

    if (unused.size()) {
        cout << -1;
        return 0;
    }

    reverse(order.begin(), order.end());
    cout << order.size() << "\n";
    for (auto u : order) {
        cout << u + 1 << ' ' << cuts[u].x + 1 << ' ' << cuts[u].y + 1 << "\n";
    }

    return 0;
}

