#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_map>

#pragma GCC optimize("Ofast")

using namespace std;

#pragma warning (disable : 4996)

#define int long long

const int MAXN = 5e5 + 10;

int t, n, m, q, p;
vector < pair < int, long long > > gr[MAXN];
unordered_map < long long, long long > lel[MAXN];

long long get(int u, long long r) {
	if (lel[u].count(r)) return lel[u][r];
	if (u == 0) {
		if (r <= 0)
			return 0;
		return 3e17;
	}
	long long mi = 3e17;
	for (int i = 0; i < gr[u].size(); i++) {
		long long tmp = get(gr[u][i].first, max(r - gr[u][i].second, (long long)0));
		mi = min(tmp + gr[u][i].second, mi);
	}
	lel[u][r] = mi;
	return lel[u][r];
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//cout << LLONG_MAX << "\n";

	cin >> t;
	while (t--) {
		cin >> n >> m >> q >> p;
		for (int i = 0; i < n; i++) {
			gr[i].clear();
			lel[i].clear();
		}
		for (int i = 0; i < m; i++) {
			int u, v;
			long long c;
			cin >> u >> v >> c;
			u--;
			v--;
			gr[v].push_back(make_pair(u, c));
		}
		while (q--) {
			int u;
			long long d;
			cin >> u >> d;
			u--;
			long long tmp = get(u, d);
			//cout << tmp << " ";
			if (tmp * (p - 1) <= p * d) {
				cout << '1';
			}
			else {
				cout << '0';
			}
			//cout << "\n";
		}
		cout << "\n";
	}

	return 0;
}

/*

2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44*/