#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_map>

#pragma GCC optimize("Ofast")

using namespace std;

#pragma warning (disable : 4996)

#define int long long

const int MAXN = 5e5 + 10;

int t, n, m, q, p;
vector < pair < int, long long > > gr[MAXN];

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//cout << LLONG_MAX << "\n";

	cin >> t;
	while (t--) {
		cin >> n >> m >> q >> p;
		for (int i = 0; i < n; i++) {
			gr[i].clear();
		}
		for (int i = 0; i < m; i++) {
			int u, v;
			long long c;
			cin >> u >> v >> c;
			u--;
			v--;
			gr[v].push_back(make_pair(u, c));
		}
		for (int i = 1; i < n; i++) {
			if (gr[i][0].second > gr[i][1].second) {
				swap(gr[i][0], gr[i][1]);
			}
		}
		while (q--) {
			int u;
			long long d;
			cin >> u >> d;
			u--;
			int sum = 0;
			vector < int > lel;
			for (int i = u; i > 0; i--) {
				sum += gr[i][0].second;
				lel.push_back(gr[i][1].second - gr[i][0].second);
			}
			sort(lel.begin(), lel.end());
			reverse(lel.begin(), lel.end());
			int l = 0;
			for (int i = 0; i < lel.size(); i++){
				if (sum + lel[i] < 2 * d) {
					sum += lel[i];
				}
			}
			if (d <= sum && sum <= 2 * d) {
				cout << '1';
			}
			else {
				cout << '0';
			}
		}
		cout << "\n";
	}

	return 0;
}

/*

2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44*/