#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>
#define f first
#define s second
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define sz(a) int(a.size())

using namespace std;

const int INF = 1e9 + 9;

struct ev {
    int x1, x2;
    int c;

    ev() {}

    ev(int x1, int x2, int c) : x1(x1), x2(x2), c(c) {}
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int m, n;
    cin >> m >> n;
    vector<int> st(n, INF), fn(n, -INF);
    vector<ev> evs1, evs2;
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        --x;
        st[x] = min(st[x], i);
        if (fn[x] != -INF) {
            evs1.eb(fn[x], i, x);
        }
        fn[x] = i;
    }
    for (int i = 0; i < n; ++i) {
        if (st[i] != INF) {
            evs2.eb(st[i], fn[i], i);
        }
    }
    sort(all(evs1), [](ev& a, ev& b) {
        return a.x1 < b.x1;
    });
    sort(all(evs2), [](ev& a, ev& b) {
        return a.x1 < b.x1;
    });
    int it = 0, last = -1;
    for (int i = 0; i < m; ++i) {
        if (it < sz(evs1) && evs1[it].x1 == i) {
            if (evs1[it].x1 >= last) {
                last = evs1[it].x2;
            }
            else if (evs1[it].x2 > last) {
                cout << -1;
                return 0;
            }
            ++it;
        }
    }
    cout << sz(evs2) << '\n';
    for (ev& x : evs2) {
        cout << x.c + 1 << ' ' << x.x1 + 1 << ' ' << x.x2 + 1 << '\n';
    }
    return 0;
}
