import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Deque;
import java.util.Scanner;

public class Main {
    public static void main(String[] arg) {
        new Main().run();
    }

    PrintWriter out;
    Scanner sc;
    int n;

    public void run() {
        out = new PrintWriter(System.out);
        sc = new Scanner(System.in);
        n = nextInt();
        solve();

        out.close();
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public String nextToken() {
        return sc.next();
    }

    public void solve() {

        int l = 1;
        int r = n + 1;

        while (l != r - 1) {
            int m = (l + r) / 2;
            System.out.println("? " + m);
            String s = nextToken();
            System.out.println("? " + m);
            String s2 = nextToken();
            if (!s.equals(s2)) {
                System.out.println("? " + m);
                s = nextToken();
            }
            if (s.equals("Yes")) {
                l = m;
            } else {
                r = m;
            }
        }
        System.out.println("! " + l);
        if (nextToken().equals("Correct")) {
            solve();
        }


//        int l = 1;
//        int r = n + 1;
//
//        boolean up = true;
//        while (l != r - 1) {
//            System.out.println("? " + (l + r) / 2);
//            if (nextToken().equals("Yes")) {
//                l = (l + r) / 2;
//                up = true;
//            } else {
//                r = (l + r) / 2;
//                up = false;
//            }
//        }
//
//
//
//        System.out.println("? " + l);
//        if (nextToken().equals("No")) {
//            System.out.println("? " + l);
//            if (nextToken().equals("Yes")) {
//                System.out.println("! " + l);
//                if (nextToken().equals("Correct")) {
//                    solve();
//                }
//                return;
//            }
//            l = 1;
//            r = l;
//        } else {
//            System.out.println("? " + (l + 1));
//            if (nextToken().equals("No")) {
//                System.out.println("? " + (l + 1));
//                if (nextToken().equals("No")) {
//                    System.out.println("! " + l);
//                    if (nextToken().equals("Correct")) {
//                        solve();
//                    }
//                    return;
//                }
//            } else {
//                System.out.println("? " + (l + 1));
//                if (nextToken().equals("No")) {
//                    System.out.println("! " + l);
//                    if (nextToken().equals("Correct")) {
//                        solve();
//                    }
//                    return;
//                }
//            }
//            l = l + 1;
//            r = n + 1;
//        }
//
//
//
//
//
//        while (l != r - 1) {
//            System.out.println("? " + (l + r) / 2);
//            if (nextToken().equals("Yes")) {
//                l = (l + r) / 2;
//                up = true;
//            } else {
//                r = (l + r) / 2;
//                up = false;
//            }
//        }
//
//        System.out.println("! " + l);
//        if (nextToken().equals("Correct")) {
//            solve();
//        }
    }
}