#include <iostream>
#include <cstring>
#include <vector>
#include <cmath>
#define int long long

using namespace std;

const int MAX_N = 5007;
vector <pair <int, int>> g[MAX_N];
bool poss[MAX_N][MAX_N];

void clear(int n) {
	for (int i = 1; i <= n; i++) {
		g[i].clear();
	}
	memset(poss, 0, sizeof(poss));
}

int calc(int x, int p) {
	long double t = (1.0 * p * x) / (p - 1);
	return floor(t);
}

signed main() {
	//freopen("Desktop/input.txt", "r", stdin);
	ios_base :: sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	for (int tt = 0; tt < t; tt++) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		clear(n);
		for (int i = 0; i < m; i++) {
			int v, u, t;
			cin >> v >> u >> t;
			g[u].push_back({v, t});
		}
		poss[1][0] = 1;
		for (int i = 1; i <= n; i++) {
			for (pair <int, int> elem : g[i]) {
				int u = elem.first, w = elem.second;
				for (int j = w; j <= 5000; j++) {
					if (poss[u][j - w]) poss[i][j] = 1;
				}
			}
		}
		for (int i = 0; i < q; i++) {
			int v, l;
			cin >> v >> l;
			int r = calc(l, p);
			bool flag = 0;
			for (int i = l; i <= r; i++) {
				if (poss[v][i]) {
					cout << "1";
					flag = 1;
					break;
				}
			}
			if (!flag) cout << "0";
		}
		cout << "\n";
	}
	return 0;
}
