#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

bool rec(int u, int f, ll dst, ll r, ll p, vector <vector <pair <int, ll>>> &g)
{
    if (u == f && r * (p - 1) <= dst * (p - 1) && dst * (p - 1) <= p * r)
        return 1;
    for (auto e : g[u])
        if (rec(e.first, f, dst + e.second, r, p, g))
            return 1;

    return 0;
}

int solve()
{
    ll n, m, q, p;
    cin >> n >> m >> q >> p;

    string ans;

    vector <vector <pair <int, ll>>> g(n + 1);

    for (int i = 0; i < m; i++)
    {
        int u, v, d;
        cin >> u >> v >> d;
        g[u].push_back({v, d});
    }

    for (int i = 0; i < q; i++)
    {
        ll f, r;
        cin >> f >> r;
        ans += (int)rec(1, f, 0, r, p, g) + '0';
    }

    cout << ans << "\n";
}

signed main()
{
#ifdef POSPELOV
    freopen("in", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}
