#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;
#define int long long
#define double long double
int n, m, q, p;
vector <vector <pair <int, int> > > g;

void read() {
	cin >> n >> m >> q >> p;
	g.assign(n, {});
	for (int i = 0; i < m; i++) {
		int v, u, d;
		cin >> v >> u >> d;
		v--;
		u--;
		g[v].push_back({ u, d });
	}
}

vector <set <int> > dp;

void dfs(int v, int t) {
	if (dp[v].find(t) != dp[v].end())
		return;
	dp[v].insert(t);
	for (auto i : g[v]) {
		dfs(i.first, t + i.second);
	}
}

bool check(int my_time, int r, int p) {
	double x = p;
	x /= p - 1;
	x *= r;
	return my_time >= r && ((double)my_time <= x);
}

string ans;

void run() {
	dp.assign(n, {});
	dfs(0, 0); 
	ans = "";
	for (int test = 0; test < q; test++) {
		int f, r;
		cin >> f >> r;
		f--;
		bool flag = false;
		for (auto i : dp[f]) {
			if (check(i, r, p)) {
				ans += "1";
				flag = true;
				break;
			}
		}
		if (!flag)
			ans += "0";
	}
}

void write() {
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	for (int test = 0; test < t; test++) {
		read();
		run();
		write();
	}
	return 0;
}