#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse3,ssse3,sse4,abm,mmx,avx,avx2,tune=native")
#include <bits/stdc++.h>
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define endl '\n'
using namespace std;
void solve();

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}




const int inf = (int) 1e9 + 7;


struct st{
    vector<int> t; int n;

    st(int _n){
        n = _n;
        t.resize(n * 2);
        forn (i, n) t[i + n] = -1;
        for (int i = n - 1; i > 0; --i) t[i] = min(t[i * 2], t[i * 2 + 1]);
    }

    int get(int l, int r){
        r++;
        int ans = inf;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1){
            if (l&1) ans = min(ans, t[l++]);
            if (r&1) ans = min(ans, t[--r]);
        }
        return ans;
    }


    void mod (int i, int val){
        for (i += n, t[i] = val; i > 1; i >>= 1) t[i >> 1] = min(t[i], t[i ^ 1]);
    }
};


const int maxn = (int) 1e6 + 7;
int rr[maxn], cc[maxn];

void solve(){
    int n, m, q; cin >> n >> m >> q;
    forn (i, n) rr[i] = -1; forn (i, m) cc[i] = -1;

    st rrst(n), ccst(m);

    int mxr = -1, mxc = -1;

    forn (timer, q){
        int t; cin >> t;
        if (t == 1){
            int r; cin >> r; r--; rr[r] = mxr = timer; rrst.mod(r, timer);

        }
        if (t == 2){
            int c; cin >> c; c--; cc[c] = mxc = timer; ccst.mod(c, timer);
        }
        if (t == 3){
            int r1, c1, r2, c2, k; cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; r2--; c1--; c2--; k = timer - k;
            if (r1 == r2 && c1 == c2){
                cout << 0 << endl;
                continue;
            }

            if (!((rr[r1] >= k || cc[c1] >= k) && (rr[r2] >= k || cc[c2] >= k))) {
                cout << -1 << endl;
                continue;
            }
            if ((r1 == r2 && rr[r1] >= k) || (c1 == c2 && cc[c1] >= k)){
                cout << (abs(r1 - r2) + abs(c1 - c2)) << endl;
                continue;
            }
            bool good = rrst.get(min(r1, r2), max(r1, r2)) >= k || ccst.get(min(c1, c2), max(c1, c2)) >= k;
            if (good){
                cout << (abs(r1 - r2) + abs(c1 - c2)) << endl;
                continue;
            }



            if (!(mxr >= k && mxc >= k)){
                cout << -1 << endl;
                continue;
            }
            if ((rr[r1] >= k && cc[c2] >= k) || (rr[r2] >= k && cc[c1] >= k)){
                cout << (abs(r1 - r2) + abs(c1 - c2)) << endl;
                continue;
            }
            if (rr[r1] >= k && rr[r2] >= k){
                int ans = abs(r1 - r2);
                int add = inf;
                forn (i, m){
                        add = min(add, (inf * (cc[i] < k)) + (c1 > i ? c1 - i : i - c1) + (c2 > i ? c2 - i : i - c2));
                }
                cout << ans  + add << endl;
                continue;
            }

            if (cc[c1] >= k && cc[c2] >= k){
                int ans = abs(c1 - c2);
                int add = inf;
                forn (i, n) {
                    add = min(add, inf * (rr[i] < k) + (r1 > i ? r1 - i : i - r1) + (r2 > i ? r2 - i : i - r2));
                }
                cout << ans + add << endl;
                continue;
            }
        }
    }
}