#include <bits/stdc++.h>
#define int long long
#define len(a) (int) (a).size()
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(a) (a).begin(), (a).end()
#define endl '\n'
using namespace std;
void solve();

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    forn (qwe, t) { solve(); cout << endl;}
}

struct edge{
    int to;
    int w;
};
vector<vector<int>> can;

int cur = 0;
void dfs(int v, vector<vector<edge>>& g){
    can[v].push_back(cur);
    for (auto u : g[v]){
        cur += u.w;
        dfs(u.to, g);
        cur -= u.w;
    }
}


void solve(){
    can.clear();
    int n, m, q, p; cin >> n >> m >> q >> p;
    can.resize(n);
    vector<vector<edge>> g(n);
    forn (qwe, m){
        int v, u, w; cin >> v >> u >> w; v--; u--;
        g[v].push_back({u, w});
    }
    dfs(0, g);
    forn (i, n) {sort(all(can[i]));}
    forn (qwe, q){
        int to; int leng; cin >> to >> leng; to--;
        auto it = lower_bound(all(can[to]), leng);
        if (it == can[to].end()){
            cout << 0;
        }
        else {
            int val = *it;
            cout << (val <= (p * leng) / (p - 1));
        }
    }
}