#include <bits/stdc++.h>

//#define int long long
#define pii pair<int, int>
#define endl "\n"

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double td;

const int INF = 1e9;
const ll P = 1e9 + 9;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}

void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<pii>& arr)
{
    for (auto i : arr)
        cout << i.first << " " << i.second << "   ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

bool make_res(vector <vector<int>>& res, vector<int>& pos, vector<int>& first, vector<int>& last, vector<int>& seq, int l, int r)
{
    if (l > r)
        return 1;
    bool flag = 1;
    int pt = l;
    vector <pii> next;
    while (pt <= r)
    {
        if (last[seq[pt]] > r)
            return 0;
        res.push_back({seq[pt] + 1, first[seq[pt]] + 1, last[seq[pt]] + 1});
        while (pos[pt] != -1)
        {
            next.push_back({pt + 1, pos[pt] - 1});
            pt = pos[pt];
        }
        ++pt;
    }
    for (auto i : next)
        flag = flag && make_res(res, pos, first, last, seq, i.first, i.second);
    return flag;
}

int main()
{
    hello();

    int m, n;
    cin >> m >> n;
    vector <int> seq(m);
    vector <int> used(n, -1);
    vector <int> pos(m);
    vector <int> first(n, -1), last(n, -1);
    for (int i = 0; i < m; ++i)
    {
        cin >> seq[i];
        --seq[i];
        if (first[seq[i]] == -1)
            first[seq[i]] = i;
        last[seq[i]] = i;
    }

    vector <vector<int>> res;
    for (int i = m - 1; i >= 0; --i)
    {
        pos[i] = used[seq[i]];
        used[seq[i]] = i;
    }

    bool flag = make_res(res, pos, first, last, seq, 0, m - 1);
    if (!flag)
    {
        cout << -1 << endl;
        return 0;
    }
    cout << res.size() << endl;
    show(res);
}
