#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

typedef long long  ll;
typedef long double    ld;
typedef pair <ll, ll> pll;

const ll kk=1000;
const ll ml=kk*kk;
const ll mod=ml*kk+7;
const long long inf=ml*ml*ml+7;
const long N=500*kk+10;
const long SN=kk+10;
const ld eps=1e-5;


ll i,j, n, m, q, p;
ll v;
long long l, r;
vector <ll> reb[SN];
vector <ll> w[N];
vector <ll> rreb[N];
vector <ll> rw[N];
set <pll> have[N];

long long all;
bitset <SN> use[SN];
long kol[SN][SN];

bool viv=false;

void add(ll v, pll pr)
{
if (viv)
  cout<<"Add "<<pr.F<<' '<<pr.S<<" to "<<v<<endl;

if (pr.S<0)
  return;
pr.F=max(pr.F, (ll)0);
have[v].insert(pr);
return;


bool cont=true;
while (cont)
  {
  auto z=have[v].lower_bound(pr);
  cont=false;
  if (z!=have[v].end()&&(*z).F<=pr.S)
    {
    cont=true;
    pr.S=max(pr.S, (*z).S);
    have[v].erase(z);
    }
  }
auto z=have[v].lower_bound(pr);
if (z!=have[v].begin())
  {
  z--;
  if ((*z).S>=pr.F)
    {
    pr.F=min(pr.F, (*z).F);
    have[v].erase(z);
    }
  }
have[v].insert(pr);

if (viv)
  {
  cout<<"and it have: ";
  for (auto i:have[v])
    cout<<i.F<<' '<<i.S<<"; ";
  cout<<endl;
  }
}

void get(ll v)
{
for (ll i=0; i<reb[v].size(); i++)
  {
  ll sos=reb[v][i];
  ll len=w[v][i];
  for (auto seg:have[sos])
    add(v, {seg.F-len, seg.S-len});
  }
}

bool check()
{
cin>>v;
v--;
cin>>l;
ld dr=((ld)l*(ld)p)/((ld)(p-1));
r=floor(dr);
if (abs(r+1-dr)<eps)
  r++;
if (viv)
  {
  cout<<"Ok, it will be "<<l<<' '<<r<<endl;
  }
for (ll i=0; i<n; i++)
  have[i].clear();
have[v].insert({l, r});
for (ll i=v-1; i>=0; i--)
  get(i);

if (viv)
  for (ll i=0; i<n; i++)
    {
    cout<<"     "<<i<<": ";
    for (auto p:have[i])
      cout<<p.F<<' '<<p.S<<"; ";
    cout<<endl;
    }
if (have[0].size()&&(*have[0].begin()).F<=0)
  return true;
return false;
}

void solve()
{
cin>>n>>m>>q>>p;
for (ll i=0; i<n; i++)
  {
  reb[i].clear();
  w[i].clear();
  rreb[i].clear();
  rw[i].clear();
  }
for (ll i=0; i<m; i++)
  {
  ll a, b, c;
  cin>>a>>b>>c;
  a--, b--;
  reb[a].push_back(b);
//  rreb[b].push_back(a);
  w[a].push_back(c);
//  rw[b].push_back(c);
  }
string ans;
for (ll u=0; u<q; u++)
  if (check())
    ans+='1';
  else
    ans+='0';
cout<<ans<<'\n';
}

void build()
{
for (ll i=0; i<n+10; i++)
  for (ll j=0; j<n+10; j++)
    use[i][j]=0;
use[0][0]=1;
for (long i=0; i<n; i++)
  for (long sos:reb[i])
    use[sos]|=(use[i]<<1);

if (viv)
  for (ll i=0; i<n; i++)
    {
    cout<<"V"<<i<<": ";
    for (ll kol=0; kol<n; kol++)
      cout<<use[i][kol]<<' ';
    cout<<endl;
    }
for (ll i=0; i<n; i++)
  for (ll j=0; j<n+9; j++)
    kol[i][j+1]=kol[i][j], kol[i][j+1]+=use[i][j];
}

bool check_same()
{
cin>>v;
v--;
cin>>l;
ld dr=((ld)l*(ld)p)/((ld)(p-1));
r=floor(dr);
//if (abs(r+1-dr)<eps)
//  r++;
r=r/all;
l=(l+all-1)/all;
if (l>=n)
  return false;
if (viv)
  {
  cout<<"Ok, it will be "<<l<<' '<<r<<endl;
  cout<<"V"<<v<<": ";
  for (ll i=0; i<n+3; i++)
    cout<<kol[v][i]<<' ';
  cout<<endl;
  }

r++;
r=min(r, (long long)n+2);
ll vars=0;
vars+=kol[v][r];
vars-=kol[v][l];
return (vars>0);
}

void same()
{
cin>>n>>m>>q>>p;
for (ll i=0; i<n; i++)
  reb[i].clear();

for (ll i=0; i<m; i++)
  {
  ll a, b;
  long long c;
  cin>>a>>b>>c;
  a--, b--;
  reb[a].push_back(b);
  all=c;
  }
build();
string ans;
for (ll u=0; u<q; u++)
  if (check_same())
    ans+='1';
  else
    ans+='0';
cout<<ans<<'\n';
}


int main()
{
//viv=true;
ll t;
cin>>t;
while (t)
  same(), t--;
//while (t)
//  solve(), t--;






    return 0;
}
/**
2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44

1
4 6 5 2
1 2 1
2 3 1
3 4 1
1 2 70
2 3 120
3 4 4
4 90
4 2
4 10
4 37
2 34

3
6 8 5 20
1 2 1
1 3 1
1 6 1
2 3 1
2 4 1
3 5 1
5 6 1
5 6 1
2 1
3 1
4 1
5 1
6 1
6 8 5 2
1 2 1
1 3 1
1 6 1
2 3 1
2 4 1
3 5 1
5 6 1
5 6 1
2 1
3 1
4 1
5 1
6 1
6 8 5 20
1 2 1
1 3 1
1 6 1
2 3 1
2 4 1
3 5 1
5 6 1
5 6 1
2 1
3 1
4 1
5 1
6 1





**/

