#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 5e5 + 10;

vector<pair<int, int64_t>> edges[MAX_N];
vector<int64_t> possible[MAX_N];

void dfs(int u, int64_t t) {
	possible[u].push_back(t);
	for (auto p : edges[u])
		dfs(p.first, t + p.second);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tests;
	cin >> tests;
	for (int test = 0; test < tests; ++test) {
		int n, m, q, p, u, v, f;
		int64_t d, r;
		cin >> n >> m >> q >> p;
		for (int i = 0; i < n; ++i)
			edges[i].clear();
		for (int i = 0; i < n; ++i)
			possible[i].clear();
		for (int i = 0; i < m; ++i) {
			cin >> u >> v >> d;
			edges[--u].push_back({--v, d});
		}
		dfs(0, 0);
		for (int query = 0; query < q; ++query) {
			cin >> f >> r;
			--f;
			bool found = 0;
			for (int64_t x : possible[f])
				if (r <= x && x * (p - 1) <= r * p)
					found = 1;
			if (!found)
				cout << "0";
			else
				cout << "1";
		}
		cout << "\n";
	}
	return 0;
}