#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 1e3 + 10;

vector<pair<int64_t, int64_t>> okRs[MAX_N];
vector<pair<int, int64_t>> edges[MAX_N];
vector<pair<int, int64_t>> iedges[MAX_N];

int64_t ceil(int64_t a, int64_t b) {
	return (a + b - 1) / b;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tests;
	cin >> tests;
	for (int test = 0; test < tests; ++test) {
		int n, m, q, p, u, v, f;
		int64_t d, r;
		cin >> n >> m >> q >> p;
		for (int i = 0; i < n; ++i)
			edges[i].clear(),
			iedges[i].clear(),
			okRs[i].clear();
		for (int i = 0; i < m; ++i) {
			cin >> u >> v >> d;
			edges[--u].push_back({--v, d});
			iedges[v].push_back({u, d});
		}
		okRs[0].push_back({0, 0});
		for (int i = 1; i < n; ++i) {
			for (auto e : iedges[i]) {
				for (auto pq : okRs[e.first])
					okRs[i].push_back({ceil((pq.second + e.second) * (p - 1), p), pq.second + e.second});
			}
			sort(okRs[i].begin(), okRs[i].end());
		}/*
		for (int i = 0; i < n; ++i) {
			for (auto p : okRs[i])
				cout << p.first << " " << p.second << "|";
			cout << "\n";
		}*/
		for (int query = 0; query < q; ++query) {
			cin >> f >> r;
			--f;
			bool found = 0;
			for (auto pq : okRs[f]) {
				if (pq.first <= r && r <= pq.second)
					found = 1;
			}
			if (!found)
				cout << "0";
			else
				cout << "1";
		}
		cout << "\n";
	}
	return 0;
}