import java.util.Scanner;
import java.util.TreeSet;

import static java.lang.Math.*;

public class B {

    static int r = 4000_005;

    static int[] trl = new int[r];
    static int[] trs = new int[r];

    static void upl(int l, int r, int u, int tek, int x) {
        if (l > u || r < u) return;
        if (l <= u && r >= u) {
            trl[tek] = max(trl[tek], x);
        }
        if (l == r) return;
        int m = (l + r) / 2;
        upl(l, m, u, tek * 2, x);
        upl(m + 1, r, u, tek * 2 + 1, x);
    }

    static void ups(int l, int r, int u, int tek, int x) {
        if (l > u || r < u) return;
        if (l <= u && r >= u) {
            trs[tek] = max(trs[tek], x);
        }
        if (l == r) return;
        int m = (l + r) / 2;
        ups(l, m, u, tek * 2, x);
        ups(m + 1, r, u, tek * 2 + 1, x);
    }

    static int mnl(int l, int r, int x, int y, int tek) {
        if (r < x || l > y) return 0;
        if (l >= x && r <= y) return trl[tek];
        if (l == r) return 0;
        int m = (l + r) >> 1;
        return min(mnl(l, m, x, y, tek * 2), mnl(m + 1, r, x, y, tek * 2 + 1));
    }

    static int mns(int l, int r, int x, int y, int tek) {
        if (r < x || l > y) return 0;
        if (l >= x && r <= y) return trs[tek];
        if (l == r) return 0;
        int m = (l + r) >> 1;
        return min(mns(l, m, x, y, tek * 2), mns(m + 1, r, x, y, tek * 2 + 1));
    }

    static int fnlpr(int l, int r, int x, int y, int tek, int pr) {
        if (trl[tek] < pr) return -1;
        if (r == l) return l;
        int m = (l + r) >> 1;
        if (m + 1 > y) {
            return fnlpr(l, m, x, y, tek * 2, pr);
        } else {
            int ans = fnlpr(m + 1, r, x, y, tek * 2 + 1, pr);
            if (ans != -1) return ans;
            else {
                return fnlpr(l, m, x, y, tek * 2, pr);
            }
        }
    }

    static int fnllr(int l, int r, int x, int y, int tek, int pr) {
        if (trl[tek] < pr) return -1;
        if (r == l) return l;
        int m = (l + r) >> 1;
        if (m < x) {
            return fnllr(m + 1, r, x, y, tek * 2 + 1, pr);
        } else {
            int ans = fnllr(l, m, x, y, tek * 2, pr);
            if (ans != -1) return ans;
            else {
                return fnllr(m + 1, r, x, y, tek * 2 + 1, pr);
            }
        }
    }

    static int fnspr(int l, int r, int x, int y, int tek, int pr) {
        if (trs[tek] < pr) return -1;
        if (r == l) return l;
        int m = (l + r) >> 1;
        if (m + 1 > y) {
            return fnspr(l, m, x, y, tek * 2, pr);
        } else {
            int ans = fnspr(m + 1, r, x, y, tek * 2 + 1, pr);
            if (ans != -1) return ans;
            else {
                return fnspr(l, m, x, y, tek * 2, pr);
            }
        }
    }

    static int fnslr(int l, int r, int x, int y, int tek, int pr) {
        if (trs[tek] < pr) return -1;
        if (r == l) return l;
        int m = (l + r) >> 1;
        if (m < x) {
            return fnslr(m + 1, r, x, y, tek * 2 + 1, pr);
        } else {
            int ans = fnslr(l, m, x, y, tek * 2, pr);
            if (ans != -1) return ans;
            else {
                return fnslr(m + 1, r, x, y, tek * 2 + 1, pr);
            }
        }
    }


    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int m = in.nextInt();
        int q = in.nextInt();
        int line[] = new int[n];
        int stol[] = new int[m];

        for (int i = 0; i < q; i++) {
            int x = in.nextInt();
            if (x == 1) {
                int tek = in.nextInt() - 1;
                line[tek] = i + 1;
                upl(0, n - 1, tek, 1, i + 1);
            } else if (x == 2) {
                int tek = in.nextInt() - 1;
                stol[tek] = i + 1;
                ups(0, m - 1, tek, 1, i + 1);
            } else {
                int x1 = in.nextInt() - 1;
                int y1 = in.nextInt() - 1;
                int x2 = in.nextInt() - 1;
                int y2 = in.nextInt() - 1;
                if (x1 > x2) {
                    int s = x1;
                    x1 = x2;
                    x2 = s;
                }
                if (y1 > y2) {
                    int s = y1;
                    y1 = y2;
                    y2 = s;
                }
                int k = -in.nextInt() + i + 1;
                int ans = -1;
                int d = abs(x1 - x2) + abs(y1 - y2);
                if (mnl(0, n - 1, x1, x2, 1) >= k || mns(0, m - 1, y1, y2, 1) >= k) ans = d;
                else {
                    int a1 = 0;
                    int a2 = 0;
                    int b1 = 0;
                    int b2 = 0;
                    if (line[x1] >= k) a1++;
                    if (line[x2] >= k) a2++;

                    if (stol[y1] >= k) b1++;
                    if (stol[y2] >= k) b2++;
                    if ((a1 > 0 && b2 > 0) || (a2 > 0 && b1 > 0)) ans = d;
                    if (a1 + a2 == 2) {
                        int uk1 = fnspr(0, m - 1, 0, y1, 1, k);
                        int uk2 = fnslr(0, m - 1, y1, m - 1, 1, k);
                        if (uk1 != -1) {
                            ans = x2 - x1 + y1 - uk1 + y2 - uk1;
                        }
                        if (uk2 != -1) {
                            ans = max(ans, x2 - x1 + uk2 - y1 + abs(uk2 - y2));
                        }
                    } else if (b1 + b2 == 2) {


                        int uk1 = fnlpr(0, n - 1, 0, x1, 1, k);
                        int uk2 = fnllr(0, n - 1, x1, n - 1, 1, k);
                        if (uk1 != -1) {
                            ans = y2 - y1 + x1 - uk1 + x2 - uk1;
                        }
                        if (uk2 != -1) {
                            ans = max(ans, y2 - y1 + uk2 - x1 + abs(uk2 - x2));
                        }
                    }
                }
                System.out.println(ans);
            }
        }
    }

}
