#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <map>
#include <set>

using namespace std;

void re() {
	system("pause");
	exit(0);
}
#define re re();

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

vector <int> r, c;
int n, m;
int t = 0;
int chmax = 4;
struct node {
	int dist;
	int x, y;
	int v; // 0 - up, 1 - down, 2 - left, 3 - right
	int change = 0;
	int hash() {
		return (x * m + y) * 4 + v;
	}
};

int bfs(int x1, int y1, int x2, int y2, int k) {
	if (t - max(r[x2], c[y2]) > k)
		return -1;
	if (t - max(r[x1], c[y1]) > k)
		return -1;
	queue<node > q;
	map<int, int> used;
	q.push({ 0, x1, y1, 0 });
	used[q.front().hash()] = 1;
	q.push({ 0, x1, y1, 1 });
	used[q.back().hash()] = 1;
	q.push({ 0, x1, y1, 2 });
	used[q.back().hash()] = 1;
	q.push({ 0, x1, y1, 3 });
	used[q.back().hash()] = 1;
	while (q.size()) {
		int d = q.front().dist;
		int x = q.front().x;
		int y = q.front().y;
		int v = q.front().v;
		int change = q.front().change;
		q.pop();
		if (x == x2 && y == y2)
			return d;
		if (x > 0 && used.find(node({ d + 1, x - 1, y, 0, change + int(v != 0) }).hash()) == used.end() && t - max(r[x - 1], c[y]) <= k && change + int(v != 0) <= chmax) {
			q.push({ d + 1, x - 1, y, 0, change + int(v != 0)});
			used[q.back().hash()] = 1;
		}
		if (x < n - 1 && used.find(node({ d + 1, x + 1, y, 1,  change + int(v != 1) }).hash()) == used.end() && t - max(r[x + 1], c[y]) <= k && change + int(v != 1) <= chmax) {
			q.push({ d + 1, x + 1, y, 1,  change + int(v != 1) });
			used[q.back().hash()] = 1;
		}
		if (y > 0 && used.find(node({ d + 1, x, y - 1, 2, change + int(v != 2) }).hash()) == used.end() && t - max(r[x], c[y - 1]) <= k && change + int(v != 2) <= chmax) {
			q.push({ d + 1, x, y - 1, 2, change + int(v != 2) });
			used[q.back().hash()] = 1;
		}
		if (y < m - 1 && used.find(node({ d + 1, x, y + 1 , 3, change + int(v != 3) }).hash()) == used.end() && t - max(r[x], c[y + 1]) <= k && change + int(v != 3) <= chmax) {
			q.push({ d + 1, x, y + 1 , 3, change + int(v != 3) });
			used[q.back().hash()] = 1;
		}
	}
	return -1;
}

int main() {
	int q;
	cin >> n >> m >> q;
	r.resize(n);
	c.resize(m);
	for (t = 1; t <= q; t++) {
		int type;
		cin >> type;
		if (type == 1) {
			int x;
			cin >> x;
			r[x - 1] = t;
		}
		if (type == 2) {
			int x;
			cin >> x;
			c[x - 1] = t;
		}
		if (type == 3) {
			int x1, x2, y1, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--, y1--, x2--, y2--;
			cout << bfs(x1, y1, x2, y2, k) << '\n';
		}
	}
	re
}