#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 5e5 + 5;

vector <pair <int, ll> > ein[maxn];
vector <ll> dop[maxn];

void source() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    for (int i = 0; i < m; i++) {
        int v, u;
        ll w;
        cin >> v >> u >> w;
        ein[u].push_back({v, w});
    }
    dop[1].push_back(0);
    for (int v = 2; v <= n; v++) {
        dop[v].clear();
        for (pair <int, ll> t : ein[v]) {
            int u = t.first;
            for (ll x : dop[u]) {
                dop[v].push_back(x + t.second);
            }
        }
    }
    for (int i = 0; i < q; i++) {
        int f;
        ll r;
        cin >> f >> r;
        bool got = false;
        for (ll x : dop[f]) {
            if (x >= r && x * (p - 1) <= p * r) {
                got = true;
            }
        }
        cout << got;
    }
    cout << "\n";
    for (int i = 1; i <= n; i++)
        ein[i].clear();
    for (int i = 1; i <= n; i++)
        dop[i].clear();
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int t;
    cin >> t;
    for (int tnum = 0; tnum < t; tnum++) {
        source();
    }
    return 0;
}
