#include <bits/stdc++.h>

#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < x; i++)
#define rforn(i, x) for (int i = x - 1; i >= 0; i--)

using namespace std;

template<typename T> void print(T a)
{
    for (auto x : a)
        cout << x << ' ';
    cout << endl;
}

const int INF = 1e9 + 9;

vector<int> t1, t2;

void build1(int v, int tl, int tr)
{
    if (tl == tr)
    {
        t1[v] = 0;
    }
    else
    {
        int tm = (tl + tr) / 2;
        build1(v * 2 + 1, tl, tm);
        build1(v * 2 + 2, tm + 1, tr);
        t1[v] = min(t1[v * 2 + 1], t1[v * 2 + 2]);
    }
}

void build2(int v, int tl, int tr)
{
    if (tl == tr)
    {
        t2[v] = 0;
    }
    else
    {
        int tm = (tl + tr) / 2;
        build2(v * 2 + 1, tl, tm);
        build2(v * 2 + 2, tm + 1, tr);
        t2[v] = min(t2[v * 2 + 1], t2[v * 2 + 2]);
    }
}

void update1(int v, int tl, int tr, int pos, int x)
{
    if (tl == tr)
        t1[v] = x;
    else
    {
        int tm = (tl + tr) / 2;

        if (pos <= tm)
            update1(v * 2 + 1, tl, tm, pos, x);
        else
            update1(v * 2 + 2, tm + 1, tr, pos, x);
        t1[v] = min(t1[v * 2 + 1], t1[v * 2 + 2]);
    }
}

void update2(int v, int tl, int tr, int pos, int x)
{
    if (tl == tr)
        t2[v] = x;
    else
    {
        int tm = (tl + tr) / 2;

        if (pos <= tm)
            update2(v * 2 + 1, tl, tm, pos, x);
        else
            update2(v * 2 + 2, tm + 1, tr, pos, x);
        t2[v] = min(t2[v * 2 + 1], t2[v * 2 + 2]);
    }
}

int get1(int v, int tl, int tr, int l, int r)
{
    if (l > r)
        return INF;
    if (tl == l && tr == r)
        return t1[v];

    int tm = (tl + tr) / 2;
    int p1 = get1(v * 2 + 1, tl, tm, l, min(tm, r));
    int p2 = get1(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r);
    return min(p1, p2);
}

int get2(int v, int tl, int tr, int l, int r)
{
    if (l > r)
        return INF;
    if (tl == l && tr == r)
        return t2[v];

    int tm = (tl + tr) / 2;
    int p1 = get2(v * 2 + 1, tl, tm, l, min(tm, r));
    int p2 = get2(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r);
    return min(p1, p2);
}

vector<int> t3, t4;

void build3(int v, int tl, int tr)
{
    if (tl == tr)
    {
        t3[v] = 0;
    }
    else
    {
        int tm = (tl + tr) / 2;
        build3(v * 2 + 1, tl, tm);
        build3(v * 2 + 2, tm + 1, tr);
        t3[v] = max(t3[v * 2 + 1], t3[v * 2 + 2]);
    }
}

void build4(int v, int tl, int tr)
{
    if (tl == tr)
    {
        t4[v] = 0;
    }
    else
    {
        int tm = (tl + tr) / 2;
        build4(v * 2 + 1, tl, tm);
        build4(v * 2 + 2, tm + 1, tr);
        t4[v] = max(t4[v * 2 + 1], t4[v * 2 + 2]);
    }
}

void update3(int v, int tl, int tr, int pos, int x)
{
    if (tl == tr)
        t3[v] = x;
    else
    {
        int tm = (tl + tr) / 2;

        if (pos <= tm)
            update3(v * 2 + 1, tl, tm, pos, x);
        else
            update3(v * 2 + 2, tm + 1, tr, pos, x);
        t3[v] = max(t3[v * 2 + 1], t3[v * 2 + 2]);
    }
}

void update4(int v, int tl, int tr, int pos, int x)
{
    if (tl == tr)
        t4[v] = x;
    else
    {
        int tm = (tl + tr) / 2;

        if (pos <= tm)
            update4(v * 2 + 1, tl, tm, pos, x);
        else
            update4(v * 2 + 2, tm + 1, tr, pos, x);
        t4[v] = max(t4[v * 2 + 1], t4[v * 2 + 2]);
    }
}

int get3(int v, int tl, int tr, int l, int r)
{
    if (l > r)
        return -INF;
    if (tl == l && tr == r)
        return t3[v];

    int tm = (tl + tr) / 2;
    int p1 = get3(v * 2 + 1, tl, tm, l, min(tm, r));
    int p2 = get3(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r);
    return max(p1, p2);
}

int get4(int v, int tl, int tr, int l, int r)
{
    if (l > r)
        return -INF;
    if (tl == l && tr == r)
        return t4[v];

    int tm = (tl + tr) / 2;
    int p1 = get4(v * 2 + 1, tl, tm, l, min(tm, r));
    int p2 = get4(v * 2 + 2, tm + 1, tr, max(tm + 1, l), r);
    return max(p1, p2);
}

signed main()
{
    //freopen("test.txt", "r", stdin);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    vector<int> a(n), b(m);

    vector<vector<int> > query;
    forn (i, q)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int r;
            cin >> r;
            r--;
            query.pb({t, r});
        }
        else if (t == 2)
        {
            int c;
            cin >> c;
            c--;
            query.pb({t, c});
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; c1--; r2--; c2--;
            query.pb({t, r1, c1, r2, c2, k});
        }
    }

    vector<int> rows(n, 0);
    vector<int> cols(m, 0);
    int delta = 0;

    t1.resize(4 * n);
    t2.resize(4 * m);
    t3.assign(4 * n, -INF);
    t4.assign(4 * m, -INF);

    build1(0, 0, n - 1);
    build2(0, 0, m - 1);
    build3(0, 0, n - 1);
    build4(0, 0, m - 1);

    forn (z, q)
    {
        delta++;

        if (query[z][0] == 1)
        {
            int r = query[z][1];
            update1(0, 0, n - 1, r, -delta);
            update3(0, 0, n - 1, r, -delta);
            continue;
        }
        else if (query[z][0] == 2)
        {
            int c = query[z][1];
            update2(0, 0, m - 1, c, -delta);
            update4(0, 0, m - 1, c, -delta);
            continue;
        }
        int r1 = query[z][1], c1 = query[z][2], r2 = query[z][3], c2 = query[z][4], k = query[z][5];

        if (delta <= k)
        {
            cout << (abs(r1 - r2) + abs(c1 - c2)) << '\n';
            continue;
        }

        if (get1(0, 0, n - 1, r1, r1) + delta <= k && get2(0, 0, m - 1, c2, c2) + delta <= k)
        {
            cout << (abs(r1 - r2) + abs(c1 - c2)) << '\n';
            continue;
        }

        if (get2(0, 0, m - 1, c1, c1) + delta <= k && get1(0, 0, n - 1, r2, r2) + delta <= k)
        {
            cout << (abs(r1 - r2) + abs(c1 - c2)) << '\n';
            continue;
        }

        if (get4(0, 0, m - 1, min(c1, c2), max(c1, c2)) + delta <= k)
        {
            cout << abs(c1 - c2) + abs(r1 - r2) << '\n';
            continue;
        }

        if (get3(0, 0, n - 1, min(r1, r2), max(r1, r2)) + delta <= k)
        {
            cout << abs(c1 - c2) + abs(r1 - r2) << '\n';
            continue;
        }

        int ans = INF;

        if (get1(0, 0, n - 1, r1, r1) + delta <= k && get1(0, 0, n - 1, r2, r2) + delta <= k)
        {
            int l = 0, r = min(c1, c2);
            while (l < r - 1)
            {
                int mid = (l + r) / 2;
                int val = get2(0, 0, m - 1, mid, min(c1, c2) - 1);
                if (val + delta <= k)
                    l = mid;
                else
                    r = mid;
            }
            if (get2(0, 0, m - 1, l, min(c1, c2) - 1) + delta <= k)
                ans = min(abs(c1 - l) + abs(c2 - l) + abs(r1 - r2), ans);

            l = min(c1, c2);
            r = m - 1;
            while (l < r - 1)
            {
                int mid = (l + r) / 2;
                int val = get2(0, 0, m - 1, min(c1, c2), mid);
                if (val + delta <= k)
                    r = mid;
                else
                    l = mid;
            }
            if (get2(0, 0, m - 1, min(c1, c2), r) + delta <= k)
                ans = min(abs(r1 - r) + abs(r2 - r) + abs(r1 - r2), ans);
            if (get2(0, 0, m - 1, min(c1, c2), l) + delta <= k)
                ans = min(abs(r1 - l) + abs(r2 - l) + abs(r1 - r2), ans);
        }

        if (get2(0, 0, m - 1, c1, c1) + delta <= k && get2(0, 0, m - 1, c2, c2) + delta <= k)
        {
            int l = 0, r = min(r1, r2);
            while (l < r - 1)
            {
                int mid = (l + r) / 2;
                int val = get1(0, 0, n - 1, mid, min(r1, r2) - 1);
                if (val + delta <= k)
                    l = mid;
                else
                    r =  mid;
            }
            if (get1(0, 0, n - 1, l, min(r1, r2) - 1) + delta <= k)
                ans = min(abs(r1 - l) + abs(r2 - l) + abs(c1 - c2), ans);

            l = min(r2, r1) - 1;
            r = n - 1;
            while (l < r - 1)
            {
                int mid = (l + r) / 2;
                int val = get1(0, 0, n - 1, min(r1, r2), mid);
                if (val + delta <= k)
                    r = mid;
                else
                    l = mid;
            }
            if (get1(0, 0, n - 1, min(r1, r2), r) + delta <= k)
                ans = min(abs(r1 - r) + abs(r2 - r) + abs(c1 - c2), ans);
        }

        if (ans == INF)
            cout << -1 << endl;
        else
            cout << ans << endl;
    }

    return 0;
}
