#include <bits/stdc++.h>

#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < x; i++)
#define rforn(i, x) for (int i = x - 1; i >= 0; i--)

using namespace std;

template<typename T> void print(T a)
{
    for (auto x : a)
        cout << x << ' ';
    cout << endl;
}

const int INF = 1e9 + 9;

signed main()
{
    //freopen("test.txt", "r", stdin);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    vector<int> a(n), b(m);

    vector<vector<int> > query;
    forn (i, q)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            int r;
            cin >> r;
            r--;
            query.pb({t, r});
        }
        else if (t == 2)
        {
            int c;
            cin >> c;
            c--;
            query.pb({t, c});
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--; c1--; r2--; c2--;
            query.pb({t, r1, c1, r2, c2, k});
        }
    }

    vector<int> rows(n, 0);
    vector<int> cols(m, 0);
    int delta = 0;

    forn (z, q)
    {
        delta++;

        forn (i, n)
            rows[i]++;
        forn (i, m)
            cols[i]++;

        if (query[z][0] == 1)
        {
            int r = query[z][1];
            rows[r] = 0;
            continue;
        }
        else if (query[z][0] == 2)
        {
            int c = query[z][1];
            cols[c] = 0;
            continue;
        }
        int r1 = query[z][1], c1 = query[z][2], r2 = query[z][3], c2 = query[z][4], k = query[z][5];
        //cout << r1 << ' ' << c1 << ' ' << r2 << ' ' << c2 << ' ' << k << endl;
        //cout << delta << endl;

        if (delta <= k)
        {
            cout << (abs(r1 - r2) + abs(c1 - c2)) << '\n';
            continue;
        }

        if (rows[r1] <= k && cols[c2] <= k)
        {
            cout << (abs(r1 - r2) + abs(c1 - c2)) << '\n';
            continue;
        }

        if (cols[c1] <= k && rows[r2] <= k)
        {
            cout << (abs(r1 - r2) + abs(c1 - c2)) << '\n';
            continue;
        }

        bool ok = true;
        for (int id = min(c1, c2); id <= max(c1, c2); id++)
            if (cols[id] > k)
                ok = false;
        if (ok)
        {
            cout << abs(c1 - c2) + abs(r1 - r2) << '\n';
            continue;
        }

        ok = true;
        for (int id = min(r1, r2); id <= max(r1, r2); id++)
            if (rows[id] > k)
                ok = false;
        if (ok)
        {
            cout << abs(c1 - c2) + abs(r1 - r2) << '\n';
            continue;
        }

        //cout << "kek" << endl;

        int ans = INF;

        if (rows[r1] <= k && rows[r2] <= k)
        {
            //cout << "sas" << endl;
            for (int id = min(c2, c1) - 1; id >= 0; id--)
            {
                if (cols[id] <= k)
                {
                    ans = min(abs(c1 - id) + abs(c2 - id) + abs(r1 - r2), ans);
                    break;
                }
            }

            for (int id = max(c2, c1); id >= min(c2, c1); id--)
            {
                if (cols[id] <= k)
                {
                    ans = min(abs(c2 - id) + abs(c1 - id) + abs(r1 - r2), ans);
                    break;
                }
            }

            for (int id = max(c2, c1) + 1; id < m; id++)
            {
                if (cols[id] <= k)
                {
                    ans = min(abs(c1 - id) + abs(c2 - id) + abs(r1 - r2), ans);
                    break;
                }
            }/*

            for (int id = 0; id < m; id++)
            {
                if (cols[id] <= k)
                {
                    ans = min(abs(c1 - id) + abs(c2 - id) + abs(r1 - r2), ans);
                    break;
                }
            }*/
        }

        if (cols[c1] <= k && cols[c2] <= k)
        {
            //cout << "sas" << endl;

            for (int id = min(r2, r1) - 1; id >= 0; id--)
            {
                if (rows[id] <= k)
                {
                    ans = min(abs(r1 - id) + abs(r2 - id) + abs(c1 - c2), ans);
                    break;
                }
            }

            for (int id = max(r2, r1); id >= min(r2, r1); id--)
            {
                if (rows[id] <= k)
                {
                    ans = min(abs(r2 - id) + abs(r1 - id) + abs(c1 - c2), ans);
                    break;
                }
            }

            for (int id = max(r2, r1) + 1; id < n; id++)
            {
                if (rows[id] <= k)
                {
                    ans = min(abs(r1 - id) + abs(r2 - id) + abs(c1 - c2), ans);
                    break;
                }
            }
        }

        if (ans == INF)
            cout << -1 << endl;
        else
            cout << ans << endl;
    }

    return 0;
}
