#include <bits/stdc++.h>
using namespace std;
struct otr{
    int left;
    int right;
    int color;
    otr(){
        left = -1;
        right = -2;
    }
};
bool cmp(otr a, otr b){
    return (a.right - a.left > b.right - b.left);
}
int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int m, n;
  cin >> m >> n;
  int arr[m];
  for (int i = 0; i < m; i++){
    cin >> arr[i];
  }
  bool used[n];
  int right[n];
  int left[n];
  for (int i = 0; i < n; i++){
    left[i] = right[i] = -1;
    used[i] = 0;
  }
  for (int i = 0; i < m; i++){
    int c = arr[i] - 1;
    if (used[c]){
      right[c] = i;
    }
    else {
      left[c] = i;
      used[c] = true;
    }
  }
  vector <otr> all;
  for (int i = 0; i < n; i++){
    if (used[i]){
        otr newotr;
        newotr.left = left[i];
        newotr.right = right[i];
        if (right[i] == -1)
            newotr.right = newotr.left;
        newotr.color = i;
        all.push_back(newotr);
    }
  }
  sort(all.begin(), all.end(), cmp);
  int newarr[m];
  for (int i = 0; i < m; i++){
    newarr[m] = -1;
  }
  for (int i = 0; i < all.size(); i++){
    int leftx = all[i].left;
    int rightx = all[i].right;
    for (int j = leftx; j <= rightx; j++){
        newarr[j] = all[i].color + 1;
    }
  }
  for (int i = 0; i < m; i++){
    if (newarr[i] != arr[i]){
        cout << -1;
        return 0;
    }
  }
  cout << all.size() << endl;
  for (int i = 0; i < all.size(); i++){
    cout << all[i].left + 1 << ' ' << all[i].right + 1 << ' ' << all[i].color + 1 << endl;
  }
}
