#include <bits/stdc++.h>
using namespace std;
struct otr{
    int left;
    int right;
    int color;
    otr(){
        left = -1;
        right = -2;
    }
};
bool cmp(otr a, otr b){
    return (a.right - a.left > b.right - b.left);
}
int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int m, n;
  cin >> m >> n;
  int arr[m];
  for (int i = 0; i < m; i++){
    cin >> arr[i];
  }
  bool used[n];
  int right[n];
  int left[n];
  vector <vector <int> > uk(n);
  for (int i = 0; i < n; i++){
    left[i] = right[i] = -1;
    used[i] = 0;
  }
  for (int i = 0; i < m; i++){
    int c = arr[i] - 1;
    if (used[c]){
      right[c] = i;
    }
    else {
      left[c] = i;
      used[c] = true;
    }
    uk[c].push_back(i);
  }
  vector <otr> all;
  for (int i = 0; i < n; i++){
    if (used[i]){
        otr newotr;
        newotr.left = left[i];
        newotr.right = right[i];
        if (right[i] == -1)
            newotr.right = newotr.left;
        newotr.color = i;
        all.push_back(newotr);
    }
  }
  sort(all.begin(), all.end(), cmp);
  bool fail = false;
    for (int i = 0; i < n; i++){
        for (int j = 0; !uk[i].empty() && j < uk[i].size() - 1; j++){
            int leftx = uk[i][j];
            int rightx = uk[i][j + 1];
            if (leftx + 1 == rightx)
                continue;
            int leftcolor = arr[leftx + 1] - 1;
            int rightcolor = arr[rightx - 1] - 1;
            if (left[leftcolor] >= leftx && right[leftcolor] <= rightx && left[rightcolor] >= leftx && right[rightcolor] <= rightx){
                continue;
            }
            else{
                fail = true;
            }
        }
    }
  if (fail){
    cout << -1;
    return 0;
  }
  cout << all.size() << endl;
  for (int i = 0; i < all.size(); i++){
    cout << all[i].color + 1 << ' ' << all[i].left + 1 << ' ' << all[i].right + 1 << ' ' << endl;
  }
}
