#include <bits/stdc++.h>
using namespace std;
const int INF = 999999999;
int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  vector <int> ans;
  int n, m, q;
  cin >> n >> m >> q;
  int pole[n][m];
  for (int i = 0; i < n; i++){
    for (int j = 0; j < m; j++){
        pole[i][j] = 0;
    }
  }
  while (q-- > 0){
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            pole[i][j]++;
        }
    }
    int w;
    cin >> w;
    if (w == 1){
      int stroke;
      cin >> stroke;
      stroke--;
      for (int i = 0; i < m; i++){
        pole[stroke][i] = 0;
      }
    }
    else if (w == 2){
      int column;
      cin >> column;
      column--;
      for (int i = 0; i < n; i++){
        pole[i][column] = 0;
      }
    }
    else if (w == 3){
      int x1, x2, y1, y2, k;
      cin >> y1 >> x1 >> y2 >> x2 >> k;
      y1--; x1--; y2--; x2--;
      bool color[n][m];
      int dist[n][m];
      for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            color[i][j] = 0;
            dist[i][j] = INF;
        }
      }
      dist[y1][x1] = 0;
      color[y1][x1] = 1;
      int lng;
      queue <pair <int, int> > q;
      if (pole[y1][x1] > k){
        ans.push_back(-1);
        continue;
      }
      q.push(make_pair(y1, x1));
      while (!q.empty()){
        pair <int, int> now = q.front();
        q.pop();
        int x = now.second;
        int y = now.first;
        if (x == x2 && y == y2){
            lng = dist[y][x];
            break;
        }
        if (x > 0 && color[y][x - 1] == 0 && pole[y][x - 1] <= k){
            dist[y][x - 1] = dist[y][x] + 1;
            color[y][x - 1] = 1;
            q.push(make_pair(y, x - 1));
        }
        if (x < m - 1 && color[y][x + 1] == 0 && pole[y][x + 1] <= k){
            dist[y][x + 1] = dist[y][x] + 1;
            color[y][x + 1] = 1;
            q.push(make_pair(y, x + 1));
        }
        if (y > 0 && color[y - 1][x] == 0 && pole[y - 1][x] <= k){
            dist[y - 1][x] = dist[y][x] + 1;
            color[y - 1][x] = 1;
            q.push(make_pair(y - 1, x));
        }
        if (y < n - 1 && color[y + 1][x] == 0 && pole[y + 1][x] <= k){
            dist[y + 1][x] = dist[y][x] + 1;
            color[y + 1][x] = 1;
            q.push(make_pair(y + 1, x));
        }
      }
      if (lng >= 999999999){
        ans.push_back(-1);
      }
      else
        ans.push_back(lng);
    }
  }
  for (int i = 0; i < ans.size(); i++){
    cout << ans[i] << endl;
  }
}
