#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

int dx[] = {0, 1, 0, -1};
int dy[] = {1, 0, -1, 0};

int main() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<vector<int>> s(n, vector<int>(m, 0));
    for (int i = 1; i <= q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            for (int j = 0; j < m; j++)
                s[r - 1][j] = -i;
        } else if (t == 2) {
            int c;
            cin >> c;
            for (int j = 0; j < n; j++)
                s[j][c - 1] = -i;
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            --r1, --c1, --r2, --c2, k -= i;
            vector<vector<int>> dist(n, vector<int>(m, INF));
            dist[r1][c1] = (k >= s[r1][c1] ? 0 : INF);
            queue<pair<int, int>> qu;
            qu.push({r1, c1});
            while (!qu.empty()) {
                int r = qu.front().first;
                int c = qu.front().second;
                qu.pop();
                for (int i = 0; i < 4; i++) {
                    int x = r + dx[i], y = c + dy[i];
                    if (x >= 0 && x < n && y >= 0 && y < m && s[x][y] <= k && dist[x][y] > dist[r][c] + 1){
                        qu.push({x, y});
                        dist[x][y] = dist[r][c] + 1;
                    }
                }
            }
            cout << (dist[r2][c2] < INF ? dist[r2][c2] : -1) << "\n";
        }
    }
    return 0;
}
