#include <bits/stdc++.h>

using namespace std;

int main() {
    int t;
    cin >> t;
    for (int it = 0; it < t; it++) {
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        vector<vector<pair<int, long long>>> graph(n);
        vector<set<long long>> dists(n);
        dists[0].insert(0);
        for (int i = 0; i < m; i++) {
            int v, u;
            long long d;
            cin >> v >> u >> d;
            graph[v - 1].push_back({u - 1, d});
        }
        queue<int> qu;
        qu.push(0);
        while (!qu.empty()) {
            int v = qu.front();
            qu.pop();
            for (pair<int, long long> p : graph[v]) {
                bool changed = false;
                for (long long d : dists[v]) {
                    if (!dists[p.first].count(d + p.second)) {
                        changed = true;
                        dists[p.first].insert(d + p.second);
                    }
                }
                if (changed)
                    qu.push(p.first);
            }
        }
        for (int i = 0; i < q; i++) {
            int f;
            long long r;
            cin >> f >> r;
            bool ok = 0;
            for (long long d : dists[f - 1]) {
                if (d >= r && d <= (r * p) / (p - 1)) {
                    ok = 1;
                    break;
                }
            }
            cout << ok;
        }
    }
    return 0;
}

