#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

using namespace std;

int lg, pw = 1, n;
vector<int> q;
vector<bool> ans;

map<pair<vector<int>, vector<bool>>, int> what;
map<pair<vector<int>, vector<bool>>, int> rs;

bool good() {
	bool ok = 1;
	set<int> can;
	for (int bad = 0; bad <= ans.size(); ++bad) {
		int l = 1, r = n + 1;
		for (int i = 0; i < ans.size(); ++i) {
			if (i != bad) {
				if (ans[i] == 1) {
					l = max(l, q[i]);
				}
				else {
					r = min(r, q[i]);
				}
			}
		}

		if (l < r) {
			if (r - l != 1) {
				return 0;
			}
			can.insert(l);
			if (can.size() > 1) return 0;
		}
	}

	if (can.size()) rs[{q, ans}] = *can.begin();

	return can.size() <= 1;
}

bool gen(int len) {
	if (good()) {
		what[{ q, ans }] = -1;
		return;
	}
	
	if (q.size() == len) return;
	
	for (int to = 1; to <= n; ++to) {
		bool all_good = 1;
		q.push_back(to);
		ans.push_back(0);
		all_good &= gen(len);
		ans.pop_back();
		ans.push_back(1);
		all_good &= gen(len);
		ans.pop_back();
		q.pop_back();
		if (all_good) {
			what[{q, ans}] = to;
			return 1;
		}
	}

	return 0;
}

signed main() {
	cin >> n;
	while (pw < n) {
		pw <<= 1;
		++lg;
	}
	lg = 2 * lg + 2;
	gen(lg);
	while (1) {
		q.clear();
		ans.clear();
		int l = 1, r = n + 1;
		while (what[{q, ans}] != -1) {
			cout << what[{q, ans}] << endl;
			q.push_back(what[{q, ans}]);
			string s;
			cin >> s;
			if (s == "Yes") ans.push_back(1);
			else ans.push_back(0);
		}
		cout << "! " << rs[{q, ans}] << endl;
		string s;
		cin >> s;
		if (s == "Done") break;
	}
	return 0;
}