#include <bits/stdc++.h>

#define int ll
#define pb push_back
#define ft first
#define sc second

using namespace std;
typedef long long ll;

vector<int> tree;

void update(int v) {
    if(v == 0)
        return;
    tree[v] = tree[2 * v] + tree[2 * v + 1];
    update(v / 2);
}

int gett(int v, int l, int r, int vl, int vr) {
    if(vr <= l || r <= vl)
        return 0;
    if(vl <= l && r <= vr)
        return tree[v];
    int m = (l + r) / 2;
    return gett(v * 2, l, m, vl, vr) + gett(v * 2 + 1, m, r, vl, vr);
}

signed main() {
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> m >> n;
    vector<int> have(m);

    for (int i = 0; i < m; i++) {
        cin >> have[i];
        have[i]--;
    }

    vector<pair<int, int>> cntt(n, {-1, -1});
    for (int i = 0; i < m; i++) {
        if(cntt[have[i]].ft == -1)
            cntt[have[i]].ft = i;
        cntt[have[i]].sc = i;
    }

    vector<pair<int, int>> cnt(n, {-1, -1});
    vector<int> num(n);
    for (int i = 0; i < n; i++) {
        num[i] = n * i * i + 1;
    }
    int N = 1;
    while(N <= m)
        N *= 2;
    tree = vector<int> (2 * N, 0);

    set<pair<int, int>> lft;
    set<pair<int, int>> rght;
    vector<pair<int, int>> scan(m, {-1, -1});
    for (int i = 0; i < n; i++) {
        if(cntt[i].ft == cntt[i].sc)
            continue;
        scan[cntt[i].ft] = {1, i};
        scan[cntt[i].sc] = {-1, i};
    }
    for (int i = 0; i < m; i++) {
        if(scan[i].sc != -1) {
            if(scan[i].ft == -1) {
                int x = scan[i].sc;
                lft.erase({cntt[x].ft, x});
                rght.erase({cntt[x].sc, x});
            }
            else {
                int x = scan[i].sc;
                lft.insert({cntt[x].ft, x});
                rght.erase({cntt[x].sc, x});
            }
        }
        if(lft.size() > 0) {
            auto uk = lft.end();
            uk--;
            if((*uk).ft > cntt[have[i]].ft) {
                cout << -1;
                return 0;
            }
        }
        if(rght.size() > 0) {
            auto uk = rght.begin();
            if((*uk).ft < cntt[have[i]].sc) {
                cout << -1;
                return 0;
            }
        }
    }

    vector<pair<int, int>> fs;
    for (int i = 0; i < n; i++) {
        if(cntt[i].ft == -1)
            continue;
        fs.pb({cntt[i].sc - cntt[i].ft + 1, i});
    }
    sort(fs.begin(), fs.end());
    reverse(fs.begin(), fs.end());
    cout << fs.size() << '\n';
    for (int i = 0; i < fs.size(); i++) {
        cout << fs[i].sc + 1 << " " << cntt[fs[i].sc].ft + 1 << " " << cntt[fs[i].sc].sc + 1 << '\n';
    }
}
