#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3,no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")

#define ALL(a) (a).begin(), (a).end()
#define endl "\n"

typedef long long ll;
typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> ordered_set;

using namespace std;

const int d = 1 << 20;

vector<pair<int, int>> row(d << 1), col(d << 1);

int get_maxx(int u, int l, int r, int a, int b, vector<pair<int, int>> const& t, int k) {
    if (t[u].second < k || r < a || b < l) return -1;
    if (u >= d) return u - d;
    if (t[u << 1 | 1].second >= k) {
        int ans = get_maxx(u << 1 | 1, (l + r) / 2 + 1, r, a, b, t, k);
        if (ans == -1) return get_maxx(u << 1, l, (l + r) / 2, a, b, t, k);
        else return ans;
    } else {
        return get_maxx(u << 1, l, (l + r) / 2, a, b, t, k);
    }
}

int get_maxx(int l, int r, vector<pair<int, int>> const& t, int k) {
    return get_maxx(1, d, 2 * d - 1, l + d, r + d, t, k);
}

int get_max(int u, int l, int r, int a, int b, vector<pair<int, int>> const& t, int k) {
    if (t[u].second < k || r < a || b < l) return -1;
    if (u >= d) return u - d;
    if (t[u << 1].second >= k) {
        int ans = get_max(u << 1, l, (l + r) / 2, a, b, t, k);
        if (ans == -1) return get_max(u << 1 | 1, (l + r) / 2 + 1, r, a, b, t, k);
        else return ans;
    } else {
        return get_max(u << 1 | 1, (l + r) / 2 + 1, r, a, b, t, k);
    }
}

int get_max(int l, int r, vector<pair<int, int>> const& t, int k) {
    return get_max(1, d, 2 * d - 1, l + d, r + d, t, k);
}

int get_min(int u, int l, int r, int a, int b, vector<pair<int, int>> const& t) {
    if (r < a || b < l) return (int)1e9;
    if (a <= l && r <= b) return t[u].first;

    return min(get_min(u << 1, l, (l + r) / 2, a, b, t),
               get_min(u << 1 | 1, (l + r) / 2 + 1, r, a, b, t));
}

int get_min(int l, int r, vector<pair<int, int>> const& t) {
    return get_min(1, d, 2 * d - 1, l + d, r + d, t);
}

void update(int i, int x, vector<pair<int, int>> &t) {
    i += d;
    t[i].first = x;
    t[i].second = x;

    for (int j = i >> 1; j > 0; j >>= 1) {
        t[j].first = min(t[j << 1].first, t[j << 1 | 1].first);
    }
    for (int j = i >> 1; j > 0; j >>= 1) {
        t[j].second = max(t[j << 1].second, t[j << 1 | 1].second);
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m, q;
    cin >> n >> m >> q;

    for (int qq = 1; qq <= q; qq++) {
        int t;
        cin >> t;

        if (t == 1) {
            int j;
            cin >> j;
            j--;
            update(j, qq, row);
        } else if (t == 2) {
            int j;
            cin >> j;
            j--;
            update(j, qq, col);
        } else {
            int i, j, ii, jj, k;
            cin >> i >> j >> ii >> jj >> k;
            i--; j--; ii--; jj--;

            if (qq - max(row[ii + d].first, col[jj + d].first) > k || qq - max(row[i + d].first, col[j + d].first) > k) cout << -1 << endl;
            else {
                int ans = (int)1e9;

                if (qq - row[ii + d].first <= k) {
                    int x = get_max(min(jj, j), d - 1, col, qq - k);
                    if (x != -1) ans = min(ans, abs(j - x) + abs(i - ii) + abs(jj - x));

                    x = get_maxx(0, max(jj, j), col, qq - k);
                    if (x != -1) ans = min(ans, abs(j - x) + abs(i - ii) + abs(jj - x));
                }

                if (qq - col[jj + d].first <= k) {
                    int x = get_max(min(ii, i), d - 1, row, qq - k);
                    if (x != -1) ans = min(ans, abs(i - x) + abs(j - jj) + abs(ii - x));

                    x = get_maxx(0, max(ii, i), row, qq - k);
                    if (x != -1) ans = min(ans, abs(i - x) + abs(j - jj) + abs(ii - x));
                }




                vector<bool> grow(n), gcol(m);

                for (int x = 0; x < n; x++) {
                    grow[x] = qq - row[x + d].first <= k;
                }
                for (int x = 0; x < m; x++) {
                    gcol[x] = qq - col[x + d].first <= k;
                }

                bool go = 1;
                if (min(ii, i) + 1 < max(ii, i)) {
                    int m = get_min(min(ii, i) + 1, max(ii, i) - 1, row);
                    if (qq - k <= row[m + d].first) ans = abs(i - ii) + abs(j - jj);
                } else {
                    if (grow[ii] || grow[i]) ans = abs(i - ii) + abs(j - jj);
                }
                if (min(jj, j) + 1 < max(jj, j)){
                    go = 1;
                    for (int x = min(jj, j) + 1; x < max(jj, j); x++) go = go && gcol[x];
                    if (go) ans = abs(i - ii) + abs(j - jj);
                } else {
                    if (gcol[jj] || gcol[j]) ans = abs(i - ii) + abs(j - jj);
                }

                //for (auto e : gcol) cout << e << ' ';cout << endl;
                //for (auto e : grow) cout << e << ' ';cout << endl;
                //cout << endl;
                if (ans == (int)1e9) cout << -1 << endl;
                else cout << ans << endl;
            }
        }
    }

    return 0;
}

/*

4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6

*/
