#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

//#define DEBUG

using namespace std;

struct paint {
	int len, L, R, c;
	paint(int len = 0, int L = 0, int R = 0, int c = -1) : len(len), L(L), R(R), c(c) {}
	bool operator < (const paint &p)const& {
		return len > p.len;
	}
};

int main() {
	int n, m;
	cin >> m >> n;
	vector <int> a(m);
	vector <int> first(n + 1, m), last(n + 1, -1);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		first[a[i]] = min(first[a[i]], i);
		last[a[i]] = i;
	}
	vector <paint> p;
	for (int i = 1; i < n + 1; i++) {
		if (first[i] != m) {
			p.emplace_back(last[i] - first[i] + 1, first[i], last[i], i);
		}
	}
	sort(p.begin(), p.end());
	vector <int> new_a(m);
	for (int i = 0; i < p.size(); i++) {
		for (int j = 0; j < p[i].len; j++) {
			new_a[p[i].L + j] = p[i].c;
		}
	}
	if (new_a != a) {
		cout << -1;
	}
	else {
		cout << p.size() << '\n';
		for (int i = 0; i < p.size(); i++) {
			cout << p[i].c << ' ' << p[i].L + 1 << ' ' << p[i].R + 1 << '\n';
		}
	}
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}