#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define forn(i, s, f) for(int i = s; i < f; ++i)
#define pii pair <int, int>
#define fs first
#define sc second
#define pb push_back
#define ll long long
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

vector <int> a, L, R;
vector <vector <int>> ans;
vector <int> cur;
vector <bool> used;

void go(int l, int r) {
    if (r - l < 0)
        return;
    if (a[l] == cur[l]) {
        go(l + 1, r);
        return;
    }
    if (a[r] == cur[r]) {
        go(l, r - 1);
        return;
    }
    //cout << l << " " << r << "  " << a[l] << " " << a[r] << "\n";;
    if (a[l] == a[r]) {
        if (used[a[l]])
            cout << -1, exit(0);
        forn (i, l, r + 1)
            cur[i] = a[l];
        used[a[l]] = 1;
        ans.pb({a[l], l, r});
        go(l + 1, r - 1);
        return;
    }
    if (R[a[l]] >  L[a[r]])
        cout << -1, exit(0);
    if (used[a[l]])
        cout << -1, exit(0);
    if (used[a[r]])
        cout << -1, exit(0);
    used[a[l]] = used[a[r]] = 1;
    ans.pb({a[l], l, R[a[l]]}), ans.pb({a[r], L[a[r]], r});
    forn (i, l, R[a[l]] + 1)
        cur[i] = a[l];
    forn (i, L[a[r]], r + 1)
        cur[i] = a[r];
    go(l + 1, R[a[l]] - 1), go(R[a[l]] + 1, L[a[r]] - 1), go(L[a[r]] + 1, r - 1);
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int m, n;
	cin >> m >> n;
	a.resize(m);
	L.resize(n, m), R.resize(n, -1);
	forn (i, 0, m) {
        cin >> a[i], a[i]--;
        L[a[i]] = min(L[a[i]], i), R[a[i]] = max(R[a[i]], i);
	}
	used.resize(n), cur.resize(m, -1);
    go(0, m - 1);
    cout << sz(ans) << "\n";
    forn (i, 0, sz(ans))
        cout << ans[i][0] + 1 << " " << ans[i][1] + 1 << " " << ans[i][2] + 1 << "\n";
	return 0;
}
