#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define forn(i, s, f) for(int i = s; i < f; ++i)
#define pii pair <int, int>
#define fs first
#define sc second
#define pb push_back
#define ll long long
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second

vector <pii> d;
int n, m;
bool is_on_field(pii a) {
    return 0 <= a.x && a.x < n && 0 <= a.y && a.y < m;
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	d.resize(4);
	d[0] = {0, -1}, d[1] = {0, 1}, d[2] = {1, 0}, d[3] = {-1, 0};
	int q;
	cin >> n >> m >> q;
	vector <vector <int>> a(n, vector <int> (m));
	forn (i, 1, q + 1) {
	    forn (k, 0, n)
            forn (l, 0, m)
                a[k][l]++;
        int tp;
        cin >> tp;
        if (tp < 3) {
            int x;
            cin >> x;
            x--;
            if (tp == 1) {
                forn (j, 0, m)
                    a[x][j] = 0;
            }
            if (tp == 2) {
                forn (j, 0, n)
                    a[j][x] = 0;
            }
        } else {
            pii st, fn;
            cin >> st.x >> st.y >> fn.x >> fn.y;
            st.x--, st.y--, fn.x--, fn.y--;
            int k;
            cin >> k;
            deque <pii> Q;
            vector <vector <int>> dst(n, vector <int> (m, 1e9));
            if (a[st.x][st.y] <= k) {
                Q.pb(st);
                dst[st.x][st.y] = 0;
            }
            while (!Q.empty()) {
                pii v = Q.front();
                Q.pop_front();
                //cout << v.x << " " << v.y << ":\n";
                forn (j, 0, 4) {
                    pii u = {v.x + d[j].x, v.y + d[j].y};
                    //cout << u.x << " " << u.y << "  " << dst[v.x][v.y] + 1 << "\n";
                    if (is_on_field(u) && a[u.x][u.y] <= k && dst[v.x][v.y] + 1 < dst[u.x][u.y]) {
                        dst[u.x][u.y] = dst[v.x][v.y] + 1;
                        Q.pb(u);
                    }
                }
            }
            if (dst[fn.x][fn.y] == 1e9)
                cout << "-1\n";
            else
                cout << dst[fn.x][fn.y] << "\n";
        }
	}
	return 0;
}
