#include <bits/stdc++.h>

using namespace std;

const int max_n = 10000;

int dt[max_n << 2];
int dm[max_n << 2];
int d = 1;

void updatedt(int x, int val)
{
    dt[x + d] = val;
    for(int v = (x + d) >> 1; v >= 1; v >>= 1) dt[v] = min(dt[v << 1], dt[v << 1 | 1]);
}

int getdt(int l, int r)
{
    int ans = 1e9;
    for(l += d, r += d; l <= r; ++l >>= 1, --r >>= 1)
    {
        if(l & 1) ans = min(ans, dt[l]);
        if(~r & 1) ans = min(ans, dt[r]);
    }
    return ans;
}

void updatedm(int x, int val)
{
    dm[x + d] = val;
    for(int v = (x + d) >> 1; v >= 1; v >>= 1) dm[v] = min(dm[v << 1], dm[v << 1 | 1]);
}

int getdm(int l, int r, int tl = 0, int tr = d - 1, int v = 1)
{
    int ans = 1e9;
    for(l += d, r += d; l <= r; ++l >>= 1, --r >>= 1)
    {
        if(l & 1) ans = min(ans, dm[l]);
        if(~r & 1) ans = min(ans, dm[r]);
    }
    return ans;
}

int main()
{
    while(d < max_n) d <<= 1;
    int n, m, q;
    scanf("%d %d %d", &n, &m, &q);
    for(int t = 1; t <= q; t++)
    {
        int type;
        scanf("%d", &type);
        if(type == 1)
        {
            int x;
            scanf("%d", &x);
            updatedt(x, t);
        }
        else if(type == 2)
        {
            int x;
            scanf("%d", &x);
            updatedm(x, t);
        }
        else
        {
            int x1, y1, x2, y2, k;
            scanf("%d %d %d %d %d", &x1, &y1, &x2, &y2, &k);
            int best = 1e9;
            int gy1y2 = 1e9, gx1x2 = 1e9;
            for(int i = min(y1, y2); i <= max(y1, y2); i++)
            {
                gy1y2 = min(gy1y2, dm[i + d]);
            }
            for(int i = min(x1, x2); i <= max(x1, x2); i++)
            {
                gx1x2 = min(gx1x2, dt[i + d]);
            }
            for(int i = 1; i <= n; i++)
            {
                if(dm[y1 + d] < t - k)
                {
                    if(getdt(min(i, x1), max(i, x1)) < t - k) continue;
                }
                if(dt[i + d] < t - k)
                {
                    if(gy1y2 < t - k) continue;
                }
                if(dm[y2 + d] < t - k)
                {
                    if(getdt(min(i, x2), max(i, x2)) < t - k) continue;
                }
                best = min(best, abs(x1 - i) + abs(x2 - i) + abs(y1 - y2));
            }
            for(int i = 1; i <= m; i++)
            {
                if(dt[x1 + d] < t - k)
                {
                    if(getdm(min(y1, i), max(y1, i)) < t - k) continue;
                }
                if(dm[i + d] < t - k)
                {
                    if(gx1x2 < t - k) continue;
                }
                if(dt[x2 + d] < t - k)
                {
                    if(getdm(min(i, y2), max(i, y2)) < t - k) continue;
                }
                best = min(best, abs(y1 - i) + abs(y2 - i) + abs(x1 - x2));
            }
            if(best == 1e9) printf("-1\n");
            else printf("%d\n", best);
        }
    }
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
