#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int MAXN = 500005;
vector<pll> G[MAXN];


const int N2 = 5013;
bitset<N2 * 2> dp[N2];

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    ll pp = p - 1;
    for (int j = 0; j < m; ++j) {
        ll d;
        int v, u;
        cin >> v >> u >> d;
        G[v].pb({u, d});
    }

    dp[1][0] = 1;
    for (int v = 1; v <= n; ++v) {
        for (auto &e : G[v]) {
            int u = e.fi;
            ll d = e.se;
            for (int x = 0; x + d < N2 * 2; ++x) {
                if (dp[v][x] == 1)
                    dp[u][x + d] = 1;
            }
        }
    }

    while (q--) {
        int v;
        ll r;
        cin >> v >> r;
        ll up = (ll)(p * r) / (p - 1);
        bool found = false;
        for (int x = r; x <= up; ++x) {
            if (dp[v][x]) {
                found = true;
                break;
            }
        }
        cout << (found ? '1' : '0');
    }
    cout << '\n';

    for (int v = 1; v <= n; ++v) {
        for (int x = 0; x < N2 * 2; ++x) dp[v][x] = 0;
        G[v].clear();
    }
}

signed main() {
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }

    return 0;
}