#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <random>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()
#define all_(x) x.rbegin(), x.rend()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const ll INF = 1e9 + 9;
const ll MAXN = 3e5 + 7;
const ll MAXN1 = 1 << 11;
const ll MOD = 1e9 + 7;
const ll PW = 239;
const ll BLOCK = 316;

void solve();
mt19937 mt(1e9 + 7);

signed main() {
	srand('a' + 'l' + 'e' + 'x' + 'X' + '5' + '1' + '2');
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*-----------------------------------------------------------------------------------------------------------------------------*/

int mx[MAXN], t[MAXN], e[MAXN];
bool used[MAXN];
int v1[4 * MAXN], psh[4 * MAXN];

void push(int vert, int tl, int tr) {
	if (tl != tr && psh[vert] != -1) {
		psh[vert << 1] = psh[vert];
		psh[vert << 1 | 1] = psh[vert];
	}
	if (psh[vert] != -1) v1[vert] = psh[vert];
	psh[vert] = -1;
}

void upd(int vert, int tl, int tr, int l, int r, int c) {
	push(vert, tl, tr);
	if (tl == l && tr == r) {
		psh[vert] = c;
		return;
	}
	int tm = (tl + tr) >> 1;
	if (r <= tm) upd(vert << 1, tl, tm, l, r, c);
	else if (l > tm) upd(vert << 1 | 1, tm + 1, tr, l, r, c);
	else upd(vert << 1, tl, tm, l, tm, c), upd(vert << 1 | 1, tm + 1, tr, tm + 1, r, c);
}

int get(int vert, int tl, int tr, int ind) {
	push(vert, tl, tr);
	if (tl == tr) {
		return v1[vert];
	}
	int tm = (tl + tr) >> 1;
	if (ind <= tm) return get(vert << 1, tl, tm, ind);
	else return get(vert << 1 | 1, tm + 1, tr, ind);
}

void solve() {
	fill(psh, psh + 4 * MAXN, -1);
	int n, m;
	cin >> m >> n;
	vector<int> v(m);
	for (int i = 0; i < m; ++i) {
		cin >> v[i];
		mx[v[i]] = i;
	}
	int r = -1;
	vector<pair<int, pii>> ans;
	set<int> s;
	for (int i = 0; i < m; ++i) {
		if (used[v[i]]) {
			continue;
		}
		used[v[i]] = 1;
		r = max(r, mx[v[i]]);
		ans.emplace_back(v[i], mp(i + 1, mx[v[i]] + 1));
		upd(1, 0, m - 1, i, mx[v[i]], v[i]);
	}
	for (int i = 0; i < m; ++i) {
		if (get(1, 0, m - 1, i) != v[i]) {
			cout << -1;
			return;
		}
	}
	cout << ans.size() << "\n";
	for (auto &i : ans) cout << i.X << " " << i.Y.X << " " << i.Y.Y << "\n";
}