#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


bool q(int x) {
    cout << '?' << ' ' << x << endl;

    string s;
    cin >> s;

    return s[0] == 'Y';
}


bool answ(int x) {
    cout << '!' << ' ' << x << endl;

    string s;
    cin >> s;

    return s[0] == 'D';
}


int solve(int L, int R, bool b) {
    if (b) {
        int low = L, high = R;
        while (high - low > 1) {
            int mid = (low + high) / 2;

            if (q(mid)) {
                low = mid;
            } else {
                high = mid;
            }
        }

        return low;
    }

    if (R - L < 3) {
        int low = L, high = R;

        while (high - low > 1) {
            int mid = (low + high) / 2;

            int a[2] = { q(mid), q(mid) };

            bool r = a[0];

            if (a[0] != a[1]) {
                r = q(mid);
            }

            if (r) {
                low = mid;
            } else {
                high = mid;
            }
        }

        return low;
    }

    int d = (R - L) / 3;

    int m1 = L + d;
    int m2 = R - d;

    int res[2] = { q(m1), q(m2) };

    if (res[0] == res[1]) {
        if (res[0] == 0) {
            if (q(m1)) {
                return solve(L, m2, 1);
            }

            return solve(L, m1, 0);
        }

        if (q(m2)) {
            return solve(m2, R, 0);
        }

        return solve(m1, R, 1);
    }

    if (res[0] == 0) {
        if (q(m1)) {
            return solve(m2, R, 1);
        }

        return solve(L, m1, 1);
    }

    if (!q(m1)) {
        return solve(L, m1, 1);
    }

    if (q(m2)) {
        return solve(m2, R, 1);
    }

    return solve(m1, m2, 0);
}


int main() {
    int n;
    cin >> n;

    for (; !answ(solve(1, n + 1, 0)););

    return 0;
}