#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<random>
#include<cmath>
#include<ctime>
using namespace std;
#define int long long
#define elif else if
vector<int>otrtree;
vector<int>otl;
int n2 = 1;
void push(int ind)
{
	if (otl[ind] == -1)
		return;
	otrtree[ind] = otl[ind];
	if (ind * 2 < otrtree.size())
	{
		otl[ind * 2] = otl[ind];
		otl[ind * 2 + 1] = otl[ind];
	}
	otl[ind] = -1;
}
void upd(int l, int r, int ind, int lQ, int rQ, int x)
{
	push(ind);
	if (rQ <= l || r <= lQ)
	{
		return;
	}
	if (lQ <= l && r <= rQ)
	{
		otl[ind] = x;
		return;
	}
	int m = (l + r) / 2;
	upd(l, m, ind * 2, lQ, rQ, x);
	upd(m, r, ind * 2 + 1, lQ, rQ, x);
}
int get(int l, int r, int ind, int x)
{
	push(ind);
	if (r <= x || l > x)
	{
		return 0;
	}
	if (l == r - 1)
	{
		return otrtree[ind];
	}
	int m = (l + r) / 2;
	return get(l, m, ind * 2, x) + get(m, r, ind * 2 + 1, x);
}
int32_t main()
{
	ios_base::sync_with_stdio(0);
	int m, n;
	cin >> m >> n;
	while (n2 < m)
	{
		n2 *= 2;
	}
	otrtree.resize(n2 * 2);
	otl.resize(otrtree.size(), -1);
	vector<int>a(m);
	vector<pair<pair<int, int>, int>>e(n, { { -1,-1 } ,0 });
	for (int i = 0; i < n; ++i)
	{
		e[i].second = i;
	}
	for (int i = 0; i < m; ++i)
	{
		cin >> a[i];
		--a[i];
		e[a[i]].first.second = max(e[a[i]].first.second, i);
		if (e[a[i]].first.first == -1)
		{
			e[a[i]].first.first = i;
		}
	}
	sort(e.begin(), e.end());
	vector<pair<pair<int, int>, int>>ans;
	int l = -1, r = -1;
	for (int i = 0; i < e.size(); ++i)
	{
		if (e[i].first.first == -1)
		{
			continue;
		}
		ans.push_back(e[i]);
		if (e[i].first.first > r)
		{
			l = e[i].first.first;
			r = e[i].first.second;
		}
		elif(e[i].first.first > l&&e[i].first.second < r)
		{
			continue;
		}
		else
		{
			cout << -1;
			return 0;
		}
	}
	for (int i = 0; i < ans.size(); ++i)
	{
		upd(1, n2 + 1, 1, ans[i].first.first + 1, ans[i].first.second + 2, ans[i].second);
	}
	for (int i = 0; i < m; ++i)
	{
		int cur = get(1, n2 + 1, 1, i + 1);
		if (cur != a[i])
		{
			cout << -1;
			return 0;
		}
	}
	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); ++i)
	{
		cout << ans[i].second + 1 << ' ' << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << '\n';
	}
	return 0;
}