#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <iomanip>
#include <algorithm>

using namespace std;

typedef long long ll;

const int SZ = 3e5 + 100;
const int INF = 1e6;

int l[SZ], r[SZ], a[SZ];
int n, m;

int main()
{
    ios::sync_with_stdio(false);

    cin >> m >> n;
    for (int i = 0; i < n; i++)
    {
        l[i] = INF;
        r[i] = -1;
    }
    for (int i = 0; i < m; i++)
    {
        cin >> a[i];
        a[i]--;
        l[a[i]] = min(l[a[i]], i);
        r[a[i]] = max(r[a[i]], i);
    }
    vector<int> pos;
    vector<int> last;
    for (int i = 0; i < n; i++)
    {
        if (r[i] == -1) continue;
        pos.push_back(l[i]);
    }
    sort(pos.begin(), pos.end());

    bool fl = true;
    int num;
    int tl, tr;
    tl = 0;
    tr = m;
    for (int i = 0; i < m; i++)
    {
        num = a[i];
        if (l[num] < tl || r[num] > tr)
        {
            fl = false;
            break;
        }
        if (l[num] == r[num]) continue;
        if (i == r[num])
        {
            last.pop_back();
            if (last.size() != 0)
            {
                num = last[last.size() - 1];
                tl = l[num];
                tr = r[num];
            }
            else
            {
                tl = 0;
                tr = m;
            }
        }
        else
        {
            if (last.size() == 0 || last[last.size() - 1] != num)
            last.push_back(num);
            tl = l[num];
            tr = r[num];
        }
    }

    if (!fl)
    {
        cout << -1 << endl;
        return 0;
    }

    cout << pos.size() << endl;
    for (int i = 0; i < pos.size(); i++)
    {
        num = a[ pos[i] ];
        cout << num + 1 << " " << l[num] + 1 << " " << r[num] + 1 << "\n";
    }


    return 0;
}
