#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
#ifdef LOCAL
	#define debug(x) std::cout << #x << ": " << x << '\n';
#endif
typedef long long ll;
struct row {
	int i, x;
	friend bool operator<(row a, row b) {
		if (a.x == b.x) {
			return a.i < b.i;
		}
		return a.x > b.x;
	}
};
const int N = 1e6 + 100;
int cntR[N], cntC[N];
int main() {
	int n, m, q;
	std::cin >> n >> m >> q;
	std::set<row> r, c;
	FOR(i, n) {
		r.insert({i, -1});
	}
	FOR(i, m) {
		c.insert({i, -1});
	}
	for (int j = 1; j <= q; ++j) {
		int type;
		std::cin >> type;
		if (type == 1) {
			int R;
			std::cin >> R;
			--R;
			cntR[R] = j;
		}
		if (type == 2) {
			int C;
			std::cin >> C;
			--C;
			cntC[C] = j;
		}
		if (type == 3) {
			int i1, j1, i2, j2, k;
			std::cin >> i1 >> j1 >> i2 >> j2 >> k;
			--i1; --j1; --i2; --j2;
			if (j <= k) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			bool fl = true;
			for (int q = std::min(j1, j2); q <= std::max(j1, j2); ++q) {
				fl &= ((j - cntC[q]) <= k);
			}
			bool fl2 = true;
			for (int q = std::min(i1, i2); q <= std::max(i1, i2); ++q) {
				fl2 &= ((j - cntR[q]) <= k);
			}
			// debug(fl << ' ' << fl2)
			if (fl || fl2) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			// debug(j - cntC[2]);
			if ((j - cntC[j1]) <= k && (j - cntR[i2]) <= k) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			if ((j - cntC[j2]) <= k && (j - cntR[i1]) <= k) {
				std::cout << llabs(i1 - i2) + llabs(j1 - j2) << '\n';
				continue;
			}
			ll answ = 1e18;
			if ((j - cntR[i1]) <= k && (j - cntR[i2]) <= k) {
				for (int q = 0; q < m; ++q) {
					if ((j - cntC[q]) <= k) {
						answ = std::min(answ, llabs(j1 - q) + llabs(j2 - q) + llabs(i1 - i2));
					}
				}
			}
			if ((j - cntC[j1]) <= k && (j - cntC[j2]) <= k) {
				for (int q = 0; q < n; ++q) {
					if ((j - cntR[q]) <= k) {
						answ = std::min(answ, llabs(i1 - q) + llabs(i2 - q) + llabs(j1 - j2));
					}
				}
			}
			if (answ == 1e18) {
				std::cout << -1 << '\n';
			}
			else {
				std::cout << answ << '\n';
			}
		}
	}
}