#include<bits/stdc++.h>

using namespace std;
#define sz(c) (int)c.size()
#define pb push_back
const int MAXN = 3e5 + 7;
int tree[4 * MAXN];
void upd(int v, int l, int r, int pos, int val)
{
    if (l == r - 1)
    {
        tree[v] = val;
        return;
    }
    int mid = (l + r) / 2;
    if (pos < mid)
    {
        upd(v * 2 + 1, l, mid, pos, val);
    }
    else
    {
        upd(v * 2 + 2, mid, r, pos, val);
    }
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}
int get(int v, int l, int r, int L, int R)
{
    if (l >= R || L >= r)
    {
        return 0;
    }
    if (L <= l && r <= R)
    {
        return tree[v];
    }
    int mid = (l + r) / 2;
    int a = get(v * 2 + 1, l, mid, L, R);
    int b = get(v * 2 + 2, mid, r, L, R);
    return max(a, b);
}
signed main()
{
    int m, n;
    cin >> m >> n;
    vector<int> a(m);
    for (int i = 0; i < m; ++i) cin >> a[i];
    vector<int> v[n + 1];
    for (int i = 0; i < m; ++i)
    {
        v[a[i]].pb(i);
    }
    int A[m];
    for (int i = 0; i < m; ++i)
    {
        A[i] = 0;
    }
    vector<int> ans;
    for (int i = 0; i < m; ++i)
    {
        if (A[i] == 0)
        {
            int col = a[i];
            int L = v[col][0];
            int R = v[col].back();
            if (get(0, 0, m, L, R + 1) != 0)
            {
                cout << -1 << endl;
                return 0;
            }
            else
            {
                ans.pb(col);
                ans.pb(L + 1);
                ans.pb(R + 1);
                for (auto el : v[col])
                {
                    A[el] = col;
                    upd(0, 0, m, el, col);
                }
            }
        }
    }
    cout << sz(ans) / 3 << endl;
    for (int i = 0; i < sz(ans); ++i)
    {
        cout << ans[i] << " ";
        if (i % 3 == 2) cout << endl;
    }
}
