#include <bits/stdc++.h>
using namespace std;

int main() {
	int m, n;
	cin >> m >> n;
	vector<int> a(m, 0);
	for ( int i = 0; i < m; ++i ) {
		cin >> a[i];
		a[i]--;
	}

	vector<int> right(n, -1);
	for ( int i = 0; i < m; ++i )
		right[a[i]] = i;

	vector<bool> used(n, false);
	vector<int> ans(m, -1);
	vector<tuple<int, int, int>> queries;
	for ( int i = 0; i < m; ++i ) {
		if ( used[a[i]] ) continue;
		for ( int x = i; x <= right[a[i]]; ++x )
			ans[x] = a[i];
		queries.push_back({a[i]+1, i+1, right[a[i]] + 1});
		used[a[i]] = true;
	}
	bool flag = true;
	for ( int i = 0; i < m; ++i )
		flag &= ans[i] == a[i];

	if ( flag ) {
		cout << queries.size() << endl;

		for ( int i = 0; i < queries.size(); ++i ) {
			cout << get<0>(queries[i]) << " " << get<1>(queries[i]) << " " << get<2>(queries[i]) << endl;
		}
	} else {
		cout << -1 << endl;
	}
	return 0;
}