#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e18;

vector<ll> t;


void upd(ll v, ll tl, ll tr, ll pos, ll nval)
{
	if (tl == tr)
		t[v] = nval;
	else
	{
		ll tm = (tl + tr) / 2;

		if (pos <= tm)
		{
			
			upd(v * 2, tl, tm, pos, nval);
		}
		else
		{
			
			upd(v*2 + 1, tm + 1, tr, pos, nval);
		}

		t[v] = min(t[v* 2], t[v * 2 + 1]);
	}
}

ll get(ll v, ll tl, ll tr, ll l, ll r)
{
	if (l > r)
		return inf;

	if (tl == l && r == tr)
		return t[v];

	ll tm = (tl + tr) / 2;

	return min(get(v * 2, tl, tm, l, min(tm, r)), get(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));

}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll  n, m, q;

	scanf("%lld%lld%lld", &n, &m, &q);//cin >> n >> m >> q;


	t.resize(4 * n, 0);

	for (int it = 1; it <= q; ++it)
	{
		ll type;

		scanf("%lld", &type);//cin >> type;

		if (type == 1)
		{
			ll ii;
			scanf("%lld", &ii);//cin >> ii;
			--ii;

			upd(1, 0, n - 1, ii, it);

		}
		else if (type == 2)
		{


		}
		else
		{
			ll i1, j1, i2, j2, k;

			scanf("%lld%lld%lld%lld%lld", &i1, &j1, &i2, &j2, &k);//cin >> i1 >> j1 >> i2 >> j2 >> k;
			--i1;
			--j1;
			--i2;
			--j2;

			ll ans = get(1, 0, n - 1, min(i1, i2), max(i1, i2));

			if (it - ans > k)
				printf("-1\n");//cout << -1 << endl;
			else
				printf("%lld\n", abs(i1 - i2) + abs(j2 - j1));//cout << abs(i1 - i2) + abs(j2 - j1) << endl;
		}

	}

	return 0;
}

/*
7 10
10 5 5 10 4 2 4

*/