#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <deque>
#include <iomanip>
#include <cstdio>
#include <climits>
#include <cmath>
#include <random>
//struct st
//{
//	std::vector<int> tree;
//	int size;
//	int combine(int a, int b)
//	{
//		return std::max(a, b);
//	}
//	st(int n, std::vector<int> arr);
//	{
//		int N = 1;
//		while(N < n) N *= 2;
//		arr.resize(N, INT_MIN); //fill the rest
//		tree.resize(2 * N);
//		size = N;
//		for(int i = 0; i < N; i++)
//		{
//			tree[i + N] = arr[i];
//		}
//		for(int i = N - 1; i > 0; i--)
//		{
//			tree[i] = combine(tree[2 * i], tree[2 * i + 1]);
//		}
//	}
//	void update(int at)
//	{
//		if(at < N) tree[i] = combine(tree[2*i], tree[2*i + 1]);
//		if(at != 1) update(at / 2);
//	}
//	void set(int at, int to)
//	{
//		tree[at + N] = to;
//		update(at + N);
//	}
//	void get(int l, int r, int v, int L, int R)
//	{
//		if(r <= L || l >= R) return INT_MIN;
//		if(v > N) return tree[v];
//		return combine(
//				get(l, (l + r) / 2, v * 2, L, R),
//				get((l + r) / 2, r, v*2+1, L, R));
//	}
//}
std::mt19937 mt;
int n; 
//#define DEBUG
int ANS = 1;
bool LIED = 0;
int query(int at)
{
	if(at < 1) return false;
	if(at >= n) return true;
#ifdef DEBUG
	printf("query: %d\n", at);
	if(!LIED && mt() % 10 == 0)
	{
		printf("lying\n");
		LIED = true;
		return at < ANS;
	}
	return at >= ANS;
#else
	printf("? %d\n", at);
	fflush(stdout);
	char buf[128]; scanf("%s", buf);
	return buf[0] == 'Y';
#endif
}
int answer(int ans)
{
#ifdef DEBUG
	printf("LIED=%d, ANS=%d, ans=%d\n", LIED, ANS, ans);
	if(ANS != ans)
	{
		std::cout << "fail!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n";
	}
	return false;
#else
	printf("! %d\n", ans);
	fflush(stdout);
	char buf[128];
	scanf("%s", buf);
	return buf[0] == 'D';
#endif
}
int solve(int n)
{
	std::vector<int> ans(2);
	for(int i = 0; i < 2; i++)
	{
		int l = 1, r = n + 1;
		while(l != r)
		{
			int m = (l + r) / 2;
			if(query(m)) //>=
			{
				r = m;
			}
			else //<
			{
				l = m + 1;
			}
		}
		ans[i] = l;
	}
	std::sort(ans.begin(), ans.end());
	return query(ans[0]) ? ans[0] : ans[1];
}
int main(int argc, char*argv[])
{
	std::cin >> n;
	for(;;)
	{
		if(answer(solve(n))) break;
		ANS = mt() % (n - 1) + 1;
		LIED = 0;
		printf("next: ans=%d\n", ANS);
	}
	return 0;
}
