#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <queue>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define np nullptr

struct R {
	int u, v;
	ll d;

	void read() {
		cin >> u >> v >> d;
		u--;
		v--;
	}

};

vector<R> rebr;
set<ld> dist[500000];
vector<pair<int, ld>> matr[500000];

int main() {
#ifdef LOCAL 
	freopen("In.txt", "r", stdin);
	freopen("Out.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int t, n, m, q, u, v, f;
	cin >> t;
	ld p, d, r;
	R pr;
	for (int x = 0; x < t; x++) {
		if (x != 0) {
			//rebr.clear();
			for (int i = 0; i < n; i++) {
				dist[i].clear();
				matr[i].clear();
			}
		}
		cin >> n >> m >> q >> p;
		for (int i = 0; i < m; i++) {
			cin >> u >> v >> d;
			u--;
			v--;
			matr[u].push_back({ v, d });
		}
		vector<pair<int, ld>> st;
		st.push_back({ 0, 0 });
		while (st.size()) {
			v = st.back().first;
			d = st.back().second;
			st.pop_back();
			dist[v].insert(d);
			for (int i = 0; i < matr[v].size(); i++) {
				u = matr[v][i].first;
				st.push_back({ u, d + matr[v][i].second });
			}
		}
		for (int i = 0; i < q; i++) {
			cin >> f >> r;
			f--;
			auto j = dist[f].lower_bound(r);
			if (j == dist[f].end() || (p - 1) * (*j) > r * p) {
				cout << 0;
			}
			else {
				cout << 1;
			}
		}
		cout << "\n";
	}
	return 0;
}