#include <bits/stdc++.h>

using namespace std;

#define int long long
#define INF 1e6

signed main() {
    int n, m;
    cin >> m >> n;
    vector<int> need(m);
    for (int i = 0; i < m; ++i) {
        cin >> need[i];
    }
    vector<pair<int, int>> b(n, {INF, -INF});
    for (int i = 0; i < m; ++i) {
        b[need[i] - 1].first = min(b[need[i] - 1].first, i);
        b[need[i] - 1].second = max(b[need[i] - 1].second, i);
    }
    vector<vector<int>> br(m + 1);
    for (int j = 0; j < n; ++j) {
        if (b[j].first != INF) {
            br[b[j].first].push_back(j + 1);
            br[b[j].second + 1].push_back(-j - 1);
        }
    }
    vector<int> cur(m);
    stack<int> st;
    vector<pair<int, pair<int, int>>> ans;
    for (int i = 0; i < m; ++i) {
        sort(br[i].begin(), br[i].end());
        for (int e:br[i]) {
            if (e > 0) {
                st.push(e);
                ans.push_back({e, {i + 1, b[e - 1].second + 1}});
            } else {
                if (st.top() != -e) {
                    cout << -1;
                    return 0;
                }
                st.pop();
            }
        }
        cur[i] = st.top();
    }
    for (int i = 0; i < m; ++i) {
        if (cur[i] != need[i]) {
            cout << -1;
            return 0;
        }
    }
    cout << ans.size() << "\n";
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].first << " " << ans[i].second.first << " " << ans[i].second.second << "\n";

    }
    return 0;
}
/*
7 10
10 5 5 10 4 2 4
 */