#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct STR {
    int mn, pos, mx, pos_f, pos_l;
    STR() {}
    STR(int mm, int pp) {
        mn = mx = mm;
        pos = pos_f = pos_l = pp;
    }
};

void upd(vector<STR> &tr, int v, int l, int r, int pos, int x) {
    if (l + 1 == r) {
        tr[v] = STR(x, pos);
        return;
    }
    int m = (l + r) / 2;
    if (pos < m) {
        upd(tr, 2 * v + 1, l, m, pos, x);
    } else {
        upd(tr, 2 * v + 2, m, r, pos, x);
    }
    if (tr[2 * v + 1].mn <= tr[2 * v + 2].mn) {
        tr[v] = tr[2 * v + 1];
    } else {
        tr[v] = tr[2 * v + 2];
    }
    if (tr[2 * v + 1].mx < tr[2 * v + 2].mx) {
        tr[v].mx = tr[2 * v + 2].mx;
        tr[v].pos_l = tr[2 * v + 2].pos_l;
        tr[v].pos_f = tr[2 * v + 2].pos_f;
    }
    if (tr[2 * v + 2].mx < tr[2 * v + 1].mx) {
        tr[v].mx = tr[2 * v + 1].mx;
        tr[v].pos_l = tr[2 * v + 1].pos_l;
        tr[v].pos_f = tr[2 * v + 1].pos_f;
    }
    if (tr[2 * v + 1].mx == tr[2 * v + 2].mx) {
        tr[v].mx = tr[2 * v + 1].mx;
        tr[v].pos_f = tr[2 * v + 1].pos_f;
        tr[v].pos_l = tr[2 * v + 2].pos_l;
    }
    return;
}

int get(vector<STR> &tr, int v, int l, int r, int L, int R) {
    if (L <= l && r <= R) {
        return tr[v].mn;
    }
    if (r <= L || R <= l) {
        return 1e9;
    }
    int m = (l + r) / 2;
    return min(get(tr, 2 * v + 1, l, m, L, R), get(tr, 2 * v + 2, m, r, L, R));
}

int get_f(vector<STR> &tr, int v, int l, int r, int L, int R, int mn) {
    if (L <= l && r <= R) {
        if (tr[v].mx >= mn) {
            return tr[v].pos_f;
        } else {
            return 1e9;
        }
    }
    if (r <= L || R <= l) {
        return 1e9;
    }
    int m = (l + r) / 2;
    return min(get_f(tr, 2 * v + 1, l, m, L, R, mn), get_f(tr, 2 * v + 2, m, r, L, R, mn));
}

int get_l(vector<STR> &tr, int v, int l, int r, int L, int R, int mn) {
    if (L <= l && r <= R) {
        if (tr[v].mx >= mn) {
            return tr[v].pos_l;
        } else {
            return 0;
        }
    }
    if (r <= L || R <= l) {
        return 0;
    }
    int m = (l + r) / 2;
    return max(get_l(tr, 2 * v + 1, l, m, L, R, mn), get_l(tr, 2 * v + 2, m, r, L, R, mn));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m, q;
    cin >> n >> m >> q;
    vector<STR> rr(4 * n + 5, STR(0, 0)), cc(4 * m + 5, STR(0, 0));
    for (int i = 1; i <= q; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int r;
            cin >> r;
            upd(rr, 0, 1, n + 1, r, i);
            continue;
        }
        if (type == 2) {
            int c;
            cin >> c;
            upd(cc, 0, 1, m + 1, c, i);
            continue;
        }
        int r1, c1, r2, c2, k;
        cin >> r1 >> c1 >> r2 >> c2 >> k;
        int rr1 = get(rr, 0, 1, n + 1, r1, r1 + 1);
        int rr2 = get(rr, 0, 1, n + 1, r2, r2 + 1);
        int cc1 = get(cc, 0, 1, m + 1, c1, c1 + 1);
        int cc2 = get(cc, 0, 1, m + 1, c2, c2 + 1);
        if (i - rr1 > k && i - cc1 > k) {
            cout << -1 << '\n';
            continue;
        }
        if (i - rr2 > k && i - cc2 > k) {
            cout << -1 << '\n';
            continue;
        }
        if (i - rr1 <= k && i - cc2 <= k) {
            cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
            continue;
        }
        if (i - rr2 <= k && i - cc1 <= k) {
            cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
            continue;
        }
        if (i - rr1 <= k) {
            int ans = 1e9;
            int tmp = get(rr, 0, 1, n + 1, min(r1, r2), max(r1, r2) + 1);
            if (i - tmp <= k) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                continue;
            }
            int x1 = get_l(cc, 0, 1, m + 1, 1, min(c1, c2) + 1, i - k);
            int x2 = get_f(cc, 0, 1, m + 1, min(c1, c2), max(c1, c2) + 1, i - k);
            int x3 = get_f(cc, 0, 1, m + 1, max(c1, c2), m + 1, i - k);
            if (x1 != 1e9) {
                ans = min(ans, abs(r2 - r1) + abs(x1 - c1) + abs(x1 - c2));
            }
            if (x2 != 0) {
                ans = min(ans, abs(r2 - r1) + abs(x2 - c1) + abs(x2 - c2));
            }
            if (x3 != 0) {
                ans = min(ans, abs(r2 - r1) + abs(x3 - c1) + abs(x3 - c2));
            }
            /*for (int j = 1; j <= m; j++) {
                int t = get(cc, 0, 1, m + 1, j, j + 1);
                if (i - t <= k) {
                    ans = min(ans, abs(r2 - r1) + abs(j - c1) + abs(j - c2));
                }
            }*/
            if (ans == 1e9) cout << -1 << '\n'; else cout << ans << '\n';
            continue;
        }
        if (i - cc1 <= k) {
            int ans = 1e9;
            int tmp = get(cc, 0, 1, m + 1, min(c1, c2), max(c1, c2) + 1);
            if (i - tmp <= k) {
                cout << abs(r1 - r2) + abs(c1 - c2) << '\n';
                continue;
            }
            for (int j = 1; j <= n; j++) {
                int t = get(rr, 0, 1, n + 1, j, j + 1);
                if (i - t <= k) {
                    ans = min(ans, abs(c2 - c1) + abs(j - r1) + abs(j - r2));
                }
            }
            if (ans == 1e9) cout << -1 << '\n'; else cout << ans << '\n';
            continue;
        }
    }
    return 0;
}
