#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <assert.h>
#include <algorithm>
#include <queue>

using namespace std;

struct inf {
	int pos;
};
int n, m, q;
int* h1;
int* h2;
int* H1;
int* H2;

void validate1(int id) {
	if (H1[h1[id * 2]] > H1[h1[id * 2 + 1]])
		h1[id] = h1[id * 2];
	else h1[id] = h1[id * 2 + 1];
}

void validate2(int id) {
	if (H2[h2[id * 2]] > H2[h2[id * 2 + 1]])
		h2[id] = h2[id * 2];
	else h2[id] = h2[id * 2 + 1];
}

int recalc1(int a, int b) {
	if (a == -1) return b;
	if (b == -1) return a;
	if (H1[a] > H1[b]) return a;
	else return b;
}
int recalc2(int a, int b) {
	if (a == -1) return b;
	if (b == -1) return a;
	if (H2[a] > H2[b]) return a;
	else return b;
}
void update1(int i, int v, int L = 0, int R = n - 1, int id = 1) {
	if (i < L || i > R) return;
	if (L == R) h1[id] = L;
	else {
		int M = (R + L) / 2;
		update1(i, v, L, M, id * 2);
		update1(i, v, M + 1, R, id * 2 + 1);
		validate1(id);
	}
}

void update2(int i, int v, int L = 0, int R = m - 1, int id = 1) {
	if (i < L || i > R) return;
	if (L == R) h2[id] = L;
	else {
		int M = (R + L) / 2;
		update2(i, v, L, M, id * 2);
		update2(i, v, M + 1, R, id * 2 + 1);
		validate2(id);
	}
}

int max1(int l, int r, int L = 0, int R = n - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) return h1[id];
	int M = (R + L) / 2;
	return recalc1(max1(l, r, L, M, id * 2), max1(l, r, M + 1, R, id * 2 + 1));
}

int max2(int l, int r, int L = 0, int R = m - 1, int id = 1) {
	if (l > R || r < L) return -1;
	if (l <= L && R <= r) return h2[id];
	int M = (R + L) / 2;
	return recalc2(max2(l, r, L, M, id * 2), max2(l, r, M + 1, R, id * 2 + 1));
}

/*int getFirstMore2(int l, int r, int k, int L = 0, int R = m - 1, int id = 1) {
	if (r < L || l > R) return -1;
	if (l <= L && R <= r) {
		if(h2[id] > k) return 
	}
}*/

int main() {
	scanf("%d %d %d", &n, &m, &q);
	h1 = new int[4 * n];
	H1 = new int[n];
	H2 = new int[m];
	h2 = new int[4 * m];
	for (int i = 0; i < 4 * n; i++) h1[i] = 0;
	for (int i = 0; i < 4 * m; i++) h2[i] = 0;
	for (int i = 0; i < m; i++) H2[i] = 0;
	for (int i = 0; i < n; i++) H1[i] = 0;
	int t;
	int pos;
	int x1, y1, x2, y2, k;
	int d1, d2;
	int now;
	int maxh;
	int l1, r1, l2, r2;
	int res1, res2;
	for (int l = 0; l < q; l++) {
		scanf("%d", &t);
		if (t != 3) {
			scanf("%d", &pos);
			pos--;
			if (t == 1) {
				//h1[pos] = -l - 1;
				H1[pos] = -l - 1;
				update1(pos, -l - 1);
			}
			else {
				//h2[pos] = -l - 1;
				H2[pos] = -l - 1;
				update2(pos, -l - 1);
			}
		}
		else {
			scanf("%d %d %d %d %d", &x1, &y1, &x2, &y2, &k);
			x1--; y1--;
			x2--; y2--;
			res2 = 1e9;
			k -= (l + 1);
			if (x1 == x2 && y1 == y2) {
				res2 = 0;
			}
			else if (min(H1[x1], H2[y1]) > k || min(H1[x2], H2[y2]) > k) {
				res2 = -1;
			}
			d1 = 1e9, d2 = 1e9;
			l1 = y1; r1 = y1;
			l2 = y2; r2 = y2;
			if (H1[x1] <= k) {
				l1 = 0;
				r1 = m - 1;
			}
			else {
				
				maxh = -1e9;
				for (int i = y1; i < m; i++) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x1], maxh) <= k) r1 = i;
					else break;
				}
				//r1 = getFirstMore2(y1, m - 1, k) - 1;
				//if (r1 == -2) r1 = m - 1;
				maxh = -1e9;
				for (int i = y1; i >= 0; i--) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x1], maxh) <= k) l1 = i;
					else break;
				}
			}
			if (H1[x2] <= k) {
				l2 = 0;
				r2 = m - 1;
			}
			else {
				maxh = -1e9;
				for (int i = y2; i < m; i++) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x2], maxh) <= k) r2 = i;
					else break;
				}
				maxh = -1e9;
				for (int i = y2; i >= 0; i--) {
					if (H2[i] > maxh) maxh = H2[i];
					if (min(H1[x2], maxh) <= k) l2 = i;
					else break;
				}
			}
			l1 = max(l1, l2);
			r1 = min(r1, r2);
			if (l1 <= r1) {
				/*maxh = -1e9;
				for (int i = min(x1, x2); i <= max(x1, x2); i++) {
					if (h1[i] > maxh) maxh = h1[i];
				}*/
				maxh = H1[max1(min(x1, x2), max(x1, x2))];
				for (int i = l1; i <= r1; i++) {
					if (min(maxh, H2[i]) <= k)
						d1 = min(d1, abs(y1 - i) + abs(y2 - i) + abs(x1 - x2));
				}
			}
			l1 = x1; r1 = x1;
			l2 = x2; r2 = x2;
			if (H2[y1] <= k) {
				l1 = 0;
				r1 = n - 1;
			}
			else {
				maxh = -1e9;
				for (int i = x1; i < n; i++) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y1], maxh) <= k) r1 = i;
					else break;
				}
				maxh = -1e9;
				for (int i = x1; i >= 0; i--) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y1], maxh) <= k) l1 = i;
					else break;
				}
			}
			if (H2[y2] <= k) {
				l2 = 0;
				r2 = n - 1;
			}
			else {
				maxh = -1e9;
				for (int i = x2; i < n; i++) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y2], maxh) <= k) r2 = i;
					else break;
				}
				maxh = -1e9;
				for (int i = x2; i >= 0; i--) {
					if (H1[i] > maxh) maxh = H1[i];
					if (min(H2[y2], maxh) <= k) l2 = i;
					else break;
				}
			}
			l1 = max(l1, l2);
			r1 = min(r1, r2);
			if (l1 <= r1) {
				/*maxh = -1e9;
				for (int i = min(y1, y2); i <= max(y1, y2); i++) {
					if (h2[i] > maxh) maxh = h2[i];
				}*/
				maxh = H2[max2(min(y1, y2), max(y1, y2))];
				for (int i = l1; i <= r1; i++) {
					if (min(maxh, H1[i]) <= k)
						d2 = min(d2, abs(x1 - i) + abs(x2 - i) + abs(y1 - y2));
				}
			}
			if (d2 < d1) d1 = d2;
			if (res2 == 1e9) {
				if (d1 == 1e9) res2 = -1;
				else res2 = d1;
			}
			printf("%d\n", res2);
		}
	}
	system("pause");
	return 0;
}