#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define ll long long
#define ull unsigned long long
const ll INF = 999999999999999999;
const double PI = acos(-1.0);

void stop()
{
	//system("pause");
	exit(0);
}

ll n, m, q;
ll A[55][55];
ll res = INF;
ll tarx, tary;
ll dp[55][55];
bool vis[55][55];

void bfs(ll x, ll y, ll k)
{
	queue<pair<ll,ll>> qu;
	for (ll i = 1; i <= n; i++)
	{
		for (ll j = 1; j <= m; j++)
		{
			vis[i][j] = 0;
		}
	}
	if (A[x][y] > k || A[tarx][tary] > k) return;
	dp[x][y] = 0;
	vis[x][y] = 1;
	qu.push(make_pair(x, y));
	while (qu.size() > 0)
	{
		ll nxtx = qu.front().first;
		ll nxty = qu.front().second;
		qu.pop();
		if (nxtx - 1 > 0 && !vis[nxtx - 1][nxty] && A[nxtx-1][nxty] <= k)
		{
			qu.push(make_pair(nxtx - 1, nxty));
			vis[nxtx - 1][nxty] = 1;
			dp[nxtx - 1][nxty] = dp[nxtx][nxty] + 1;
		}
		if (nxty - 1 > 0 && !vis[nxtx][nxty - 1] && A[nxtx][nxty - 1] <= k)
		{
			qu.push(make_pair(nxtx, nxty - 1));
			vis[nxtx][nxty - 1] = 1;
			dp[nxtx][nxty - 1] = dp[nxtx][nxty] + 1;
		}
		if (nxtx + 1 <= n && !vis[nxtx + 1][nxty] && A[nxtx + 1][nxty] <= k)
		{
			qu.push(make_pair(nxtx + 1, nxty));
			vis[nxtx + 1][nxty] = 1;
			dp[nxtx + 1][nxty] = dp[nxtx][nxty] + 1;
		}
		if (nxty + 1 <= m && !vis[nxtx][nxty + 1] && A[nxtx][nxty + 1] <= k)
		{
			qu.push(make_pair(nxtx, nxty + 1));
			vis[nxtx][nxty + 1] = 1;
			dp[nxtx][nxty + 1] = dp[nxtx][nxty] + 1;
		}
	}
	res = dp[tarx][tary];
}

int main()
{
	ios::sync_with_stdio(false);

	cin >> n >> m >> q;
	ll type, x1, y1, x2, y2, k;
	for (ll i = 1; i <= n; i++)
	{
		for (ll j = 1; j <= m; j++)
		{
			A[i][j]++;
		}
	}
	for (ll qe = 1; qe <= q; qe++)
	{
		cin >> type;
		if (type == 1)
		{
			cin >> x1;
			for (ll i = 1; i <= m; i++)
			{
				A[x1][i] = 0;
			}
		}
		else if (type == 2)
		{
			cin >> y1;
			for (ll i = 1; i <= n; i++)
			{
				A[i][y1] = 0;
			}
		}
		else
		{
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			/*if (qe <= k)
			{
				cout << abs(x1 - x2) + abs(y1 - y2) << endl;
				continue;
			}*/
			tarx = x2;
			tary = y2;
			bfs(x1, y1, k);
			if (!vis[x2][y2]) cout << -1 << endl;
			else cout << res << endl;
			/*for (ll i = 1; i <= n; i++)
			{
				for (ll j = 1; j <= m; j++)
				{
					cout << dp[i][j] << " ";
				}
				cout << endl;
			}*/
		}
		for (ll i = 1; i <= n; i++)
		{
			for (ll j = 1; j <= m; j++)
			{
				A[i][j]++;
			}
		}
	}

	stop();
}