#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define ll long long
#define ull unsigned long long
const ll INF = 999999999999999999;
const double PI = acos(-1.0);

void stop()
{
	//system("pause");
	exit(0);
}



int main()
{
	ios::sync_with_stdio(false);

	ll t;
	cin >> t;
	for (ll tt = 0; tt < t; tt++)
	{
		ll n, m, q, p;
		cin >> n >> m >> q >> p;
		vector<pair<ll,ll>> v[5005];
		ll a, b, d;
		for (ll i = 0; i < m; i++)
		{
			cin >> a >> b >> d;
			v[a].push_back(make_pair(b,d));
		}
		set<ll> st[5005];
		vector<ll> vst[5005];
		vst[1].push_back(0);
		for (ll i = 1; i <= n; i++)
		{
			for (ll j = 0; j < v[i].size(); j++)
			{
				ll nxt = v[i][j].first;
				ll dl = v[i][j].second;
				for (ll h = 0; h < vst[i].size(); h++)
				{
					vst[nxt].push_back(vst[i][h] + dl);
				}
			}
			for (ll j = 0; j < vst[i].size(); j++)
			{
				st[i].insert(vst[i][j]);
			}
		}
		ll f, r;
		for (ll qe = 0; qe < q; qe++)
		{
			cin >> f >> r;
			if (st[f].lower_bound(r) == st[f].end())
			{
				cout << 0;
			}
			else
			{
				ll cur = *st[f].lower_bound(r);
				if ((double)cur <= (double)p * (double)r / (double)(p - 1))
				{
					cout << 1;
				}
				else
				{
					cout << 0;
				}
			}
		}
		cout << endl;
	}

	stop();
}