#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    int n, m, q;
    cin >> n >> m >> q;
    int a[n][m];
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) a[i][j] = 0;
    for (int _ = 0; _ < q; ++_) {
        int t;
        cin >> t;
        for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) a[i][j]++;
        if (t == 1) {
            int r;
            cin >> r;
            --r;
            for (int j = 0; j < m; ++j) a[r][j] = 0;
        }
        else if (t == 2) {
            int c;
            cin >> c;
            --c;
            for (int i = 0; i < n; ++i) a[i][c] = 0;
        }
        else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            --r1, --c1, --r2, --c2;
            if (a[r1][c1] > k) {
                cout << -1 << "\n";
                continue;
            }
            int d[n][m];
            for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) d[i][j] = (int)1e9;
            d[r1][c1] = 0;
            queue<pair<int, int>> now;
            d[r1][c1] = 0;
            now.push({r1, c1});
            while (!now.empty()) {
                pair<int, int> v = now.front();
                int r = v.first;
                int c = v.second;
                now.pop();
                if (r != 0) {
                    if (a[r - 1][c] <= k && d[r - 1][c] > d[r][c] + 1) {
                        d[r - 1][c] = d[r][c] + 1;
                        now.push({r - 1, c});
                    }
                }
                if (r != n - 1) {
                    if (a[r + 1][c] <= k && d[r + 1][c] > d[r][c] + 1) {
                        d[r + 1][c] = d[r][c] + 1;
                        now.push({r + 1, c});
                    }
                }
                if (c != 0) {
                    if (a[r][c - 1] <= k && d[r][c - 1] > d[r][c] + 1) {
                        d[r][c - 1] = d[r][c] + 1;
                        now.push({r, c - 1});
                    }
                }
                if (c != m - 1) {
                    if (a[r][c + 1] <= k && d[r][c + 1] > d[r][c] + 1) {
                        d[r][c + 1] = d[r][c] + 1;
                        now.push({r, c + 1});
                    }
                }
            }
            if (d[r2][c2] == (int)1e9) {
                cout << -1 << "\n";
            }
            else cout << d[r2][c2] << "\n";
        }
    }
    return 0;
}