#include <bits/stdc++.h>

using namespace std;
using ll = long long;


struct Seg {
    int l, r;
    Seg(int l_ = 0, int r_ = 0) : l(l_), r(r_) {}
    bool operator<(const Seg& a) const {
        return pair{min(l, r), l + r} < pair{min(a.l, a.r), a.l + a.r};
    }
};




int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> a(n);

    for (int& v : a) {
        char ch; cin >> ch;
        v = ch - '0';
    }

    vector<Seg> sg;
    int cnt = 0;

    for (int i = 0; i < n; ++i) {
        if (a[i] == 1) {
            if (sg.empty()) {
                sg.emplace_back(cnt);
                cnt = 0;

            }
            else {
                sg.back().r = cnt;
                sg.emplace_back(cnt);
                cnt = 0;
            }
        }
        else {
            ++cnt;
        }
    }

    if (cnt > 0) {
        sg.back().r = cnt;
    }

    cnt = 0;
    int ans = 0;
    auto min_el = *min_element(sg.begin(), sg.end());
    ans = min(min_el.l, min_el.r) * (sg.size() + 1) + sg.size();
    while (sg.size() >= 1) {
        int ind = min_element(sg.begin(), sg.end()) - sg.begin();
        ans = max(ans, min(sg[ind].l, sg[ind].r) * ((int)sg.size() + 1) + (int)sg.size());
        if (sg.size() == 1) {
            break;
        }
        if (ind == 0) {
            sg[1].l += sg[0].l;
            sg.erase(sg.begin());
        }
        else if (ind == sg.size() - 1) {
            sg[ind - 1].r += sg[ind].r;
            sg.pop_back();
        }
        else {
            sg[ind - 1].r += sg[0].r;
            sg[ind + 1].l += sg[ind].l;
            sg.erase(sg.begin() + ind);
        }
    }

    sg.clear();

    for (int i = 0; i < n; ++i) {
        if (a[i] == 1) {
            if (sg.empty()) {
                sg.emplace_back(cnt);
                cnt = 0;
            }
            else {
                sg.back().r = cnt;
                sg.emplace_back(cnt);
                cnt = 0;
            }
        }
        else {
            ++cnt;
        }
    }

    if (cnt > 0) {
        sg.back().r = cnt;
    }
    min_el = *min_element(sg.begin(), sg.end());
    int curr = min(min_el.l, min_el.r) * (sg.size() + 1) + sg.size();

    while (curr != ans) {
        int ind = min_element(sg.begin(), sg.end()) - sg.begin();
        curr = max(curr, min(sg[ind].l, sg[ind].r) * ((int)sg.size() + 1) + (int)sg.size());
        if (ans == curr) {
            break;
        }
        if (ind == 0) {
            sg[1].l += sg[0].l;
            sg.erase(sg.begin());
        }
        else if (ind == sg.size() - 1) {
            sg[ind - 1].r += sg[ind].r;
            sg.pop_back();
        }
        else {
            sg[ind - 1].r += sg[0].r;
            sg[ind + 1].l += sg[ind].l;
            sg.erase(sg.begin() + ind);
        }
    }

    cout << ans << "\n";
    min_el = *min_element(sg.begin(), sg.end());
    int len = min(min_el.l, min_el.r);
    for (int i = 0; i < sg.size(); ++i) {
        for (int j = 0; j < len; ++j) {
            cout << 0;
        }
        cout << 1;
    }
    for (int j = 0; j < len; ++j) {
        cout << 0;
    }


    return 0;
}