#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int pi_func(const string& t, int k) {
    vector<int> p(t.size());

    for (int i = 1; i < t.size(); ++i) {
        p[i] = p[i - 1];
        while (p[i] > 0 && t[p[i]] != t[i]) {
            p[i] = p[p[i] - 1];
        }
        if (t[p[i]] == t[i]) {
            ++p[i];
        }
    }

    return count_if(p.begin(), p.end(), [&k](int a) { return a == k; });
}



signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n;
    cin >> m >> n;

    string p;
    cin >> p;

    string s, temp;
    s.reserve(1000000);

    for (int i=  0; i < n; ++i) {
        int t; cin >> t;
        if (t == 1) {
            cin >> temp;
            s += temp;
        }
        else {
            int pos, len;
            cin >> pos >> len;
            --pos;
            for (int i = pos; i < pos + len; ++i) {
                s += s[i];
            }
        }
    }

    cout << pi_func(p + "#" + s, p.size());

    return 0;
}

/*


 */