#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18;
const int MAXK = 2e5 + 18;
const int MAXN = 2e5 + 18;

vector<pair<int, int>> a(MAXK);

vector<int> h(2 * MAXN, INF);

int get(int i, int j)
{
    if (h[i] >= a[j].first && h[i] <= a[j].second)
    {
        return 0;
    }
    return min(abs(h[i] - a[j].first), abs(h[i] - a[j].second));
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int m, n, k;
    cin >> m >> n >> k;
    for (int i = 0; i < k; ++i)
    {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < 2 * n; ++i)
    {
        cin >> h[i];
    }
    sort(h.begin(), h.end());
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        int cur = INF;
        for (int j = 0; j < k; ++j)
        {
            cur = min(cur, get(2 * i, j) + get(2 * i + 1, j));
        }
        ans += cur;
    }
    cout << ans << endl;
    return 0;
}

