#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e18;
const int MAXK = 2e5 + 18;
const int MAXN = 2e5 + 18;

vector<pair<int, int>> a(MAXK);

vector<vector<int>> h;

int get(int num, int i, int j)
{
    if (h[num][i] >= a[j].first && h[num][i] <= a[j].second)
    {
        return 0ll;
    }
    return min(abs(h[num][i] - a[j].first), abs(h[num][i] - a[j].second));
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int m, n, k;
    cin >> m >> n >> k;
    for (int i = 0; i < k; ++i)
    {
        cin >> a[i].first >> a[i].second;
    }
    h.resize(m);
    for (int i = 0; i < m; ++i)
    {
        h[i].resize(2 * n);
        for (int j = 0; j < 2 * n; ++j)
        {
            cin >> h[i][j];
        }
        sort(h[i].begin(), h[i].end());
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        int cur = INF;
        for (int j = 0; j < k; ++j)
        {
            int s = 0;
            for (int num = 0; num < m; ++num)
            {
                s += (get(num, 2 * i, j) + get(num, 2 * i + 1, j));
            }
            cur = min(cur, s);
        }
        ans += cur;
    }
    cout << ans << endl;
    return 0;
}

