#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e6 + 18;

#define int long long

const int mod = 2e9 + 17;

const int base = 47;

int p1[MAXN];
int h[MAXN];

int get_hash(int l, int r)
{
    return (h[r] - h[l] * p1[r - l] % mod + mod) % mod;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    string p;
    cin >> p;
    string t;
    for (int ii = 0; ii < m; ++ii)
    {
        int cmd;
        cin >> cmd;
        if (cmd == 1)
        {
            string s;
            cin >> s;
            for (auto el : s)
            {
                t.push_back(el);
            }
        }
        else
        {
            int pos, len;
            cin >> pos >> len;
            for (int i = pos - 1; i < pos + len - 1; ++i)
            {
                t.push_back(t[i]);
            }
        }
    }
    int ans = 0;
    p1[0] = 1;
    for (int i = 1; i < MAXN; ++i)
    {
        p1[i] = (p1[i - 1] * base) % mod;
    }
    h[0] = 0;
    for (int i = 0; i < t.size(); ++i)
    {
        h[i + 1] = (h[i] * base + (t[i] - 'a' + 1)) % mod;
    }
    int h_p = 0;
    for (int i = 0; i < p.size(); ++i)
    {
        h_p = (h_p * base + (p[i] - 'a' + 1)) % mod;
    }
    for (int i = 0; i + p.size() <= t.size(); ++i)
    {
        if (get_hash(i, i + p.size()) == h_p)
        {
            ++ans;
        }
    }
    cout << ans << endl;
    return 0;
}


