#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define pb push_back
#define kek pop_back
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define len(v) ((int)(v).size())
#define mp make_pair

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

const int INF = 1e18 + 666;

void run();

signed main() {
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
}

const int mod = 998244353;

void run() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<int>> mn(n + 1, vector<int>(m + 1, INF)), mx(n + 1, vector<int>(m + 1, -INF));
	for (int i = 0; i <= n; ++i) {
		mn[i][m] = 0;
		mx[i][m] = 0;
	}
	for (int j = 0; j <= m; ++j) {
		mn[n][j] = 0;
		mx[n][j] = 0;
	}
	for (int i = 0; i < k; ++i) {
		int x, y, v;
		cin >> x >> y >> v;
		--x, --y;
		mn[x][y] = v;
		mx[x][y] = v;
	}
	for (int i = n - 1; i > -1; --i) {
		for (int j = m - 1; j > -1; --j) {
			if (mn[i][j] != INF) {
				continue;
			}
			mn[i][j] = min(mx[i + 1][j], mx[i][j + 1]);
			mx[i][j] = max(mn[i + 1][j], mn[i][j + 1]);
		}
	}
	int sm = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			sm += mn[i][j];
			if (sm < 0) {
				sm += mod;
			}
			if (sm >= mod) {
				sm -= mod;
			}
		}
	}
	cout << sm << endl;
}