#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <fstream>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif
const int INF = 1e9;
const int MOD = 1e9 + 7;
mt19937 rng(time(0));

int n;
string s;

void init() {

}

void solve() {
	init();
	vector<int> zeros;
	vector<int> ones;
	for (int i = 0; i < n; i++) {
		if (s[i] == '0') {
			zeros.push_back(i);
		}
		else {
			ones.push_back(i);
		}
	}
	int ans = ones.size();
	int kek = -1;
	for (int cnt_zeros = 1; cnt_zeros < n; cnt_zeros++) {
		int pnt = 0;
		int iter = 0;
		while (1) {
			pnt += cnt_zeros - 1;
			if (pnt >= zeros.size()) {
				iter--;
				break;
			}
			int idx = (pnt == -1 ? 0 : zeros[pnt]);
			int nxt = lower_bound(ones.begin(), ones.end(), idx) - ones.begin();
			if (nxt == ones.size()) {
				break;
			}
			pnt = lower_bound(zeros.begin(), zeros.end(), ones[nxt]) - zeros.begin();
			iter++;
		}
		cerr << cnt_zeros << ' ' << iter << '\n';
		if (iter == 0) {
			continue;
		}
		if (ans < cnt_zeros * (iter + 1) + iter) {
			ans = cnt_zeros * (iter + 1) + iter;
			kek = cnt_zeros;
		}
	}
	cerr << '\n';
	cout << ans << '\n';
	if (kek == -1) {
		while (ans--) {
			cout << '1';
		}
	}
	else {
		while (ans > kek) {
			for (int i = 0; i < kek; i++) {
				cout << '0';
			}
			cout << '1';
			ans -= kek + 1;
		}
		for (int i = 0; i < kek; i++) {
			cout << '0';
		}
	}
	cout  << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("A.in", "r", stdin);
		freopen("A.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> s) {
		solve();
	}
	return 0;
}


