#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const ll N = 500010;
const ll INF = 1000000000;

string s, c;
ll dp[N];
ll zero[N], one[N];
bool ok[N];
int ud = 0;
vector < int > ons;
vector < int > ok_ch;

int bp(int tl, int tr, int g, int i) {
	int l = tl - 1, r = tr + 1;
	while (r - l > 1) {
		int mid = (l + r) >> 1;
		if (zero[ons[mid]] - g >= i)
			r = mid;
		else
			l = mid;
	}
	if (r == tr + 1)
		return INF;
	else
		return r;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n;
	cin >> n;
	cin >> s;
	s = '0' + s;
	dp[0] = 0;
	for (int i = 1; i <= n; ++i) {
		zero[i] = zero[i - 1] + (s[i] == '0');
		one[i] = one[i - 1] + (s[i] == '1');
		if (s[i] == '1')
			ons.push_back(i);
	}
	pair < ll, ll > Min = { INF, INF };
	for (int i = 0; i <= n; ++i) {
		while (!ok_ch.empty())
			ok[ok_ch.back()] = false, ok_ch.pop_back();
		int pred = 0;
		int m = 0;
		int last = -1;
		for (;;) {
			int ind = bp(last + 1, ons.size() - 1, zero[pred], i);
			if (ind == INF)
				break;
			int j = ons[ind];
			if (zero[j] - zero[pred] >= i && zero[n] - zero[j] >= i) {
				ok[j] = true;
				ok_ch.push_back(j);
				m += zero[j - 1] - zero[pred] - i;
				m += one[j - 1] - one[pred];
				pred = j;
				last = ind;
			}
			else {
				break;
			}
		}
		int j = pred;
		m += zero[n] - zero[j] - i;
		m += one[n] - one[j];
		if (pred == 0)
			m = INF;
		Min = min(Min, { m, i });
	}
	cout << n - Min.first << endl;
	for (int i = 1; i <= n - Min.first; ++i) {
		if (i % (Min.second + 1) == 0)
			cout << '1';
		else
			cout << '0';
	}
}