#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const ll N = 500010;
const ll INF = 1000000000000;

pair < ll, ll > SL[N];
ll h[N];

ll d(ll a, pair < ll, ll > b) {
	if (a >= b.first && a <= b.second)
		return 0;
	return min(abs(a - b.first), abs(a - b.second));
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	ll m, n, k;
	cin >> m >> n >> k;
	for (ll i = 1; i <= k; ++i)
		cin >> SL[i].first >> SL[i].second;
	sort(SL + 1, SL + (k + 1));
	ll P = 0;
	for (int i = 1; i <= 2 * n * m; ++i)
		cin >> h[i];
	for (int j = 0; j < m; ++j) {
		sort(h + 2 * n * j + 1, h + 2 * n * (j + 1) + 1);
	}
	int last = 1;
	for (int i = 0; i < n; ++i) {
		ll Min = INF;
		int iter = 0;
		for (int l = last; l <= k; ++l) {
			ll sum = 0;
			for (int j = 0; j < m; ++j) {
				int ind = (2 * i + j * 2 * n) + 1;
				sum += d(h[ind], SL[l]) + d(h[ind + 1], SL[l]);
			}
			if (Min > sum)
				Min = sum, iter = l;
		}
		P += Min;
		last = iter;
	}
	cout << P;
}