#include <bits/stdc++.h>

using namespace std;
vector<int> base_points;

int check(int k) {
    int bonus = 0;
    int deleted = 0;
    for (int i = 0; i < base_points.size(); ++i) {
        if (base_points[i] + bonus >= k) {
            bonus = 0;
            continue;
        }
        bonus += base_points[i];
        deleted++;
    }
    return deleted;
}

int main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int last_one = -1;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1') {
            base_points.emplace_back(i - last_one - 1);
            last_one = i;
        }
    }
    base_points.emplace_back(n - 1 - last_one);

    int l = 0, r = n + 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (base_points.size() - check(m) > 1) {
            l = m;
        } else {
            r = m;
        }
    }
    int gr_cnt = base_points.size() - check(l) - 1;
    cout << (gr_cnt + 1) * l + gr_cnt << endl;
    for (int i = 0; i < l; ++i) {
        cout << '0';
    }
    for (int i = 0; i < gr_cnt; ++i) {
        cout << '1';
        for (int j = 0; j < l; ++j) {
            cout << '0';
        }
    }
    cout << endl;
}