#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<set>
#include<map>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<long long>> ms(n, vector<long long>(m, 1e18));
	for (int i = 0; i < k; i++) {
		int x, y, z;
		cin >> x >> y >> z;
		ms[x - 1][y - 1] = z;
	}
	vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(m + 1, { 0,0 }));
	long long ans = 0;
	for (int i = n-1; i >-1; i--) {
		for (int j = m - 1; j > -1; j--) {
			if (ms[i][j] != 1e18) {
				dp[i][j].first = ms[i][j];
				dp[i][j].second = ms[i][j];
			}
			else {
				dp[i][j].first = min(dp[i][j + 1].second, dp[i + 1][j].second);
				dp[i][j].second = max(dp[i][j + 1].first, dp[i + 1][j].first);
			}
			ans += dp[i][j].first;
			ans %= 998244353;
			ans += 998244353;
			ans %= 998244353;
		}
	}
	cout << ans;
	system("pause");
}