#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++i)
#define all(x) (x).begin(), (x).end()

vector<int> pf(string s) {
    int n = s.size();
    vector<int> res(n, 0);
    for (int i = 1; i < n; ++i) {
        int j = res[i - 1];
        while (j > 0 && s[j] != s[i]) {
            j = res[j - 1];
        }

        res[i] = j + (s[i] == s[j]);
    }

    return res;
}

int get(string a, string b) {
    string s = a + "#" + b;
    auto p = pf(s);
    int res = 0;
    for (int i = 0; i < p.size(); ++i) {
        if (p[i] >= a.size()) {
            res++;
        }
    }
    return res;
}

const int MAXN = 2e3 + 5;
int n, m;
string s;
string s0;
int cnt0, cnt01;
ll c;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> m >> n;
    cin >> s;

    rep(i, n) {
        int t;
        cin >> t;
        if (t == 1) {
            cin >> s0;
            c = 1;
        } else {
            int pos, len;
            cin >> pos >> len;
            pos--;
            c += len / s0.size();
        }
    }

    string s1;
    int sz1 = 0;
    while (s1.size() < s.size()) {
        s1 += s0;
        sz1++;
    }

    if (sz1 > c) {
        cout << 0 << endl;
        return 0;
    }

    int strict = get(s, s1);
    int unstrict = get(s, s1 + s0) - strict;

    ll res = 1LL * (c - sz1 + 1) * unstrict + strict;
    cout << res << endl;
}