#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops  ")

int32_t main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a;
    a.reserve(n);

    int pref = 0;
    char x;
    for (int i = 0; i < n; i++) {
        cin >> x;
        if (x == '0') {
            pref++;
        } else {
            a.push_back(pref);
            pref = 0;
        }
    }

    a.push_back(pref);

    int best = 0;
    vector<int> ba;
    bool change = false;
    int last = 0;

    auto solve = [&](const int &t) -> int {
        vector<int> b;
        int p = 0;
        for (int x : a) {
            if (x >= t) {
                b.push_back(t);
                p = 0;
            } else {
                p += x;
                if (p >= t) {
                    b.push_back(t);
                    p = 0;
                }
            }
        }
        if (b.size() < 2) {
            return 0;
        }
        int cur = (int) b.size() * t + (int) b.size() - 1;
        return cur;
    };

    auto solve2 = [&](const int &t) -> pair<int, vector<int>> {
        vector<int> b;
        int p = 0;
        for (int x : a) {
            if (x >= t) {
                b.push_back(t);
                p = 0;
            } else {
                p += x;
                if (p >= t) {
                    b.push_back(t);
                    p = 0;
                }
            }
        }
        if (b.size() < 2) {
            return {0, {}};
        }
        int cur = (int) b.size() * t + (int) b.size() - 1;

        return {cur, b};
    };

    int l = -1, r = n;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        int t1 = solve(m);
        int t2 = solve(m + 1);
        if (t1 <= t2 && t2 > 0) {
            l = m;
        } else {
            r = m;
        }
    }

    auto ans = solve2(r);

    best = ans.first;
    ba = ans.second;

    cout << best << '\n';
    for (int i = 0; i < ba.size(); i++) {
        for (int j = 0; j < ba[i]; j++) {
            cout << '0';
        }
        if (i != ba.size() - 1) {
            cout << '1';
        }
    }

    return 0;
}