from itertools import combinations_with_replacement

m, n, k = map(int, input().split())

tables = [list(map(int, input().split())) for _ in range(k)]
students = [sorted(list(map(int, input().split()))) for _ in range(m)]


def fits(a, b, l, r):
    S = 0
    if not l <= a <= r:
        S += min(abs(a - l), abs(a - r))
    if not l <= b <= r:
        S += min(abs(b - l), abs(b - r))
    return S


tables.sort()

ans = 0
for i in range(n):
    cur = 10 ** 19
    last = 10 ** 19
    broke = False
    for t in range(k):
        l, r = tables[t]
        tmp = 0
        for j in range(m):
            a, b = students[j][2 * i], students[j][2 * i + 1]
            tmp += fits(a, b, l, r)
        cur = min(cur, tmp)
        if not broke and tmp < last:
            broke = True
        elif broke and tmp > last:
            exit(-1)
        last = tmp
    ans += cur
print(ans)
