#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#define $ if (DEV)

#include <bits/stdc++.h>
using namespace std;
void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        test_cnt = 179;
    }
    for (int t = 0; t < test_cnt; ++t) {
        if (feof(stdin)) break;
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
}

template<typename T>
bool relmax(T& lhs, const T rhs) {
    if (lhs < rhs) {
        lhs = rhs;
        return true;
    }
    return false;
}template<typename T>
bool relmin(T& lhs, const T rhs) {
    if (lhs > rhs) {
        lhs = rhs;
        return true;
    }
    return false;
}
using ll = long long;
const ll MOD = 998'244'353;
#define all(x) x.begin(), x.end()
void entry(int test_id) {
    int n, m, k;
    scanf("%d %d %d", &m, &n, &k);
    vector<pair<ll, ll>> S;
    for (int i = 0; i < k; ++i) {
        ll l, r;
        scanf("%lld %lld", &l, &r);
        S.emplace_back(l,r);
    }
    {
        auto ss = S;
        sort(all(ss), [&](pair<ll, ll> lhs, pair<ll, ll> rhs){
            if (lhs.first != rhs.first) return lhs.first < rhs.first;
            return lhs.second > rhs.second;
        });
        S.clear();
        ll j = -1;
        for (int i = 0; i < k; ++i) {
            if (ss[i].second <= j) continue;
            j = ss[i].second;
            S.push_back(ss[i]);
        }
        k = S.size();
    }
    vector<ll> H(2*n*m);
    for (int i = 0; i < 2*n*m; ++i){
        int x;
        scanf("%d", &x);
        H[i] = x;
    }
    for (int i = 0; i < m; ++i) {
        int l = 2*n*i;
        int r = l+2*n;
        sort(H.begin()+l, H.begin()+r);
    }
    auto calc = [&](ll l, ll r, ll h) {
        if (h < l) return l - h;
        if (h > r) return h-r;
        return (ll) 0;
    };
    ll ans = 0;
    for (int part = 0; part < n; ++part) {
        ll res = 1e18;
        for (int ty = 0; ty < k; ++ty) {
            ll score = 0;
            for (int j = 0; j < m; ++j) {
                score += calc(S[ty].first, S[ty].second, H[j*2*m + 2*part]);
                score += calc(S[ty].first, S[ty].second, H[j*2*m + 2*part+1]);
            }
            res = min(res, score);
        }
        ans += res;
    }    //relmin(ans, res);
    printf("%lld\n", ans);
}