#include <string>
#include <vector>
#include <iostream>
#include <map>
#include <algorithm>

using namespace std;

#define int long long
#define all(s) s.begin(), s.end()
typedef pair<int, int> pii;

vector <int> prefix_function(string s)
{
	vector <int> ret(s.size());
	ret[0] = 0;
	for (int i = 1; i < s.size(); ++i)
	{
		int pi = ret[i - 1];
		while (true)
		{
			if (s[pi] == s[i])
			{
				pi++;
				break;
			}
			if (pi == 0) break;
			pi = ret[pi - 1];
		}
		ret[i] = pi;
	}
	return ret;
}

signed main()
{
	//freopen("true.txt", "r", stdin);
	int n, m;
	cin >> n >> m;
	string p;
	cin >> p;

	string t;
	while (m--)
	{
		int re;
		cin >> re;
		if (re == 1)
		{
			string s;
			cin >> s;
			t += s;
		}
		else
		{
			int pos, len;
			cin >> pos >> len;
			for (int j = pos - 1, need = 0; need < len; ++need)
				t += t[j++];
		}
	}

	int ans = 0;
	string f = p + '#' + t;
	auto g = prefix_function(f);

	ans = count(g.begin(), g.end(), p.size());
	cout << ans;
	return 0;
}