#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> zfunc(string &s)
{
    int n = s.size();
    vector<int> z(n, 0);
    int l = 0;
    int r = 0;

    for (int i = 1; i < n; i++)
    {
        if (i <= r)
            z[i] = min(z[i - l], r - i + 1);
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if (i + z[i] - 1 > r)
        {
            l = i;
            r = i + z[i] - 1;
        }
    }

    return z;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n;
    cin >> m >> n;

    string p;
    cin >> p;

    string t;
    ll added = 0;
    for (int i = 0; i < n; i++)
    {
        int c;
        cin >> c;

        if (c == 1)
            cin >> t;
        else
        {
            ll pos, len;
            cin >> pos >> len;
            pos--;
            added += len;
        }
    }

    string mts = t;
    while (mts.size() < p.size() + t.size() + 2 &&
            mts.size() + 1 <= t.size() + added)
        mts += t.back();

    int r = t.size() - 1;
    while (r != 0 && t[r - 1] == t.back())
        r--;

    string f = p + "#" + mts;
    auto z = zfunc(f);
    ll ans = 0;
    for (int i = p.size() + 1; i < p.size() + 1 + r; i++)
        if (z[i] == p.size())
            ans++;

    bool flag = false;
    for (char c : p)
        if (c != t.back())
            flag = true;

    if (!flag)
        ans += t.size() - r + added - p.size() + 1;

    cout << ans << endl;

    return 0;
}