#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> zfunc(string &s)
{
    int n = s.size();
    vector<int> z(n, 0);
    int l = 0;
    int r = 0;

    for (int i = 1; i < n; i++)
    {
        if (i <= r)
            z[i] = min(z[i - l], r - i + 1);
        while (i + z[i] < n && s[i + z[i]] == s[z[i]])
            z[i]++;
        if (i + z[i] - 1 > r)
        {
            l = i;
            r = i + z[i] - 1;
        }
    }

    return z;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n;
    cin >> m >> n;

    string p;
    cin >> p;

    vector<string> strings;
    vector<pair<char, ll>> unacc;
    char lchar;
    for (int i = 0; i < n; i++)
    {
        int c;
        cin >> c;

        if (c == 1)
        {
            string x;
            cin >> x;
            strings.push_back(x);
            lchar = strings.back().back();
        }
        else
        {
            ll pos, len;
            cin >> pos >> len;
            pos--;

            if (len <= p.size())
                strings.push_back(string(len, lchar));
            else
            {
                strings.push_back(string(p.size(), lchar));
                unacc.push_back({lchar, len - p.size()});
            }
        }
    }

    int k = strings.size();
    ll ans = 0;
    for (int i = 0; i < k; i++)
    {
        string f = p + "#" + strings[i];
        if (i != k - 1)
        {
            int cur = i + 1;
            int left = p.size();
            while (left > 0 && cur < k)
            {
                if (strings[cur].size() < left)
                {
                    f += strings[cur];
                    left -= strings[cur].size();
                    cur++;
                }
                else
                {
                    for (int j = 0; j < left; j++)
                        f += strings[cur][j];
                    break;
                }
            }
        }

        auto z = zfunc(f);
        for (int j = p.size() + 1; j < p.size() + 1 + strings[i].size(); j++)
            if (z[j] == p.size())
                ans++;
    }

    for (auto up : unacc)
    {
        bool flag = false;
        for (char c : p)
            if (c != up.first)
                flag = true;

        if (!flag)
            ans += up.second;
    }

    cout << ans << endl;

    return 0;
}