#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

const int N = (int)5e5;
int cnt[N];
string s;

int get_ans(int d, int n)
{
    int now = 0;
    int cnt_del = 0, right = n - 1;
    while (now != d)
    {
        if (s[right--] == '0')
            now += 1;
        else
            cnt_del++;
    }
    now = 0;
    for (int i = 0; i <= right; i++)
    {
        if (s[i] == '1')
        {
            if (now != d)
                cnt_del++;
            else
                now = 0;
        }
        else
        {
            if (now != d)
                now++;
            else
                cnt_del++;
        }
    }
    cnt_del += now;
    return n - cnt_del;
}

int main()
{
    int n;
    cin >> n;
    cin >> s;
    if (s[0] == '0')
        cnt[0] = 1;
    for (int i = 1; i < n; i++)
    {
        cnt[i] += cnt[i - 1];
        if (s[i] == '0')
            cnt[i]++;
    }
    int max_d = -1;
    for (int i = 0; i < n; i++)
        if (s[i] == '1')
        {
            //cout << i << ") " << cnt[i] << ' ' << cnt[n - 1] - cnt[i] << '\n';
            max_d = max(max_d, min(cnt[i], cnt[n - 1] - cnt[i]));
        }
    get_ans(3, n);
    int ans = -1, ans_d = -1;
    for (int i = 0; i <= max_d; i++)
    {
        int res = get_ans(i, n);
        if (res > ans)
        {
            ans = res;
            ans_d = i;
        }
    }
    cout << ans << '\n';
    int p = (ans - ans_d) / (1 + ans_d);
    for (int i = 0; i < p; i++)
    {
        for (int j = 0; j < ans_d; j++)
            cout << '0';
        cout << '1';
    }
    for (int j = 0; j < ans_d; j++)
        cout << '0';
    return 0;
}

/*
10
0100100000
*/
