#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <cassert>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>
#include <ctime>
#include <fstream>
#include <deque>

#pragma warning(4996:disable)
#pragma comment(linker, "/STACK:512000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()

const int inf = 2e9;
const ll llinf = 1e18, mod = 998'244'353;
const char el = '\n';

mt19937 rnd(time(NULL));

struct biba {
	int r, c, v, b;
	biba(int _r, int _c, int _v) { r = _r, c = _c, v = _v; }
	biba() {}
};
bool operator <(const biba & a, const biba & b) {
	return a.r + a.c > b.r + b.c;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector<biba> a(k);
	map<int, int> q;
	forn(i, k) {
		cin >> a[i].r >> a[i].c >> a[i].v;
		a[i].b = a[i].c - a[i].r + (n - 1);
		q[a[i].b] = max(q[a[i].b], a[i].c);
	}
	sort(all(a));
	forn(i, k) {
		bool tmp = q[a[i].b - 3] >= a[i].c - 1;
		if (tmp)
			q[a[i].b - 1] = max(q[a[i].b - 1], a[i].c - 1);
		tmp = q[a[i].b + 3] >= a[i].c + 2;
		if (tmp)
			q[a[i].b + 1] = max(q[a[i].b + 1], a[i].c);
	}
	int l1 = -10, l2 = -10;
	for (auto to : q) {
		if (to.x < 0 || to.y == 0 || to.x >= n + m - 1) continue;
		if (to.x & 1) {
			if (to.x - l1 == 4) {
				q[to.x - 2] = max(q[to.x - 2], min(to.y - 2, q[to.x - 4]));
			}
			l1 = to.x;
		}
		else {
			if (to.x - l2 == 4) {
				q[to.x - 2] = max(q[to.x - 2], min(to.y - 2, q[to.x - 4]));
			}
			l2 = to.x;
		}
	}
	ll ans = 0;
	for (auto to : q) {
		if (to.x < 0 || to.y == 0 || to.x >= n + m - 1) continue;
		if (to.x < n - 1) ans = (ans + to.y) % mod;
		else ans = (ans + (to.y - (to.x - n + 1))) % mod;
	}
	ans = (ans % mod + mod) % mod;
	cout << ans;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}