#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define x first
#define y second

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 random1(1893496);
int randlr(int l, int r) {
    return random1() % (r - l + 1) + l;
}

const int inf = 1e15;
const int mod = 998244353;
//int trap[1009][1009];
int dp[1009][1009][2];

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            //trap[i][j] = inf;
            dp[i][j][0] = inf;
            dp[i][j][1] = inf;

            //trap[n][j] = 0;
            dp[n][j][0] = 0;
            dp[n][j][1] = 0;
        }

        //trap[i][m] = 0;
        dp[i][m][0] = 0;
        dp[i][m][1] = 0;
    }

    int k;
    cin >> k;

    for (int i = 0; i < k ; i++) {
        int x, y;
        cin >> x >> y;
        int w;
        cin >> w;
        x--;
        y--;

       // trap[x][y] = w;
        dp[x][y][0] = w;
        dp[x][y][1] = w;
    }

    int answ = 0;
    for (int i = n - 1; i > -1; i --) {
        for (int j = m - 1; j > -1; j--) {
            if (dp[i][j][0] != inf) continue;
            dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
            dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
        }
    }

    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
           // cout << dp[i][j][0] << ' ';
            answ = (answ + dp[i][j][0] + 7 * mod) % mod;
        }
       // cout << endl;
    }

    cout << answ;

    return 0;
}


