#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <math.h>
#include <algorithm>
#include <string>
#include <vector>

#define pb push_back

using namespace std;

typedef long long ll;

ll const inf = 1e18;

ll n, m, k;

vector<pair<ll, ll> > part;
vector <ll> ch[100100];

int main()
{
	//freopen("input.txt", "r", stdin);
	cin >> m >> n >> k;
	for (ll i = 0; i < k; i++)
	{
		ll l, r;
		cin >> l >> r;
		part.pb({ l, r });
	}

	sort(part.begin(), part.end());

	for (ll i = 0; i < m; i++)
	{
		for (ll j = 0; j < 2 * n; j++)
		{
			ll a;
			cin >> a;
			ch[i].pb(a);
		}
		sort(ch[i].begin(), ch[i].end());
	}

	ll S = 0;
	int it = 0;
	vector<ll> vec;
	ll pref[2 * m + 1];
	for (ll i = 0; i < n; i++)
	{
		vec.clear();
		for (ll j = 0; j < m; j++)
		{
			vec.pb(ch[j][i * 2]);
			vec.pb(ch[j][i * 2 + 1]);
		}
		sort(vec.begin(), vec.end());
		ll siz = vec.size();
		pref[0] = 0;
		for (ll j = 0; j < vec.size(); j++)
		{
			pref[j + 1] = pref[j] + vec[j];
		}
		ll mini = inf;
		for (ll j = it; j < k; j++)
		{
			
			ll sum = 0;
			ll l = -1;
			ll r = siz;
			while (l != r - 1)
			{
				ll m = (l + r) / 2;
				if (vec[m] >= part[j].first)r = m; else l = m;
			}
			ll l1 = l;
			l = -1;
			r = siz;
			while (l != r - 1)
			{
				ll m = (l + r) / 2;
				if (vec[m] <= part[j].second)l = m; else r = m;
			}
			ll r1 = r;
			
			sum += (l1 + 1) * part[j].first - pref[l1 + 1];
			sum += (pref[siz] - pref[r1] - (siz - r1) * part[j].second);
			it++;
			mini = min(mini, sum);
		}
		S += mini;
	}
	cout << S;
	return 0;
}