#include <iostream>
#include <cstring>
#define int long long

using namespace std;

const int M = 998244353, INF = 1e18;
int n, m, k;

bool ok(int x, int y) {
	return (x < n && y < m);
}

signed main() {
	ios_base :: sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m >> k;
	bool bad[n][m];
	int val[n][m];
	memset(bad, 0, sizeof(bad));
	for (int i = 0; i < k; i++) {
		int x, y, t;
		cin >> x >> y >> t;
		x--;
		y--;
		bad[x][y] = 1;
		val[x][y] = t;
	}
	int dp1[n][m], dp2[n][m];
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			dp1[i][j] = INF;
			dp2[i][j] = -INF;
			if (bad[i][j]) {
				dp1[i][j] = dp2[i][j] = val[i][j];
				continue;
			}
			if (i == n - 1 || j == m - 1) {
				dp1[i][j] = min(dp1[i][j], 0ll);
				dp2[i][j] = max(dp2[i][j], 0ll);
			}
			if (i != n - 1) {
				dp1[i][j] = min(dp1[i][j], dp2[i + 1][j]);
				dp2[i][j] = max(dp2[i][j], dp1[i + 1][j]);
			}
			if (j != m - 1) {
				dp1[i][j] = min(dp1[i][j], dp2[i][j + 1]);
				dp2[i][j] = max(dp2[i][j], dp1[i][j + 1]);
			}
		}
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			ans += dp1[i][j];
		}
	}
	ans %= M;
	if (ans < 0) ans += M;
	cout << ans << endl;
	return 0;
}
