#define _CRT_SECURE_NO_WARNINGS

#include <set>
#include <string>
#include <vector>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = (int)3e3 + 7;
const int INF = (int)1e9 + 7;
long long MOD = 998244353;

#define mp make_pair

////////////////////////////////////////////

int m, n, k;
long long l[N], r[N], d[N][N][2], res[N][N];

long long get_bad(long long l, long long r, long long x) {
	return (l <= x && x <= r ? 0 : min(abs(l - x), abs(r - x)));
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif
	cin >> m >> n >> k;
	for (int i = 0; i < k; i++)
		cin >> l[i] >> r[i];
	if (k == 2)
		l[k] = r[k] = 1e15;
	vector <int> h(2 * n);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++)
			cin >> h[j];
		sort(h.begin(), h.end());
		int to = 1, fr = 0;
		d[0][0][fr] = get_bad(l[2], r[2], h[0]) + get_bad(l[2], r[2], h[1]);
		d[0][1][fr] = get_bad(l[1], r[1], h[0]) + get_bad(l[1], r[1], h[1]);
		d[1][0][fr] = get_bad(l[0], r[0], h[0]) + get_bad(l[0], r[0], h[1]);
		for (int j = 1; j < n; j++) {
			for (int g = 0; g < n; g++) {
				for (int s = 0; s < n; s++) {
					if (g + s > j + 1)
						continue;
					d[g][s][to] = 1e18;
					if (g + s != j + 1) 
						d[g][s][to] = min(d[g][s][to], d[g][s][fr] + get_bad(l[2], r[2], h[2 * j]) + get_bad(l[2], r[2], h[2 * j + 1]));
					if (s != 0)
						d[g][s][to] = min(d[g][s][to], d[g][s - 1][fr] + get_bad(l[1], r[1], h[2 * j]) + get_bad(l[1], r[1], h[2 * j + 1])); 
					if (g != 0)
						d[g][s][to] = min(d[g][s][to], d[g - 1][s][fr] + get_bad(l[0], r[0], h[2 * j]) + get_bad(l[0], r[0], h[2 * j + 1]));
				}
			}
			swap(fr, to);
		}
		for (int j = 0; j < n; j++) {
			for (int g = 0; g < n; g++)
				res[j][g] += d[j][g][fr];
		}
	}
	long long ans = 1e18;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i + j > n)
				continue;
			ans = min(ans, res[i][j]);
		}
	}
	cout << ans;
}