#include <bits/stdc++.h>
 
#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}
 
const int MAXN = 2e5 + 1;
vector<int> a[MAXN];
 
const ll INF = 1e18;
 
int get(pair<int, int> a, int h) {
    if (a.f <= h && h <= a.s) return 0;
    return min(abs(a.f - h), abs(a.s - h));
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m, k;
    cin >> m >> n >> k;
    map<int, int> d;
    for (int i = 0; i < k; ++i) {
        int l, r;
        cin >> l >> r;
        chkmax(d[l], r);
    }
    vector<pair<int, int>> dsk;
    dsk.reserve(d.size());
    for (auto i : d)
        dsk.pb(i);
    for (int i = 0; i < m; ++i) {
        a[i].resize(2 * n);
        for (int j = 0; j < 2 * n; ++j)
            cin >> a[i][j];
        sort(a[i].begin(), a[i].end());
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        int ci = 2 * i;
        ll cur_ans = INF;
        for (auto j : dsk) {
            ll res = 0;
            for (int cl = 0; cl < m; ++cl) {
                res += get(j, a[cl][ci]);
                res += get(j, a[cl][ci + 1]);
            }
            chkmin(cur_ans, res);
        }
        ans += cur_ans;
    }
    cout << ans;
    return 0;
}