#include <bits/stdc++.h>
#define int long long
#define endl '\n'
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define len(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()

using namespace std;
void solve();
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}

struct tbl{
    int l, r;

    int dist(int a){
        return l <= a && a <= r ? 0 : min(abs(l - a), abs(r - a));
    }
};

struct person2{
    int r1, r2;
};

int dist(person2 a, tbl p){
    return p.dist(a.r1) + p.dist(a.r2);
}


const int inf = (int) 1e18 + 3;

void solve(){
    int m, n, k; cin >> m >> n >> k;
    vector<tbl> tbls(k); forn (i, k) cin >> tbls[i].l >> tbls[i].r;
    vector<vector<person2>> grps(m);
    forn (i, m){
        vector<int> a(n * 2); forn (j, n * 2) cin >> a[j];
        sort(all(a)); forn (j, n) grps[i].push_back({a[j * 2], a[j * 2 + 1]});
    }
    int bst_splt = inf;
    for (int cnt0 = 0; cnt0 <= n; ++cnt0){
        int ans = 0;

        int cnt1 = n - cnt0;
        auto tbls1 = tbls[1], tbls0 = tbls[0];


        for (auto grp : grps) {
            int cur = 0;
            for (auto j : grp)
                cur += dist(j, tbls0);
            vector<int> add(n);
            for (auto j : grp){
                add.push_back(dist(j, tbls1) - dist(j, tbls0));
            }
            sort(all(add));
            forn (i, cnt1) cur += add[i];
        }
        bst_splt = min(bst_splt, ans);
    }
    cout << bst_splt << endl;
}