# include <iostream>
# include <vector>
# include <map>
# include <set>
# include <math.h>
# include <cmath>
# include <algorithm>
# include <string>
# include <stack>

using namespace std;
long long const mod =239239;
long long const kek = 987;

long long poww(long long a, long long b) {
	long long res = 1;
	while (b > 0) {
		if (b % 2 == 1) res *= a;
		a *= a;
		b /= 2;
		a %= mod;
		res %= mod;
	}
	return res;
}

int main() {

	int n, m;
	cin >> m >> n;

	string t;
	cin >> t;
	string s = "";
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		if (a == 1) {
			string ss;
			cin >> ss;
			s += ss;
		}
		else {
			int l, num;
			cin >> l >> num;
			--l;
			for (int j = 0; j < num; j++) {
				s += s[j + l];
			}
		}
	}
	vector<long long> hash(s.size() + 1);
	hash[0] = 0;
	for (int i = 0; i < s.size(); i++) {
		hash[i + 1] = hash[i] * kek + s[i];
		hash[i + 1] %= mod;
	}
	long long hash1 = 0;
	for (int i = 0; i < t.size(); i++) {
		hash1 = hash1 * kek + t[i];
		hash1 %= mod;
	}
	int num = 0;
	for (int i = 0; i<int(s.size()) - int(t.size()) + 1; i++) {
		long long h = hash[i + t.size()] - hash[i] * poww(kek, t.size());
		h = (h % mod + mod) % mod;
		if (h == hash1) num++;
	}
	cout << num;
	cin >> num;

}
/*
3 4
aba
1 ab
2 1 3
2 3 3
2 1 8
*/

/*
2 4 3
1 2 2
2 4 -3
2 1 1

*/