# include <iostream>
# include <vector>
# include <map>
# include <set>
# include <math.h>
# include <cmath>
# include <algorithm>
# include <string>
# include <stack>

using namespace std;
long long const mod =239239239;
long long const kek = 98798;

long long poww(long long a, long long b) {
	long long res = 1;
	while (b > 0) {
		if (b % 2 == 1) res *= a;
		a *= a;
		b /= 2;
		a %= mod;
		res %= mod;
	}
	return res;
}

int main() {

	int n, m;
	cin >> m >> n;

	string t;
	cin >> t;
	int a;
	cin >> a;
	string s;
	cin >> s;
	long long num = 1;
	for (int i = 0; i < n - 1; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		num += c / s.size();
	}
	string ss = "";
	while (ss.size() < 2 * t.size()) ss += s;
	vector<long long> hash(ss.size() + 1);
	hash[0] = 0;
	for (int i = 0; i < ss.size(); i++) {
		hash[i + 1] = hash[i] * kek + ss[i];
		hash[i + 1] %= mod;
	}
	long long hash1 = 0;
	for (int i = 0; i < t.size(); i++) {
		hash1 = hash1 * kek + t[i];
		hash1 %= mod;
	}
	int num1 = 0;
	int num2 = 0;
	vector<int> d(s.size(), 0);
	for (int i = 0; i<s.size(); i++) {
		long long h = hash[i + t.size()] - hash[i] * poww(kek, t.size());
		h = (h % mod + mod) % mod;
		if (h == hash1) d[i] = 1;

	}
	num1 = s.size()*num - t.size() + 1;
	num1 /= s.size();
	long long f = s.size()*num - t.size() + 1 - num1 * s.size();
	long long ans = 0;
	for (int i = 0; i < s.size(); i++) {
		if (i <= f) ans += d[i];
		ans += d[i] * num1;
	}
	cout << ans;
	cin >> ans;
}
/*
3 4
aba
1 ab
2 1 3
2 3 3
2 1 8
*/

/*
2 4 3
1 2 2
2 4 -3
2 1 1

*/