#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define endl "\n"

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int INF = 1e18;
const ll P = 1e9 + 9;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}

void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

int check(int p, int l, int r)
{
    if (p >= l && p <= r)
        return 0;
    return min(abs(r - p), abs(l - p));
}
int m, n, k;
int find_val(int i1, vector<vector<int>>& p, vector<pii>& desk, int s)
{
    int i = 2 * i1;
    int j = 2 * i1 + 1;
    int tsum = 0;
    for (int t = 0; t < m; ++t)
    {
        tsum += check(p[t][i], desk[s].first, desk[s].second) + check(p[t][j], desk[s].first, desk[s].second);
    }
    return tsum;
}

signed main()
{
    hello();

    cin >> m >> n >> k;
    vector <pii> desk(k);
    for (int i = 0; i < k; ++i)
        cin >> desk[i].first >> desk[i].second;

    sort(desk.begin(), desk.end());

    vector <vector<int>> p;
    for (int t = 0; t < m; ++t)
    {
        vector <int> ppl(2 * n);
        for (int i = 0; i < 2 * n; ++i)
            cin >> ppl[i];
        sort(ppl.begin(), ppl.end());
        p.push_back(ppl);
    }
    int res = 0;
    for (int i1 = 0; i1 < n; ++i1)
    {
        int mres = INF;
        int l = 0, r = k - 1;
        while (r - l > 3)
        {
            int m1 = (r - l) / 3 + l;
            int m2 = r - (r - l) / 3;
            int r1 = find_val(i1, p, desk, m1);
            int r2 = find_val(i1, p, desk, m2);
            if (r1 > r2)
                r = m2;
            else
                l = m1;
        }
        for (int i = l; i <= r; ++i)
            mres = min(mres, find_val(i1, p, desk, i));
        res += mres;
    }
    cout << res << endl;
}
