#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <string>
#include <vector>
#include <functional>>
#include <set>
#include <queue>

using namespace std;

const int INF = 1000000000;

int main() {
	int m, n, k;
	cin >> m >> n >> k;
	vector <pair<int, int>> p(k);
	for (int i = 0; i < k; i++) {
		cin >> p[i].first >> p[i].second;
	}

	vector <vector <int>> arr(m, vector <int>(2 * n));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> arr[i][j];
		}
		sort(arr[i].begin(), arr[i].end());
	}

	int ans = 0;
	for (int i = 0; i < n; i++) {
		int l = i * 2, r = i * 2 + 1;
		int dp_ans = INF;
		for (int j = 0; j < k; j++) {
			int dp_dp_ans = 0;
			for (int f = 0; f < m; f++) {
				dp_dp_ans += abs(arr[f][l] - p[j].first) + abs(arr[f][l] - p[j].second) - abs(p[j].first - p[j].second);
				dp_dp_ans += abs(arr[f][r] - p[j].first) + abs(arr[f][r] - p[j].second) - abs(p[j].first - p[j].second);
			}
			dp_ans = min(dp_dp_ans, dp_ans);
		}
		ans += dp_ans;
	}
	cout << ans / 2;
	system("pause");
	return 0;
}