#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>

#define rn(n); int n; cin >> n
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int INF = (int)1e9 + 10;
const int N = (int)1e5 + 10;
const int MOD = (int)1e9 + 7;

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int m, n, k;
	cin >> m >> n >> k;
	vvi a(m, vi(2 * n));
	vii b(k);
	for (int i = 0; i < k; ++i)
		cin >> b[i].first >> b[i].second;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) {
			cin >> a[i][j];
		}
		sort(a[i].begin(), a[i].end());
	}
	
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int minn = INF;
		for (int j = 0; j < k; ++j) {
			int sum = 0;
			for (int x = 0; x < m; ++x) {
				if (b[j].first > a[x][i * 2])
					sum += b[j].first - a[x][i * 2];
				if (b[j].first > a[x][i * 2 + 1])
					sum += b[j].first - a[x][i * 2 + 1];
				if (b[j].second < a[x][i * 2])
					sum += a[x][i * 2] - b[j].second;
				if (b[j].second < a[x][i * 2 + 1])
					sum += a[x][i * 2 + 1] - b[j].second;
			}
			minn = min(minn, sum);
		}
		ans += minn;
	}
	cout << ans;

	return 0;
}