#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>

#define rn(n); int n; cin >> n
#define mp make_pair
#define pb push_back
#define endl '\n'
#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int INF = (int)1e18 + 10;
const int N = (int)1e5 + 10;
const int MOD = (int)1e9 + 7;

int count(vi& a, int x) {
	int ans = 0;
	for (int i = 0; i < a.size(); ++i)
		ans += abs(a[i] - x);
	return ans;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int m, n, k;
	cin >> m >> n >> k;
	vvi a(m, vi(2 * n));
	vii b(k);
	bool flag = 1;
	for (int i = 0; i < k; ++i) {
		cin >> b[i].first >> b[i].second;
		if (b[i].first != b[i].second)
			flag = 0;
	}
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < 2 * n; ++j) {
			cin >> a[i][j];
		}
		sort(a[i].begin(), a[i].end());
	}
	if (flag)
		sort(b.begin(), b.end());
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		vi v(2 * m);
		for (int j = 0; j < m; ++j) {
			v[j * 2] = a[j][i * 2];
			v[j * 2 + 1] = a[j][i * 2 + 1];
		}
		sort(v.begin(), v.end());
		if (flag) {
			int x = v[v.size() / 2];
			int l = -1, r = k;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (b[l].first < x)
					l = x;
				else
					r = x;
			}
			if (l == -1)
				ans += count(v, b[r].first);
			else if (r == k)
				ans += count(v, b[l].first);
			else
				ans += min(count(v, b[l].first), count(v, b[r].first));
			continue;
		}
		vi pref(2 * m + 1), suf(2 * m + 1);
		for (int j = 1; j <= 2 * m; ++j)
			pref[j] = pref[j - 1] + v[j - 1];
		for (int j = 2 * m - 1; j >= 0; --j)
			suf[j] = suf[j + 1] + v[j];
		int minn = INF;
		for (int j = 0; j < k; ++j) {
			int sum = 0;
			int l = -1, r = 2 * m;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (v[mid] < b[j].first)
					l = mid;
				else
					r = mid;
			}
			sum += b[j].first * r - pref[r];
			l = -1; r = 2 * m;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (v[mid] <= b[j].second)
					l = mid;
				else
					r = mid;
			}
			sum += suf[r] - b[j].second * (2 * m - r);
			minn = min(minn, sum);
		}
		ans += minn;
	}
	cout << ans;

	return 0;
}