#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
#define inf (long long)1e9+5
//#define DBG

using namespace std;

int discomfort(int h, pair<int, int> x) {
    auto[l, r] = x;
    if (h >= l && h <= r) return 0;
    return min(abs(l - h), abs(r - h));
}

int main() {
#ifdef DBG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int m, n, k;
    cin >> m >> n >> k;
    vector<pair<int, int>> a;
    for (int i = 0; i < k; i++) {
        int l, r;
        cin >> l >> r;
        a.push_back(make_pair(l, r));
    }
    vector<vector<int>> h(m, vector<int>(n * 2));
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n * 2; i++) {
            cin >> h[j][i];
        }
        sort(h[j].begin(), h[j].end());
    }

    int res = 0;
    for (int g = 0; g < m; g++) {
        vector<bool> used(n * 2);
        for (int x = 0; x < k; x++) {
            int minia = 0;
            int minib = 1;
            for (int i = 0; i < n * 2; i++) {
                if (used[i]) continue;
                for (int j = i + 1; j < n * 2; j++) {
                    if (used[j]) continue;

                    if (discomfort(h[g][j], a[x]) + discomfort(h[g][j], a[x]) <
                        discomfort(h[g][minia], a[x]) + discomfort(h[g][minib], a[x])) {
                        minia = j;
                        minib = i;
                    }
                }
            }
            res += discomfort(h[g][minia], a[x]) + discomfort(h[g][minib], a[x]);
            used[minia] = true;
            used[minib] = true;
        }
    }

    cout << res;


    return 0;
}