#include <bits/stdc++.h>
using namespace std;

struct ZeroCut {
	int len, lef, rig;
};

struct OneValue {
	int i, lef, rig;
};

bool operator<(const ZeroCut& a, const ZeroCut& b) {
	return (a.len == b.len) ? a.lef < b.lef : a.len < b.len;
}

bool operator<(const OneValue& a, const OneValue& b) {
	return a.i < b.i;
}

const int MAX_N = 5e5 + 10;
char str[MAX_N], ans[MAX_N], buffer[MAX_N];
int ansLen = 0;
set<ZeroCut> zerocuts;
set<OneValue> ones;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n >> str;
	int num_ones = 0, last_one = -1;
	
	int tmp = 0;
	for (; tmp < n; ++tmp)
		if (str[tmp] == '1')
			break;
	ones.insert({-1, int(1e7), tmp});
	tmp = 0;
	for (; tmp < n; ++tmp)
		if (str[n - tmp - 1] == '1')
			break;
	ones.insert({n, tmp, int(1e7)});

	for (int i = 0; i < n; ++i) {
		if (str[i] == '1') {
			++num_ones;
			zerocuts.insert({i - last_one - 1, last_one + 1, i - 1});
			tmp = 0;
			for (; i + tmp + 1 < n; ++tmp)
				if (str[i + tmp + 1] == '1')
					break;
			ones.insert({i, i - last_one - 1, tmp});
			last_one = i;
		}
	}
	zerocuts.insert({n - last_one - 1, last_one + 1, n - 1});
	/*for (auto v : ones)
		cout << v.i << " " << v.lef << " " << v.rig << "\n";
	cout << "\n";
	for (auto v : zerocuts)
		cout << v.len << " " << v.lef << " " << v.rig << "\n";
	cout << "----\n";*/
	for (int one = num_ones; one > 0; --one) {
		auto p = *zerocuts.begin();
		int dist = p.len;
		if (ansLen < dist * (one + 1) + one) {
			ansLen = dist * (one + 1) + one;
			for (int i = 0; i < ansLen; ++i)
				ans[i] = '0';
			for (int i = 0; i < one; ++i)
				ans[(i + 1) * (dist + 1) - 1] = '1';
			ans[ansLen] = '\0';
		}
		if (one != 1) {
			//DELETE NEXT
			//cout << "DELETE " << one << endl;
			OneValue lefBound = *(--ones.lower_bound({zerocuts.begin()->lef, -1, -1}));
			OneValue rigBound = *(ones.lower_bound({zerocuts.begin()->rig + 1, -1, -1}));
			ZeroCut curr = *zerocuts.begin();
			//cout << lefBound.i << " " << rigBound.i << "\n";
			if (lefBound.lef > rigBound.rig) {
				OneValue newBound = *ones.lower_bound({rigBound.i + 1, -1, -1});
				ZeroCut nextCut = *zerocuts.lower_bound({newBound.lef, rigBound.i + 1, newBound.i - 1});
				ones.erase(newBound);
				ones.erase(rigBound);
				ones.erase(lefBound);
				ones.insert({newBound.i, newBound.lef + curr.len, newBound.rig});
				ones.insert({lefBound.i, lefBound.lef, newBound.lef + curr.len});
				zerocuts.erase(curr);
				zerocuts.erase(nextCut);
				zerocuts.insert({nextCut.len + curr.len, lefBound.i + 1, newBound.i - 1});
			} else {
				OneValue newBound = *(--ones.find(lefBound));
				ZeroCut nextCut = *zerocuts.lower_bound({newBound.rig, newBound.i + 1, lefBound.i - 1});
				ones.erase(newBound);
				ones.erase(lefBound);
				ones.erase(rigBound);
				ones.insert({newBound.i, newBound.lef, newBound.rig + curr.len});
				ones.insert({rigBound.i, rigBound.lef + curr.len, rigBound.rig});
				zerocuts.erase(nextCut);
				zerocuts.erase(curr);
				zerocuts.insert({curr.len + nextCut.len, newBound.i + 1, rigBound.rig - 1});
			}
			//cout << "\n";
		} else {
			break;
		}
		/*for (auto v : ones)
			cout << v.i << " " << v.lef << " " << v.rig << "\n";
		cout << "\n";
		for (auto v : zerocuts)
			cout << v.len << " " << v.lef << " " << v.rig << "\n";
		cout << "----\n";*/
	}
	cout << ansLen << "\n" << ans << "\n";
	return 0;
}