#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 1e6 + 10, BASE = 29, MOD = 1e9 + 7;

char p[MAX_N], w[MAX_N];
int buffLen = 0;
int64_t powers[MAX_N];

int64_t pHash = 0;
int64_t tHashes[MAX_N];

int isOk[MAX_N];

int64_t mod(int64_t a) {
	int64_t res = a % MOD;
	if (res < 0)
		return res + MOD;
	return res;
}

int64_t getH(int l, int r) {
	return mod(tHashes[r] - tHashes[l] * powers[r - l] % MOD);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	powers[0] = 1;
	for (int i = 1; i < MAX_N; ++i)
		powers[i] = powers[i - 1] * BASE % MOD;
	int n, m, type;
	cin >> m >> n >> p;
	for (int i = 0; i < m; ++i)
		pHash = (pHash * BASE + p[i] - 'a') % MOD;
	int64_t blocksCnt = 1;
	int64_t wLen = 0;
	for (int j = 0; j < n; ++j) {
		cin >> type;
		if (type == 1) {
			cin >> w;
			wLen = strlen(w);
		} else {
			int64_t pos, len;
			cin >> pos >> len;
			blocksCnt += len / wLen;
		}
	}
	tHashes[0] = 0;
	for (int i = 0; i < max(3 * wLen, 3 * m); ++i)
		tHashes[i + 1] = (tHashes[i] * BASE + w[i % wLen] - 'a') % MOD;
	for (int i = 0; i <= wLen; ++i)
		if (pHash == getH(i, i + m)) {
			isOk[i] = 1;
		}
	if (m > int64_t(blocksCnt) * wLen) {
		cout << "0\n";
	} else {
		int64_t blockAns = 0;
		for (int i = 0; i < wLen; ++i)
			blockAns += isOk[i];
		int64_t ans = int64_t(blocksCnt) * blockAns - int64_t((m - 1) / wLen) * blockAns;
		for (int i = 0; i < (m - 1) % wLen; ++i)
			ans -= isOk[wLen - i - 1];
		cout << ans << "\n";
	}
	return 0;
}