#pragma GCC optimize("O3", "unroll-loops")
 
#include <iostream>
#include <vector>
#include <algorithm>
 
using namespace std;
 
#define sz(x) ((int)(x).size())
#define pii pair<int, int>
#define l first
#define r second
#define MAXN 200002
 
int n, m, k;
 
pii d[MAXN];
pair<long long, long long> td[MAXN];
vector<int> a[MAXN];
 
struct tmp {
    int x, idx = 0;
    bool is_right = false;
    bool is_left = false;
    bool is_guy = false;
    long long ans = 0;
    bool operator<(tmp a) {
        return (x < a.x);
    }
};

tmp t[4 * MAXN];
int t_sz = 0;

void add(tmp w) {
    t[t_sz++] = w;
    return;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> m >> n >> k;
    for(int i = 0; i < k; ++i) 
        cin >> d[i].l >> d[i].r;
    for(int i = 0; i < m; ++i) {
        a[i].resize(2*n);
        for(int j = 0; j < 2*n; ++j) 
            cin >> a[i][j];
        sort(a[i].begin(), a[i].end());
    }
 
    long long sum = 0;
 
    for(int j = 0; j < 2*n; j += 2) {
        long long t_ans = 1e18;
        t_sz = 0;
        for(int i = 0; i < m; ++i) {
            tmp w;
            w.is_guy = true;
            w.x = a[i][j];
            add(w);
            w.x = a[i][j + 1];
            add(w);
        }
        for(int i = 0; i < k; ++i) {
            tmp w;
            w.idx = i;
            w.x = d[i].l;
            w.is_left = true;
            add(w);

            w.is_left = false;
            w.is_right = true;
            w.x = d[i].r;
            add(w);
        }
        sort(t, t + t_sz);
        int cnt = 0;
        long long last_x = 0;
        long long cost = 0;
        for(int i = 0; i < t_sz; ++i) {
            cost += (t[i].x - last_x) * cnt;
            if(t[i].is_left)
                t[i].ans = cost;
            if(t[i].is_guy) 
                cnt++;
            last_x = t[i].x;
        }

        cnt = 0;
        last_x = 1000000000;
        cost = 0;

        for(int i = t_sz - 1; i >= 0; --i) {
            cost += (last_x - t[i].x) * cnt;
            if(t[i].is_right)
                t[i].ans = cost;
            if(t[i].is_guy) 
                cnt++;
            last_x = t[i].x;
        }

        for(int i = 0; i < t_sz; ++i) {
            if(t[i].is_left)
                td[t[i].idx].l = t[i].ans;
            if(t[i].is_right)
                td[t[i].idx].r = t[i].ans;
        }

        for(int i = 0; i < k; ++i)
            t_ans = min(t_ans, td[i].l + td[i].r);
        sum += t_ans;
    }
 
    cout << sum << endl;
    return 0;
}