#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int checker(int n, int k, const string& s, int space) {
	int del = 0, block = 0, cnt_del_flag = 0;
	for (int i = 0; i < n; ++i)
		if (s[i] == '0')
			++block;
		else {
			if (block < space) {
				++del;
				++cnt_del_flag;
			}
			else {
				del += block - space;
				block = 0;
			}
		}
	if (block < space) {
		del += block + 1;
		++cnt_del_flag;
	}
	else
		del += block - space;
	return (cnt_del_flag == k) ? n : del;
}

int main() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int k = count(s.begin(), s.end(), '1');

	int left = 0, right = n;
	while (left + 1 < right) {
		int mid = (left + right) / 2;
		if (checker(n, k, s, mid) < n)
			left = mid;
		else
			right = mid;
	}
	int ans_len = n - checker(n, k, s, left);
	string ans(ans_len, '0');
	for (int i = left; i < ans_len; i += left + 1)
		ans[i] = '1';
	cout << ans_len << "\n" << ans;
}
