#include <iostream>

using namespace std;

int ch(string &s, int k) {
    int cnt = 0;
    int ans = 0;
    for (int i = 0; i < s.size(); i++) {
        if (cnt == k) {
            while (i < s.size() && s[i] != '1') {
                i++;
            }
            if (i < s.size()) {
                ans++;
                cnt = 0;
            }
            continue;
        }
        if (s[i] == '0') {
            cnt++;
            ans++;
        }
    }
    if (cnt < k) {
        ans -= cnt;
        ans--;
    }
    if (ans <= k) {
        return 0;
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    int mx = 0;
    int id = 0;


    int l = 0;
    int r = n + 1;
    while (r - l > 2) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        if (ch(s, m1) < ch(s, m2)) {
            l = m1;
        } else {
            r = m2;
        }
    }

    for (int i = max(0, l - 2000); i <= min(r + 2000, n); i++) {
        if (ch(s, i) > mx) {
            mx = ch(s, i);
            id = i;
        }
    }
    for (int i = 0; i <= min(2000, n); i++) {
        if (ch(s, i) > mx) {
            mx = ch(s, i);
            id = i;
        }
    }
    for (int i = max(0, n - 2000); i <= n; i++) {
        if (ch(s, i) > mx) {
            mx = ch(s, i);
            id = i;
        }
    }
    cout << mx << "\n";
    for (int i = 0; i < mx; i++) {
        if (i % (id + 1) != id) {
            cout << 0;
        } else {
            cout << 1;
        }
    }
    return 0;
}