#include <stdio.h>
#include <algorithm>
#include <utility>

long long count(int *arr, int n, int l, int r) {
	long long ans = 0;
	for (int j = 0; j < n; j++) {
		if (arr[j] < l) {
			ans += l - arr[j];
		} else if (arr[j] > r) {
			ans += arr[j] - r;
		}
	}
	return ans;
}

int **arr, lol;
std::pair<int, int> *pa;

long long kek(int in1, int in2) {
	return count(arr[in1], lol, pa[in2].first, pa[in2].second);
}

long long enot(int tl, int tr, int l, int r) {
	if (tr < tl) {
		return 0;
	}
	long long ans = 0;
	int opt = l;
	int m = tl + (tr - tl) / 2;
	long long p = kek(m, l);
	for (int i = l + 1; i <= r; i++) {
		long long p1 = kek(m, i);
		if (p1 < p) {
			p = p1;
			opt = i;
		}
	}
	ans = p;
	ans += enot(tl, m - 1, l, opt);
	ans += enot(m + 1, tr, opt, r);
	return ans;
}

int main() {
	int m, n, k;
	scanf("%d%d%d", &m, &n, &k);
	std::pair<int, int> pa1[k];
	for (int i = 0; i < k; i++) {
		scanf("%d%d", &pa1[i].first, &pa1[i].second);
	}
	std::sort(pa1, pa1 + k);
	int k1 = k;
	for (int i = 0; i < k; i++) {
		if ((i > 0 && pa1[i].second <= pa1[i - 1].second) || (i < k - 1 && pa1[i].first == pa1[i + 1].first && pa1[i].second < pa1[i + 1].second)) {
			k1--;
		}
	}
	pa = new std::pair<int, int>[k1];
	k1 = 0;
	for (int i = 0; i < k; i++) {
		if ((i > 0 && pa1[i].second <= pa1[i - 1].second) || (i < k - 1 && pa1[i].first == pa1[i + 1].first && pa1[i].second < pa1[i + 1].second)) {}
		else {
			pa[k1++] = pa1[i];
		}
	}
	k = k1;
	arr = new int*[n];
	for (int i = 0; i < n; i++) {
		arr[i] = new int[2 * m];
	}
	for (int i = 0; i < m; i++) {
		int a[2 * n];
		for (int j = 0; j < 2 * n; j++)  {
			scanf("%d", &a[j]);
		}
		std::sort(a, a + 2 * n);
		for (int j = 0; j < n; j++) {
			arr[j][2 * i] = a[2 * j];
			arr[j][2 * i + 1] = a[2 * j + 1];
		}
	}
	lol = 2 * m;
	int l = 0;
	long long p = kek(0, 0);
	for (int i = 1; i < k; i++) {
		long long p1 = kek(0, i);
		if (p1 < p) {
			p = p1;
			l = i;
		}
	}
	int r = 0;
	p = kek(n - 1, 0);
	for (int i = 1; i < k; i++) {
		long long p1 = kek(n - 1, i);
		if (p1 < p) {
			p = p1;
			r = i;
		}
	}
	printf("%lld", enot(0, n - 1, l, r));
	return 0;
}
