#include <stdio.h>
#include <algorithm>

const int mod = 998244353;

int main() {
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);
	int field[n][m];
	bool field1[n][m];
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			field[i][j] = 0;
			field1[i][j] = false;
		}
	}
	for (int i = 0; i < k; i++) {
		int r, c, v;
		scanf("%d%d%d", &r, &c, &v);
		r--, c--;
		field[r][c] = v;
		field1[r][c] = true;
	}
	int dp[n + 1][m + 1][2];
	for (int i = 0; i <= m; i++) {
		dp[n][i][0] = dp[n][i][1] = 0;
	}
	for (int i = 0; i <= n; i++) {
		dp[i][m][0] = dp[i][m][1] = 0;
	}
	long long ans = 0;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (field1[i][j]) {
				dp[i][j][0] = dp[i][j][1] = field[i][j];
			} else {
				dp[i][j][0] = std::min(dp[i + 1][j][1], dp[i][j + 1][1]);
				dp[i][j][1] = std::max(dp[i + 1][j][0], dp[i][j + 1][0]);
			}
			ans += dp[i][j][0];
			ans %= mod;
		}
	}
	printf("%lld", (ans + mod) % mod);
	return 0;
}
