#include <stdio.h>
#include <algorithm>

const int MAX = 1e6;

int count_z(char *s, int *z, int n, int m) {
	int in = 0, cnt = 0;
	z[0] = 0;
	for (int i = 1; i < n; i++) {
		z[i] = 0;
		if (i <= z[in] + in) {
			z[i] = z[i - in];
			if (i + z[i] > in + z[in]) {
				z[i] = in + z[in] - i;
			}
		}
		while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
			z[i]++;
		}
		if (in + z[in] < i + z[i]) {
			in = i;
		}
		if (i > m && z[i] >= m) {
			cnt++;
		}
	}
	return cnt;
}

int main() {
	int m;
	long long n;
	scanf("%d%lld", &m, &n);
	char s[m + 1], w[MAX];
	int ttt;
	scanf("\n%s\n%d%s", s, &ttt, w);
	int le = 0;
	for (; w[le]; le++);
	long long n1 = 0;
	for (int i = 0; i < n - 1; i++) {
		long long tt;
		scanf("%d%d%lld", &ttt, &ttt, &tt);
		n1 += tt / le;
	}
	n = n1 + 1;
	if (n * le < m) {
		printf("0");
		return 0;
	}
	int t = (m + le - 1) / le;
	if (t > n) {
		t = n;
	}
	if (t == 0) {
		t = 1;
	}
	char s1[m + 1 + t * le + 1];
	s1[m + 1 + t * le] = 0;
	int z[m + 1 + t * le];
	for (int i = 0; i < m; i++) {
		s1[i] = s[i];
	}
	s1[m] = 0;
	for (int i = 0; i < t; i++) {
		for (int j = 0; j < le; j++) {
			s1[m + 1 + i * le + j] = w[j];
		}
	}
	int zz1 = count_z(s1, z, m + 1 + t * le, m);
	if (t == n) {
		printf("%d", zz1);
		return 0;
	}
	char s2[m + 1 + (t + 1) * le + 1];
	s2[m + 1 + (t + 1) * le] = 0;
	int z1[m + 1 + (t + 1) * le];
	for (int i = 0; i < m; i++) {
		s2[i] = s[i];
	}
	s2[m] = 0;
	for (int i = 0; i <= t; i++) {
		for (int j = 0; j < le; j++) {
			s2[m + 1 + i * le + j] = w[j];
		}
	}
	int z2 = count_z(s2, z1, m + 1 + (t + 1) * le, m);
	printf("%lld", zz1 + 1ll * (n - t) * (z2 - zz1));
	return 0;
}
