#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;


// -1, 1
// 0

const ll inf = (ll)1e16;




struct ev{
    ll x;
    ll type;
    ll from;
    ll pos;
    ll id;
    ev(){}
    ev(ll x, ll type, ll from, ll id): x(x), type(type), from(from), id(id) {}
    bool operator <(ev &other){
        if(x == other.x){
            return type < other.type;
        }
        return x < other.x;
    }
};


vector < ev > e;



ll m, n, k;

vector < ll > gl, gr;
vector < vector < ll > > a;
vector < ll > dp;
vector < vector < ll > > b;
vector < ll > s;

ll chck(ll bp, ll pos){
    ll res = 0;
    for(ll p1 = 0; p1 < b[bp].size(); ++p1){
        ll x = b[bp][p1];
        if(gl[s[pos]] <= x && x <= gr[s[pos]]){

        } else {
            res += min(abs(x - gl[s[pos]]), abs(x - gr[s[pos]]));
        }
    }
    return res;
}




void solve(){
//    cerr << "h\n";
    cin >> m >> n >> k;
    n *= 2;
    gl.resize(k), gr.resize(k);
    a.resize(m, vector < ll > (n));
    for(ll i = 0; i < k; ++i){
        ll l, r;
        cin >> l >> r;
        gl[i] = l, gr[i] = r;
        e.push_back({l, -1, -1, i});
        e.push_back({r, 1, -1, i});
    }
    for(ll i = 0; i < m; ++i){
        for(ll j = 0; j < n; ++j){
            cin >> a[i][j];
            e.push_back({a[i][j], 0, i, j});
        }
    }
//    cerr << "HERE\n";
    sort(e.begin(), e.end());
    vector < pair < ll, ll > > p;
    for(ll i = 0; i < e.size(); ++i){
        if(e[i].type == 0){
            p.push_back({e[i].from, e[i].id});
        } else if(e[i].type == -1) {
            s.push_back({e[i].id});
        }
    }
    b.resize(n / 2);
    map < ll, ll > cnt;
    for(ll i = 0; i < p.size(); ++i){
        b[cnt[p[i].first] / 2].push_back(a[p[i].first][p[i].second]);
        cnt[p[i].first]++;
    }
    for(ll i = 0; i < b.size(); ++i){
        sort(b[i].begin(), b[i].end());
    }

    dp.resize(b.size(), inf);
    for(ll i = 0; i < b.size(); ++i){
//        cerr << i << "\n";
        ll bdelta = inf;
        ll l = 0;
        ll r = k - 1;
        while(r - l > 3){
            ll m1 = l + (r - l) / 3;
            ll m2 = r - (r - l) / 3;
            if(chck(i, m1) < chck(i, m2)){
                r = m2;
            } else {
                l = m1;
            }
        }
        for(ll j = l; j <= r; ++j){
            bdelta = min(bdelta, chck(i, j));
        }
//        for(ll j = 0; j < k; ++j){
//            ll delta = 0;
//            for(ll p1 = 0; p1 < b[i].size(); ++p1){
//                ll x = b[i][p1];
//                if(gl[s[j]] <= x && x <= gr[s[j]]){
//
//                } else {
//                    delta += min(abs(x - gl[s[j]]), abs(x - gr[s[j]]));
//                }
//            }
//        }
        if(i == 0){
            dp[i] = min(dp[i], bdelta);
        } else {
            dp[i] = min(dp[i], dp[i - 1] + bdelta);
        }
    }
    cout << dp[b.size() - 1] << "\n";
}



signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
