#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = (ll)1e16;
const ll mod = 998244353;
const ll maxn = 1002;

ll n, m, k;

vector < vector < vector < ll > > > dp;
vector < vector < ll > > has;


inline ll rec(ll i, ll j, ll p){
    if(i < 0 || j < 0 || i >= n || j >= m)return 0;
    if(dp[i][j][p] != inf)return dp[i][j][p];
    if(has[i][j] != inf){
        dp[i][j][p] = has[i][j];
    } else {
        ll r1 = rec(i + 1, j, 1 - p);
        ll r2 = rec(i, j + 1, 1 - p);
        if(p == 0){
            if(dp[i][j][p] == inf){
                dp[i][j][p] = r1;
            }
            dp[i][j][p] = min(dp[i][j][p], r1);
            dp[i][j][p] = min(dp[i][j][p], r2);
        } else {
            if(dp[i][j][p] == inf){
                dp[i][j][p] = r1;
            }
            dp[i][j][p] = max(dp[i][j][p], r1);
            dp[i][j][p] = max(dp[i][j][p], r2);
        }
    }
    return dp[i][j][p];
}

void solve(){
    cin >> n >> m >> k;
    dp.resize(n, vector < vector < ll > > (m, vector < ll > (2, inf)));
    has.resize(n, vector < ll > (m, inf));
    for(ll i = 0; i < k; ++i){
        ll y, x, v;
        cin >> y >> x >> v;
        --y, --x;
        has[y][x] = v;
    }
//    for(ll i = 0; i < n; ++i){
//        for(ll j = 0; j < m; ++j){
//            cerr << has[i][j] << " ";
//        }
//        cerr << "\n";
//    }
    for(ll i = 0; i < n; ++i){
        for(ll j = 0; j < m; ++j){
            rec(i, j, 0);
            rec(i, j, 1);
        }
    }
//    for(ll i = 0; i < n; ++i){
//        for(ll j = 0; j < m; ++j){
//            cerr << dp[i][j][1] << " ";
//        }
//        cerr << "\n";
//    }
    ll sm = 0;
    for(ll i = 0; i < n; ++i){
        for(ll j = 0; j < m; ++j){
            sm += dp[i][j][0];
        }
    }
    sm += (ll)2e7 * (ll)mod;
    sm %= mod;
    cout << sm << "\n";
}



signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
