#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

#define add push_back
#define del pop_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const ll INF = (ll)1e9 + 2019;
const ll MOD = 998244353;

const int N = 1e5 + 100;
ll dp[7][N][2], v[7][N];
bool f[7][N];
int tt[7][N], T;

void clr(int i, int j) {
	if (tt[i][j] >= T) {
		return;
	}
	dp[i][j][0] = 0, dp[i][j][1] = 0;
	v[i][j] = 0;
	f[i][j] = 0;
	tt[i][j] = T;
}

ll recalc(int n, int m) {
	for (int i = n; i > 0; i--) {
		for (int j = m; j > 0; j--) {
			clr(i, j);
			if (f[i][j]) {
				dp[i][j][0] = dp[i][j][1] = v[i][j];
				continue;
			}
			clr(i, j + 1);
			clr(i + 1, j);
			dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
			dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
		}
	}
	ll ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			ans += (dp[i][j][0] + MOD * 2ll) % MOD;
			ans %= MOD;
		}
	}
	return ans;
}

void mane() {
	int n, m, k;
	cin >> n >> m >> k;
	queue <pair <pii, int>> q;
	for (int i = 0; i < k; i++) {
		int r, c, w;
		cin >> r >> c >> w;
		q.push({{r, c}, w});
	}
	ll ans = 0;
	while (sz(q)) {
		T++;
		int cc = q.front().f.s;
		int r = q.front().f.f, c = q.front().f.s;
		clr(r, c - cc + 7);
		f[r][c - cc + 7] = 1;
		v[r][c - cc + 7] = q.front().s;
		q.pop();
		cerr << r << " " << c << endl;
		while (sz(q) && q.front().f.s - c <= 7) {
			r = q.front().f.f, c = q.front().f.s;
			clr(r, c - cc + 7);
			f[r][c - cc + 7] = 1;
			v[r][c - cc + 7] = q.front().s;
			q.pop();
			cerr << r << " " << c << endl;
		}
		cerr << "RE" << endl;
		ans += recalc(n, m);
		ans %= MOD;
	}
	cout << ans;
}

int main() {
#ifdef osss
	freopen("input.txt", "r", stdin);
#endif
	mane();
}