#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e9 + 7;
const int p = 998244353;

void uniq(vector<int> &a)
{
    sort(a.begin(), a.end());
    vector<int> b;
    b.push_back(a[0]);
    for (int i = 1; i < a.size(); ++i)
        if (a[i] != a[i - 1])
            b.push_back(a[i]);
    a = b;
}

signed main()
{
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<pair<int, int>, int> > d;
    for (int i = 0; i < k; ++i)
    {
        int r, c, v;
        cin >> r >> c >> v;
        d.push_back({{r, c}, v});
    }
    vector<int> all;
    for (int i = 0; i < k; ++i)
    {
        for (int j = 0; j < 8; ++j)
            if (d[i].first.second - j >= 0)
                all.push_back(d[i].first.second - j);
    }
    uniq(all);
    map<int, int> to;
    for (int i = 0; i < all.size(); ++i)
        to[all[i]] = i;
    m = all.size();
    int dp[n][m][2];
    for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
    for (int k = 0; k < 2; ++k)
        dp[i][j][k] = MAXN;
    for (int i = 0; i < k; ++i)
    {
        int r, c, v;
        r = d[i].first.first;
        c = to[d[i].first.second];
        v = d[i].second;
        --r;
        --c;
        dp[r][c][0] = v;
        dp[r][c][1] = v;
    }

    for (int i = n - 1; i > -1; --i)
    for (int j = m - 1; j > -1; --j)
    {
        if (dp[i][j][0] != MAXN) continue;
        if (i < n - 1) dp[i][j][0] = dp[i + 1][j][1];
        else
            dp[i][j][0] = 0;
        if (j == m - 1)
            dp[i][j][0] = min(dp[i][j][0], 0ll);
        else
            dp[i][j][0] = min(dp[i][j][0], dp[i][j + 1][1]);
        if (i < n - 1)
            dp[i][j][1] = dp[i + 1][j][0];
        else dp[i][j][1] = 0;
        if (j == m - 1) dp[i][j][1] = max(dp[i][j][1], 0ll);
        else dp[i][j][1] = max(dp[i][j][1], dp[i][j + 1][0]);
    }
    int res = 0;
    for (int i = 0; i < n; ++i)
    for (int j = 0; j < m; ++j)
        res = (res + dp[i][j][0]) % p;
    res += p;
    res %= p;
    cout << res << endl;
}
