#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <cstring>

using namespace std;

#define int long long
#define sz(a) (int)(a.size())
#define pb emplace_back

void fast_io() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

const int MAXN = 50;
const int MAXM = 100 + 3;
pair<int, int> sl[MAXN];
vector<int> groups[MAXM];

signed main() {
	fast_io();
	int m, n, k;
	cin >> m >> n >> k;
	fill(groups, groups + m, vector<int>(2 * n));
	for (int i = 0; i < k; i++) {
		int l, r;
		cin >> l >> r;
		for (int j = 0; j < n; j++) {
			sl[i * n + j] = { l, r };
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			cin >> groups[i][j];
		}
		sort(groups[i].begin(), groups[i].end());
	}
	int ans = 1e18;
	for (int mask = 0; mask < (1 << (n * k)); mask++) {
		vector<pair<int, int>> cur;
		int cnt = 0;
		for (int i = 0; i < n * k; i++) {
			if ((mask | (1 << i)) == mask) {
				cur.pb(sl[i]);
				cnt++;
			}
		}
		if (cnt == n) {
			sort(cur.begin(), cur.end());
			int cur_p = 0;
			for (int j = 0; j < m; j++) {
				double cur_sl = 0;
				int l = sl[0].first, r = sl[0].second;
				for (int it = 0; it < 2 * n; it++) {
					if (cur_sl == (int)cur_sl) {
						l = cur[(int)cur_sl].first, r = cur[(int)cur_sl].second;
					}
					cur_p += (l <= groups[j][it] && groups[j][it] <= r ? 0 :
						min(abs(groups[j][it] - l), abs(groups[j][it] - r)));
					cur_sl += 0.5;
				}
			}
			ans = min(ans, cur_p);
		}
	}
	cout << ans;
	return 0;
}