#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define sz(x) int(x.size())
#define pii pair<int, int>

vector <int> ans;

void solve(string &s, int k) {
    ans.resize(0);
    int cnt = 0;
    int ones = 0;
    for (int i = 0; i < sz(s); ++i) {
        if (s[i] == '0' && cnt < k) {
            ++cnt;
            ans.pb(0);
        }
        else if (cnt == k && s[i] == '1') {
            cnt = 0;
            ans.pb(1);
            ++ones;
        }
    }
    if (cnt < k) {
        while (cnt) {
            ans.pop_back();
            --cnt;
        }
        if (sz(ans) && ans.back() == 1) {
            ans.pop_back();
            --ones;
        }
    }
    if (ones == 0)
        ans.resize(0);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    int cnto = 0, cntz = 0;
    for (char c : s) {
        if (c == '1')
            ++cnto;
        else
            ++cntz;
    }
    int res = cnto;
    vector <int> t;
    int ncc = 0;
    set <int> tos;
    for (int i = 0;i < n; ++i) {
        if (s[i] == '0')
            ++ncc;
        else {
            tos.insert(ncc);
            if (ncc)
                tos.insert(ncc - 1);
            tos.insert(ncc + 1);
            ncc = 0;
        }
    }
    tos.insert(ncc);
    for (int i = 1; i < 1000; ++i) {
        solve(s ,i);
        if (sz(ans) > sz(t))
            swap(t, ans);
    }
    for (int i = max(1, n - 1000); i < n; ++i) {
        solve(s, i);
        if (sz(ans) > sz(t))
            swap(t, ans);
    }
    for (int i : tos) {
        if (!i)
            continue;
        solve(s, i);
        if (sz(ans) > sz(t))
            swap(t, ans);
    }
    int res2 = 0;
    int nc= 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0')
            ++nc;
        else {
              //  cout << i << " " << min(nc, cntz - nc) * 2 + 1 << endl;
            res2 = max(res2, min(nc, cntz - nc) * 2 + 1);
        }
    }
   // cout << res2 << endl;
    if (res2 >= res && res2 >= sz(t)) {
        cout << res2 << endl;
        for (int i = 0; i < res2 / 2; ++i) {
            cout << '0';
        }
        cout << '1';
        for (int i = 0; i < res2 / 2; ++i) {
            cout << '0';
        }
        return 0;
    }
    if (res >= res2 && res >= sz(t)) {
        cout << res << endl;
        for (int i = 0; i < res; ++i)
            cout << '1';
        return 0;
    }
    cout << sz(t) << endl;
    for (int i : t)
        cout << i;
    return 0;
}
