#pragma GCC optimize("Ofast")
#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
//#define int ll
#define pb push_back
#define sz(x) int(x.size())
#define pii pair<int, int>

vector <int> ans;

void solve(string &s, int k) {
    ans.resize(0);
    int cnt = 0;
    int ones = 0;
    for (int i = 0; i < sz(s); ++i) {
        if (s[i] == '0' && cnt < k) {
            ++cnt;
            ans.pb(0);
        }
        else if (cnt == k && s[i] == '1') {
            cnt = 0;
            ans.pb(1);
            ++ones;
        }
    }
    if (cnt < k) {
        while (cnt) {
            ans.pop_back();
            --cnt;
        }
        if (sz(ans) && ans.back() == 1) {
            ans.pop_back();
            --ones;
        }
    }
    if (ones == 0)
        ans.resize(0);
}

const int N = 5e5 + 5;
int used[N];
int cnto, cntz;
vector <int> t;

int solve2(int cnti, string&s) {
    int L =0, R = cntz;
    while (R - L > 1) {
        int m = (R + L) / 2;
        solve(s, m);
        if (sz(ans) >= (cnti + 1) * m)
            L = m;
        else
            R = m;
    }
    solve(s, L);
    if (sz(t) < sz(ans)) {
       t = ans;
    }
    return sz(ans);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (char c : s) {
        if (c == '1')
            ++cnto;
        else
            ++cntz;
    }
    int res = cnto;
    int ncc = 0;
    int L = 1, R = cnto;
    while (R - L > 1) {
        int m = (R + L) / 2;
        int aa = solve2(m, s);
        int bb = solve2(m + 1, s);
        if (aa < bb)
            L = m;
        else
            R = m;
    }
    int res2 = 0;
    int nc= 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '0')
            ++nc;
        else {
              //  cout << i << " " << min(nc, cntz - nc) * 2 + 1 << endl;
            res2 = max(res2, min(nc, cntz - nc) * 2 + 1);
        }
    }
   // cout << res2 << endl;
    if (res2 >= res && res2 >= sz(t)) {
        cout << res2 << endl;
        for (int i = 0; i < res2 / 2; ++i) {
            cout << '0';
        }
        cout << '1';
        for (int i = 0; i < res2 / 2; ++i) {
            cout << '0';
        }
        return 0;
    }
    if (res >= res2 && res >= sz(t)) {
        cout << res << endl;
        for (int i = 0; i < res; ++i)
            cout << '1';
        return 0;
    }
    cout << sz(t) << endl;
    for (int i : t)
        cout << i;
    return 0;
}
