#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
#define int ll
#define pb push_back
#define sz(x) int(x.size())
#define pii pair<int, int>

int get(pii pl, int h) {
    if (h >= pl.first && h <= pl.second)
        return 0;
    return min(abs(h - pl.first), abs(h - pl.second));
}

struct node {
    int l = 0, r = 0, sm = 0, cnt = 0;
};

const int N = 1e9 + 1;
vector <node> tree;

void add(int i, int l, int r, int val) {
   // cout << i << " " << l << " " << r << endl;
    if (l == r) {
        ++tree[i].cnt;
        tree[i].sm += val;
        return;
    }
    int m = (l + r) / 2;
    if (tree[i].l == 0) {
        node c;
        tree[i].l = sz(tree);
        tree.pb(c);
        tree[i].r = sz(tree);
        tree.pb(c);
    }
   // cout << tree[i].l << " " << tree[i].r << endl;
    if (val <= m) {
        add(tree[i].l,l,m,val);
    }
    else
        add(tree[i].r, m + 1, r, val);
    tree[i].sm = (tree[tree[i].r].sm + tree[tree[i].l].sm);
    tree[i].cnt = (tree[tree[i].r].cnt + tree[tree[i].l].cnt);
}

pii get(int i, int l, int r, int nl, int nr) {
    if (i == 0)
        return {0, 0};
    if (l > nr || r < nl)
        return {0, 0};
    if (l >= nl && r <= nr)
        return {tree[i].sm, tree[i].cnt};
    int m = (l + r) / 2;
    pii tmp = get(tree[i].l, l,m,nl, nr);
    pii tmp2 = get(tree[i].r, m + 1, r, nl, nr);
    tmp.first += tmp2.first;
    tmp.second += tmp2.second;
    return tmp;
}


int solve(pii cur) {
    int cnt = 0;
       // cout << cur.first << endl;
    pii toa = get(1, 0, N, 0, cur.first - 1);
    pii tod = get(1, 0, N, cur.second + 1, N);
    cnt += (cur.first * toa.second - toa.first);
    cnt += (tod.first - cur.second * tod.second);
    return cnt;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, n, k;
    node c;
    tree.pb(c);
    tree.pb(c);
    cin >> m >> n >> k;
    vector <vector <pii> > sch(n);
    vector <pii> place(k);
    for (int i = 0; i < k; ++i)
        cin >> place[i].first >> place[i].second;
    sort(place.begin(), place.end());
    vector <pii> cp;
    int mr = place[0].second;
    cp.pb(place[0]);
    for (pii c : place) {
        while (sz(cp) && cp.back().first == c.first && cp.back().second < c.second)
            cp.pop_back();
        if (mr >= c.second)
            continue;
        cp.pb(c);
    }
    swap(cp, place);
    //cout << sz(place) << endl;
    for (int i = 0; i < m; ++i) {
        vector <int> cur(2 * n);
        for (int i = 0; i < 2 * n; ++i)
            cin >> cur[i];
        sort(cur.begin(), cur.end());
        for (int i = 0; i < n; ++i)
            sch[i].pb({cur[2 * i], cur[2 * i + 1]});
    }
    int ans = 0;
    int in = 0;
    for (int i = 0; i < n; ++i) {
        int tmp = 1e18;
        tree[1] = c;
        for (pii cur : sch[i]) {
           // cout << "toa " << endl;
            add(1, 0, N, cur.first);
      //  cout << "toa 2 " << endl;
            add(1, 0, N, cur.second);
        }
        while (in + 1 < sz(place) && solve(place[in + 1]) <= solve(place[in]))
            ++in;
        tmp = solve(place[in]);
        ans += tmp;
    }
    cout << ans;
    return 0;
}
