#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

pair <int, int> otr[200005];
vector <pair <int, int> > seg;
vector <int> spis[200005];

bool cmp(pair <int, int> A, pair <int, int> B)
{
    return (A.x < B.x) || (A.x == B.x && A.y > B.y);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int m, n, k;
    cin >> m >> n >> k;

    for (int i = 1; i <= k; i++) cin >> otr[i].x >> otr[i].y;
    sort(otr + 1, otr + k + 1, cmp);
    seg.pb(otr[1]);
    int last = otr[1].y;
    for (int i = 2; i <= k; i++)
        if (otr[i].y > last)
        {
            seg.pb(otr[i]);
            last = otr[i].y;
        }

    for (int i = 1; i <= m; i++)
    {
        spis[i].resize(2 * n);
        for (int j = 0; j < 2 * n; j++) cin >> spis[i][j];
        sort(spis[i].begin(), spis[i].end());
    }

    ll answer = 0;
    int uk = 0;
    for (int i = 0; i < 2 * n; i += 2)
    {
        while (uk < (int) seg.size() - 1)
        {
            ll val1 = 0, val2 = 0;
            pair <int, int> A = seg[uk], B = seg[uk + 1];
            for (int z = 1; z <= m; z++)
            {
                if (spis[z][i] < A.x) val1 += (ll) (A.x - spis[z][i]);
                if (spis[z][i] > A.y) val1 += (ll) (spis[z][i] - A.y);
                if (spis[z][i + 1] < A.x) val1 += (ll) (A.x - spis[z][i + 1]);
                if (spis[z][i + 1] > A.y) val1 += (ll) (spis[z][i + 1] - A.y);

                if (spis[z][i] < B.x) val2 += (ll) (B.x - spis[z][i]);
                if (spis[z][i] > B.y) val2 += (ll) (spis[z][i] - B.y);
                if (spis[z][i + 1] < B.x) val2 += (ll) (B.x - spis[z][i + 1]);
                if (spis[z][i + 1] > B.y) val2 += (ll) (spis[z][i + 1] - B.y);
            }
            if (val1 < val2) break;
            uk++;
        }

        pair <int, int> A = seg[uk];
        for (int z = 1; z <= m; z++)
        {
            if (spis[z][i] < A.x) answer += (ll) (A.x - spis[z][i]);
            if (spis[z][i] > A.y) answer += (ll) (spis[z][i] - A.y);
            if (spis[z][i + 1] < A.x) answer += (ll) (A.x - spis[z][i + 1]);
            if (spis[z][i + 1] > A.y) answer += (ll) (spis[z][i + 1] - A.y);
        }
    }
    cout << answer;
    return 0;
}

