#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

/*
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("O3")
*/

#define ALL(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update> ordered_set;

using namespace std;

main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int m, n, k;
    cin >> m >> n >> k;

    vector<pair<int, int>> a(k);
    for (auto &e : a) cin >> e.first >> e.second;
    sort(ALL(a));

    vector<vector<int>> b(n);

    for (int t = 0; t < m; t++) {
        vector<int> bb(2 * n);
        for (auto &e : bb) cin >> e;
        sort(ALL(bb));

        for (int j = 0; j < 2 * n; j += 2) {
            b[j / 2].push_back(bb[j]);
            b[j / 2].push_back(bb[j + 1]);
        }
    }
    for (int i = 0; i < n; i++) sort(ALL(b[i]));

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll ans_now = (ll)2e18;
        for (int j = 0; j < k; j++) {
            ll now = 0;

            for (auto e : b[i]) {
                if (e < a[j].first) {
                    now += a[j].first - e;
                } else if (e > a[j].second) {
                    now += e - a[j].second;
                }
            }
            //cout << j << ' ' << now << endl;

            ans_now = min(ans_now, now);
        }
        ans += ans_now;
    }

    cout << ans << endl;

    return 0;
}

/*

1 3 4
10 100
200 200
10 100
300 1000
5 10 20 15 200 90



*/

