#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	string s;
	cin >> s;
	reverse(s.begin(), s.end());
	s.push_back('1');
	reverse(s.begin(), s.end());
	s.push_back('1');

	vector<int> pref(s.size());
	vector<pair<int, int> > ind;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '1') {
			s[i] = '0';
		}
		else {
			s[i] = '1';
		}
		pref[i] = s[i] - '0' + ((i > 0) ? pref[i - 1] : 0);
		if (s[i] == '0')
			ind.push_back({ pref[i], i });
	}
	int ans = ind.size() - 2, ans_d = 0;
	for (int d = 1; d < n; ++d) {
		int c = 0, j = 0, t = 0;
		while (true) {
			j = lower_bound(ind.begin(), ind.end(), make_pair(t + d, -1)) - ind.begin();
			if (j == ind.size()) {
				--c;
				break;
			}
			else {
				t = ind[j].first;
				++c;
			}
		}
		if (ans_d * (ans + 1) + ans < d * (c + 1) + c && c > 0) {
			ans = c;
			ans_d = d;
		}
	}
	cout << ans_d * (ans + 1) + ans << '\n';
	for (int i = 0; i <= ans; ++i) {
		for (int j = 0; j < ans_d; ++j) {
			cout << '0';
		}
		if (i < ans)
			cout << '1';
	}
	return 0;
}


/*
10
0100100000

*/