#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>
#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>
#define vvi vector<vi>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

const int inf = 1024 * 1024 * 1023 * 2 - 1;
int n, m, k;

const ll maxn = 2e6 + 1;
const ll mod1 = 1e9 + 7;
const ll mod2 = 1e9 + 9;

int main() {
    init();
    int m, n;
    cin >> m >> n;
    string str = "";
    string str1;
    cin >> str1;
    for (int i = 0; i < n; ++i){
        int z;
        cin >> z;
        if (z == 1){
            string s;
            cin >> s;
            str += s;
        } else {
            int p, l;
            cin >> p >> l;
            p--;
            for (int j = p; j < p + l; ++j) str += str[j];
        }
    }
    vll p1(maxn), p2(maxn);
    p1[0] = p2[0] = 1;
    for (int i = 1; i < maxn; ++i){
        p1[i] = (p1[i - 1] * 47) % mod1;
        p2[i] = (p2[i - 1] * 47) % mod2;
    }
    n = str.length();
    vll hash1(n), hash2(n);
    ll h1 = 0, h2 = 0;
    for (int i = 0; i < n; ++i){
        h1 = (h1 + (ll) (str[i] - 'a' + 1) * p1[i]) % mod1;
        h2 = (h2 + (ll) (str[i] - 'a' + 1) * p2[i]) % mod2;
        hash1[i] = h1, hash2[i] = h2;
    }
    ll hash3 = 0, hash4 = 0;
    for (int i = 0; i < str1.length(); ++i){
        hash3 = (hash3 + (ll) (str1[i] - 'a' + 1) * p1[i]) % mod1;
        hash4 = (hash4 + (ll) (str1[i] - 'a' + 1) * p2[i]) % mod2;
    }
    hash3 = (hash3 * p1[maxn - 1]) % mod1;
    hash4 = (hash4 * p2[maxn - 1]) % mod2;
   cout << endl;
    int ans = 0;
    for (int i = 0; i + str1.length() <= n; ++i){
        int j = i + str1.length() - 1;
        ll h3 = hash1[j], h4 = hash2[j];
        if (i > 0){
            h3 = (h3 + mod1 - hash1[i - 1]) % mod1;
            h4 = (h4 + mod2 - hash2[i - 1]) % mod2;
        }
        h3 = (h3 * p1[maxn - i - 1]) % mod1;
        h4 = (h4 * p2[maxn - i - 1]) % mod2;
        if (h3 == hash3 && h4 == hash4) ans++;
    }
    cout << ans << endl;
    return 0;
}
