#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int N = 200005;
int n, m, k;
pii sg[N];
vector<int> g[N];

ll dist(int x, pii s) {
    if (s.fi <= x && x <= s.se)
        return 0;
    if (x < s.fi)
        return s.fi - x;
    return x - s.se;
}

ll ans;
vector<pii> T;

void solve() {
    //cout << "T : ";
    //for (auto el : T) cout << el.fi << '-' << el.se << ' ';
    //cout << endl;
    ll res = 0;
    for (int i = 0; i < m; ++i) {
        bool used[n + n];
        fill(used, used + n + n, false);
        bool usedt[n];
        fill(usedt, usedt + n, false);
        for (int u = 0; u < n; ++u) {
            ll mn = 2e18;
            int mnj = -1;
            for (int j = 0; j < n + n; j += 2) {
                if (used[j]) continue;
                if (chkmin(mn, dist(g[i][j], T[u]) + dist(g[i][j + 1], T[u]))) mnj = j;
            }
            res += mn;
            used[mnj] = used[mnj + 1] = true;
        }
        /*for (int j = 0; j < n + n; j += 2) {
            ll mn = 2e18;
            int mnu = -1;
            for (int u = 0; u < n; ++u) {
                if (usedt[u]) continue;
                if (chkmin(mn, dist(g[i][j], T[u]) + dist(g[i][j + 1], T[u]))) mnu = u;
            }
            usedt[mnu] = true;
            res += mn;
        }*/
    }
    //cout << "res =  " << res << endl << endl;
    /*for (int i = 0; i < m; ++i) {
        bool used[n + n];
        fill(used, used + n + n, false);
        bool usedt[n];
        fill(usedt, usedt + n, false);
        for (int itr = 0; itr < n; ++itr) {
            int mnu = -1;
            ll mnval = 2e18;
            int _mn1 = -1, _mn2 = -1;
            for (int u = 0; u < n; ++u) {
                if (usedt[u]) continue;

                auto &s = T[u];

                int mn1 = -1;
                int mn2 = -1;
                for (int j = 0; j < n + n; ++j) {
                    if (!used[j]) {
                        if (mn1 == -1 || dist(g[i][j], s) <= dist(g[i][mn1], s)) {
                            mn2 = mn1;
                            mn1 = j;
                        } else if (mn2 == -1 || dist(g[i][j], s) < dist(g[i][mn2], s)) {
                            mn2 = j;
                        }
                    }
                }
                //used[mn1] = true;
                //used[mn2] = true;
                //res += dist(g[i][mn1], s);
                //res += dist(g[i][mn2], s);
                ll val = dist(g[i][mn1], s) + dist(g[i][mn2], s);
                if (mnu == -1 || mnval > val) {
                    mnval = val;
                    mnu = u;
                    _mn1 = mn1;
                    _mn2 = mn2;
                }
            }
            usedt[mnu] = true;
            used[_mn1] = used[_mn2] = true;
            res += mnval;
        }
    }/**/
    chkmin(ans, res);
}

void gen(int t) {
    if (T.size() == n) {
        solve();
        return;
    }
    for (int nxt = t; nxt < k; ++nxt) {
        T.pb(sg[nxt]);
        gen(nxt);
        T.pop_back();
    }
}

signed main() {
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> m >> n >> k;
    for (int u = 0; u < k; ++u) cin >> sg[u].fi >> sg[u].se;
    sort(sg, sg + k);

    for (int i = 0; i < m; ++i) {
        g[i].resize(n + n);
        for (int j = 0; j < n + n; ++j) {
            cin >> g[i][j];
        }
        sort(all(g[i]));
    }

    ans = 2e18;
    gen(0);

    cout << ans << '\n';

    return 0;
}