#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

ll dist(int x, pii s) {
    if (s.fi <= x && x <= s.se)
        return 0;
    if (x < s.fi)
        return s.fi - x;
    return x - s.se;
}

signed main() {
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int m, n, k;
    cin >> m >> n >> k;
    assert(n == 1);
    vector<pii> sg(k);
    for (auto &s : sg) cin >> s.fi >> s.se;
    vector<int> g;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g.pb(a);
        g.pb(b);
    }
    
    ll ans = 2e18;
    for (int j = 0; j < k; ++j) {
        ll res = 0;
        for (int x : g) {
            res += dist(x, sg[j]);
        }
        chkmin(ans, res);
    }
    cout << ans << '\n';

    return 0;
}