#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define f first
#define s second
#define pb push_back
#define mp make_pair
#define sz(s) (int)s.size()
#define all(s) s.begin(), s.end()

const int INF = 2e9 + 7;
const ll INFLL = 1e18 + 7;
const ld EPS = 1e-9;
const int MAXN = 5e5 + 7;
const int MOD = 998244353;

mt19937 myRand(1337);
mt19937_64 myRand64(1337);

int rnd(int a, int b) {
    uniform_int_distribution<> dis(a, b);
    return dis(myRand);
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    set<pii> lens, blocks;
    vector<int> vbl;
    int len = 0, cntOne = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '1') {
            vbl.pb(len);
            len = 0;
            cntOne++;
        } else len++;
    }
    vbl.pb(len);
    for (int i = 0; i < sz(vbl); ++i) {
        lens.insert(mp(vbl[i], i));
        blocks.insert(mp(i, vbl[i]));
    }
    ll maxAns = 0, ansLen = 0, sumBl = 0;
    for (int k = cntOne; k; --k) {
        auto it = lens.begin();
        ll ans = (it->f + 1) * sz(lens) - 1;
        if (ans > maxAns) {
            maxAns = ans;
            ansLen = it->f;
            sumBl = sz(lens);
        }
        if (k == 1)
            break;
        pii v = *it;
        lens.erase(it);
        it = blocks.find(mp(v.s, v.f));
        pii l = mp(-1, -1), r = mp(-1, -1);
        if (it != blocks.begin()) {
            --it;
            l = *it;
        }
        it = blocks.find(mp(v.s, v.f));
        ++it;
        if (it != blocks.end()) {
            r = *it;
        }
        it = blocks.find(mp(v.s, v.f));
        blocks.erase(it);
        if (l.s == -1 || (r.s != -1 && r.s < l.s)) {
            lens.erase(mp(r.s, r.f));
            lens.insert(mp(v.f + r.s, v.s));
            blocks.erase(r);
            blocks.insert(mp(v.s, v.f + r.s));
        } else {
            lens.erase(mp(l.s, l.f));
            lens.insert(mp(v.f + l.s, v.s));
            blocks.erase(l);
            blocks.insert(mp(v.s, v.f + l.s));
        }
    }
    cout << maxAns << endl;
    while (sumBl) {
        for (int i = 0; i < ansLen; ++i)
            cout << '0';
        if (sumBl > 1)
            cout << '1';
        sumBl--;
    }
}
