#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <random>
#include <ctime>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void solve();

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

/*--------------------------------------------------------------------*/

void solve() {
	int m, n, k;
	cin >> m >> n >> k;
	vector<pll> vec(k);
	for (auto &i : vec) cin >> i.X >> i.Y;
	sort(all(vec));
	vector<vector<ll>> v(m, vector<ll>(2 * n));
	for (auto &i : v) {
		for (auto &j : i) cin >> j;
		sort(all(i));
	}
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		ll now = 1e18;
		for (int j = 0; j < k; ++j) {
			ll now1 = 0;
			for (int q = 0; q < m; ++q) {
				ll tmp = 0;
				if (v[q][i * 2] < vec[j].X) tmp += vec[j].X - v[q][i * 2];
				if (v[q][i * 2 + 1] < vec[j].X) tmp += vec[j].X - v[q][i * 2 + 1];
				if (v[q][i * 2] > vec[j].Y) tmp += v[q][i * 2] - vec[j].Y;
				if (v[q][i * 2 + 1] > vec[j].Y) tmp += v[q][i * 2 + 1] - vec[j].Y;
				now1 += tmp;
			}
			now = min(now, now1);
		}
		ans += now;
	}
	cout << ans;
}