#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


#define int long long


const int INF = (int)1e17;


int ned(int l, int r, int x) {
    if (x < l) {
        return l - x;
    }

    if (x > r) {
        return x - r;
    }

    return 0;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int m, n, k;
    cin >> m >> n >> k;

    vector<int> ls(k), rs(k);

    for (int i = 0; i < k; ++i) {
        cin >> ls[i] >> rs[i];

        if (ls[i] != rs[i]) {
            return 1;
        }
    }

    vector<vector<int>> sc(m, vector<int>(2 * n));

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 2 * n; ++j) {
            cin >> sc[i][j];
        }

        sort(sc[i].begin(), sc[i].end());
    }

    int answ = 0;

    sort(ls.begin(), ls.end());
    unique(ls.begin(), ls.end());

    for (int i = 0; i < n; ++i) {
        vector<int> sts;
        for (int j = 0; j < m; ++j) {
            sts.push_back(sc[j][2 * i]);
            sts.push_back(sc[j][2 * i + 1]);
        }

        sort(sts.begin(), sts.end());

        vector<int> prs(2 * m + 1);
        for (int i = 0; i < 2 * m; ++i) {
            prs[i + 1] = prs[i] + sts[i];
        }

        int mres = INF;

        int cj = lower_bound(ls.begin(), ls.end(), prs[m]) - ls.begin();

        for (int j = max(0LL, cj - 200); j <= min(k - 1, cj + 200); ++j) {
            int x = ls[j];

            int cl = lower_bound(sts.begin(), sts.end(), x) - sts.begin();
            int cr = sts.end() - upper_bound(sts.begin(), sts.end(), x);

            int cres = x * cl - prs[cl] + (prs[2 * m] - prs[2 * m - cr]) - x * cr;

            if (cres < mres) {
                mres = cres;
            }
        }

        answ += mres;
    }

    cout << answ;

    return 0;
}


/*

1 2 2
5 25
50 90
60 5 10 40

*/