#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

#define ll long long 
#define pii piar<ll, ll>
#define x first
#define y second

using namespace std;

const ll NMAX = 1111111;
const ll inf = 8e18;
const ll MOD = 998244353;

ll z[NMAX];

void Z(string & s, ll * z)
{
	z[0] = 0;
	ll l = 0;
	ll r = 0;
	ll n = s.size();
	for (ll i = 1; i < n; i++)
	{
		if (i < r)
		{
			z[i] = min(r - i, z[i - l]);
		}
		while (i + z[i] < n && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] > r)
		{
			r = i + z[i];
			l = i;
		}
	}
	return;
}

pair<ll, char> a[NMAX];
pair<ll, char> b[NMAX];



signed main()
{
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll m, n;
	cin >> m >> n;
	string p;
	cin >> p;
	ll k = 1;
	a[1] = { 1, p[0] };
	for (ll i = 1; i < p.size(); i++)
	{
		if (p[i] == a[k].y)
			a[k].x++;
		else
		{
			k++;
			a[k] = { 1, p[i] };
		}
	}
	ll q = 0;
	for (ll i = 1; i <= n; i++)
	{
		ll type;
		cin >> type;
		if (type == 1)
		{
			string w;
			cin >> w;
			if (q == 0)
			{
				q++;
				b[q] = { 0, w[0] };
			}
			for (ll i = 0; i < w.size(); i++)
			{
				if (w[i] == b[q].y)
				{
					b[q].x++;
				}
				else
				{
					q++;
					b[q].y = w[i];
				}
			}
		}
		else
		{
			ll pos, len;
			cin >> pos >> len;
			b[q].x += len;
		}
	}
	if (k == 1)
	{
		ll ans = 0;
		for (ll i = 1; i <= q; i++)
		{
			if (b[q].y == a[k].y)
			{
				if (b[q].x >= a[k].x)
					ans += b[q].x - a[k].x + 1;
			}
		}
		cout << ans << endl;
		return 0;
	}
	ll ans = 0;
	for (ll i = 1; i + k - 1 <= q; i++)
	{
		ll res = 1;
		for (ll j = 1; j <= k; j++)
		{
			if (j == 1 || j == k)
			{
				if (b[j + i - 1].y == a[j].y && b[j + i - 1].x >= a[j].y)
					res = 1;
				else
				{
					res = 0;
					break;
				}
			}
			else
			{
				if (b[j + i - 1] == a[j])
					res = 1;
				else
				{
					res = 0;
					break;
				}
			}
		}
		ans += res;
	}
	cout << ans << endl;
	return 0;
}