#include <iostream>
#include <climits>

using namespace std;

int main() {
#ifdef LOCAL
    freopen("B.in", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);

    cin.tie(0);
    cout.tie(0);
    int m, n, k;
    cin >> m >> n >> k;
    pair<int, int> pS[k];
    for (int i = 0; i < k; ++i) {
        int a, b;
        cin >> a >> b;
        pS[i] = {a, b};
    }
    int h[2 * n];
    for (int i = 0; i < 2 * n; ++i) {
        cin >> h[i];
    }
    int ans = INT_MAX;
    for (int i = 0; i < k; ++i) {
        pair<int, int> taken = pS[i];
        int curAns = 0;
        for (int j = 0; j < 2 * n; ++j) {
            if (h[j] >= taken.first && h[j] <= taken.second) {
                continue;
            }
            curAns += min(abs(taken.first - h[j]), abs(taken.second - h[j]));
        }
        ans = min(ans, curAns);
    }
    cout << ans;

    return 0;
}