#include <iostream>
#include <map>
#include <set>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <vector>

using namespace std;

typedef long long ll;

const int SZ = 2000 + 100;

int n, m;
string p, t, s;

int typ[SZ];
string st[SZ];
int pos[SZ], len[SZ];

int main()
{
    ios::sync_with_stdio(false);

    cin >> m >> n;
    cin >> p;
    t = "";
    for (int i = 0; i < n; i++)
    {
        cin >> typ[i];
        if (typ[i] == 1)
        {
            cin >> st[i];
        }
        else
        {
            cin >> pos[i] >> len[i];
            pos[i]--;
        }
    }

    for (int i = 0; i < n; i++)
    {
        if (typ[i] == 1)
        {
            t += st[i];
        }
        else
        {
            for (int j = pos[i]; j < (pos[i] + len[i]); j++)
            {
                t += t[j];
            }
        }
    }

    s = p + " " + t;
    vector<int> pref;
    pref.push_back(0);
    int sz = s.length();
    int ans = 0;
    for (int i = 1; i < sz; i++)
    {
        pref.push_back(pref[i - 1]);
        while (pref[i] > 0 && s[ pref[i] ] != s[i])
        {
            pref[i] = pref[pref[i] - 1];
        }
        if (s[ pref[i] ] == s[i]) pref[i]++;
        if (pref[i] == p.length()) ans++;
    }
    cout << ans << endl;



    return 0;
}
