#include <iostream>
using namespace std;

const int k = 750;

int check(string s, int f)
{
    int j = 0, ans = 0, t = 0;
    for (int i = 0; i < s.length(); ++i)
    {
        if (s[i] == '0')
            j++;
        else if (j >= f)
            j = 0, ans += f + 1, t++;
    }
    if (j >= f)
        ans += f;
    else
        ans--, t--;
    return t ? ans : -1;
}

void add(string& s, int f)
{
    for (int i = 0; i < f; ++i)
        s += '0';
    s += '1';
}

string get(string s, int f)
{
    string ans;
    int j = 0, n = s.length();
    for (int i = 0; i < n; ++i)
    {
        if (s[i] == '0')
            j++;
        else if (j >= f)
            j = 0, add(ans, f);
    }
    if (j >= f)
        add(ans, f);
    ans.pop_back();
    return ans;
}

int main()
{
    int n;
    cin >> n;
    string s;
    cin >> s;

    int best = -1, r = 0;
    for (int i = 0; i < k; ++i)
    {
        int u = check(s, i);
        if (u > best)
            best = u, r = i;
    }
    for (int i = 0; i < k; ++i)
    {
        int j = n - i;
        if (j % (i + 1))
            continue;
        j /= i + 1;
        int u = check(s, j);
        if (u > best)
            best = u, r = j;
    }
    cout << best << '\n' << get(s, r);
    return 0;
}
