#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;
const int inf = 1e9;

inline int rr(int x, int l, int r) {return x < l ? l - x : x > r ? x - r : 0;}

int calc(int k, int* l, int* r, int x, int y)
{
    int ans = inf;
    for (int i = 0; i < k; ++i)
        ans = min(ans, rr(x, l[i], r[i]) + rr(y, l[i], r[i]));
    return ans;
}

signed main()
{
    int m, n, k;
    cin >> m >> n >> k;
    int l[k], r[k];
    for (int i = 0; i < k; ++i)
        cin >> l[i] >> r[i];
    vector<vector<int>> v;
    for (int i = 0; i < m; ++i)
    {
        vector<int> a;
        for (int i = 0; i < 2 * n; ++i)
        {
            int x;
            cin >> x;
            a.push_back(x);
        }
        sort(a.begin(), a.end());
        v.push_back(a);
    }
    if (m == 1)
    {
        int ans = 0;
        for (int i = 0; i < v[0].size(); i += 2)
            ans += calc(k, l, r, v[0][i], v[0][i+1]);
        cout << ans;
    }
    return 0;
}
