#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
const int N = 5e5 + 100;
int pref[N], suf[N];
int main() {
	int n;
	std::cin >> n;
	std::string s;
	std::cin >> s;
	std::vector<std::pair<int,int>> cur;
	int zero = 0;
	FOR(i, (int)s.size()) {
		if (s[i] == '1') {
			cur.push_back({zero, i});
		}
		else {
			zero++;
		}
		pref[i] = zero;
	}	
	for (int i = (int)s.size() - 1; i >= 0; --i) {
		suf[i] = suf[i + 1] + (s[i] == '0');
	}
	int max = 0, sz = 0;
	FOR(i, (int)s.size()) {
		auto start = std::lower_bound(cur.begin(), cur.end(), std::make_pair(i, 0));
		if (start == cur.end() || (suf[start->second] < i)) {
			break;
		}
		int cnt = 1;
		while (start != cur.end() && (suf[start->second] >= i)) {
			start = std::upper_bound(cur.begin(), cur.end(), std::make_pair(i + (start->first), start->second));
			// debug(start->second)

			if (start != cur.end() && (suf[start->second] >= i)) {
				++cnt;
			}
		}
		if (cnt + (cnt + 1) * i > max) {
			max = cnt + (cnt + 1) * i;
			sz = i;
		} 
	}
	std::cout << max << '\n';
	for (int j = 0; j < max; ++j) {
		if ((j + 1) % (sz + 1) == 0) {
			std::cout << '1';
		}
		else {
			std::cout << '0';
		}
	}
}