#include <iostream>
using namespace std;

const int maxn = 2e6 + 6;
int pi[maxn];

void parse_pi(string& s) {
    for (int i = 1; i < s.size(); i++) {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = pi[j - 1];
        }
        if (s[i] == s[j]) j++;
        pi[i] = j;
     //   cout << j << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    int m, n;
    cin >> m >> n;
    string p;
    cin >> p;
    string s = "";
    s.reserve(1e6);
    for (int it = 0; it < n; it++) {
        int req_type;
        cin >> req_type;
        if (req_type == 1) {
            string add;
            cin >> add;
            s += add;
        } else {
            int pos, len;
            cin >> pos >> len;
            pos--;
            for (int i = pos; i < pos + len; i++) {
                s += s[i];
            }
        }
    }
//    cout << s;
    s = p + "$" + s;
    parse_pi(s);
    int res = 0;
    for (int i = 0; i < s.size(); i++) {
        if (pi[i] == p.size()) {
            res++;
        }
    }
    cout << res;
    return 0;

}