#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <math.h>
#include <map>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

typedef long long ll;
typedef double dl;

ll inf = 1e10;

ll get(ll h, ll l, ll r)
{
	if (h >= l && h <= r)
		return 0;
	return min(abs(h - l), abs(h - r));
}

int main()
{
	//freopen("input.txt", "r", stdin);

	ll m, n, k;

	cin >> m >> n >> k;


	vector<ll> l(k), r(k);

	for (int i = 0; i < k; ++i)
		cin >> l[i] >> r[i];

	vector<vector<ll>> h(m, vector<ll>(2 * n));

	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < 2 * n; ++j)
		{
			cin >> h[i][j];
		}

		sort(h[i].begin(), h[i].end());
	}

	ll sum = 0;
	for (int i = 0; i < 2 * n; i += 2)
	{
		vector<ll> all;
		for (int day = 0; day < m; ++day)
		{
			all.push_back(h[day][i]);
			all.push_back(h[day][i + 1]);
		}
		sort(all.begin(), all.end());

		vector<ll> val;
		val.push_back(all[max(0ll, (ll)all.size() / 2 - 1)]);
		val.push_back(all[all.size() / 2]);
		val.push_back(all[min(all.size() - 1, all.size() / 2 + 1)]);

		vector<ll> cond;

		for (ll in : val)
		{
			ll pos = lower_bound(l.begin(), l.end(), in) - l.begin();
			if (pos < k)
				cond.push_back(pos);

			 pos = upper_bound(l.begin(), l.end(), in) - l.begin();
			if (pos < k)
				cond.push_back(pos);


			 pos = lower_bound(r.begin(), r.end(), in) - r.begin();
			if (pos < k)
				cond.push_back(pos);

			 pos = upper_bound(r.begin(), r.end(), in) - r.begin();
			if (pos < k)
				cond.push_back(pos);
		}

		ll minn = inf;
		for (ll t : cond)
		{
			ll cur = 0;
			for (int day = 0; day < m; ++day)
			{
				cur += get(h[day][i], l[t], r[t]);
				cur += get(h[day][i + 1], l[t], r[t]);
			}

			minn = min(minn, cur);
		}

		sum += minn;
	}

	cout << sum << endl;

	return 0;
}