#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const ll MOD = 998244353;
const int mx = 1010;
const int NEUTRAL = 2e9;

int n, m, k, a[mx][mx][2];

int main() {
	fast_io();
	cin >> n >> m >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			a[i][j][0] = NEUTRAL;
			a[i][j][1] = NEUTRAL;
		}
	}
	for (int i = 0; i < k; ++i) {
		int x, y, u;
		cin >> x >> y >> u;
		x--;
		y--;
		a[x][y][0] = u;
		a[x][y][1] = u;
	}
	for (int i = n - 1; i >= 0; --i) {
		for (int j = m - 1; j >= 0; --j) {
			if (a[i][j][0] != NEUTRAL) {
				continue;
			}
			a[i][j][0] = min(a[i + 1][j][1], a[i][j + 1][1]);
			a[i][j][1] = max(a[i + 1][j][0], a[i][j + 1][0]);
		}
	}
	ll sum = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			sum += a[i][j][0];
			//cout << a[i][j][0] << " ";
		}
		//cout << endl;
	}
	sum = (sum % MOD + MOD) % MOD;
	cout << sum << endl;
}
