#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

vector<int> prefix_function(string s) {
	vector<int> p(s.size());
	for (int i = 1; i < s.size(); ++i) {
		p[i] = p[i - 1];
		while (p[i] && s[p[i]] != s[i]) {
			p[i] = p[p[i] - 1];
		}
		if (s[p[i]] == s[i]) {
			p[i]++;
		}
	}
	return p;
}

int n, m;
string s, t;

int main() {
	fast_io();
	cin >> m >> n;
	cin >> t;
	for (int i = 0; i < n; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			string p;
			cin >> p;
			s += p;
		}
		else {
			int l, len;
			cin >> l >> len;
			l--;
			for (int j = 0; j < len; ++j) {
				s.push_back(s[l++]);
			}
		}
	}
	string S = t + "#" + s;
	vector<int> p = prefix_function(S);
	int ans = 0;
	for (int i = t.size() + 1; i < S.size(); ++i) {
		if (p[i] == t.size()) {
			ans++;
		}
	}
	cout << ans << endl;
}
