#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <random>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
#define np nullptr

int mas[500010];
int n;

int check(int l) {
	int curl = 0;
	int ud = 0;
	bool f = true;
	for (int i = 0; i < n; i++) {
		if (mas[i] == 1) {
			if (curl == l) {
				f = false;
				curl = 0;
			}
			else {
				ud++;
			}
		}
		else {
			if (curl == l) {
				ud++;
			}
			else {
				curl++;
			}
		}
	}
	if (f) return n;
	return ud;
}

int main() {
#ifdef LOCAL 
	freopen("In.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	char c;
	for (int i = 0; i < n; i++) {
		cin >> c;
		mas[i] = c - '0';
	}
	int l = 0;
	int r = n;
	int m1, m2;
	while (r - l > 2) {
		m1 = l + (r - l) / 3;
		m2 = r - (r - l) / 3;
		if (check(m1) < check(m2)) {
			r = m2;
		}
		else {
			l = m1;
		}
	}
	int opt = check(l);
	if (opt > check(l + 1))
		l++;
	int sv = l;
	l = -1;
	r = n - 1;
	while (r - l > 2) {
		m1 = l + (r - l) / 3;
		m2 = r - (r - l) / 3;
		if (check(m1) <= check(m2)) {
			r = m2;
		}
		else {
			l = m1;
		}
	}
	if (opt > check(r)) 
		sv = r;
	if (opt > check(r - 1)) 
		sv = r - 1;
	l = sv;
	int curl = 0;
	int ud = 0;
	bool f = true;
	cout << n - check(l) << "\n";
	for (int i = 0; i < n; i++) {
		if (mas[i] == 1) {
			if (curl == l) {
				f = false;
				curl = 0;
				cout << mas[i];
			}
			else {
				ud++;
			}
		}
		else {
			if (curl == l) {
				ud++;
			}
			else {
				curl++;
				cout << mas[i];
			}
		}
	}
	return 0;
}