#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <random>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
#define np nullptr

pair<ll, ll> par[200010];
vector<ll> gr[200010];
vector<ll> mas[200010];
ll sumk[500010];

int zf(string s, int len, int gr) {
	vector<int> z(s.length());
	for (int i = 1, l = 0, r = 0; i < s.length(); i++) {
		if (i < r) {
			z[i] = min(z[i - l], r - i);
		}
		while (i + z[i] < s.length() && s[z[i]] == s[i + z[i]])
			z[i]++;
		if (i + z[i] >= r) {
			r = i + z[i];
			l = i;
		}
	}
	int kol = 0;
	for (int i = len + 1; i < len + 1 + gr; i++) {
		if (z[i] >= len) {
			kol++;
		}
	}
	return kol;
}

int main() {
#ifdef LOCAL 
	freopen("In.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int m, n, tp, pos, l;
	cin >> m >> n;
	string p, w;
	cin >> p;
	string t = "";
	cin >> tp >> t;
	w = t;
	ll kol = 1;
	for (int i = 1; i < n; i++) {
		cin >> tp;
		cin >> pos >> l;
		kol += l / w.length();
	}
	ll h = 1;
	while (t.length() < p.length()) {
		t += w;
		h++;
	}
	if (h > kol) {
		cout << 0;
		return 0;
	}
	ll res = zf(p + "#" + t, p.length(), w.length());
	cout << res * (kol - h + 1);
	return 0;
}