#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;

int m, n, k;
int L[500000], R[500000];
vector<int> sc[500000];
vector<int> new_groups[501000];
vector<int> f;
long long result;

inline long long abs1(long long c)
{
    if (c > 0) return c; return -c;
}

void relaxs(vector<int> scolars, long long id)
{
    if (id < 0 || id >= k)
        return;
    long long summ = 0;
    for (int i = 0; i < scolars.size(); i++)
    {
        summ += abs1(scolars[i] - L[id]);
        //cout << scolars[i] << " ";
        //cout << L[id] << endl;
    }
    //cout << endl;
    result = min(result, summ);
}

signed main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    cin >> m >> n >> k;
    for (int i = 0; i < k; i++)
    {
        cin >> L[i] >> R[i];
    }
    vector<pair<int, int> > p;
    for (int i = 0; i < k; i++)
        p.push_back({L[i], R[i]});
    sort(p.begin(), p.end());
    for (int i = 0; i < k; i++)
    {
        L[i] = p[i].first;
        R[i] = p[i].second;
    }
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            int h;
            cin >> h;
            sc[i].push_back(h);
        }
        sort(sc[i].begin(), sc[i].end());
    }
    //cout << 1 << endl;
    long long ans = 0;
    for (int i = 0; i < n; i++)
    {
        for (int g = 0; g < m; g++)
        {
            new_groups[i].push_back(sc[g][2 * i]);
            new_groups[i].push_back(sc[g][2 * i + 1]);
        }
        sort(new_groups[i].begin(), new_groups[i].end());
        for (int j = 0; j < new_groups[i].size(); j++)
        {
            ;//cout << new_groups[i][j] << " ";
        }
        //cout << endl;
        result = 1e18;
        long long h1 = new_groups[i][n - 1];
        long long h2 = new_groups[i][n];
        //cout << h1 << " " << h2 << endl;
        long long l = 0, r = k;
        while (l + 1 < r)
        {
            int mid = (l + r) / 2;
            if (L[mid] <= h1)
                l = mid;
            else
                r = mid;
        }
        if (l - 1 >= 0 && l - 1 < k)
            relaxs(new_groups[i], l - 1);
        if (l >= 0 && l < k)
            relaxs(new_groups[i], l);
        if (r >= 0 && r < k)
            relaxs(new_groups[i], r);
        //cout << l << " " << r << endl;
        l = 0, r = k;
        while (l + 1 < r)
        {
            int mid = (l + r) / 2;
            if (L[mid] < h2)
                l = mid;
            else
                r = mid;
        }
        if (l - 1 >= 0 && l - 1 < k)
            relaxs(new_groups[i], l - 1);
        if (l >= 0 && l < k)
            relaxs(new_groups[i], l);
        if (r >= 0 && r < k)
            relaxs(new_groups[i], r);

        //for (int ii = 0; ii < k; ii++)
        //    relaxs(new_groups[i], ii);
        //cout << l << " " << r << endl;
        ans += result;
        //cout << result << endl << endl << endl;
    }
    cout << ans;
}
/*
3 2 2
3 3
1 1
1 10 40 50
1 1 2 2
9 9 49 49
*/
