#pragma GCC optimaze("Ofast, no-stack-protectorz");
#pragma GCC optimaze("unroll-loops");
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<complex>
#include<map>
#include<set>
#include<math.h>
#include<random>
#include<chrono>

using namespace std;

mt19937 rng{ 197 };

const int maxn = 1e4 + 113;
long long zn[maxn];

long long solve(vector<int> si, vector<pair<int, int>> si2)
{
	vector<pair<int, int>> de;
	for (int i = 0; i < si.size(); i++)
		de.push_back({ si[i], 0 });
	vector<long long> ans(si2.size(), 0);
	for (int i = 0; i < si2.size(); i++)
	{
		de.push_back({ si2[i].first, i + 1 });
		de.push_back({ si2[i].second, -i - 1 });
	}
	long long le = 0, re = 0;
	long long kle = 0, kre = si.size();
	sort(de.begin(), de.end());
	for (int i = 0; i < de.size(); i++)
	{
		if (de[i].second == 0)
			re += (de[i].first - de[0].first);
	}
	for (int i = 0; i < de.size(); i++)
	{
		if (de[i].second != 0)
		{
			if (de[i].second > 0)
				ans[de[i].second - 1] += le;
			else
				ans[-de[i].second - 1] += re;
		}
		else
		{
			kre--;
			kle++;
		}
		if (i + 1 != de.size())
		{
			int nex = de[i + 1].first;
			long long hj = (nex - de[i].first);
			re -= kre * hj;
			le += kle * hj;
		}
	}
	long long anw = (long long)1e18 + 113;
	for (int i = 0; i < ans.size(); i++)
		anw = min(anw, ans[i]);
	return anw;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
	cout.setf(ios::fixed);
	cout.precision(10);
	int n, m, k;
	cin >> m >> n >> k;
	vector<vector<int>> sp;
	vector<pair<int, int>> te;
	for (int i = 0; i < k; i++)
	{
		int l, r;
		cin >> l >> r;
		te.push_back({ l, r });
	}
	sort(te.begin(), te.end());
	for (int i = 0; i < m; i++)
	{
		vector<int> gh;
		for (int i = 0; i < 2 * n; i++)
		{
			int a;
			cin >> a;
			gh.push_back(a);
		}
		sort(gh.begin(), gh.end());
		sp.push_back(gh);
	}
	for (int j = 0; j < n; j++)
	{
		vector<int> ws;
		for (int u = 0; u < m; u++)
		{
			ws.push_back(sp[u][2 * j]);
			ws.push_back(sp[u][2 * j + 1]);
		}
		zn[j] = solve(ws, te);
	}
	long long sum = 0;
	for (int i = 0; i < n; i++)
		sum += zn[i];
	cout << sum;
	//system("pause");
}

/*
1 2 2
5 25
50 90
60 5 10 40

2 3 3
200 400
300 500
100 600
300 330 440 40 30 300
150 250 350 450 550 300
*/