#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define ll long long
#define ull unsigned long long
const ll INF = 999999999999999999;
const double PI = acos(-1.0);

void stop()
{
	//system("pause");
	exit(0);
}

ll n;
string s;

ll get_kol(ll c)
{
	ll kol = 0;
	ll curr = 0;
	for (ll i = 0; i < n; i++)
	{
		if (s[i] == '0')
		{
			curr++;
		}
		else
		{
			if (curr >= c)
			{
				kol++;
				curr = 0;
			}
		}
	}
	if (curr < c)
	{
		kol--;
	}
	return max(kol,0LL);
}

int main()
{
	ios::sync_with_stdio(false);

	cin >> n >> s;
	ll gs=0, gk=0, gc=0;
	ll l = 0, r = n;
	while (r-l > 1)
	{
		//cout << l << " " << r << endl;
		ll mid1 = (l + r) / 3;
		ll mid2 = (l + r) * 2 / 3;
		ll kol1 = get_kol(mid1);
		ll kol2 = get_kol(mid2);
		ll d1 = kol1 + (kol1 + 1)*mid1;
		ll d2 = kol2 + (kol2 + 1)*mid2;
		if (kol1 == 0) d1 = 0;
		if (kol2 == 0) d2 = 0;
		if (d1 > gs)
		{
			gs = d1;
			gk = kol1;
			gc = mid1;
		}
		if (d2 > gs)
		{
			gs = d2;
			gk = kol2;
			gc = mid2;
		}
		if (kol1 == 0 && kol2==0)
		{
			r = mid1 - 1;
		}
		else if (d2 > d1)
		{
			l = mid1 + 1;
		}
		else if (d2 < d1)
		{
			r = mid2 - 1;
		}
		else
		{
			l = mid1 + 1;
			r = mid2 - 1;
		}
		//cout << d1 << " " << d2 << endl;
		//cout << l << " " << r << endl;
	}
	ll kol1 = get_kol(l);
	ll kol2 = get_kol(r);
	ll d1 = kol1 + (kol1 + 1)*l;
	ll d2 = kol2 + (kol2 + 1)*r;
	if (d1 > gs)
	{
		gs = d1;
		gk = kol1;
		gc = l;
	}
	if (d2 > gs)
	{
		gs = d2;
		gk = kol2;
		gc = r;
	}
	cout << gs << endl;
	for (ll i = 0; i < gk; i++)
	{
		for (ll j = 0; j < gc; j++)
		{
			cout << 0;
		}
		cout << 1;
	}
	for (ll j = 0; j < gc; j++)
	{
		cout << 0;
	}

	stop();
}