#include <iostream>
#include <string>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

#define ll long long
#define ull unsigned long long
const ll INF = 999999999999999999;
const double PI = acos(-1.0);

void stop()
{
	//system("pause");
	exit(0);
}

vector<ll> zf(string s)
{
	ll n = s.size();
	vector<ll> z(n);
	ll l = 0, r = 0;
	for (ll i = 1; i < n; i++)
	{
		if (i <= r) z[i] = min(r - i + 1, z[i - l]);
		while (i + z[i] < n && s[z[i]] == s[i + z[i]]) z[i]++;
		if (i + z[i] - 1 > r)
		{
			l = i;
			r = i + z[i] - 1;
		}
	}
	return z;
}

int main()
{
	ios::sync_with_stdio(false);

	ll m, n;
	cin >> m >> n;
	string t;
	cin >> t;
	string s = "";
	string dop;
	ll type, pos, len;
	ll kol = 1;
	for (ll i = 0; i < n; i++)
	{
		cin >> type;
		if (type == 1)
		{
			cin >> dop;
			s += dop;
		}
		else
		{
			cin >> pos >> len;
			pos--;
			kol += len / (ll)s.size();
		}
	}
	vector<ll> ans = zf(t + "#" + s + s);
	ll res = 0;
	for (ll i = t.size()+1; i < t.size()+1+s.size(); i++)
	{
		if (ans[i] == t.size()) res++;
	}
	vector<ll> ans1 = zf(t + "#" + s);
	ll res1 = 0;
	for (ll i = t.size() + 1; i < ans1.size(); i++)
	{
		if (ans1[i] == t.size()) res1++;
	}
	if (n == 1)
	{
		cout << res1;
		stop();
	}
	res *= kol-1;
	res += res1;
	cout << res;

	stop();
}