#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;

const int mod = 998244353;

signed main() {
    ios::sync_with_stdio(false);
    //    cin.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    int a1[n + 1][m + 1];
    int a[n + 1][m + 1];

    for (int i = 0; i <= n; ++i) for (int j = 0; j <= m; ++j) a[i][j] = a1[i][j] = 0;
    for (int i = 0; i < k; ++i) {
        int r, c, v;
        cin >> r >> c >> v;
        --r, --c;
        a1[r][c] = 1;
        a[r][c] = v;
    }
    int dpf[n + 1][m + 1], dps[n + 1][m + 1];
    for (int i = 0; i <= n; ++i) for (int j = 0; j <= m; ++j) dpf[i][j] = mod, dps[i][j] = -mod;
    for (int i = 0; i <= n; ++i) dps[i][m] = dpf[i][m] = 0;
    for (int j = 0; j <= m; ++j) dps[n][j] = dpf[n][j] = 0;
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a1[i][j]) dps[i][j] = dpf[i][j] = a[i][j];
            else {
                dpf[i][j] = min(dps[i + 1][j], dps[i][j + 1]);
                dps[i][j] = max(dpf[i + 1][j], dpf[i][j + 1]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            ans = ((dpf[i][j] + ans) % mod + mod) % mod;
        }
    }
    cout << ans << endl;
    return 0;
}