#include <bits/stdc++.h>
#define int long long

using namespace std;

int n, m;
vector <vector <int> > num;

int bfs(int x1, int y1, int x2, int y2, int k) {
    if (num[x1][y1] > k) return -1;
    vector <vector <int> > used(n, vector <int> (m));
    vector <vector <int> > dist(n, vector <int> (m, -1));
    queue <pair <int, int> > q;
    vector <int> dx = {-1, 0, 1};
    vector <int> dy = {-1, 0, 1};
    q.push({x1, y1});
    dist[x1][y1] = 0;
    while (!q.empty()) {
        pair <int, int> now = q.front();
        int xn = now.first;
        int yn = now.second;
        q.pop();
        for (auto x : dx) {
            for (auto y : dy) {
                if (abs(x + y) == 1) {
                    if (xn + x >= 0 && xn + x < n && yn + y >= 0 && yn + y < m) {
                        if (!used[xn + x][yn+ y] && num[xn + x][yn + y] <= k) {
                            used[xn + x][yn + y] = 1;
                            dist[xn + x][yn + y] = dist[xn][yn] + 1;
                            q.push({xn + x, yn + y});
                        }
                    }
                }
            }
        }
    }
    return dist[x2][y2];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> n >> m >> q;
    num.resize(n);
    for(int i = 0; i < n; i++) num[i].resize(m);
    int sh = -1;
    while (q--) {
        for (int i = 0; i < n; i++) {
            for (int j= 0; j < m; j++) num[i][j]++;
        }
        int req;
        cin >> req;
        if (req == 1) {
            int x;
            cin >> x;
            x--;
            for (int j = 0; j < m; j++) num[x][j] = 0;
        }
        else if (req == 2) {
            int x;
            cin >> x;
            x--;
            for (int i = 0; i < n; i++) num[i][x] = 0;
        }
        else {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            x1--;
            y1--;
            x2--;
            y2--;
            cout << bfs(x1, y1, x2, y2, k) << "\n";
        }
    }
    return 0;
}
