#include <bits/stdc++.h>
using namespace std;


const int INF = 1e9 + 228;

vector<int> t, p;

void push(int v, int l, int r)
{
    if(p[v] == INF)
        return;
    if(r - l > 1)
    {
        p[v * 2] = p[v];
        p[v * 2 + 1] = p[v];
    }
    t[v] = p[v];
    p[v] = INF;
}

void upd(int v, int l, int r, int L, int R, int x)
{
    push(v, l, r);
    if(l >= R || L >= r)
        return;
    if(L <= l && r <= R)
    {
        p[v] = x;
        push(v, l, r);
        return;
    }
    upd(v * 2, l, (l + r) / 2, L, R, x);
    upd(v * 2 + 1, (l + r) / 2, r, L, R, x);
}
int get(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if(l >= R || L >= r)
        return -INF;
    if(L <= l && r <= R)
    {
        return t[v];
    }
    return max(get(v * 2, l, (l + r) / 2, L, R), get(v * 2 + 1, (l + r) / 2, r, L, R));
}

signed main()
{
    int n, m;
    cin >> n >> m;
    vector<int> v(n);
    vector<pair<int, int>> f_s(m, {-1, -1});
    for(int i = 0; i < n; ++i)
    {
        cin >> v[i];
        --v[i];
        if(f_s[v[i]].first == -1)
            f_s[v[i]].first = f_s[v[i]].second = i;
        else
            f_s[v[i]].second = i;
    }
    vector<int> ans(n);
    vector<pair<pair<int, int>, int>> ss;
    for(int i = 0; i < m; ++i)
    {
        if(f_s[i].first != -1)
            ss.push_back({{f_s[i]}, i});
    }
    sort(ss.begin(), ss.end());
    t.resize(4 * n);
    p.resize(4 * n, INF);
    for(auto i : ss)
    {
        upd(1, 0, n, i.first.first, i.first.second + 1, i.second);
    }
    for(int i = 0; i < n; ++i)
        ans[i] = get(1, 0, n, i, i + 1);
    if(ans != v)
        cout << -1;
    else {
        cout << ss.size() << '\n';
        for (auto i : ss)
            cout << i.second + 1 << ' ' << i.first.first + 1 << " " << i.first.second + 1 << '\n';
    }
}