#include <bits/stdc++.h>

using namespace std;
using ll = long long;


char _buf_[(int)1e8];
size_t _p_ = 0;

void* operator new(size_t _n_) {
    _p_ += _n_;
    return _buf_ + _p_ - _n_;
}

void operator delete(void*) {};

constexpr int NMAX = 1000;
ll l, r;

vector<vector<pair<int, ll>>> g;
vector<int> arr;
bool ans[NMAX];
set<ll> go[NMAX];


void dfs(int v, ll d) {
    if (d > r) {
        return;
    }
    if (d >= l && d <= r) {
        ans[v] = true;
    }
    if (go[v].find(d) == go[v].end()) {
        go[v].insert(d);
        for (auto [u, w] : g[v]) {
            dfs(u, d + w);
        }
    }
}


void solve() {
    int n, m, q;
    cin >> n >> m >> q;
    ll p; cin >> p;


    g.clear();
    arr.resize(q);
    g.resize(n);
    memset(go, 0, sizeof(go));
    memset(ans, 0, sizeof(ans));

    for (int i = 0; i < n; ++i) {
        go[i].clear();
    }

    for (int i = 0; i < m; ++i) {
        int u, v; ll d;
        cin >> u >> v >> d;
        --u; --v;
        g[u].emplace_back(v, d);
    }



    for (int i = 0; i < q; ++i) {
        cin >> arr[i] >> l;
        --arr[i];
        r = p * l / (p - 1);
    }

    dfs(0, 0);

    for (int i = 0; i < q; ++i) {
        cout << ans[arr[i]];
    }

    cout << "\n";
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);


    int t;
    cin >> t;
    while (t-- > 0) {
        solve();
    }


    return 0;
}