#include <vector>
#include <set>
#include <iostream>

using namespace std;

int main() {

    int T;
    cin >> T;
    for(int test = 0; test < T; test++){
        int n, m, q;
        long long p;
        cin >> n >> m >> q >> p;
        vector< vector<pair<int, long long> > > list(n + 1);
        for(int i = 0; i < m; i++){
            int u, v;
            long long t;
            cin >> u >> v >> t;
            list[u].push_back({v, t});
        }
        vector< set<long long> > dp(n + 1, set<long long>());
        dp[1].insert(0);
        for(int i = 1; i <= n; i++){
            for(auto it: dp[i]){
                for(auto j: list[i]){
                    dp[j.first].insert(it + j.second);
                }
            }
        }
        for(int i = 0; i < q; i++){
            int f;
            long long r;
            cin >> f >> r;
            auto find = dp[f].lower_bound(r);
            if(find != dp[f].end()){
                if((*find) * (p - 1) <= p * r){
                    cout << "1";
                }else{
                    cout << "0";
                }
            }
        }
        cout << endl;
    }
    return 0;

}
