#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <sstream>
#include <fstream>
#include <queue>
#include <deque>
#include <algorithm>

using namespace std;

vector<int> add;
vector<int> t;
vector<int> a;
void push(int v)
{
	if (!add[v]) return;
	if (v * 2 + 1 < t.size())
		t[v * 2 + 0] = add[v], add[v * 2 + 0] = add[v];
	if (v * 2 + 2 < t.size())
		t[v * 2 + 1] = add[v], add[v * 2 + 1] = add[v];
	add[v] = 0;
}

void tset(int vz, int tl, int tr, int l, int r, int v)
{
	if (tl > r || tr < l) return;
	if (l <= tl && tr <= r)
	{
		add[vz] = v;
		t[vz] = v;
		return;
	}
	push(vz);
	int m = (tl + tr) / 2;
	tset(vz * 2, tl, m, l, r, v);
	tset(vz * 2 + 1, m + 1, tr, l, r, v);
}

void push_all(int v)
{
	if (v >= t.size()) return;
	push(v);
	push_all(v * 2 + 0);
	push_all(v * 2 + 1);
}

void solve()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(false);
	int m, n;
	cin >> m >> n;
	vector<int> s(m);
	for (int i = 0; i < m; i++) cin >> s[i];
	map<int, int> start;
	map<int, int> end;
	for (int i = 0; i < m; i++)
	{
		if (!start.count(s[i])) start[s[i]] = i;
		end[s[i]] = i;
	}
	vector<pair<pair<int, int>, pair<int, int>>> z;
	for (auto q : start)
		z.push_back({ {end[q.first] - q.second, q.first}, {q.second, end[q.first]} });
	sort(z.begin(), z.end());
	reverse(z.begin(), z.end());
	vector<int> ans(m);
	vector<bool> ok(m, false);
	int yt = 1;
	while (yt < m) yt *= 2;
	a.resize(yt);
	t.resize(yt << 1);
	add.resize(yt << 1);

	for (auto w : z)
	{
		tset(1, 0, yt - 1, w.second.first, w.second.second, w.first.second);/*
		for (int i = w.second.first; i <= w.second.second; i++)
			ans[i] = w.first.second;*/
	}
	push_all(1);
	for (int i = 0; i < m; i++)
		if (s[i] != t[yt + i]) cout << "-1", exit(0);
	cout << z.size() << endl;

	for (auto w : z)
	{
		cout << w.first.second << " " << w.second.first + 1 << " " << w.second.second + 1 << endl;
	}
	z = z;
	z = z;
}

int main()
{
	solve();
}