#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <sstream>
#include <fstream>
#include <queue>
#include <deque>
#include <algorithm>

using namespace std;
int e[60][60] = {};
int dx[4] = { 0, 1, 0, -1 };
int dy[4] = { -1, 0, 1, 0 };
void solve()
{
	int n, m, q;
	cin >> n >> m >> q;
	for (int w = 0; w < q; w++)
	{
		int a;
		cin >> a;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				e[i][j]++;
		if (a == 1) {
			int b; cin >> b;
			b--;
			for (int i = 0; i < m; i++)
				e[b][i] = 0;
		}
		if (a == 2) {
			int b; cin >> b;
			b--;
			for (int i = 0; i < n; i++)
				e[i][b] = 0;
		}
		if (a == 3) {
			int b, c, ex, ey, k;
			cin >> b >> c >> ex >> ey >> k;
			b--; c--;
			ex--; ey--;
			queue<pair<pair<int, int>, pair<int, int>>> q;
			bool us[60][60] = {};
			int be[60][60];
			int bw[60][60];

			for (int i = 0; i < n; i++)
			{
				for (int j = 0; j < m; j++) be[i][j] = 1e9, bw[i][j] = 1e9, us[i][j] = false;
			}
			be[b][c] = e[b][c];
			q.push({ {e[b][c], 0}, { b,c } });
			while (q.size())
			{
				auto cur = q.front();
				q.pop();
				if (cur.first.first > k) continue;
				if (!us[cur.second.first][cur.second.second] ||
					(us[cur.second.first][cur.second.second] && (be[cur.second.first][cur.second.second] > cur.first.first || bw[cur.second.first][cur.second.second] > cur.first.second)))
				{
					be[cur.second.first][cur.second.second] = cur.first.first;
					bw[cur.second.first][cur.second.second] = cur.first.second;
					us[cur.second.first][cur.second.second] = 1;

					for (int i = 0; i < 4; i++)
					{
						int cx = cur.second.first + dx[i];
						int cy = cur.second.second + dy[i];
						if (cx < 0 || cy < 0 || cx >= n || cy >= m) continue;
						if (e[cx][cy] <= k)
							q.push({ { max(e[cx][cy], cur.first.first), cur.first.second + 1}, { cx, cy } });
					}
				}
			}
			if (k < be[ex][ey]) cout << -1 << endl;
			else cout << bw[ex][ey] << endl;
		}

	}
}

int main()
{
	solve();
}