#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif

mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;

int n, m, q;

int w[MAXN];
int h[MAXN];

void init() {

}

void solve() {
	init();
	for (int i = 1; i <= q; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x;
			x--;
			w[x] = -i;
		}
		if (t == 2) {
			int x;
			cin >> x;
			x--;
			h[x] = -i;
		}
		if (t == 3) {
			int a, b, c, d, k;
			cin >> a >> b >> c >> d >> k;
			a--, b--, c--, d--;
			bool ok_w_a = w[a] + i <= k;
			bool ok_h_a = h[b] + i <= k;
			bool ok_w_b = w[c] + i <= k;
			bool ok_h_b = h[d] + i <= k;
			cerr << a << ' ' << b << ' ' << c << ' ' << d << '\n';
			cerr << ok_w_a << ' ' << ok_h_a << ' ' << ok_w_b << ' ' << ok_h_b << '\n' << '\n';			
			if (ok_h_b && ok_w_a) {
				cout << abs(c - a) + abs(b - d) << '\n';
				continue;
			}
			if (ok_h_a && ok_w_b) {
				cout << abs(c - a) + abs(b - d) << '\n';
				continue;
			}
			if (a == c && ok_w_a) {
				cout << abs(b - d) + abs(a - c) << '\n';
				continue;
			}
			if (b == d && ok_h_a) {
				cout << abs(b - d) + abs(a - c) << '\n';
				continue;
			}
			int ans = INF;
			if (ok_h_a && ok_h_b) {
				for (int j = 0; j < n; j++) {
					if (w[j] + i <= k) {
						ans = min(ans, abs(j - a) + abs(j - c) + abs(b - d));
					}
				}
				bool ok = 1;
				for (int j = min(b, d); j <= max(b, d); j++) {
					if (h[j] + i > k) {
						ok = 0;
					}
				}
				if (ok) {
					ans = abs(b - d) + abs(a - c);
				}
			}
			if (ok_w_a && ok_w_b) {
				for (int j = 0; j < m; j++) {
					if (h[j] + i <= k) {
						ans = min(ans, abs(j - b) + abs(j - d) + abs(a - c));
					}
				}
				bool ok = 1;
				for (int j = min(a, c); j <= max(a, c); j++) {
					if (w[j] + i > k) {
						ok = 0;
					}
				}
				if (ok) {
					ans = abs(b - d) + abs(a - c);
				}
			}
			if (ans != INF) {
				cout << ans << '\n';
			}
			else {
				cout << "-1\n";
			}
		}
	}
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#else

	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m >> q){
		solve();
	}
	return 0;
}