#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <random>
#include <ctime>
#include <cassert>

using namespace std;
typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif

mt19937 rng(time(0));
const int MOD = 1e9 + 7;
const int INF = 1e9;

int n;

int query(int x) {
	cout << "? " << x << endl;
	string s;
	cin >> s;
	bool a = s == "Yes";
	cout << "? " << x << endl;
	cin >> s;
	bool b = s == "Yes";
	if (a != b) {
		cout << "? " << x << endl;
		cin >> s;
		return s == "Yes";
	}
	return a;
}

void init() {

}

void solve() {
	init();
	int l = 1;
	int r = n + 1;
	while (l + 1 < r) {
		int mid = (l + r) >> 1;
		if (query(mid)) {
			l = mid;
		}
		else {
			r = mid;
		}
	}
	cout << "! " << l << endl;
	string s;
	cin >> s;
	if (s == "Done") {
		exit(0);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	while (1) 
		solve();
	return 0;
}