#include <bits/stdc++.h>

#pragma GCC optimize("O3")

#define mp make_pair

using namespace std;

const int MAX_N = 1000001, MAX_M = 1000001;
int verts[MAX_M], hors[MAX_N];
int DO_verts[MAX_M * 4], DO_hors[MAX_N * 4];    //DO on maxs
int n, m;
int time_elapsed = 0;

int DO_verts_getmax(int ind, int q_l, int q_r, int r_l, int r_r) {
    if (r_r <= q_l) return -1000000000;
    if (q_r <= r_l) return -1000000000;
    if (r_r == q_r && r_l == q_l) return DO_verts[ind];
    int r_m = (r_r + r_l) / 2;
    return max(DO_verts_getmax(ind * 2, q_l, min(r_m, q_r), r_l, r_m),
               DO_verts_getmax(ind * 2 + 1, max(q_l, r_m), q_r, r_m, r_r));
}

void DO_verts_set(int ind, int val, int pos, int l_now, int r_now) {
    if (pos >= r_now || pos < l_now) return;
    if (l_now + 1 == r_now) {
        DO_verts[ind] = val;
        return;
    }
    int m_now = (l_now + r_now) / 2;
    DO_verts_set(ind * 2, val, pos, l_now, m_now);
    DO_verts_set(ind * 2 + 1, val, pos, m_now, r_now);
    DO_verts[ind] = max(DO_verts[ind * 2], DO_verts[ind * 2 + 1]);
}

int DO_hors_getmax(int ind, int q_l, int q_r, int r_l, int r_r) {
    if (r_r <= q_l) return -1000000000;
    if (q_r <= r_l) return -1000000000;
    if (r_r == q_r && r_l == q_l) return DO_hors[ind];
    int r_m = (r_r + r_l) / 2;
    return max(DO_hors_getmax(ind * 2, q_l, min(r_m, q_r), r_l, r_m),
               DO_hors_getmax(ind * 2 + 1, max(q_l, r_m), q_r, r_m, r_r));
}

void DO_hors_set(int ind, int val, int pos, int l_now, int r_now) {
    if (pos >= r_now || pos < l_now) return;
    if (l_now + 1 == r_now) {
        DO_hors[ind] = val;
        return;
    }
    int m_now = (l_now + r_now) / 2;
    DO_hors_set(ind * 2, val, pos, l_now, m_now);
    DO_hors_set(ind * 2 + 1, val, pos, m_now, r_now);
    DO_hors[ind] = max(DO_hors[ind * 2], DO_hors[ind * 2 + 1]);
}

bool can_vert(int ind, int prohod, int hor1, int hor2) {
    if (verts[ind] + time_elapsed <= prohod) return true;
    int maxx = DO_hors_getmax(1, hor1, hor2 + 1, 0, n);
    return maxx + time_elapsed <= prohod;
}

bool can_hor(int ind, int prohod, int vert1, int vert2) {
    if (hors[ind] + time_elapsed <= prohod) return true;
    int maxx = DO_verts_getmax(1, vert1, vert2 + 1, 0, m);
    return maxx + time_elapsed <= prohod;
}

int bfs(int r1, int c1, int r2, int c2, int prohod) {
    bool pos_vert_c1_r1_r2 = can_vert(c1, prohod, min(r1, r2), max(r1, r2));
    bool pos_hor_r2_c1_c2 = can_hor(r2, prohod, min(c1, c2), max(c1, c2));
    bool pos_vert_c2_r1_r2 = can_vert(c2, prohod, min(r1, r2), max(r1, r2));
    bool pos_hor_r1_c1_c2 = can_hor(r1, prohod, min(c1, c2), max(c1, c2));
    if (pos_vert_c1_r1_r2 && pos_hor_r2_c1_c2) {
        return abs(r1 - r2) + abs(c1 - c2);
    }
    if (pos_vert_c2_r1_r2 && pos_hor_r1_c1_c2) {
        return abs(r1 - r2) + abs(c1 - c2);
    }

    int minnn = 1000000000;

    if (pos_hor_r1_c1_c2 && pos_hor_r2_c1_c2) {
        for (int i = min(c1, c2); i <= max(c1, c2); ++i) {
            if (i == min(c1, c2)) {
                if (can_vert(i, prohod, min(r1, r2), max(r1, r2)))
                    return abs(r1 - r2) + abs(c1 - c2);
            } else {
                if (verts[i] + time_elapsed <= prohod) { return abs(r1 - r2) + abs(c1 - c2); }
            }
        }
        for (int i = min(c1, c2); i >= 0; --i) {
            if (verts[i] + time_elapsed <= prohod) {
                minnn = min(minnn, abs(c1 - i) + abs(c2 - i) + abs(r1 - r2));
                break;
            }
        }
        for (int i = max(c1, c2); i < m; ++i) {
            if (verts[i] + time_elapsed <= prohod) {
                minnn = min(minnn, abs(c1 - i) + abs(c2 - i) + abs(r1 - r2));
                break;
            }
        }
    }

    if (pos_vert_c1_r1_r2 && pos_vert_c2_r1_r2) {
        for (int i = min(r1, r2); i <= max(r1, r2); ++i) {
            if (i == min(r1, r2)) {
                if (can_hor(i, prohod, min(c1, c2), max(c1, c2)))
                    return abs(r1 - r2) + abs(c1 - c2);
            } else {
                if (hors[i] + time_elapsed <= prohod) {
                    return abs(r1 - r2) + abs(c1 - c2);
                }
            }

        }
        for (int i = min(r1, r2); i >= 0; --i) {
            if (hors[i] + time_elapsed <= prohod) {
                minnn = min(minnn, abs(r1 - i) + abs(r2 - i) + abs(c1 - c2));
                break;
            }
        }
        for (int i = max(r1, r2); i < m; ++i) {
            if (hors[i] + time_elapsed <= prohod) {
                minnn = min(minnn, abs(r1 - i) + abs(r2 - i) + abs(c1 - c2));
                break;
            }
        }
    }

    if (minnn == 1000000000) return -1;
    return minnn;
}

int main() {

    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);

    int q;
    cin >> n >> m >> q;
    for (int ii = 0; ii < q; ++ii) {
        time_elapsed++;
        int code;
        cin >> code;
        if (code == 1) {
            int r;
            cin >> r;
            r--;
            hors[r] = -time_elapsed;
            DO_hors_set(1, -time_elapsed, r, 0, n);
        }
        if (code == 2) {
            int c;
            cin >> c;
            c--;
            verts[c] = -time_elapsed;
            DO_verts_set(1, -time_elapsed, c, 0, m);
        }
        if (code == 3) {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            c1--;
            r2--;
            c2--;

            cout << bfs(r1, c1, r2, c2, k) << '\n';
        }
    }
}
