#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, m;
vector <vector <int> > a;
vector <vector <int> > dist;
int x, y, u, v, k;

void bfs(int _x, int _y) {
    dist.clear();
    dist.resize(n, vector <int> (m, -1));
    queue <pair <int, int> > q;
    if (a[_x][_y] <= k) {
        dist[_x][_y] = 0;
        q.push({_x, _y});
    }
    while (!q.empty()) {
        _x = q.front().first;
        _y = q.front().second;
        q.pop();
        if (_x - 1 >= 0 && a[_x - 1][_y] <= k && (dist[_x - 1][_y] == -1 || dist[_x - 1][_y] > dist[_x][_y] + 1)) {
            q.push({_x - 1, _y});
            dist[_x - 1][_y] = dist[_x][_y] + 1;
        }
        if (_y - 1 >= 0 && a[_x][_y - 1] <= k && (dist[_x][_y - 1] == -1 || dist[_x][_y - 1] > dist[_x][_y] + 1)) {
            q.push({_x, _y - 1});
            dist[_x][_y - 1] = dist[_x][_y] + 1;
        }
        if (_x + 1 < n && a[_x + 1][_y] <= k && (dist[_x + 1][_y] == -1 || dist[_x + 1][_y] > dist[_x][_y] + 1)) {
            q.push({_x + 1, _y});
            dist[_x + 1][_y] = dist[_x][_y] + 1;
        }
        if (_y + 1 < m && a[_x][_y + 1] <= k && (dist[_x][_y + 1] == -1 || dist[_x][_y + 1] > dist[_x][_y] + 1)) {
            q.push({_x, _y + 1});
            dist[_x][_y + 1] = dist[_x][_y] + 1;
        }
    }
}

void solve() {
    int q;
    cin >> n >> m >> q;
    a.resize(n, vector <int> (m, 0));
    while (q) {
        --q;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) ++a[i][j];
        }
        int type;
        cin >> type;
        if (type == 1) {
            int x;
            cin >> x;
            --x;
            for (int i = 0; i < m; ++i) a[x][i] = 0;
        }
        if (type == 2) {
            int x;
            cin >> x;
            --x;
            for (int i = 0; i < n; ++i) a[i][x] = 0;
        }
        if (type == 3) {
            cin >> x >> y >> v >> u >> k;
            --x;
            --y;
            --v;
            --u;
            bfs(x, y);
            cout << dist[v][u] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
