#include <bits/stdc++.h>

using namespace std;

#define int long long

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    vector <vector <pair <int, int> > > g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        if (v < u) swap(u, v);
        --v;
        --u;
        g[u].push_back({v, w});
    }
    vector <pair <int, int> > quest(q);
    int maxr = 0;
    for (int i = 0; i < q; ++i) {
        cin >> quest[i].first >> quest[i].second;
        --quest[i].first;
        maxr = max(maxr, quest[i].second);
    }
    //cout << 1;
    vector <vector <bool> > dp(n, vector <bool> (maxr * p / (p - 1) + 1));
    dp[0][0] = 1;
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 0; j < dp[i].size(); ++j) {
            if (dp[i][j]) {
                for (auto el : g[i]) {
                    if (j + el.second < dp[i].size()) dp[el.first][j + el.second] = 1;
                }
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        bool check = 0;
        for (int j = quest[i].second; j <= quest[i].second * p / (p - 1); ++j) {
            if (dp[quest[i].first][j]) {
                check = 1;
                break;
            }
        }
        if (check) cout << 1;
        else cout << 0;
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t) {
        --t;
        solve();
    }
    return 0;
}
