#include <bits/stdc++.h>
typedef long long ll;
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 5e5 + 64;

int n, c;
int arr[N];
int fir[N];
int las[N];
int res[N];

struct Cmp {
	bool operator()(int a, int b) {
		int len_a = las[a] - fir[a] + 1;
		int len_b = las[b] - fir[b] + 1;
		return tie(len_a, a) > tie(len_b, b);
	}
} cmp;

vector<int> ord;

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	fill_n(fir, N, N);
	cin >> n >> c;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
		fir[arr[i]] = min(fir[arr[i]], i);
		las[arr[i]] = max(las[arr[i]], i);
	}
	for (int i = 1; i <= c; ++i) {
		if (fir[i] > las[i]) {
			continue;
		}
		ord.push_back(i);
	}
	sort(all(ord), cmp);
	//for (int e : ord) {
	//	cerr << e << " ";
	//}
	//cerr << endl;
	for (int col : ord) {
		fill(res + fir[col], res + las[col] + 1, col); 
	}
	if (equal(res, res + n, arr, arr + n)) {
		cout << ord.size() << "\n";
		for (int col : ord) {
			cout << col << " " << fir[col] + 1 << " " << las[col] + 1 << "\n";
		}
	} else {
		cout << "-1\n";
	}
	return 0;
}

