#include <bits/stdc++.h>
typedef long long ll;
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 5e3 + 64;
int n, m, q;
ll p;
vector<pair<ll, int>> query[N];
bool answer[N];
vector<pair<int, ll>> g[N];
vector<ll> can[N];

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int test;
	cin >> test;
	while (test--) {
		cin >> n >> m >> q >> p;
		for (int i = 0; i < N; ++i) {
			query[i].clear();
			answer[i] = false;
			g[i].clear();
			can[i].clear();
		}
		can[1].push_back(0);
		for (int v, u, i = 0; i < m; ++i) {
			ll w;
			cin >> v >> u >> w;
			g[v].emplace_back(u, w);
		}
		for (int f, i = 1; i <= q; ++i) {
			ll r;
			cin >> f >> r;
			query[f].emplace_back(r, i);
		}
		for (int v = 1; v <= n; ++v) {
			sort(all(can[v]));
			can[v].erase(unique(all(can[v])), can[v].end());
			while (can[v].size() && can[v].back() > 5000) {
				can[v].pop_back();
			}
			for (auto pa : query[v]) {
				ll r = pa.first;
				int ind = pa.second;
				auto it = lower_bound(all(can[v]), r);
				answer[ind] = (it != can[v].end() && *it * (p - 1) <= p * r);
			}
			for (auto pa : g[v]) {
				int u = pa.first;
				ll w = pa.second;
				for (ll x : can[v]) {
					can[u].push_back(x + w);
				}
			}
		}
		for (int i = 1; i <= q; ++i) {
			cout << answer[i];
		}
		cout << "\n";
	}
	return 0;
}

