#include <bits/stdc++.h>
typedef long long ll;
#define all(x) x.begin(), x.end()
using namespace std;
char res[10];
bool query(int x) {
    cout << "? " << x << endl;
    cin >> res;
    return res[0] == 'Y';
}
 
void answer(int x) {
    cout << "! " << x << endl;
    cin >> res;
    if (res[0] != 'C') {
        exit(0);
    }
}
 
const int N     = 100;
const int Q     = 100;
const int INF   = 1e9;
int qt[13];
int n, q;
 
bool cur[Q][N];
bool pos[Q][N];
bool neg[Q][N];
 
void build(int id, int x) {
    copy_n(cur[0], Q * N, pos[0]);
    for (int i = 0; i <= q; ++i) {
        if (i == id) {
            fill(pos[i] + x, pos[i] + N, 0);
        } else {
            fill(pos[i], pos[i] + x, 0);
        }
    }
    copy_n(cur[0], Q * N, neg[0]);
    for (int i = 0; i <= q; ++i) {
        if (i != id) {
            fill(neg[i] + x, neg[i] + N, 0);
        } else {
            fill(neg[i], neg[i] + x, 0);
        }
    }
}
 
int getcnt(bool arr[Q][N]) {
    int cnt = 0;
    for (int i = 0; i <= q; ++i) {
        for (int x = 1; x <= n; ++x) {
            cnt += arr[i][x];
        }
    }
    return cnt;
}
 
void find_ans() {
    for (int i = 0; i <= q; ++i) {
        for (int x = 1; x <= n; ++x) {
            if (cur[i][x]) {
                answer(x);
                return;
            }
        }
    }
    assert(false);
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
     
    cin >> n;
    qt[2] = 3;
    qt[3] = 5;
    qt[4] = 5;
    qt[5] = 6;
    qt[6] = 6;
    qt[7] = 6;
    qt[8] = 7;
    qt[9] = 7;
    qt[10] = 7;
    qt[11] = 7;
    qt[12] = 7;
    
    qt[13] = 7;
    qt[14] = 7;
    qt[15] = 7;
    qt[16] = 7;
    qt[17] = 7;
    qt[18] = 7;
    qt[19] = 7;
    qt[20] = 7;
    qt[21] = 7;
    qt[22] = 7;
    qt[23] = 7;
    qt[24] = 8;
    qt[25] = 8;
     
     
    q = qt[n];
    cerr << "q = " << q << endl;
    while (1) {
        if (n == 1) {
            answer(1);
            continue;
        }
        for (int i = 0; i <= q; ++i) {
            for (int j = 1; j <= n; ++j) {
                cur[i][j] = true;
            }
        }
        int id = 1;
        while (getcnt(cur) > 1) {
            int best = -1;
            int val = INF;
            for (int x = 1; x <= n; ++x) {
                build(id, x);
                int mcnt = max(getcnt(pos), getcnt(neg));
                if (mcnt < val) {
                    val = mcnt;
                    best = x;
                }
            }
            assert(best != -1);
            int x = best;
            build(id, x);
            //cerr << "id, pcnt, ncnt " << id << " " << getcnt(pos) << " " << getcnt(neg) << endl;
            if (query(x)) {
                copy_n(pos[0], Q * N, cur[0]);
            } else {
                copy_n(neg[0], Q * N, cur[0]);
            }
            ++id;
        }
        assert(getcnt(cur) == 1);
        find_ans();
    }
     
    return 0;
}
