#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    int t;
    cin >> t;
    for (int test = 0; test < t; test++) {
        int n, m, p, q;
        cin >> n >> m >> q >> p;
        if (p != 2)
            return 0;
        vector<long long> forw(n + 1);
        vector<long long> backw(n + 1);
        for (int i = 0; i < m; i++) {
            int u, v;
            long long d;
            cin >> u >> v >> d;
            if (v == u + 1) {
                forw[u] = d;
            } else if (u == v + 1) {
                backw[u] = d;
            } else {
                return 0;
            }
        }
        for (int i = 0; i < q; i++) {
            int f;
            long long r;
            cin >> f >> r;
            vector<long long> d(n + 1);
            long long w = 0;
            for (int v = 1; v < f; v++) {
                w += forw[v];
            }
            for (int v = 1; v <= f; v++) {
                d[v] = w;
            }
            for (int v = f + 1; v <= n; v++) {
                d[v] = d[v - 1] + forw[v - 1] + backw[v];
            }
            bool ok = false;
            for (int v = 1; v < n; v++) {
                long long c = forw[v] + backw[v + 1];
                if (d[v] > 2 * r) {
                    continue;
                }
                if (c < r || d[v] + c <= 2 * r || (d[v] >= r && d[v] <= r * 2)) {
                    ok = true;
                    break;
                }
            }
            cout << ok;
        }
        cout << '\n';
    }
}
/*
1
4 6 1 2
1 2 5
2 3 8
3 4 3
4 3 10
3 2 9
2 1 7
2 1
*/
