#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

const int MAXN = 1e4 + 5;
int n, m, q;
int rs[MAXN];
int cs[MAXN];
int mn_row[MAXN * 4];
int mx_row[MAXN * 4];
int mn_col[MAXN * 4];
int mx_col[MAXN * 4];

void tupdate_pos(int *mn, int *mx, int v, int tl, int tr, int p, int x) {
    mn[p] = x;
    mx[p] = x;
}

int tget_min(int *mn, int v, int tl, int tr, int l, int r) {
    return *min_element(mn + l, mn + r);
}

int tget_max(int *mx, int v, int tl, int tr, int l, int r) {
    return *max_element(mx + l, mx + r);
}



void update_row(int r, int v) {
    v = -v;
    rs[r] = v;
    tupdate_pos(mn_row, mx_row, 0, 0, n, r, v);
}

void update_col(int c, int v) {
    v = -v;
    cs[c] = v;
    tupdate_pos(mn_col, mx_col, 0, 0, m, c, v);
}

int max_row(int l, int r) {
    if (l > r) swap(l, r);
    return tget_max(mx_row, 0, 0, n, l, r + 1);
}

int min_row(int l, int r) {
    if (l > r) swap(l, r);
    return tget_min(mn_row, 0, 0, n, l, r + 1);
}

int max_col(int l, int r) {
    if (l > r) swap(l, r);
    return tget_max(mx_col, 0, 0, n, l, r + 1);
}

int min_col(int l, int r) {
    if (l > r) swap(l, r);
    return tget_min(mn_col, 0, 0, n, l, r + 1);
}

int solve_gen(int r1, int c1, int r2, int c2, int k) {
    if (max_row(r1, r2) <= k ||
        max_col(c1, c2) <= k ||
        rs[r1] <= k && rs[r2] <= k && min_col(c1, c2) <= k ||
        cs[c1] <= k && cs[c2] <= k && min_row(r1, r2) <= k ||
        rs[r1] <= k && cs[c2] <= k ||
        cs[c1] <= k && rs[r2] <= k) return abs(r1 - r2) + abs(c1 - c2);
    int res = INT_MAX;
    if (rs[r1] <= k && rs[r2] <= k) {
        for (int i = 0; i < m; ++i) {
            if (cs[i] <= k) res = min(res, abs(r1 - r2) + abs(i - c1) + abs(i - c2));
        }
    }
    if (cs[c1] <= k && cs[c2] <= k) {
        for (int i = 0; i < n; ++i) {
            if (rs[i] <= k) res = min(res, abs(c1 - c2) + abs(i - r1) + abs(i - r2));
        }
    }
    if (res == INT_MAX) return -1;
    return res;
}

int d[MAXN][MAXN];
int dx[] = {-1, 0, 0, 1};
int dy[] = {0, -1, 1, 0};
int solve(int r1, int c1, int r2, int c2, int k) {
    if (min(rs[r1], cs[c1]) > k) return -1;
    return solve_gen(r1, c1, r2, c2, k);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m >> q;
    rep(i, q) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            update_row(r - 1, i + 1);
        } else if (t == 2) {
            int c;
            cin >> c;
            update_col(c - 1, i + 1);
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            cout << solve(r1 - 1, c1 - 1, r2 - 1, c2 - 1, k - (i + 1)) << '\n';
        }
    }
}