#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

using namespace std;

const int N = 12;

vector <vector <pair <int, long long>>> g(N);
vector <set <long long>> f(N);

void dfs(int v = 0, long long p = 0) {
	f[v].insert(p);
	for (auto i : g[v])
		dfs(i.first, p + i.second);
}

int main() {
	ios_base::sync_with_stdio(false);
#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) {
		long long n, m, q, p;
		cin >> n >> m >> q >> p;
		g.clear();
		g.resize(n);
		for (int j = 0; j < m; j++) {
			int a, b;
			long long d;
			cin >> a >> b >> d;
			g[a - 1].push_back({ b - 1, d });
		}
		dfs(0);
		for (int j = 0; j < q; j++) {
			int a;
			long long d;
			cin >> a >> d;
			if (f[a - 1].lower_bound(d) != f[a - 1].end() &&
				*f[a - 1].lower_bound(d) < (p * d) / (p - 1))
				cout << 1;
			else cout << 0;
		}
		cout << endl;
	}
}