
#include <iostream>
#include <vector>
#include <queue>
#include <utility>
using namespace std;

vector <pair<int, int>> g[15];
int le, ri, fl;

void dfs(int u, int len, int to) {
	if (u == to) {
		fl |= (le <= len && len <= ri);
		return;
	}
	if (fl) return;
	if (len > ri) return;
	for (auto v : g[u]) {
		dfs(v.first, len + v.second, to);
		if (fl) return;
	}
	if (fl) return;
}

void run() {
	int n, m, q, p;
	cin >> n >> m >> q >> p;
	for (int i = 1; i <= n; ++i) g[i].clear();
	while (m--) {
		int u, v, l;
		cin >> u >> v >> l;
		g[u].push_back({ v, l });
	}
	while (q--) {
		int f, r;
		cin >> f >> r;
		le = r;
		double fi = (1.0 * p / (1.0 * (p - 1))) * r;
		ri = int(fi);
		fl = 0;
		dfs(1, 0, f);
		cout << fl;
	}
}

void solve() {
	int t;
	cin >> t;
	while (t--) {
		run();
		cout << '\n';
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	//freopen("true.txt", "r", stdin);
	solve();
	return 0;
}