#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <pair <long long, long long> > g[5000];
bool dp[5000][10001];

void solve(long long v, bool cond) {
    for (long long i = 0; i < g[v].size(); i++) {
        long long u = g[v][i].first;
        long long c = g[v][i].second;
        for (long long j = 0; j <= 10000 - c; j++) {
            if (dp[v][j]) {
                //cout << v << " " << u << " " << j << endl;
                dp[u][j + c] = cond;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long t;
    cin >> t;
    while (t--) {
        long long n, m, q, p, u, v;
        long long c;
        cin >> n >> m >> q >> p;
        for (long long i = 0; i < n; i++)
            g[i].clear();
        for (long long i = 0; i < m; i++) {
            cin >> u >> v >> c;
            u--;
            v--;
            g[u].push_back({v, c});
        }
        dp[0][0] = true;
        for (long long i = 0; i < n; i++)
            solve(i, true);
        for (long long i = 0; i < q; i++) {
            cin >> v >> c;
            v--;
            bool cond = false;
            for (long long j = c; j <= ((c * p) / (p - 1)); j++) {
                //cout << j << endl;
                if (dp[v][j]) {
                    cond = true;
                    //cout << j << "!" << (c * p) / (p - 1) << endl;
                }
            }
            cout << cond;
        }
        cout << '\n';
        for (long long i = n - 1; i >= 0; i--)
            solve(i, false);
    }
}
