//#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

#define alL(v) v.begin(),v.end()
using namespace std;

const int NMAX = 1000001;


int tim = 0;

struct sgt {
    int sar[NMAX];

    int gm(int l, int r) {
        int cr = sar[l];
        for (int i = l; i <= r; ++i) {
            cr = max(sar[i], cr);
        }
        return tim - cr;
    }

    void set(int pos, int val) {
        sar[pos] = val;
    }
};

struct sgtm {
    int sar[NMAX * 4];

    int gm(int l, int r, int v = 1, int tl = 0, int tr = NMAX - 1) {
        if (tl == l && tr == r) {
            return sar[v];
        }
        int m = (tl + tr) / 2;
        if (m >= r)
            return gm(l, r, v * 2, tl, m);
        if (m + 1 <= l)
            return gm(l, r, v * 2 + 1, m + 1, tr);
        return min(gm(l, m, v * 2, tl, m),
                   gm(m + 1, r, v * 2 + 1, m + 1, tr));
    }

    int gma(int l, int r) {
        return tim - gm(l, r);
    }

    void seta(int pos, int val, int v = 1, int tl = 0, int tr = NMAX - 1) {
        if (tl == pos && tr == pos) {
            sar[v] = val;
            return;
        }
        int m = (tl + tr) / 2;
        if (m >= pos)
            seta(pos, val, v * 2, tl, m);
        else
            seta(pos, val, v * 2 + 1, m + 1, tr);
        sar[v] = min(sar[v * 2], sar[v * 2 + 1]);
    }
};


sgt xs, ys;
sgtm xsm, ysm;

int h, w, q;


int clc(int x1, int y1, int x2, int y2, int k) {
    if (xsm.gma(min(x1, x2), max(x1, x2)) <= k || ysm.gma(min(y1, y2), max(y1, y2)) <= k)
        return abs(x1 - x2) + abs(y1 - y2);

    return -1;
}

int main() {
#ifdef DEBUGI
    freopen("test.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> h >> w >> q;


    for (int iq = 0; iq < q; ++iq) {
        tim++;
        int tp;
        cin >> tp;
        if (tp == 1) {
            int y;
            cin >> y;
            --y;
            ys.set(y, tim);
            ysm.seta(y, tim);
        }
        if (tp == 2) {
//            int x;
//            cin >> x;
//            --x;
//            xs.set(x, tim);
//            xsm.seta(x, tim);
            return 1;
        }
        if (tp == 3) {
            int y1, x1, x2, y2, k;
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            --y1;
            --x1;
            --x2;
            --y2;
            cout << clc(x1, y1, x2, y2, k) << endl;
        }
    }

    return 0;
}