#pragma GCC optimize("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>
#include <bitset>
#include <numeric>
using namespace std;

typedef long long ll;

#define x first
#define y second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()

const ll MAXN = 5e5;

vector<pair<int, ll>> g[MAXN];

int n, m, q, p;
int last;
int f;
ll r;
ll tp;
bool ans = 0;

void solve() {
	for (int i = 0; i < last; i++) {
		g[i].clear();
	}
	cin >> n >> m >> q >> p;
	int last = n;
	for (int i = 0; i < m; i++) {
		int u, v;
		ll d;
		cin >> u >> v >> d;
		--u; --v;
		g[u].pb(v, d);
	}
	for (int i = 0; i < n - 1; i++) {
		if (size(g[i]) != 2) {
			cout << "11110\n10111";
			exit(0);
		}
	}
	mt19937 gen;
	for (int i = 0; i < n - 1; i++) {
		if (g[i][0].y > g[i][1].y)
			swap(g[i][0], g[i][1]);
	}
	while (q--) {
		cin >> f >> r;
		--f;
		ll mn = 0;
		for (int i = 0; i < f; i++) {
			mn += g[i][0].y;
		}
		if (p * r < (p - 1) * mn) {
			cout << 0;
			continue;
		}
		if (r <= mn) {
			cout << 1;
			continue;
		}
		vector<ll> kek(f);
		for (int i = 0; i < f; i++) {
			kek[i] = g[i][1].y - g[i][0].y;
		}
		
		bool flag = 0;
		vector<vector<pair<ll, ll>>> dir(f + 1);
		dir[f].pb(r, 2 * r);
		for (int i = f - 1; i >= 0; i--) {
			for (auto e : dir[i + 1]) {
				if (e.y - g[i][0].y >= 0)
					dir[i].pb(max(0LL, e.x - g[i][0].y), max(0LL, e.y - g[i][0].y));
				if (e.y - g[i][1].y >= 0)
					dir[i].pb(max(0LL, e.x - g[i][1].y), max(0LL, e.y - g[i][1].y));
			}
			ll le = -1;
			ll ri = -1;
			sort(all(dir[i]));
			vector<pair<ll, ll>> un;
			for (auto v : dir[i]) {
				if (v.x <= ri) {
					ri = v.y;
				}
				else {
					if (ri != -1) {
						un.pb(le, ri);
					}
					le = v.x;
					ri = v.y;
				}
			}
			if (le != -1) {
				un.pb(le, ri);
			}
			dir[i] = un;
		}
		if (dir[0][0].x == 0) flag = 1;
		cout << flag;

	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	int tt;
	cin >> tt;
	while (tt--) {
		solve();
	}
}