#include <iostream>
#include <vector>
#include <set>
#include <ios>
using namespace std;

vector<pair<int, long long>> g[500000];
set<long long> dp[500000];
int main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    for(int k=0; k<t; k++){
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        for(int i=0; i<n; i++){
            g[i].clear();
            dp[i].clear();
        }
        for(int i=0; i<m; i++){
            int v, u;
            long long d;
            cin >> v >> u >> d;
            v--; u--;
            if(v > u)
                swap(v, u);
            g[u].push_back(make_pair(v, d));
        }
        dp[0] = {0};
        for(int i=1; i<n; i++){
            for(auto p : g[i]){
                for(auto new_d : dp[p.first]){
                    dp[i].insert(new_d + p.second);
                }
            }
        }
        /*cout << endl;
        cout << "dp[n - 1]: ";
        for(auto x : dp[n - 1])
            cout << x << " ";
        cout << endl;
        cout << "dp[0]: ";
        for(auto x : dp[0])
            cout << x << " ";
        cout << endl;*/
        for(int t=0; t<q; t++){
            int f;
            long long r;
            cin >> f >> r;
            f--;
            long long min_ = r, max_ = r * p / (p - 1);
            auto it = dp[f].lower_bound(min_);
            if(it == dp[f].end() || *it > max_)
                cout << 0;
            else
                cout << 1;
        }
        cout << "\n";
    }
    return 0;
}
