#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cassert>

using namespace std;

#define int long long
#define pii pair<int, int>

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

int n;

void solve2(int l, int r) {
    while (l < r) {
        int m = (l + r + 1) / 2;
        cout << "? " << m << endl;
        string s1;
        cin >> s1;

        if (s1[0] == 'Y') {
            l = m;
        } else {
            r = m - 1;
        }

    }
    cout << "! " << l << endl;
}

void solve() {
    int l = 1, r = n;
    while (l < r) {
        int m = (l + r + 1) / 2;
        cout << "? " << m << endl;
        string s1;
        cin >> s1;
        cout << "? " << m << endl;
        string s2;
        cin >> s2;
        if (s1 != s2) {
            solve2(l, r);
            return;
        } else {
            if (s1[0] == 'Y') {
                l = m;
            } else {
                r = m - 1;
            }
        }
    }
    cout << "! " << l << endl;
}

signed main() {
    fast();
    cin >> n;
    solve();
    string s;
    while (cin >> s) {
        if (s == "Done") return 0;
        solve();
    }
    return 0;
}