#include <bits/stdc++.h>
#include <complex>
#define pll pair <ll, ll>
#define pb push_back
#define pyshna ios_base :: sync_with_stdio(0); cin.tie(0); cout.tie(0);
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

typedef long long ll;

typedef double ld;

using namespace std;

const ll maxn = 5e3 + 100;
const ll inf = 4e18;
const ll mod = 1e9 + 7;

ll n, m, k, p;

struct edge{
    ll v;
    ll to;
    ll w;
};

vector <edge> V[maxn];

vector <edge> RV[maxn];

ll D[maxn][maxn];

bool used[maxn];

void getdp(ll v){
    ll q, w;
    if (used[v]){
        return;
    }
    used[v] = 1;
    for (q = 0; q < RV[v].size(); q++){
        getdp(RV[v][q].v);
        for (w = 0; w < maxn; w++){
            if (w - RV[v][q].w >= 0){
                D[v][w] += D[RV[v][q].v][w - RV[v][q].w];
                D[v][w] %= mod;
            }
//            if (D[v][w] != 0)cout << "DP " << v << " " << w << " " << D[v][w] << endl;
        }
    }
}

//bool dfs(ll v, ll l, ll r, ll u){
////    cout << "V " << v << " " << l << " " << r << " " << u << endl;
//    if (v == u){
//        if (l <= 0 && r >= 0){
//            return 1;
//        }
//        return 0;
//    }
//    if (r < 0){
//        return 0;
//    }
//    ll q;
//    for (q = 0; q < V[v].size(); q++){
//        if (dfs(V[v][q].to, l - V[v][q].w, r - V[v][q].w, u)){
//            return 1;
//        }
//    }
//    return 0;
//}

int main()
{
    ll q, w, e, t, a, b, c;
    pyshna;
    cin >> t;
    for (e = 0; e < t; e++){
        cin >> n >> m >> k >> p;
        for (q = 0; q < n; q++){
            V[q].clear();
            RV[q].clear();
            used[q] = 0;
            for (w = 0; w < maxn; w++){
                D[q][w] = 0;
            }
        }
        for (q = 0; q < m; q++){
            cin >> a >> b >> c;
            edge e;
            a--; b--;
            e.to = b; e.v = a; e.w = c;
            V[a].pb(e);
            RV[b].pb(e);
        }
        used[0] = 1;
        D[0][0] = 1;
        for (q = 0; q < n; q++){
            getdp(q);
        }
        for (q = 0; q < n; q++){
            for (w = 1; w < maxn; w++){
                D[q][w] = D[q][w - 1] + D[q][w];
//                cout << D[q][w] << endl;
            }
        }
        for (q = 0; q < k; q++){
            cin >> a >> b;
            a--;
            ll l = b, r = (ll)(floor(b * (p) * 1.0 / (p - 1)));
            ll dl, dr;
            if (l != 0){
                dl = D[a][l - 1];
            }
            else{
                dl = 0;
            }
            dr = D[a][r];
            if (dl == dr){
                cout << 0;
            }
            else{
                cout << 1;
            }
        }
        cout << endl;
//        for (q = 0; q < k; q++){
//            cin >> a >> b;
//            a--;
//            ll ans = dfs(0, b * (p - 1), b * p, a);
//            cout << ans;
//        }
//        cout << endl;
    }
    return 0;
}
