#include <iostream>
#include <vector>
#include <random>
#include <string>
#include <algorithm>
#include <random>
#include <cmath>
# include <stack>
using namespace std;

float Eps = 0.001;



int main() {
	int t;
	cin >> t;
	for (int qwert = 0; qwert < t; qwert++) {
		int n, m, q, pr;
		cin >> n >> m >> q >> pr;
		vector<vector<pair<long long, float >>> g(n), rg(n);
		vector<vector<pair<float, long long>>> kek(n);
		for (int i = 0; i < m; i++) {
			int a, b, c;
			cin >> a >> b >> c;
			--a;
			--b;
			g[a].push_back({ b,c });
			rg[b].push_back({ a,c });
		}
		kek[0] = { {0,0},{0,1} };
		for (int i = 1; i < n; i++) {
			vector<pair<float, long long>> mem;
			for (auto p : rg[i]) {
				int v = p.first;
				int cost = p.second;
				for (auto pp : kek[v]) {
					if (pp.second == 0)
						mem.push_back({ pp.first + cost * 1.0*(pr - 1) / (pr),0 });
					else {
						mem.push_back({ pp.first + cost ,1 });
					}

				}
			}
			sort(mem.begin(), mem.end());
			sort(mem.begin(), mem.end());
			int sum = 0;
			for (auto p : mem) {
				if (p.second == 0 && sum == 0) kek[i].push_back({ p.first,0 });
				if (p.second == 0) sum++;
				else sum--;
				if (sum == 0) kek[i].push_back({ p.first,1 });
			}
		}
		vector<bool> ans(q);
		for (int i = 0; i < q; i++) {
			int a;
			cin >> a;
			--a;
			float rr;
			cin >> rr;
			if (kek[a].size() == 0 || (kek[a][0].first > rr + Eps || kek[a][kek[a].size() - 1].first < rr - Eps)) ans[i] = false;
			else {
				int l = 0;
				int r = kek[a].size();
				while (r - l > 1) {
					int m = (l + r) / 2;
					if (kek[a][m].first > rr + Eps) r = m;
					else l = m;
				}
				if (kek[a][l].second == 0 || abs(kek[a][l].first - rr) < Eps) ans[i] = !false;
				else ans[i] = !true;
			}
		}
		for (int i = 0; i < q; i++) {
			if (ans[i] == true) cout << 1;
			else cout << 0;
		}
		cout << endl;


	}
	cin >> t;
}


/*
2
3 3 5 20
1 2 20
2 3 1
1 3 10
2 19
2 20
3 20
3 21
3 9
7 10 5 5
1 2 15
1 3 10
2 4 21
3 4 30
2 5 14
3 5 31
4 6 3
5 6 14
1 7 39
5 7 13
7 42
7 43
7 44
5 39
6 44


*/