#include <bits/stdc++.h>

//#define int long long
#define pii pair<int, int>
#define endl "\n"

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double td;

const int INF = 1e9;
const ll P = 1e9 + 9;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
}

void show(vector<int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<pii>& arr)
{
    for (auto i : arr)
        cout << i.first << " " << i.second << "   ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

bool ask(int val)
{
    cout << "? " << val << endl;
    cout.flush();
    string s;
    cin >> s;
    if (s[0] == 'Y')
        return 1;
    return 0;
}

void ans(int val)
{
    cout << "! " << val << endl;
    cout.flush();
    string s;
    cin >> s;
    if (s[0] == 'D')
        exit(0);
}

int main()
{
    hello();

    int n, m, q;
    cin >> n >> m >> q;
    vector <vector<int>> field(n, vector<int>(m, 0));
    for (int t = 0; t < q; ++t)
    {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
                field[i][j]++;
        int type;
        cin >> type;
        if (type == 1)
        {
            int x;
            cin >> x;
            for (int i = 0; i < m; ++i)
                field[x - 1][i] = 0;
        }
        else if (type == 2)
        {
            int x;
            cin >> x;
            for (int i = 0; i < n; ++i)
                field[i][x - 1] = 0;
        }
        else
        {
            vector <vector<int>> dist(n, vector<int>(m, -1));
            queue <pii> q;
            pii st, fin;
            int k;
            cin >> st.first >> st.second >> fin.first >> fin.second >> k;
            --st.first; --st.second; --fin.first; --fin.second;
            dist[st.first][st.second] = 0;
            if (field[st.first][st.second] > k)
            {
                cout << -1 << endl;
                continue;
            }
            q.push(st);
            while (!q.empty())
            {
                pii cur = q.front();
                q.pop();
                int x = cur.first, y = cur.second;
                if (x && dist[x - 1][y] == -1 && field[x - 1][y] <= k)
                {
                    dist[x - 1][y] = dist[x][y] + 1;
                    q.push({x - 1, y});
                }
                if (y && dist[x][y - 1] == -1 && field[x][y - 1] <= k)
                {
                    dist[x][y - 1] = dist[x][y] + 1;
                    q.push({x, y - 1});
                }
                if (x + 1 < n && dist[x + 1][y] == -1 && field[x + 1][y] <= k)
                {
                    dist[x + 1][y] = dist[x][y] + 1;
                    q.push({x + 1, y});
                }
                if (y + 1 < m && dist[x][y + 1] == -1 && field[x][y + 1] <= k)
                {
                    dist[x][y + 1] = dist[x][y] + 1;
                    q.push({x, y + 1});
                }
            }

            cout << dist[fin.first][fin.second] << endl;
        }
    }
}
