#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <ctime>

#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int INF = (int)1e9 + 10;

struct Edge {
	int v;
	ll w;
	Edge(int v = 0, ll w = 0) : v(v), w(w) {};
};

int dfs(vector<vector<Edge>>& a, int v, int r, int p, ll d) {
	if (v == 0)
		return r <= d && d <= (ld)p * r / (p - 1);
	for (int i = 0; i < (int)a[v].size(); ++i) {
		if (dfs(a, a[v][i].v, r, p, d + a[v][i].w))
			return 1;
	}
	return 0;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t;
	cin >> t;
	for (int ii = 0; ii < t; ++ii) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;
		vector<vector<Edge>> a(n);
		for (int i = 0; i < m; ++i) {
			int v, u;
			ll d;
			cin >> v >> u >> d;
			--v; --u;
			a[u].pb({ v, d });
		}
		for (int i = 0; i < q; ++i) {
			int f;
			ll r;
			cin >> f >> r;
			--f;
			cout << dfs(a, f, r, p, 0);
		}
		cout << endl;
	}

	return 0;
}