#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 5e5 + 10;

vector<int64_t> values[MAX_N];

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tests;
	cin >> tests;
	for (int test = 0; test < tests; ++test) {
		int n, m, q, p, u, v, f;
		int64_t d, r;
		cin >> n >> m >> q >> p;
		for (int i = 0; i < n; ++i)
			values[i].clear();
		for (int i = 0; i < m; ++i) {
			cin >> u >> v >> d;
			values[--u].push_back(d);
		}
		for (int i = 0; i < n - 1; ++i)
			if (values[i][0] > values[i][1])
				swap(values[i][0], values[i][1]);
		for (int query = 0; query < q; ++query) {
			cin >> f >> r;
			--f;
			int64_t summ = 0;
			for (int i = 0; i < f; ++i)
				summ += values[i][0];
			if (summ > 2 * r) {
				cout << "0";
				continue;
			}
			if (summ >= r) {
				cout << "1";
				continue;
			}
			int64_t delta = r - summ, got = 0;
			bool found = 0;
			for (int i = 0; i < f; ++i) {
				int64_t locald = values[i][1] - values[i][0];
				if (locald >= delta && locald <= delta + r) {
					found = 1;
					break;
				} else if (got + locald <= delta + r) {
					got += locald;
				}
				if (got >= delta) {
					found = 1;
					break;
				}
			}
			if (!found)
				cout << "0";
			else
				cout << "1";
		}
		cout << "\n";
	}
	return 0;
}