#include <bits/stdc++.h>

using namespace std;

vector<int> a;
vector<int> last;
vector<pair<int, pair<int, int>>> res;

bool solve(int l, int r) {
//    cout << l << " " << r << "\n";
    if (r - l < 1) {
        return true;
    }
    if (l > 0 && a[l] == a[l - 1]) {
        return solve(l + 1, r);
    }
    if (r < a.size() && a[r - 1] == a[r]) {
        return solve(l, r - 1);
    }


    int c = a[l];
    int l_c = last[c];
    if (l_c >= r) {
        return false;
    }
    res.push_back({c, {l, l_c}});
    bool r1 = solve(l + 1, l_c);
    bool r2 = solve(l_c + 1, r);
    return r1 && r2;
}

signed main() {
    int n, m;
    cin >> n >> m;
    if (n > 10) {
        return -1;
    }

    for (int i = 0; i < m + 1; ++i) {
        last.push_back(-1);
    }
    for (int i = 0; i < n; ++i) {
        int x = (i < 50 ? i : 99 - i) + 1;
        cin >> x;
        x--;
        a.push_back(x);
        last[x] = i;
    }
    bool ans = solve(0, n);
    if (ans) {
        cout << res.size() << "\n";
        for (auto &re : res) {
            cout << re.first + 1 << " " << re.second.first + 1 << " " << re.second.second + 1 << "\n";
        }
    } else {
        cout << -1;
    }

}