#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int N = 1e6 + 10;

int n;

bool get(int x) {
    cout << '?' << ' ' << x << endl;
    string y;
    cin >> y;
    return (y[0] == 'Y');
}

void solve() {
    int l = 0, r = n + 1;
    bool b = 0;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        bool x = get(m);
        if (!b) {
            bool y = get(m);
            if (x != y) {
                b = 1;
                x = get(m);
            }
        }
        if (x)
            l = m;
        else
            r = m;
    }
    cout << '!' << ' ' << l << endl;
    string s;
    cin >> s;
    if (s[0] == 'C')
        solve();
    else
        exit(0);
}

void solve1() {
    cout << '?' << ' ' << 1 << endl;
    string s;
    cin >> s;
    if (s[0] == 'C')
        solve1();
    else
        exit(0);
}

void solve2() {
    int x = get(2), y = get(2);
    if (x != y)
        x = get(2);
    cout << '?' << ' ' << x << endl;
    string s;
    cin >> s;
    if (s[0] == 'C')
        solve2();
    else
        exit(0);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    if (n == 1)
        solve1();
    if (n == 2)
        solve2();
    solve();

    return 0;
}
