#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <math.h>

using namespace std;

struct obj{
	int t; //1 - row // 2 -  col
	int tim;
	int ind;
	obj(){}
	obj(int t1, int time1, int id) {
		t = t1;
		tim = time1;
		ind = id;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, q;
	cin >> n >> m >> q;
	vector<int> row(n);
	vector<int> col(m);
	for (int i = 0; i < n; i++) row[i] = 0;
	for (int i = 0; i < m; i++) col[i] = 0;
	int tim = 0;
	vector<obj> way1;
	vector<obj> way2;
	for (int ijk = 0; ijk < q; ijk++) {
		tim++;
		int type;
		cin >> type;
		if (type == 1) {
			int r;
			cin >> r;
			r--;
			row[r] = tim;
			way1.push_back({ 1, tim, r });
		}
		if (type == 2) {
			int c;
			cin >> c;
			c--;
			col[c] = tim;
			way2.push_back({ 2, tim, c });
		}
		if (type == 3) {
			int x1, y1, x2, y2;
			int k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--; y1--; x2--; y2--;
			int manhet = abs(x1 - x2) + abs(y1 - y2);
			if (k >= tim) {
				cout << manhet << "\n";
				continue;
			}
			int r1 = 0, r2 = 0, c1 = 0, c2 = 0;
			int need = tim - k;
			if (row[x1] >= need) r1 = 1;
			if (col[y1] >= need) c1 = 1;
			if (row[x2] >= need) r2 = 1;
			if (col[y2] >= need) c2 = 1;
			if ((r1 == 0 && c1 == 0) || (r2 == 0 && c2 == 0)) {
				cout << -1 << "\n";
				continue;
			}
			if (r1 == 1 && c2 == 1) {
				cout << manhet << "\n";
				continue;
			}
			if (r2 == 1 && c1 == 1) {
				cout << manhet << "\n";
				continue;
			}
			if (r1 == 1 && r2 == 1) {
				int ans = 1e9;
				if (y1 > y2) {
					swap(y1, y2);
					swap(x1, x2);
				}
				for (int ijk = way2.size() - 1; ijk >= 0; ijk--) {
					auto elem = way2[ijk];
					if (elem.tim < need) break;
					if (elem.t == 1) continue;
					int y = elem.ind;
					int now = 0;
					now += abs(x1 - x2);
					now += abs(y - y1);
					now += abs(y - y2);
					if (now < ans) ans = now;
				}
				if (ans == 1e9) ans = -1;
				cout << ans << "\n";
				continue;
			}
			else{
				int ans = 1e9;
				if (x1 > x2) {
					swap(x1, x2);
					swap(y1, y2);
				}
				for (int ijk = way1.size() - 1; ijk >= 0; ijk--) {
					auto elem = way1[ijk];
					if (elem.tim < need) break;
					if (elem.t == 2) continue;
					int x = elem.ind;
					int now = 0;
					now += abs(y1 - y2);
					now += abs(x - x1);
					now += abs(x - x2);
					if (now < ans) ans = now;
				}
				if (ans == 1e9) ans = -1;
				cout << ans << "\n";
				continue;
			}
		}
	}
}