#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

#define sz(x) ((int)(x).size())
#define INF 2000111222
#define pii pair<int, long long>

int n, m, q;
double p;

vector<pii> g[11];
bool flag;

void dfs(int v, long long score, int fin, long long need) {
    if(flag)
        return;
    if(v == fin) {
        if(score >= need && score * p - score <= need * p) {
            cout << "1";
            flag = true;
        }
        return;
    }
    for(int i = 0; i < sz(g[v]); ++i)
        dfs(g[v][i].first, score + g[v][i].second, fin, need);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        cin >> n >> m >> q >> p;
        for(int i = 0; i < 11; ++i)
            g[i].clear();
        for(int i = 0; i < m; ++i) {
            int u, v;
            long long d;
            cin >> v >> u >> d;
            g[v].push_back(make_pair(u, d));
        }
        while(q--) {
            int f;
            long long r;
            cin >> f >> r;
            flag = false;
            dfs(1, 0LL, f, r);
            if(!flag)
                cout << "0";
        }
        cout << endl;
    }

    return 0;
}