#include <bits/stdc++.h>

using namespace std;

#define int long long

vector< vector< pair<int, int> > > adj;
vector< set<int> > dist;
vector<int> cnt_adjr;
vector<int> cnt_visited;

void dfs(int u) {
	cnt_visited[u]++;
	if(cnt_visited[u] < cnt_adjr[u]) {
		return;
	}

	for(auto p: adj[u]) {
		int v = p.first;
		int d = p.second;
		for(int d1: dist[u]) {
			if(dist[v].size() >= 1000) {
				auto it = dist[v].lower_bound(d1 + d);
				if(it != dist[v].end() && 1000 * (*it) / (d1 + d) < 300) {
					dist[v].erase(it);
				}
			}
			dist[v].insert(d1 + d);
		}
		dfs(v);
	}
}

signed main() {
	int t;
	cin >> t;
	while(t-- > 0) {
		int n, m, q, p;
		cin >> n >> m >> q >> p;

		adj.clear();
		adj.resize(n);
		cnt_adjr.clear();
		cnt_adjr.resize(n);

		for(int i = 0; i < m; i++) {
			int u, v, d;
			cin >> u >> v >> d;
			u--; v--;
			adj[u].emplace_back(v, d);
			cnt_adjr[v]++;
		}

		dist.clear();
		dist.resize(n);
		dist[0].insert(0);
		cnt_visited.clear();
		cnt_visited.resize(n);
		dfs(0);

		for(int i = 0; i < q; i++) {
			int f, r;
			cin >> f >> r;
			f--;

			auto it = dist[f].lower_bound(r);
			if(it != dist[f].end() && *it <= r * p / (p - 1)) {
				cout << "1";
			} else {
				cout << "0";
			}
		}
		cout << "\n";
	}

	return 0;
}