#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

ll n, m, q;

const ll inf = (ll)1e13;


vector < vector < ll > > a;
vector < ll > ax;
vector < ll > ay;

void solve(){
    cin >> n >> m >> q;
    a.resize(n, vector < ll > (m));
    ax.resize(m);
    ay.resize(n);
    ll ct = 1;
    for(ll i = 0; i < q; ++i){
//        cerr << i << "\n";
        ll type;
        cin >> type;
        if(type == 2){
            ll x;
            cin >> x;
            x--;
            for(ll j = 0; j < n; ++j){
                a[j][x] = ct;
            }
            ax[x] = ct;
        } else if(type == 1){
            ll y;
            cin >> y;
            y--;
            for(ll j = 0; j < m; ++j){
                a[y][j] = ct;
            }
            ay[y] = ct;
        } else {
            ll y1, x1, y2, x2, k;
            cin >> y1 >> x1 >> y2 >> x2 >> k;
            --y1, --x1, --y2, --x2;
            ll ans = inf;
            if(x1 > x2){
                swap(x1, x2);
                swap(y1, y2);
            }
            bool ok = 1;
            for(ll cx = x1; cx <= x2; ++cx){
                if(ct - ax[cx] > k){
                    ok = 0;
                }
            }
            if(ok){
                ans = abs(x1 - x2) + abs(y1 - y2);
            }
            for(ll y = 0; y < n; ++y){
                if(ct - ax[x1] <= k && ct - ax[x2] <= k && ct - ay[y] <= k){
                    ans = min(ans, abs(y1 - y) + abs(x1 - x2) + abs(y - y2));
                }
            }
            if(y1 > y2){
                swap(x1, x2);
                swap(y1, y2);
            }
            ok = 1;
            for(ll cy = y1; cy <= y2; ++cy){
                if(ct - ax[cy] > k){
                    ok = 0;
                }
            }
            if(ok){
                ans = abs(x1 - x2) + abs(y1 - y2);
            }
            for(ll x = 0; x < m; ++x){
                if(ct - ay[y1] <= k && ct - ay[y2] <= k && ct - ax[x] <= k){
                    ans = min(ans, abs(x1 - x) + abs(y1 - y2) + abs(x - x2));
                }
            }
            if(ans == inf){
                cout << -1 << "\n";
            } else {
                cout << ans << "\n";
            }
        }
        ct++;
    }
}


signed main(){
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else

    #endif
    while(t--){
        solve();
    }
}
