#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> r_clear(n, 0);
    vector<int> c_clear(m, 0);
    int last_c, last_r;
    last_c = last_r = -1;
    for (int i = 1; i <= q; i++)
    {
        int a;
        cin >> a;
        if (a == 1)
        {
            int r;
            cin >> r;
            r_clear[r - 1] = i;
            last_r = r - 1;
        }
        else if (a == 2)
        {
            int c;
            cin >> c;
            c_clear[c - 1] = i;
            last_c = c - 1;
        }
        else
        {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            c1--;
            r2--;
            c2--;
            if ((k >= i - r_clear[r1] && k >= i - c_clear[c2]) || (k >= i - c_clear[c1] && k >= i - r_clear[r2]))
            {
                cout << abs(r1 - r2) + abs(c1 - c2) << endl;
            }
            else if (k < i - max(r_clear[r1], c_clear[c1]) || k < i - max(r_clear[r2], c_clear[c2]))
            {
                cout << -1 << endl;
            }
            else if (k >= i - r_clear[r1])
            {
                bool t = true;
                for (int j = min(r1, r2); j <= max(r1, r2); j++)
                {
                    if (k < i - r_clear[j])
                    {
                        t = false;
                        break;
                    }
                }
                if (t)
                {
                    cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                }
                else
                {
                    if (last_c == -1 || k < i - c_clear[last_c])
                    {
                        cout << -1 << endl;
                    }
                    else
                    {
                        for (int j = min(c1, c2); j <= max(c1, c2); j++)
                        {
                            if (k >= i - c_clear[j])
                            {
                                cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                                t = true;
                                break;
                            }
                        }
                        if (!t)
                        {
                            for (int j = 1; j < m; j++)
                            {
                                if ((min(c1, c2) - j >= 0 && k >= i - c_clear[min(c1, c2) - j]) || (max(c1, c2) + j < m && k >= i - c_clear[max(c1, c2) + j]))
                                {
                                    cout << abs(r1 - r2) + abs(c1 - c2) + 2 * j << endl;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            else if (k >= i - c_clear[c1])
            {
                bool t = true;
                for (int j = min(c1, c2); j <= max(c1, c2); j++)
                {
                    if (k < i - c_clear[j])
                    {
                        t = false;
                        break;
                    }
                }
                if (t)
                {
                    cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                }
                else
                {
                    if (last_r == -1 || k < i - r_clear[last_r])
                    {
                        cout << -1 << endl;
                    }
                    else
                    {
                        for (int j = min(r1, r2); j <= max(r1, r2); j++)
                        {
                            if (k >= i - r_clear[j])
                            {
                                cout << abs(r1 - r2) + abs(c1 - c2) << endl;
                                t = true;
                                break;
                            }
                        }
                        if (!t)
                        {
                            for (int j = 1; j < n; j++)
                            {
                                if ((min(r1, r2) - j >= 0 && k >= i - r_clear[min(r1, r2) - j]) || (max(r1, r2) + j < n && k >= i - r_clear[max(r1, r2) + j]))
                                {
                                    cout << abs(r1 - r2) + abs(c1 - c2) + 2 * j << endl;
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return 0;
}
