#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = (1 << 20);
const int inf = 1e9;

struct domax {
    int mx[2 * maxn + 3];
    void upd(int p, int a, int x = 1, int L = 0, int R = maxn) {
        if (p < L || p >= R)
            return;
        if (R == L + 1) {
            mx[x] = a;
            return;
        }
        mx[x] = max(mx[x << 1], mx[(x << 1) + 1]);
    }
    int get(int l, int r, int x = 1, int L = 0, int R = maxn) {
        if (r <= L || R <= l)
            return 0;
        if (l <= L && R <= r) {
            return mx[x];
        }
        return max(get(l, r, x << 1, L, (L + R) >> 1), get(l, r, (x << 1) + 1, (L + R) >> 1, R));
    }
    int left2(int x, int a) {
        if (x >= maxn) {
            if (mx[x] >= a)
                return x;
            else
                return maxn;
        }
        int t = left2(x << 1, a);
        if (t != maxn)
            return t;
        else
            return left2((x << 1) + 1, a);
    }
    int left1(int l, int r, int a, int x = 1, int L = 0, int R = maxn) {
        if (r <= L || R <= l)
            return 0;
        if (l <= L && R <= r) {
            if (mx[x] >= a)
                return x;
            else
            return 0;
        }
        int t = left1(l, r, a, x << 1, L, (L + R) >> 1);
        if (t)
            return t;
        else
            return left1(l, r, a, (x << 1) + 1, (L + R) >> 1, R);
    }
    int left(int l, int r, int a) {
        int t = left1(l, r, a);
        if (!t)
            return maxn;
        else
            return left2(t, a);
    }
};

domax dox, doy, dorx, dory;

int mx[maxn], my[maxn];

signed main() {
    ios_base::sync_with_stdio(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int n, m, q;
    cin >> n >> m >> q;
    for (int i = 1; i <= q; i++) {
        int typ;
        cin >> typ;
        if (typ == 1) {
            int t;
            cin >> t;
            mx[t] = i;
            dox.upd(t, i);
            dorx.upd(n - t + 1, i);
        }
        else if (typ == 2) {
            int t;
            cin >> t;
            my[t] = i;
            doy.upd(t, i);
            dory.upd(m - t + 1, i);
        }
        else {
            /*for (int t1 = 1; t1 <= n; t1++) {
                for (int t2 = 1; t2 <= m; t2++) {
                    cerr << min(i - mx[t1], i - my[t2]) << " ";
                }
                cerr << "\n";
            }
            cerr << "\n";*/
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            int res = inf;
            if (i - mx[x1] <= k && i - mx[x2] <= k) {
                int t = dory.get(m - min(y1, y2) + 1 + 1, m + 1);
                if (t != maxn) {
                    t = n - t + 1;
                    res = min(res, abs(x1 - x2) + abs(y1 - t) + abs(y2 - t));
                }
                /*for (int j = 1; j <= m; j++) {
                    if (i - my[j] <= k) {
                        res = min(res, abs(x1 - x2) + abs(y1 - j) + abs(y2 - j));
                    }
                }*/
                bool sog = true;
                for (int j = min(x1, x2); j <= max(x1, x2); j++) {
                    if (i - mx[j] > k)
                        sog = false;
                }
                if (sog)
                    res = min(res, abs(x1 - x2) + abs(y1 - y2));
            }
            if (i - my[y1] <= k && i - my[y2] <= k) {
                //cerr << "N\n";
                for (int j = 1; j <= n; j++) {
                    if (i - mx[j] <= k) {
                        res = min(res, abs(y1 - y2) + abs(x1 - j) + abs(x2 - j));
                    }
                }
                bool sog = true;
                for (int j = min(y1, y2); j <= max(y1, y2); j++) {
                    if (i - my[j] > k)
                        sog = false;
                }
                if (sog)
                    res = min(res, abs(x1 - x2) + abs(y1 - y2));
            }
            if (i - mx[x1] <= k && i - my[y2] <= k) {
                //cerr << "T\n";
                res = min(res, abs(x1 - x2) + abs(y1 - y2));
            }
            if (i - my[y1] <= k && i - mx[x2] <= k) {
                //cerr << "S\n";
                res = min(res, abs(x1 - x2) + abs(y1 - y2));
            }
            cout << (res == inf ? -1 : res) << "\n";
        }
    }
    return 0;
}
