#include <bits/stdc++.h>

#define int long long
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, x) for (int i = 0; i < x; i++)
#define rforn(i, x) for (int i = x - 1; i >= 0; i--)

using namespace std;

template<typename T> void print(T a)
{
    for (auto x : a)
        cout << x << ' ';
    cout << endl;
}

bool cmp(const vector<int> &a, const vector<int> &b)
{
    return a[1] - a[0] < b[1] - b[0];
}

signed main()
{
    //freopen("test.txt", "r", stdin);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int m, n;
    cin >> m >> n;
    vector<int> a(m);
    forn (i, m)
    {
        cin >> a[i];
        a[i]--;
    }

    vector<int> first(n, -1), last(n, -1);

    forn (i, m)
    {
        if (first[a[i]] == -1)
            first[a[i]] = i;
        last[a[i]] = i;
    }

    vector<int> l(m + 10), r(m + 10);
    forn (i, m + 10)
        l[i] = i - 1;
    forn (i, m + 10)
        r[i] = i + 1;

    vector<vector<int> > seg;
    forn (i, n)
    {
        if (last[i] == -1)
            continue;

        seg.pb({++first[i], ++last[i], i});
    }
    /*sort(all(seg), cmp);
    cout << sz(seg) << '\n';
    forn (i, sz(seg))
        cout << seg[i][2] << ' ' << seg[i][0] << ' ' << seg[i][1] << '\n';
    */
    forn (i, sz(seg))
    {
        int left = seg[i][0], right = seg[i][1];
        int id = left;

        //cout << left << ' ' << right << endl;

        while (id != right)
        {
            id = r[id];
            //cout << id << ' ' << seg[i][2] << ' ' << a[id - 1] << endl;
            if (a[id - 1] != seg[i][2])
            {
                cout << -1;
                return 0;
            }
        }
        //cout << endl;

        l[r[right]] = l[left];
        r[l[left]] = r[right];
    }

    cout << sz(seg) << '\n';
    forn (i, sz(seg))
        cout << ++seg[i][2] << ' ' << seg[i][0] << ' ' << seg[i][1] << '\n';
    return 0;
}
