#include <bits/stdc++.h>
#define rep(i, n) for (int i = 0; i < (n); i++)
#define all(a) a.begin(), a.end()
typedef long long ll;
typedef long double ld;

using namespace std;

const int N = 1 << 20, INF = 1e7;
int t1[2][N * 2], t2[2][N * 2];

void add(int z, int v, int d) {
	t1[z][N + v] = t2[z][N + v] = d;
	for (int i = (N + v) / 2; i; i /= 2) {
		t1[z][i] = max(t1[z][i * 2], t1[z][i * 2 + 1]);
		t2[z][i] = min(t2[z][i * 2], t2[z][i * 2 + 1]);
	}
}

int getl(int z, int p, int x, int v=1, int l=0, int r=N) {
	if (p < l || t1[z][v] < x)
		return -1;
	if (r - l == 1)
		return l;
	int cx = getl(z, p, x, v * 2 + 1, (l + r) / 2, r);
	if (cx != -1)
		return cx;
	return getl(z, p, x, v * 2, l, (l + r) / 2);
}

int getr(int z, int p, int x, int v=1, int l=0, int r=N) {
	if (p >= r || t1[z][v] < x)
		return -1;
	if (r - l == 1)
		return l;
	int cx = getr(z, p, x, v * 2, l, (l + r) / 2);
	if (cx != -1)
		return cx;
	return getr(z, p, x, v * 2 + 1, (l + r) / 2, r);
}

int getmn(int z, int cl, int cr, int v=1, int l=0, int r=N) {
	if (cr <= l || r <= cl)
		return INF;
	if (cl <= l && r <= cr)
		return t2[z][v];
	return min(getmn(z, cl, cr, v * 2, l, (l + r) / 2), getmn(z, cl, cr, v * 2 + 1, (l + r) / 2, r));
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m, q, cq, p, ax, ay, bx, by, pr;
	cin >> n >> m >> q;
	for (int i = 1; i <= q; i++) {
		cin >> cq;
		if (cq == 1) {
			cin >> p;
			add(0, p, i);			
		}
		else if (cq == 2) {
			cin >> p;
			add(1, p, i);
		}
		else {
			cin >> ax >> ay >> bx >> by >> pr;
			if (ax > bx) {
				swap(ax, bx);
				swap(ay, by);
			}
			int cm = i - pr;
			int lx = min(ax, bx), rx = max(ax, bx), ly = min(ay, by), ry = max(ay, by);
			int mind = rx - lx + ry - ly;
			if (getmn(0, lx, rx + 1) >= cm || getmn(1, ly, ry + 1) >= cm) {
				cout << mind << '\n';
				continue;
			}
			int blx = getl(0, lx, cm), bly = getl(1, ly, cm);
			int brx = getr(0, rx, cm), bry = getr(1, ry, cm);
			if (ay <= by && (blx == lx && bry == ry || bly == ly && brx == rx) ||
					ay >= by && (blx == lx && bly == ly || brx == rx && bry == ry)) {
				cout << mind << '\n';
				continue;
			}
			if (blx == lx && brx == rx) {
				int rt = getr(1, ly, cm);
				if (rt != -1 && rt <= ry) {
					cout << mind << '\n';
					continue;
				}
				int dd = INF;
				if (bly != -1)
					dd = min(dd, ly - bly);
				if (bry != -1)
					dd = min(dd, bry - ry);
				if (dd == INF)
					cout << -1 << '\n';
				else
					cout << dd * 2 + mind << '\n';
			}
			else if (bly == ly && bry == ry) {
				int rt = getr(0, lx, cm);
				if (rt != -1 && rt <= rx) {
					cout << mind << '\n';
					continue;
				}
				int dd = INF;
				if (blx != -1)
					dd = min(dd, lx - blx);
				if (brx != -1)
					dd = min(dd, brx - rx);
				if (dd == INF)
					cout << -1 << '\n';
				else
					cout << dd * 2 + mind << '\n';	
			}
			else
				cout << -1 << '\n';
		}
	}
}
