#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define IDB if (debug)

typedef long long ll;
typedef pair <int, int> pii;
const int oo = 1e9 + 4;
const bool debug = 0;

struct nd {
    int mn, mx;
    nd() : mn(0), mx(0) {}
};

int n, m, q, CNT;
vector <nd> R, C;

void read() {
    cin >> n >> m >> q;
}

void make() {
    int KR, KC;
    KR = KC = 1;
    while (KR <= n) KR *= 2;
    while (KC <= m) KC *= 2;

    R.resize(2 * KR + 10, nd());
    C.resize(2 * KC + 10, nd());

    R[0].mn = KR;
    C[0].mn = KC;
}

void upd(auto &g, int pos, int val) {
    pos += g[0].mn;
//    cout << g[0] << ' ' << pos << ' ' << g.size() << endl;
    g[pos].mn = g[pos].mx = val;
    pos /= 2;
    while (pos > 0) {
        g[pos].mn = min(g[2 * pos].mn, g[2 * pos + 1].mn);
        g[pos].mx = max(g[2 * pos].mx, g[2 * pos + 1].mx);
        pos /= 2;
    }
}

void upd(int s) {
    int r;
    cin >> r;
    r--;
    if (s == 1) upd(R, r, CNT);
    else upd(C, r, CNT);

//    IDB
//        for (int i = 0; i < n; i++)
//            for (int j = 0; j < m; j++)
//                cout << g[i][j] << " \n"[j == m - 1];
}

int get_min(auto &g, int l, int r, int v, int tl, int tr) {
    if (r < tl || tr < l) return oo;
    if (l <= tl && tr <= r) return g[v].mn;
    int m = (tl + tr) / 2;
    return min(get_min(g, l, r, 2 * v, tl, m), get_min(g, l, r, 2 * v + 1, m + 1, tr));
}

int get_max(auto &g, int l, int r, int v, int tl, int tr) {
    if (r < tl || tr < l) return -oo;
    if (l <= tl && tr <= r) return g[v].mx;
    int m = (tl + tr) / 2;
    return max(get_max(g, l, r, 2 * v, tl, m), get_max(g, l, r, 2 * v + 1, m + 1, tr));
}


void req() {
    int sr, sc, fr, fc, k;
    cin >> sr >> sc >> fr >> fc >> k;
    sr--; sc--; fr--; fc--;

    int mnR = get_min(R, min(fr, sr), max(fr, sr), 1, 0, R[0].mn - 1);
    int mnC = get_min(C, min(fc, sc), max(fc, sc), 1, 0, C[0].mn - 1);


    if (CNT - mnR <= k || CNT - mnC <= k){
        cout << abs(fr - sr) + abs(fc - sc) << endl;
        return;
    }

    int AR = get_min(R, sr, sr, 1, 0, R[0].mn - 1), AC = get_min(C, sc, sc, 1, 0, C[0].mn - 1);
    int BR = get_min(R, fr, fr, 1, 0, R[0].mn - 1), BC = get_min(C, fc, fc, 1, 0, C[0].mn - 1);

    if (sc == fc && CNT - AC <= k ||
        sr == fr && CNT - AR <= k ||
        CNT - AC <= k && CNT - BR <= k ||
        CNT - AR <= k && CNT - BC <= k) {
            cout << abs(fr - sr) + abs(fc - sc) << endl;
            return;
        }

    int l, r, ans = oo;

    if (CNT - AC <= k && CNT - BC <= k) {

        l = min(fr, sr) - 1, r = n;

        while (r - l > 1) {
            int M  = (r + l) / 2;
            if (CNT - get_max(R, min(fr, sr), M, 1, 0, R[0].mn - 1) <= k) r = M; else l = M;
        }

        if (r >= 0 && r < n && CNT - get_max(R, min(fr, sr), r, 1, 0, R[0].mn - 1) <= k) ans = min(ans, abs(fr - r) + abs(sr - r) + abs(sc - fc));

        IDB cout << ans << ' ' << r <<  endl;

        l = -1, r = max(fr, sr) + 1;

        while (r - l > 1) {
            int M  = (r + l) / 2;
//            IDB cout << M << ' ' << get_max(R, M, max(fr, sr), 1, 0, R[0].mn - 1) << endl;
            if (CNT - get_max(R, M, max(fr, sr), 1, 0, R[0].mn - 1) <= k) l = M; else r = M;
        }

        if (l >= -1 && l < n && CNT - get_max(R, l, max(fr, sr), 1, 0, R[0].mn - 1) <= k) ans = min(ans, abs(fr - l) + abs(sr - l) + abs(sc - fc));

        IDB cout << ans << ' ' << l << endl;

    }

    if (CNT - get_min(R, sr, sr, 1, 0, R[0].mn - 1) <= k &&
        CNT - get_min(R, fr, fr, 1, 0, R[0].mn - 1) <= k) {

        l = min(fc, sc) - 1, r = m;

        while (r - l > 1) {
            int M  = (r + l) / 2;
            if (CNT - get_max(C, min(fc, sc), M, 1, 0, C[0].mn - 1) <= k) r = M; else l = M;
        }

        if (r >= 0 && r < m && CNT - get_max(C, min(fc, sc), r, 1, 0, C[0].mn - 1) <= k) ans = min(ans, abs(fc - r) + abs(sc - r) + abs(sr - fr));


        IDB cout << ans << ' ' << r << endl;

        l = -1, r = max(fc, sc) + 1;

        while (r - l > 1) {
            int M  = (r + l) / 2;
            if (CNT - get_max(C, M, max(fc, sc), 1, 0, C[0].mn - 1) <= k) l = M; else r = M;
        }

        if (l < m && l >= 0 && CNT - get_max(C, l, max(fc, sc), 1, 0, C[0].mn - 1) <= k) ans = min(ans, abs(fc - l) + abs(sc - l) + abs(sr - fr));


        IDB cout << ans <<' ' << l << endl;
    }


    cout << (ans == oo ? -1 : ans) << endl;
}

void solve() {
    make();
    while (q--) {
        CNT++;
        int op;
        cin >> op;
        if (op < 3) upd(op);
        else req();
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    IDB freopen("in.txt", "r", stdin);

    read();
    solve();
}
