#include <bits/stdc++.h>

using namespace std;

struct node{
    int color, left, right;
};

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int m, n;
    cin >> m >> n;
    vector<int> lst(m);
    for (int i = 0; i < m; i++){
        cin >> lst[i];
        lst[i]--;
    }
    vector<int> last(n, -1);
    for (int i = m - 1; i >= 0; i--){
        if (last[lst[i]] == -1)
            last[lst[i]] = i;
    }

//    cout << "last\n";
//    for (int el : last)
//        cout << el << " ";

    vector<int> open(m, -1);
    vector<int> close(m, -1);
    vector<bool> used(n);
    vector<node> ans;
    for (int i = 0; i < m; i++){
        //cout << i << endl;
        int curr = lst[i];
        if (!used[curr]){
            used[curr] = true;
            open[i] = curr;
            close[last[curr]] = curr;
            ans.push_back({curr + 1, i + 1, last[curr] + 1});
        }
    }
//    cout << "\nopen\n";
//    for (int el : open)
//        cout << el << " ";
//    cout << "\nclose\n";
//    for (int el : close)
//        cout << el << " ";
//    cout << endl;

    vector<int> st;
    for(int i = 0; i < m; i++){
        if (open[i] != -1)
            st.push_back(open[i]);
        if (st.back() != lst[i]){
            cout << -1;
            return 0;
        }
        if (close[i] != -1){
            if (st.back() != close[i]){
                cout << -1;
                return 0;
            }
            else{
                st.pop_back();
            }
        }
    }
    cout << ans.size() << "\n";
    for (auto el : ans){
        cout << el.color << " " << el.left << " " << el.right << "\n";
    }
    return 0;
}