#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <cassert>

using namespace std;

const int maxn = 3e5 + 5, inf = 1e9, sz = 1e6 + 2;

int n, m, q, Time = 0;
vector<int> a, b;
//int tb[4 * sz], ta[4 * sz

int slow(int i, int j, int x, int y, int k)
{
	int nw = inf;
	vector<bool> can(m, false);
	bool nw_can = true;
	for (int ps = j; ps >= 0; ps--)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = j; ps < m; ps++)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	if (Time - a[i] <= k)
		can.assign(m, true);
	vector<bool> Can(m, false);
	nw_can = true;
	for (int ps = y; ps >= 0; ps--)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = y; ps < m; ps++)
	{
		if (Time - b[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	if (Time - a[x] <= k)
		Can.assign(m, true);
	for (int ps = 0; ps < m; ps++)
	{
		if (can[ps] && Can[ps] && Time - b[ps] <= k)
			nw = min(nw, abs(ps - j) + abs(ps - y) + abs(x - i));
	}
	return nw;
}
int SLOW(int i, int j, int x, int y, int k)
{
	int nw = inf;
	vector<bool> can(n, false);
	bool nw_can = true;
	for (int ps = i; ps >= 0; ps--)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = i; ps < n; ps++)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		can[ps] = nw_can;
	}
	if (Time - b[j] <= k)
		can.assign(n, true);
	vector<bool> Can(n, false);
	nw_can = true;
	for (int ps = x; ps >= 0; ps--)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	nw_can = true;
	for (int ps = x; ps < n; ps++)
	{
		if (Time - a[ps] > k)
			nw_can = false;
		Can[ps] = nw_can;
	}
	if (Time - b[y] <= k)
		Can.assign(n, true);
	for (int ps = 0; ps < n; ps++)
	{
		if (can[ps] && Can[ps] && Time - a[ps] <= k)
			nw = min(nw, abs(ps - x) + abs(ps - i) + abs(j - y));
	}
	return nw;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	cin >> n >> m >> q;
	a.resize(n, 0);
	b.resize(m, 0);

	for (int i = 1; i <= q; i++)
	{
		Time = i;
		int nw;
		cin >> nw;
		if (nw == 3)
		{
			int s_x, s_y, e_x, e_y, k;
			cin >> s_x >> s_y >> e_x >> e_y >> k;
			//int f = rc(--s_x, --s_y, --e_x, --e_y, k);
			//int s = inf;
			//s = RC(--s_x, --s_y, --e_x, --e_y, k);
			int ans = slow(--s_x, --s_y, --e_x, --e_y, k);
			ans = min(SLOW(s_x, s_y,e_x, e_y, k), ans);
			if (ans == inf)
			{
				cout << -1;
			}
			else
			{
				cout << ans;
			}
			cout << '\n';
		}
		else if (nw == 2)
		{
			int J;
			cin >> J;
			b[--J] = i;
			//upd_tb(1, 0, sz, J);
		}
		else
		{
			int I;
			cin >> I;
			a[--I] = i;
		}
	}


	return 0;
}