#include <iostream>
#include <algorithm>

using namespace std;

/*struct tree
{
    int l;
    int r;
    bool set;
    tree* left;
    tree* right;
    tree(int l, int r, bool set) : l(l), r(r), set(set)
    {
        set = false;
        if(r - l > 1)
        {
            int m = (l + r) / 2;
            left = new tree(l, m);
            right = new tree(m, r);
        }
    }
    tree(tree* left, tree* right) : left(left), right(right)
    {
        l = left->l;
        r = right->r;
        set = left->set || right->set;
    }
    tree* set(int pos, int val)
    {
        if(pos < l || pos >= r)
            return this;
        else if(r - l == 1)
        {
            if(set)
                return this;
            return new tree(l, r, true);
        }
    }
    
*/

void solve()
{
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    if(m != 2 * n - 2 || p != 2)
        exit(1);
    long long a[n - 1], b[n - 1];
    for(int i = 0; i < n - 1; i++)
        a[i] = b[i] = -1;
    for(int i = 0; i < m; i++)
    {
        int x, y;
        long long z;
        cin >> x >> y >> z;
        if(y != x + 1)
            exit(1);
        x--;
        if(a[x] < 0)
            a[x] = z;
        else
            b[x] = z;
    }
    long long prefsums[n];
    prefsums[0] = 0;
    for(int i = 0; i < n - 1; i++)
    {
        if(a[i] > b[i])
            swap(a[i], b[i]);
        prefsums[i + 1] = prefsums[i] + a[i];
        b[i] -= a[i];
    }
    #define a (-:]
    string ans(q, '0');
    for(int i = 0; i < q; i++)
    {
        int f;
        long long r;
        cin >> f >> r;
        f--;
        long long r2 = 2 * r;
        r -= prefsums[f];
        r2 -= prefsums[f];
        if(r2 < 0)
            continue;
        else if(r <= 0)
        {
            ans[i] = '1';
            continue;
        }
        long long data[f];
        for(int i = 0; i < f; i++)
            data[i] = b[i];
        sort(data, data + f);
        long long maxx = 0;
        bool ok = false;
        for(long long i : data)
        {
            maxx += i;
            if(maxx >= r)
            {
                if(i <= r2)
                    ok = true;
                break;
            }
        }
        ans[i] = (ok?'1':'0');
    }
    cout << ans << endl;
}

int main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; i++)
        solve();
    return 0;
}
