#include <bits/stdc++.h>

using namespace std;

int d[100][100];
int u[100][100];
int dd[4][2] = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

struct Item
{
    int x, y;
};

int main()
{
    int n, m, q;
    cin >> n >> m >> q;
    for(int t = 0; t < q; t++)
    {
        for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= m; j++)
            {
                d[i][j]++;
                for(int z = 0; z < 4; z++) u[i][j] = 0;
            }
        }
        int type;
        cin >> type;
        if(type == 1)
        {
            int x;
            cin >> x;
            for(int j = 1; j <= m; j++) d[x][j] = 0;
        }
        else if(type == 2)
        {
            int x;
            cin >> x;
            for(int j = 1; j <= n; j++) d[j][x] = 0;
        }
        else
        {
            int x1, y1, x2, y2, k;
            cin >> x1 >> y1 >> x2 >> y2 >> k;
            queue<Item> q;
            q.push({x1, y1});
            u[x1][y1] = 1;
            if(d[x1][y1] > k)
            {
                cout << -1 << endl;
                continue;
            }
            bool f = 1;
            while(!q.empty())
            {
                auto p = q.front();
                q.pop();
                if(p.x == x2 && p.y == y2)
                {
                    f = 0;
                    cout << u[p.x][p.y] - 1 << endl;
                    break;
                }
                for(int i = 0; i < 4; i++)
                {
                    int ti = p.x + dd[i][0];
                    int tj = p.y + dd[i][1];
                    if(1 <= ti && ti <= n && 1 <= tj && tj <= m && !u[ti][tj] && d[ti][tj] <= k)
                    {
                        u[ti][tj] = u[p.x][p.y] + 1;
                        q.push({ti, tj});
                    }
                }
            }
            if(f) cout << -1 << endl;
        }
    }
}

/*
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
