#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int MAXN = 300005;
int a[MAXN];
int L[MAXN];
int R[MAXN];
bool used[MAXN];

vector<int> ans;

void die() {
    cout << "-1\n";
    exit(0);
}

void run(int l, int r) {
    if (l > r) return;
    int i = l;
    while (i <= r) {
        int x = a[i];
        if (used[x]) {
            ++i;
            continue;
        }

        used[x] = true;
        if (R[x] > r) die();
        
        ans.pb(x);

        run(i + 1, R[x] - 1);

        i = R[x] + 1;
    }
}

signed main() {
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    int m, n;
    cin >> m >> n;
    for (int i = 1; i <= m; ++i) {
        cin >> a[i];
        if (L[a[i]] == 0) L[a[i]] = i;
        R[a[i]] = i;
    }
    run(1, m);

    vector<int> stk;
    int t = 0;
    for (int i = 1; i <= m; ++i) {
        if (L[a[i]] == i) stk.pb(a[i]);
        if (stk.empty() || a[i] != stk.back()) die();
        if (R[a[i]] == i) stk.pop_back();
    }

    cout << ans.size() << '\n';
    for (int x : ans) {
        cout << x << ' ' << L[x] << ' ' << R[x] << '\n';
    }

    return 0;
}