#pragma GCC optimize("Ofast")

#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <iomanip>
#include <bitset>
#include <random>

using namespace std;

#define X first
#define Y second
#define mp make_pair
#define all(x) x.begin(), x.end()
#define all_(x) x.rbegin(), x.rend()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

const ll INF = 1e9 + 9;
const ll MAXN = 3e5 + 7;
const ll MAXN1 = 1 << 11;
const ll MAXN2 = 1e6 + 7;
const ll MOD = 1e9 + 7;
const ll PW = 239;
const ll BLOCK = 316;

void solve();
mt19937 mt(1e9 + 7);

signed main() {
	srand('a' + 'l' + 'e' + 'x' + 'X' + '5' + '1' + '2');
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
#define MAXN 5000
#define MAXN2 10000
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int q = 1;
	if (multi_test) cin >> q;
	while (q--) solve();
}

/*-----------------------------------------------------------------------------------------------------------------------------*/

int tstr[MAXN2], tst[MAXN2];

void solve() {
	int n, m, q;
	cin >> n >> m >> q;
	for (int i = 1; i <= q; ++i) {
		int t, r1;
		cin >> t >> r1;
		if (t == 1) {
			tstr[r1] = -i;
		}
		else if (t == 2) {
			tst[r1] = -i;
		}
		else {
			int ans = INF, c1, r2, c2, k;
			cin >> c1 >> r2 >> c2 >> k;
			k -= i;
			if (tst[c1] <= k && tstr[r2] <= k) ans = abs(c1 - c2) + abs(r1 - r2);
			if (tst[c2] <= k && tstr[r1] <= k) ans = abs(c1 - c2) + abs(r1 - r2);
			if (c1 > c2) swap(c1, c2);
			if (r1 > r2) swap(r1, r2);
			if (tst[c1] <= k && tst[c2] <= k) {
				for (int j = r1; j > 0; --j) {
					if (tstr[j] <= k) {
						ans = min(ans, abs(c1 - c2) + abs(j - r1) + abs(j - r2));
						break;
					}
				}
				for (int j = r1; j <= n; ++j) {
					if (tstr[j] <= k) {
						ans = min(ans, abs(c1 - c2) + abs(j - r1) + abs(j - r2));
						break;
					}
				}
			}
			if (tstr[r1] <= k && tstr[r2] <= k) {
				for (int j = c1; j > 0; --j) {
					if (tst[j] <= k) {
						ans = min(ans, abs(r1 - r2) + abs(j - c1) + abs(j - c2));
						break;
					}
				}
				for (int j = r1; j <= m; ++j) {
					if (tst[j] <= k) {
						ans = abs(r1 - r2) + abs(j - c1) + abs(j - c2);
						break;
					}
				}
			}
			int cnt = 0;
			for (int i = c1; i <= c2; ++i) {
				if (tst[i] <= k) ++cnt;
			}
			if (cnt == c2 - c1 + 1) ans = abs(c1 - c2) + abs(r1 - r2);
			cnt = 0;
			for (int i = r1; i <= r2; ++i) {
				if (tstr[i] <= k) ++cnt;
			}
			if (cnt == r2 - r1 + 1) ans = abs(c1 - c2) + abs(r1 - r2);
			if (ans == INF) ans = -1;
			cout << ans << "\n";
		}
	}
}