#include <iostream>
#include <stack>
#include <vector>
#include <algorithm>
#include <bitset>

#define ll long long
#define pii pair<ll, ll>

using namespace std;

const ll NMAX = 20011;
const ll inf = 2e9;

vector<pii> g[NMAX];

bitset<NMAX> a[NMAX];

void solve()
{
	ll n, m, q, p;
	cin >> n >> m >> q >> p;
	for (ll i = 1; i <= n; i++)
		g[i].clear();
	for (ll i = 1; i <= n; i++)
		g[i].shrink_to_fit();
	for (ll i = 1; i <= m; i++)
	{
		ll u, v, w;
		cin >> u >> v >> w;
		g[u].emplace_back(v, w);
	}
	for (ll i = 1; i <= n; i++)
		a[i] = 0;
	a[1][0] = 1;
	for (ll i = 1; i <= n; i++)
	{
		for (auto u : g[i])
		{
			a[u.first] |= a[i] << u.second;
		}
	}
	for (ll i = 1; i <= q; i++)
	{
		ll f, r;
		cin >> f >> r;
		for (ll i = r; i * (p - 1) <= p * r; i++)
		{
			if (a[f][i])
			{
				cout << 1;
				goto lab;
			}
		}
		cout << 0;
	lab:
		;
	}
	cout << endl;
}

signed main()
{
	cout.sync_with_stdio(0);
	cin.sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	ll t;
	cin >> t;
	for (ll i = 1; i <= t; i++)
	{
		solve();
	}
	return 0;
}