#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int INF = 1e9;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int m, n;
	cin >> m >> n;
	vector<int> v(m);
	for (int& i : v) {
		cin >> i;
		--i;
	}
	
	vector<int> first(n, -1);
	vector<int> last(n, -1);
	for (int i = 0; i < m; ++i)
		last[v[i]] = i;
	for (int i = m - 1; i >= 0; --i)
		first[v[i]] = i;
	vector<bool> used(n);
	vector<int> q;
	for (int i = 0; i < m; ++i) {
		if (used[v[i]] && last[v[i]] != q.back()) {
			cout << -1;
			return 0;
		}
		if (first[v[i]] == i)
			q.push_back(last[v[i]]);
		if (last[v[i]] == i)
			q.pop_back();
		used[v[i]] = true;
	}
	int cnt = 0;
	for (int i = 0; i < n; ++i)
		if (first[i] != -1)
			++cnt;
	vector<pair<int, pair<int, int>>> ans;
	for (int i = 0; i < m; ++i)
		if (first[v[i]] == i)
			ans.push_back({v[i] + 1, {first[v[i]] + 1, last[v[i]] + 1}});
	cout << cnt << '\n';
	for (auto p : ans)
		cout << p.first << ' ' << p.second.first << ' ' << p.second.second << '\n';
	return 0;
}
