#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 100;
int a[MAXN], id[MAXN], lf[MAXN], rg[MAXN], t[MAXN * 4];
bool used[MAXN];

void update(int v, int tl, int tr, int pos, int val) {
	if (tl + 1 == tr) {
		t[v] = val;
		return;
	}
	int tm = (tl + tr) >> 1;
	if (pos < tm) {
		update(v * 2 + 1, tl, tm, pos, val);
	}
	else {
		update(v * 2 + 2, tm, tr, pos, val);
	}
	t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int tl, int tr, int l, int r) {
	if (tl >= r || tr <= l) {
		return MAXN;
	}
	if (tl >= l && tr <= r) {
		return t[v];
	}
	int tm = (tl + tr) >> 1;
	int f = get(v * 2 + 1, tl, tm, l, r);
	int s = get(v * 2 + 2, tm, tr, l, r);
	return min(f, s);
}

signed main() {
	int m, n;
	cin >> m >> n;
	for (int i = 0; i < m; ++i) {
		cin >> a[i];
	}
	memset(lf, -1, sizeof(lf));
	for (int i = 0; i < m; ++i) {
		if (lf[a[i]] == -1) {
			lf[a[i]] = i;
		}
 	}
 	memset(rg, -1, sizeof(rg));
	for (int i = m - 1; i >= 0; --i) {
		if (rg[a[i]] == -1) {
			rg[a[i]] = i;
		}
 	}
 	fill(t, t + MAXN * 4, MAXN);
 	memset(id, -1, sizeof(id));
 	int cur = 0;
 	for (int i = 0; i < m; ++i) {
 		if (id[a[i]] == -1) {
 			id[a[i]] = cur++;
 		}
 		update(0, 0, m, i, id[a[i]]);
 	}
 	int ptr = 0;
 	vector<tuple<int, int, int>> ans;
 	while (ptr < m) {
 		if (used[a[ptr]]) {
 			ptr++;
 			continue;
 		}
 		int mn = get(0, 0, m, lf[a[ptr]], rg[a[ptr]] + 1);
 		if (mn < id[a[ptr]]) {
 			cout << -1 << '\n';
 			return 0;
 		}
 		ans.push_back({a[ptr], lf[a[ptr]], rg[a[ptr]]});
 		used[a[ptr]] = true;
 	}
 	cout << ans.size() << '\n';
 	for (auto &[f, s, fs] : ans) {
 		cout << f << ' ' << s + 1 << ' ' << fs + 1 << '\n';
 	}
}