#include <bits/stdc++.h>
   
using namespace std;
   
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
  
#define all(x) (x).begin(), (x).end()
#define int long long
  
void FAST_IO() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}
  
const int MAXN = 5e5 + 100;
vector<ll> in[MAXN];
vector<pll> qs[MAXN];
int ans[MAXN];

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    for (int i = 0; i < n; ++i) {
        in[i].clear();
        qs[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        u--;
        v--;
        in[v].push_back(w);
    }
    for (int i = 0; i < q; ++i) {
    	int to;
    	ll lf;
    	cin >> to >> lf;
    	to--;
    	qs[to].push_back({lf, i});
    }
    ll cur = 0;
    multiset<ll> dx;
    for (int i = 1; i < n; ++i) {
    	sort(all(in[i]));
    	cur += in[i][0];
    	dx.insert(in[i][1] - in[i][0]);
    	for (auto &[lf, id] : qs[i]) {
    		if (cur > 2 * lf) {
    			ans[id] = 0;
    			continue;
    		}
    		vector<ll> erased;
    		while (cur < lf && dx.size() > 0) {
    			auto it = dx.lower_bound(lf - cur);
    			if (it != dx.end() && cur + *it <= 2 * lf) {
    				cur += *it;
    				erased.push_back(*it);
    				break;
    			}
    			if (it != dx.begin()) {
    				it--;
    				cur += *it;
    				erased.push_back(*it);
    				dx.erase(it);
    			}
    			else {
    				break;
    			}
    		}
    		ans[id] = (cur >= lf);
    		for (ll x : erased) {
    			cur -= x;
    			dx.insert(x);
    		}
    	}
    }
    for (int i = 0; i < q; ++i) {
    	cout << char('0' + ans[i]);
    }
    cout << '\n';
}
  
signed main() {
    FAST_IO();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}