#include <bits/stdc++.h>
using namespace std;

#define int long long

const int INF = 1e18;

main() {
    int n, m, q;
    cin >> n >> m >> q;
    vector<int> row(n), col(m);
    for (int i = 0; i < q; i++) {
        int type;
        cin >> type;
        for (int j = 0; j < n; j++) {
            row[j]++;
        }
        for (int j= 0; j < m; j++) {
            col[j]++;
        }
        if (type == 1) {
            int r;
            cin >> r;
            r--;
            row[r] = 0;
        } else if (type == 2) {
            int c;
            cin >> c;
            c--;
            col[c] = 0;
        } else {
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;
            r1--;
            r2--;
            c1--;
            c2--;
            if (min(row[r1], col[c1]) > k) {
                cout << -1 << endl;
                continue;
            }
            vector<vector<int>> dist(n, vector<int> (m, INF));
            dist[r1][c1] = 0;
            set<pair<int, pair<int, int>>> s;
            s.insert({abs(r1 - r2) + abs(c1 - c2), {r1, c1}});
            while (s.size()) {
                int d = s.begin()->first;
                int r = s.begin()->second.first;
                int c = s.begin()->second.second;
                s.erase(s.begin());
                if (d > dist[r2][c2]) {
                	continue;
                }
                d -= abs(r - r2) + abs(c - c2);
                
                int new_r = r + 1;
                int new_c = c;
                if (0 <= new_r && new_r < n && 0 <= new_c && new_c < m) {
                if (min(row[new_r], col[new_c]) <= k)
                	if (dist[new_r][new_c] > d + 1) {
                		s.erase({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                		dist[new_r][new_c] = d + 1;
                		s.insert({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                	}
                }
                new_r = r - 1;
                new_c = c;
                if (0 <= new_r && new_r < n && 0 <= new_c && new_c < m) {
                if (min(row[new_r], col[new_c]) <= k)
                	if (dist[new_r][new_c] > d + 1) {
                		s.erase({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                		dist[new_r][new_c] = d + 1;
                		s.insert({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                	}
                }
                new_r = r;
                new_c = c - 1;
                if (0 <= new_r && new_r < n && 0 <= new_c && new_c < m) {
                if (min(row[new_r], col[new_c]) <= k)
                	if (dist[new_r][new_c] > d + 1) {
                		s.erase({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                		dist[new_r][new_c] = d + 1;
                		s.insert({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                	}
                }
                new_r = r;
                new_c = c + 1;
                if (0 <= new_r && new_r < n && 0 <= new_c && new_c < m) {
                if (min(row[new_r], col[new_c]) <= k)
                	if (dist[new_r][new_c] > d + 1) {
                		s.erase({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                		dist[new_r][new_c] = d + 1;
                		s.insert({dist[new_r][new_c] + abs(new_r - r2) + abs(new_c - c2), {new_r, new_c}});
                	}
                }
            }
            if (dist[r2][c2] == INF) {
                cout << -1 << endl;
            } else {
                cout << dist[r2][c2] << endl;
            }
        }
    }
}

            

