#include <iostream>
#include "set"
#include "vector"
using namespace std;

const int maxn = 5e3;
vector<int> values[maxn];

vector<pair<int, int>> graph[maxn];

int main() {
    int ktests;
    cin >> ktests;
    for (int test = 0; test < ktests; test++) {
        for (int i = 0; i < maxn; i++) {
            values[i].clear();
            graph[i].clear();
        }
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        for (int i = 0; i  < m; i++) {
            int v, u, d;
            cin >> v >> u >> d;
            v--; u--;
            graph[v].push_back({u, d});
        }
        values[0].push_back(0);
        for (int i = 0; i < n; i++) {
            for (auto& val: values[i]) {
                cout << val << " ";
                for (auto& u: graph[i]) {
                    values[u.first].push_back(u.second + val);
                }
            }
            cout << endl;
        }
        for (int i = 0; i < q; i++) {
            int v, d;
            cin >> v >> d; v--;
            int res = 0;
            for (auto& val: values[v]) {
                if (d <= val && (p - 1) * val <= p * d) {
                    res = 1;
                }
            }
            cout << res;
        }
        cout << "\n";
    }
}