#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define fi first
#define se second
#define un (unsigned)
const ll INF = INT_MAX;
const ll INFll = LLONG_MAX;
void solveA();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

#ifdef INOUT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solveA();

    return 0;
}

int N, M;

struct req {
    int t, k;
    pair<int, int> s, f;
};

vector<pair<int, int>> xy = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};
int table[10013][10013];
bool mark[10013][10013];

int path(const pair<int, int> &a, const pair<int, int> &b, const int &k) {
    if (table[a.fi][a.se] <= k) {

        queue<pair<pair<int, int>, int>> work;
        set<pair<int, int>> mark;

        work.push({a, 0});
        mark.insert(a);

        while (!work.empty()) {
            pair<int, int> v = work.front().fi;
            int d = work.front().se;
            work.pop();

            for (pair<int, int> add: xy) {
                int tox = v.fi + add.fi, toy = v.se + add.se;
                if (tox >= 1 && tox <= N && toy >= 1 && toy <= M && mark.find({tox, toy}) == mark.end() &&
                    table[tox][toy] <= k) {
                    mark.insert({tox, toy});
                    work.push({{tox, toy}, d + 1});

                    if (b == make_pair(tox, toy))
                        return work.front().se;
                }
            }
        }
    }

    return -1;
}

void add() {
    for (int o = 1; o <= N; o++) {
        for (int p = 1; p <= M; p++)
            table[o][p]++;
    }
}

void solveA() {
    int q; cin >> N >> M >> q;

    vector<req> reqs(un q);
    for (int i = 0; i < q; i++) {
        cin >> reqs[i].t;
        if (reqs[i].t == 3) {
            cin >> reqs[i].s.fi >> reqs[i].s.se >> reqs[i].f.fi >> reqs[i].f.se >> reqs[i].k;
        } else {
            cin >> reqs[i].k;
        }
    }

    for (int i = 0; i < q; i++) {
        add();

        if (reqs[i].t == 1) {
            for (int j = 1; j <= M; j++)
                table[reqs[i].k][j] = 0;
        } else if (reqs[i].t == 2) {
            for (int j = 1; j <= N; j++)
                table[j][reqs[i].k] = 0;
        } else {
            cout << path(reqs[i].s, reqs[i].f, reqs[i].k) << '\n';
        }
    }
}