#include <bits/stdc++.h>

using namespace std;

signed main() {
	int n, m, q;
	cin >> n >> m >> q;
	vector<vector<int>> v(n, vector<int> (m, 0));
	for (int i = 0; i < q; ++i) {
		for (int x = 0; x < n; ++x)
		for (int y = 0; y < m; ++y)
			v[x][y]++;
		int t;
		cin >> t;
		if (t == 1) {
			int x;
			cin >> x; x--;
			for (int y = 0; y < m; ++y)
				v[x][y] = 0;
		} else if (t == 2) {
			int y;
			cin >> y; y--;
			for (int x = 0; x < n; ++x)
				v[x][y] = 0;
		} else {
			int x1, y1, x2, y2, k;
			cin >> x1 >> y1 >> x2 >> y2 >> k;
			x1--; y1--; x2--; y2--;
			queue<pair<int, pair<int, int>>> Q;
			vector<vector<bool>> used(n, vector<bool> (m, false));
			int ans = -1;
			if (v[x1][y1] <= k) {
				used[x1][y1] = 1;
				Q.push({0, {x1, y1}});
			}
			while (!Q.empty()) {
				auto p = Q.front();
				Q.pop();
				if (p.second == make_pair(x2, y2)) {
					ans = p.first;
					break;
				}
				int x = p.second.first, y = p.second.second;
				if (x > 0 && !used[x - 1][y] && v[x - 1][y] <= k) {
					used[x - 1][y] = 1;
					Q.push({p.first + 1, {x - 1, y}});
				}
				if (y > 0 && !used[x][y - 1] && v[x][y - 1] <= k) {
					used[x][y - 1] = 1;
					Q.push({p.first + 1, {x, y - 1}});
				}
				if (x < n - 1 && !used[x + 1][y] && v[x + 1][y] <= k) {
					used[x + 1][y] = 1;
					Q.push({p.first + 1, {x + 1, y}});
				}
				if (y < m - 1 && !used[x][y + 1] && v[x][y + 1] <= k) {
					used[x][y + 1] = 1;
					Q.push({p.first + 1, {x, y + 1}});
				}
			}
			cout << ans << endl;
		}
	}
}