#include <bits/stdc++.h>

//#define __LOCAL

#ifdef __LOCAL
#define DBG(X) cerr << #X << "=" << (X) << endl;
#else
#define DBG(X) 42;
#endif

using namespace std;

#define endl '\n'

struct Query
{
	int c, l, r;

	Query(int _c, int _l, int _r): c(_c), l(_l), r(_r)
	{
	}
};

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

void solve()
{
	int m, n;
	cin >> m >> n;

	vector<int> arr(m);
	vector<bool> used(n + 1, false);
	vector<bool> met(n + 1, false);

	for(auto& el: arr)
		cin >> el;

	vector<Query> answ;
	vector<int> st;

	for(int i = 0; i < m; ++i)
	{
		DBG(i);
		if(st.empty() || !met[arr[i]] || arr[st.back()] == arr[i])
		{
			st.push_back(i);
			met[arr[i]] = true;
		}
		else
		{
			while(!st.empty() && arr[st.back()] != arr[i])
			{
				int R = st.back();
				int L = R;
				int c = arr[R];
				st.pop_back();

				while(!st.empty() && arr[st.back()] == arr[R])
				{
					L = st.back();
					st.pop_back();
				}

				if(used[c])
				{
					cout << "-1" << endl;
					return;
				}
				else
				{
					answ.emplace_back(c, L + 1, R + 1);
					used[c] = true;
				}
			}

			st.push_back(i);
		}
	}

	while(!st.empty())
	{
		int R = st.back();
		int L = R;
		int c = arr[R];
		st.pop_back();

		while(!st.empty() && arr[st.back()] == arr[R])
		{
			L = st.back();
			st.pop_back();
		}

		if(used[c])
		{
			cout << "-1" << endl;
			return;
		}
		else
		{
			answ.emplace_back(c, L + 1, R + 1);
			used[c] = true;
		}
	}

	reverse(answ.begin(), answ.end());

	cout << answ.size() << endl;

	for(auto& el: answ)
		cout << el.c << " " << el.l << " " << el.r << endl;
}

int main()
{
	fastio();
	solve();
	return 0;
}