#include <bits/stdc++.h>
#define int ll

using namespace std;

typedef long long ll;

const int INF = 1e18;

const int MAXN = 1e6;

int pmn[MAXN], pmx[MAXN];
vector<int> to[MAXN];

int mx(int l, int r) {
    return pmx[r] - pmx[l];
}

int mn(int l, int r) {
    return pmn[r] - pmn[l];
}

bool can(int v, int u, int needl, int needr) {
    if (v == u) {
         return true;
    }
    for (int i = 0; i < 2; ++i) {
        if (needr < mn(v + 1, u) + to[v][i] && mx(v + 1, u) + to[v][i] < needl) {
            continue;
        }
        if (can(v + 1, u, needl - to[v][i], needr - to[v][i])) {
            return true;
        }
    }
    return false;
}

void solve() {
    int n, m, q, p;
    cin >> n >> m >> q >> p;
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        to[--a].push_back(w);
    }
    for (int i = 0; i < n - 1; ++i) {
        if (to[i][0] > to[i][1]) {
            swap(to[i][0], to[i][1]);
        }
    }
    for (int i = 0; i < n - 1; ++i) {
        pmn[i + 1] = pmn[i] + to[i][0];
        pmx[i + 1] = pmx[i] + to[i][1];
    }
    string ans;
    while (q--) {
        int u, r;
        cin >> u >> r;
        u--;
        ans += char('0' + int(can(0, u, r, r * p / (p - 1))));
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /// freopen("input.txt", "r", stdin);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
