#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 5e5;
vector<pair<int, int>> g[MAXN];
vector<int> ans[MAXN];

void solve(int n) {
    for (int v = 0; v < n; ++v) {
        for (auto elem : g[v]) {
            int u = elem.first;
            int w = elem.second;
            for (auto el : ans[v]) {
                ans[u].push_back(el + w);
            }
        }
    }
}

main() {
    int t;
    cin >> t;
    for (int tst = 0; tst < t; ++tst) {
        int n, m, q, p;
        cin >> n >> m >> q >> p;
        for (int i = 0; i < n; ++i) {
            g[i].clear();
            ans[i].clear();
        }
        for (int i = 0; i < m; ++i) {
            int u, v, w;
            cin >> u >> v >> w;
            u--; v--;
            g[u].push_back({v, w});
        }
        ans[0].push_back(0);
        solve(n);
        /*for (int i = 0; i < n; ++i) {
            for (auto elem : ans[i]) {
                cout << elem << " ";
            }
            cout << endl;
        }*/
        for (int i = 0; i < q; ++i) {
            int u, r;
            cin >> u >> r;
            u--;
            sort(ans[u].begin(), ans[u].end());
            int l = -1, rr = ans[u].size();
            while (rr - l > 1) {
                int mm = (rr + l) / 2;
                if (ans[u][mm] >= r) {
                    rr = mm;
                } else {
                    l = mm;
                }
            }
            // cout << rr << " " << ans[u][rr] << endl;;
            if (ans[u][rr] * (p - 1) <= p * r) {
                cout << "1";
            } else {
                cout << "0";
            }
        }
        cout << endl;
    }
    return 0;
}
