#pragma GCC optimaze("Ofast, no-stack-protectors");
#pragma GCC optimaze("unroll-loops");
//#pragma GCC target("sse,sse2,sse3,sse4,sse4.2,abm,mmx,popcnt,tune=native");
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<random>
#include<chrono>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 3e5 + 113;
int le[maxn];
int re[maxn];
int num[maxn];

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr), cout.tie(nullptr);
	cout.setf(ios::fixed);
	cout.precision(12);
	int n, m;
	cin >> n >> m;
	vector<int> in;
	for (int i = 1; i <= n; i++) {
		int a;
		cin >> a;
		if (le[a] == 0)
			le[a] = i;
		re[a] = i;
		in.push_back(a);
	}
	vector<pair<int, int>> qu;
	for (int i = 1; i <= m; i++)
	{
		if (le[i] != 0)
		{
			num[le[i]] = i;
			num[re[i]] = i;
		}
	}
	vector<pair<int, pair<int, int>>> ans;
	set<pair<int, int>> uf;
	for (int i = 1; i <= n; i++)
	{
			if (le[num[i]] == i)
			{
				int r = re[num[i]];
				if (uf.size() && (*uf.begin()).first < r)
				{
					cout << "-1";
					exit(0);
				}
				uf.insert({ r, num[i] });
				ans.push_back({ num[i], {le[num[i]], re[num[i]]} });
			}
			if ((*uf.begin()).second != in[i - 1])
			{
				cout << "-1";
				exit(0);
			}
			if (re[num[i]] == i)
				uf.erase({ i, num[i] });
	}
	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i].first << " " << ans[i].second.first << " " << ans[i].second.second << "\n";
	//system("pause");
}

/*
7 10
10 5 5 10 4 2 4

5 2
1 2 1 2 1
*/