#include <bits/stdc++.h>
using namespace std;
//#define int long long
#define pb push_back
#define rep(a, l, r) for (int a = l; a < r; a++)
#define sz(a) (int) a.size()
typedef vector<int> vint;
int getInt() { int a; cin >> a; return a; }
const int oo = 2e9;
vector<pair<int, int>> rows, cols;

inline int f(int x, int a, int b) { return (x == -1) ? oo : (abs(x - a) + abs(x - b)); }
void run() {
    int n, m, q;
    cin >> n >> m >> q;

    int col[m + 1], row[n + 1];
    memset(col, 0, sizeof col);
    memset(row, 0, sizeof row);

    for (int h = 1; h <= q; h++) {
        int t;
        cin >> t;
        if (t == 1) {
            int r;
            cin >> r;
            rows.pb({h, r});
            row[r] = h;
        } else if (t == 2) {
            int c;
            cin >> c;
            cols.pb({h, c});
            col[c] = h;
        } else {
            assert(t == 3);
            int r1, c1, r2, c2, k;
            cin >> r1 >> c1 >> r2 >> c2 >> k;

            ///min l, h - l = k; l = h - k
            int l = max(0, h - k);

            bool hasr1 = 0, hasc1 = 0, hasr2 = 0, hasc2 = 0;
            bool allCols = 1, allRows = 1;
            for (int i = min(r1, r2); i <= max(r1, r2); i++)
                allRows &= row[i] >= l;
            for (int i = min(c1, c2); i <= max(c1, c2); i++)
                allCols &= col[i] >= l;

            int closestRow = -1, closestCol = -1;
            for (int i = sz(cols) - 1; i >= 0 && cols[i].first >= l; i--) {
                if (f(closestCol, c1, c2) > f(cols[i].second, c1, c2))
                    closestCol = cols[i].second;
                hasc1 |= cols[i].second == c1;
                hasc2 |= cols[i].second == c2;
            }

            for (int i = sz(rows) - 1; i >= 0 && rows[i].first >= l; i--) {
                if (f(closestRow, r1, r2) > f(rows[i].second, r1, r2))
                    closestRow = rows[i].second;
                hasr1 |= rows[i].second == r1;
                hasr2 |= rows[i].second == r2;
            }

            int ans = oo;
            if ((hasr1 && hasc2) || (hasc1 && hasr2) || allCols || allRows)
                ans = min(ans, abs(r1 - r2) + abs(c1 - c2));

            if (hasr1 && hasr2 && closestCol != -1)
                ans = min(ans, abs(c1 - closestCol) + abs(r1 - r2) + abs(closestCol - c2));

            if (hasc1 && hasc2 && closestRow != -1)
                ans = min(ans, abs(r1 - closestRow) + abs(c1 - c2) + abs(r2 - closestRow));

            if (ans == oo)
                cout << -1 << endl;
            else
                cout << ans << endl;
        }
    }
}
/* 3 -1 5 -1 3
4 3 9
3 2 1 3 3 1
3 2 1 3 3 1
2 1
2 3
1 1
3 2 1 3 3 3
3 2 1 3 3 3
2 2
3 2 1 3 3 6
*/
signed main() { ios::sync_with_stdio(0); cin.tie(0); run(); }
