#include <bits/stdc++.h>
using namespace std;


#define int long long
const int INF = 1e18;


const int MOD = 998244353;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<vector<int>>> dp(n + 2, vector<vector<int>> (m + 2, vector<int> (2)));
    vector<vector<int>> v(n + 2, vector<int> (m + 2, INF));
    for(int i = 0; i < k; ++i)
    {
        int r, c;
        cin >> r >> c;
        cin >> v[r][c];
    }
    for(int i = n; i > 0; --i)
    {
        for(int j = m; j > 0; --j)
        {
            if(v[i][j] == INF)
            {
                dp[i][j][0] = min(dp[i][j + 1][1], dp[i + 1][j][1]);
                dp[i][j][1] = max(dp[i][j + 1][0], dp[i + 1][j][0]);
            }
            else
            {
                dp[i][j][0] = dp[i][j][1] = v[i][j];
            }
        }
    }
    int sum = 0;
    for(int i = 1; i <= n; ++i)
    {
        for(int j = 1; j <= m; ++j)
        {
            sum += dp[i][j][0];
            sum += MOD * 200;
            sum %= MOD;
        }
    }
    cout << sum;
}