#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<iomanip>
#include<vector>
#include<string>
#include<stack>
#include<queue>
#include<deque>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<algorithm>
#include<math.h>
#include<cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

ll INF = 2*(1e18);
ll inf = 1e9 + 10;
ld  eps = 1e-9;
ll MOD = 998244353;

signed main() {
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
#ifdef DEBUG
	freopen("input.txt", "r", stdin);
#endif // DEBUG

	ll n, m, k;
	cin >> n >> m >> k;
	vector<vector<vector<ll>>>dp(n + 2, vector<vector<ll>>(m + 2, vector<ll>(2, 0)));
	vector<vector<ll>>used(n + 2, vector<ll>(m + 2, 0));

	for (ll i = 0; i < k; i++) {
		ll i1, j1, val;
		cin >> i1 >> j1 >> val;
		dp[i1][j1][0] = dp[i1][j1][1] = val;
		used[i1][j1] = 1;
	}

	ll ans = 0;

	for (ll i = n; i >= 1; i--) {
		for (ll j = m; j >= 1; j--) {
			if (used[i][j] == 0) {
				dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
				dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
			}
			ans += dp[i][j][0];
			ans %= MOD;
		}
	}

	cout << (ans % MOD + MOD) % MOD;





	return 0;
}