#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define INF 1000000010
#define MOD 1000000007
#define f first
#define s second

using vi = vector <int>;
using pii = pair <int, int>;
using ll = long long;

void fastIO(){
 	ios_base::sync_with_stdio(0);
 	cin.tie(0);
 	#ifdef LOCAL
 		freopen("input.txt", "r", stdin);
 		freopen("output.txt", "w", stdout);
 	#endif
}
  
const int MAXN = 1e6 + 10;

int m, n;
string p;
vi zap;
vector <string> q1;
vector <pii> q2;
	
vi calc_z(string s){
	vi z(s.size(), 0);
	int l = 0, r = -1;
	for(int i = 1; i < s.size(); i++){
		if(i <= r)
			z[i] = min(r - i + 1, z[i - l]);
		while(i + z[i] < s.size() && s[i + z[i]] == s[z[i]])
			z[i]++;
		if(i + z[i] - 1 > r){
			l = i;
			r = i + z[i] - 1;
		}
	}
	return z;
}	

bool check2(){
	if(q1.size() > 1)
		return false;
	for(int i = 0; i < q2.size(); i++){
		if(q2[i].f != 0 || (q1[0].size() % q2[i].s != 0))
			return false;
	}
	return true;
}

int recalc(int len){
	string s = p + '#';
	for(int i = 0; i < len; i++)
		s.pb(q1[0][i]);
	vi z = calc_z(s);
	int ans = 0;
	for(int i = m + 1; i < s.size(); i++){
		if(z[i] == m)
			ans++;
	}
	return ans;
}

void solve2(){
	cout << 0;
	exit(0);
//	cerr << "aaaa";
	vi cnt(MAXN, -1);
	string cur = q1[0];
	ll ans = 0;
	for(int i = 0; i < q2.size(); i++){
		int pos = q2[i].f, len = q2[i].s;
		if(cnt[len] == -1)
			cnt[len] = recalc(len);
		ans += cnt[len];
		if(len < m){
			for(int j = 0; j < len; j++)
				cur.pb(p[j]);
		}
		else{
			for(int j = 0; j < m - 1; j++)
				cur.pb(p[j]);
			cur.pb('$');
			for(int j = len - m + 1; j < len; j++)
				cur.pb(p[j]);
		}
	}
	p += '#' + cur;
	vi z = calc_z(p);
	for(int i = m + 1; i < p.size(); i++){
		if(z[i] == m)
			ans++;
	}
	cout << ans;
	exit(0);
}

int main(){
	fastIO();
	cin >> m >> n >> p;
	for(int i = 0; i < n; i++){
		int type;
		cin >> type;
		zap.pb(type);
		if(type == 1){
			string s;
			cin >> s;
			q1.pb(s);
		}
		else{
			int pos, len;
			cin >> pos >> len;
			pos--;
			q2.pb({pos, len});
		}
	}
	if(check2())
		solve2();
	int uk1 = 0, uk2 = 0;
	string cur;
	for(int i = 0; i < n; i++){	
		if(zap[i] == 1){
			cur += q1[uk1];
			uk1++;
		}
		else{
			for(int j = q2[uk2].f; j < q2[uk2].f + q2[uk2].s; j++){
				cur.pb(cur[j]);
			}
			uk2++;
		}
			
	}
	p += '#' + cur;
	vi z = calc_z(p);
	int ans = 0;
	for(int i = m + 1; i < p.size(); i++){
		if(z[i] == m)
			ans++;
	}
	cout << ans;
	return 0;
}	
