#include <iostream>
#include <vector>
#include <algorithm>

const long long INF = 1e18;

int main(void) {
    long long m = 0, n = 0, k = 0;
    std::cin >> m >> n >> k;
    std::vector <long long> L(k), R(k);
    for (long long i = 0; i < k; i++)
        std::cin >> L[i] >> R[i];
    long long **group = new long long *[m];
    for (long long i = 0; i < m; i++) {
        group[i] = new long long[2 * n];
        std::vector <long long> mGroup(2 * n);
        for (long long j = 0; j < 2 * n; j++)
            std::cin >> mGroup[j];
        std::sort(mGroup.begin(), mGroup.end());
        for (long long j = 0; j < 2 * n; j++)
            group[i][j] = mGroup[j];
    }

    long long cost = 0, bestCost = INF;
    long long l0 = std::min(L[0], L[1]), l1 = std::max(L[0], L[1]);
    long long r0, r1;
    if (L[0] < L[1]) {
        r0 = R[0];
        r1 = R[1];
    }
    else if (L[0] == L[1]) {
        r0 = std::min(R[0], R[1]);
        r1 = std::max(R[0], R[1]);
    }
    else {
        r0 = R[1];
        r1 = R[0];
    }
    for (long long num1 = 0; num1 <= n; num1++) {
        long long num2 = n - num1;
        cost = 0;
        for (long long groupId = 0; groupId < m; groupId++) {
                for (long long i = 0; i < 2 * n; i++) {
                    if (i < num1 * 2)
                        cost += std::max(std::max(l0 - group[groupId][i], group[groupId][i] - r0), 0LL);
                    else
                        cost += std::max(std::max(l1 - group[groupId][i], group[groupId][i] - r1), 0LL);
                }
        }
        if (cost < bestCost) {
            bestCost = cost;
            //std::cout << num1 << " " << num2 << " " << cost << std::endl;
        }
    }
    std::cout << bestCost << std::endl;
    return 0;
}
