#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <stdio.h>
#include <math.h>
#include <stack>
#include <queue>
#include <tuple>

#define forn(i,n) for(int i=0;i<n;i++)
#define ll long long
#define ld long double
#define pii pair<int,int>
#define mp make_pair

using namespace std;

const ll MOD = 998244353;

struct pt {
	int x, y, v;
	pt() {};
	pt(int x, int y, int v) :x(x), y(y), v(v) {};
};

int main() {
//	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<pii>>dp(n+1, vector<pii>(m+1, mp(0, 0)));
	vector<vector<bool>>used(n, vector<bool>(m, 0));
	vector<pt>p(k);
	forn(i, k) {
		cin >> p[i].x >> p[i].y >> p[i].v;
		p[i].x--;
		p[i].y--;
		dp[p[i].x][p[i].y] = mp(p[i].v,p[i].v);
		used[p[i].x][p[i].y] = 1;
	}
	ll ans = 0;
	for (int i = n - 1; i >= 0;i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (used[i][j])ans += dp[i][j].first;
			else {
				dp[i][j].first = min(dp[i][j + 1].second, dp[i + 1][j].second);
				dp[i][j].second = max(dp[i][j + 1].first, dp[i + 1][j].first);
				ans += dp[i][j].first;
			}
			if (ans >= MOD)ans -= MOD;
			if (ans < 0)ans += MOD;
		}
	}
	cout << (ans%MOD + MOD) % MOD;
}