#include <math.h>
#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <set>
#include <random>

using namespace std;


#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")


#define x first
#define y second
#define all(v) v.begin(), v.end()
#define int long long

int m, n, k;
vector<int> pt;
vector<vector<int>> people;

int get(int aaaa, int man)
{
	if (man == aaaa) return 0;
	return abs(man - aaaa);
}

int32_t main()
{
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	mt19937 rnd(275038);
	int ans = 0, tmp, tmp2, ind = 0;
	cin >> m >> n >> k;
	set<int> pt2;
	for (int i = 0; i < k; i++)
	{
		cin >> tmp >> tmp;
		pt2.insert(tmp);
	}
	k = pt2.size();
	for (auto i : pt2)
	{
		pt.push_back(i);
	}
	people.resize(m, vector<int>(n + n));
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < n + n; j++)
		{
			cin >> people[i][j];
		}
		sort(all(people[i]));
	}
	sort(all(pt));

	int summ = 0, kolvo = 2 * n * m;
	int left, right, mid;
	for (int i = 0; i < n + n; i += 2)
	{
		tmp = tmp2 = summ = 0;
		for (int l = 0; l < m; l++)
		{
			summ += people[l][i] + people[l][i + 1];
		}
		for (int j = ind; j < min(ind + 20, k); j++)
		{
			tmp2 = 0;
			for (int l = 0; l < m; l++)
			{
				tmp2 += get(pt[j], people[l][i]) + get(pt[j], people[l][i + 1]);
			}
			if (tmp2 < tmp)
			{
				tmp = tmp2;
				ind = j;
			}
		}
		for (int jj = 0; jj < 50; jj++)
		{
			int j = rnd() % (k - ind) + ind;
			tmp2 = 0;
			for (int l = 0; l < m; l++)
			{
				tmp2 += get(pt[j], people[l][i]) + get(pt[j], people[l][i + 1]);
			}
			if (tmp2 < tmp)
			{
				tmp = tmp2;
				ind = j;
			}
		}
		left = 0;
		right = k;
		while (right - left > 1)
		{
			mid = (right + left) / 2;
			if (pt[mid] * kolvo > summ) right = mid;
			else left = mid;
		}
		for (int l = 0; l < m; l++) tmp += get(pt[left], people[l][i]) + get(pt[left], people[l][i + 1]);
		tmp2 = 0;
		if(left != k - 1) for (int l = 0; l < m; l++) tmp2 += get(pt[left + 1], people[l][i]) + get(pt[left + 1], people[l][i + 1]);
		tmp = min(tmp, tmp2); tmp2 = 0;
		if(left != 0) for (int l = 0; l < m; l++) tmp2 += get(pt[left - 1], people[l][i]) + get(pt[left - 1], people[l][i + 1]);
		tmp = min(tmp, tmp2);
		ans += tmp;
	}
	cout << ans;
	system("pause");
	return 0;
}