#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int MN = 5e5 + 111;
ll MOD = 998244353;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<ll>> mi(n + 1, vector<ll>(m + 1, 1e9 + 7));
    vector<vector<ll>> ma(n + 1, vector<ll>(m + 1, 1e9 + 7));
    for(int i = 0; i < k;++i) {
        int u, v, c;
        cin >> u >> v >> c;
        u--; v--;
        mi[u][v] = c;
        ma[u][v] = c;
    }
    for(int i = 0; i <= n; ++i) {
        mi[i][m] = 0;
        ma[i][m] = 0;
    }
    for(int i = 0; i <= m; ++i) {
        mi[n][i] = 0;
        ma[n][i] = 0;
    }
    ll ans = 0;
    for(int i = n - 1; i >= 0; --i){
        for(int j = m - 1; j >= 0; --j) {
            if(mi[i][j] > 1e9 + 1) {
                mi[i][j] = min(ma[i + 1][j], ma[i][j + 1]);
                ma[i][j] = max(mi[i + 1][j], mi[i][j + 1]);

            }ans += mi[i][j];
            ans %= MOD;
        }
    }
    ans += MOD;
    ans %= MOD;
    cout << ans;

}
