#include <iostream>
#include <fstream>

#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <functional>

#include <cstring>
#include <cstdio>
using namespace std;
//#define DEBUG
#ifdef DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif
#define endl '\n'
typedef long long ll;
typedef pair<ll, ll> pll;


set<int> diags;
map<pll, ll> traps;
vector<pll> calc;
map<pll, ll> gm;
ll modulo = 998244353;
int n, m, k;
bool in(int r, int c) {
	return ((r >=0) && (r <n) && (c >=0) && (c < m));
}

ll g(pll pos);

ll gmax(pll pos) {
	if (!in(pos.first, pos.second))return 0;
	if (traps.find(pos) != traps.end()) return traps[pos];
	return max(g({ pos.first, pos.second + 1 }), g({ pos.first + 1, pos.second }));
}

ll g(pll pos) {
	if (!in(pos.first, pos.second))return 0;
	//if (diags.find(pos.first + pos.second) == diags.end())return 0;
	if (gm.find(pos) == gm.end()) {
		if (traps.find(pos) != traps.end())gm[pos] = traps[pos];
		else {
			gm[pos] = min(gmax({ pos.first, pos.second + 1 }), gmax({ pos.first + 1, pos.second }));
		}
	}
	return gm[pos];
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(NULL);
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		ll r, c, v;
		cin >> r >> c >> v; r--; c--;
		traps[{r, c}] = v;
		diags.insert(r + c + 1);
		diags.insert(r + c - 1);
		diags.insert(r + c);
	}

	/*
	for (int r = 0; r < n; r++) {
		for (auto v : diags) {
			int c = v - r;
			if (c >= 0 && (c < m)) {
				calc.push_back({ r,c });
			}
		}
	}

	*/
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			calc.push_back({ i,j });
		}
	}

	ll ans = 0,res;
	for (auto pos : calc) {
		res = g(pos);
		ans += res;
		ans += (modulo << 10);
		ans %= modulo;
	}
	cout << ans;
	return 0;



}