#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
#define rep(i, n) for (int (i) = 0; (i) < (n); ++i)
#define all(x) (x).begin(), (x).end()

struct seg {
    int l, r;
};

const int MAXN = 2e5 + 5;
int n, m, k;
seg s[MAXN];
seg ns[MAXN];
vector<int> h[MAXN];
vector<int> a[MAXN];
vector<ll> suml[MAXN];
vector<ll> sumr[MAXN];
// int ans[MAXN];
// int pos[MAXN];
ll res = 0;
int sg[MAXN];

void rec(int l, int r, int sl, int sr) {
    if (r < l) return;

    int t = l + (r - l) / 2;
    ll ans = INT64_MAX;
    int best = -1;

    suml[t].resize(m * 2);
    sumr[t].resize(m * 2);

    suml[t][0] = -a[t][0];
    for (int i = 1; i < m * 2; ++i) {
        suml[t][i] = suml[t][i - 1] - a[t][i];
    }
    sumr[t][m * 2 - 1] = a[t][m * 2 - 1];
    for (int i = m * 2 - 2; i >= 0; --i) {
        sumr[t][i] = sumr[t][i + 1] + a[t][i];
    }

    int pl = -1, pr = 0;
    for (int i = sl; i <= sr; ++i) {
        while (pr < m * 2 && a[t][pr] <= s[i].r) pr++;
        while (pl + 1 < m * 2 && a[t][pl + 1] < s[i].l) pl++;

        ll val = 0;
        if (pl != -1) val += 1LL * (pl + 1) * s[i].l + suml[t][pl];
        if (pr != m * 2) val += -1LL * (m * 2 - pr) * s[i].r + sumr[t][pr];

        // cout << ": " << i << ' ' << pl << ' ' << pr << ' ' << suml[t][pl] << endl;;

        if (val < ans) {
            ans = val;
            best = i;
        }
    }

    // cout << t << ' ' << ans << endl;

    res += ans;
    rec(l, t - 1, sl, best);
    rec(t + 1, r, best, sr);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> m >> n >> k;
    rep(i, k) {
        cin >> s[i].l >> s[i].r;
    }

    sort(s, s + k, [&](const seg &a, const seg &b){
        if (a.l == b.l) return a.r > b.r;
        return a.l < b.l;
    });

    int last = 0, r = -1;
    for (int i = 0; i < k; ++i) {
        if (s[i].r <= r) continue;
        r = s[i].r;
        ns[last++] = s[i];
    }

    rep(i, last) {
        s[i] = ns[i];
    }
    k = last;

    rep(i, m) {
        rep(j, n * 2) {
            int x;
            cin >> x;
            h[i].push_back(x);
        }
        sort(all(h[i]));
        rep(j, n) {
            a[j].push_back(h[i][j * 2]);
            a[j].push_back(h[i][j * 2 + 1]);
        }
    }

    // rep(i, n) {
    //     cout << " : " << i << " : " << endl;
    //     for (auto it : a[i]) {
    //         cout << it << ' ';
    //     }
    //     cout << endl;
    // }

    rec(0, n - 1, 0, k - 1);
    // rec(0, 0, 0, k - 1);

    cout << res << endl;
}
