#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#define $ if (DEV)

#include <bits/stdc++.h>
using namespace std;
void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        test_cnt = 179;
    }
    for (int t = 0; t < test_cnt; ++t) {
        if (feof(stdin)) break;
        $ printf("--- TEST CASE %d ---\n", t);
        entry(t);
    }
}

template<typename T>
bool relmax(T& lhs, const T rhs) {
    if (lhs < rhs) {
        lhs = rhs;
        return true;
    }
    return false;
}template<typename T>
bool relmin(T& lhs, const T rhs) {
    if (lhs > rhs) {
        lhs = rhs;
        return true;
    }
    return false;
}
using ll = long long;
const ll MOD = 998'244'353;
#define all(x) x.begin(), x.end()
void entry(int test_id) {
    int n, m, k;
    scanf("%d %d %d", &m, &n, &k);
    vector<pair<ll, ll>> S;
    for (int i = 0; i < k; ++i) {
        ll l, r;
        scanf("%lld %lld", &l, &r);
        S.emplace_back(l,r);
    }
    {
        auto ss = S;
        sort(all(ss), [&](pair<ll, ll> lhs, pair<ll, ll> rhs){
            if (lhs.first != rhs.first) return lhs.first < rhs.first;
            return lhs.second > rhs.second;
        });
        S.clear();
        ll j = -1;
        for (int i = 0; i < k; ++i) {
            if (ss[i].second <= j) continue;
            j = ss[i].second;
            S.push_back(ss[i]);
        }
        k = S.size();
    }
    vector<vector<ll>> H(m, vector<ll>(2*n));
    for (int i = 0; i < m; ++i){
        for (int j = 0; j < 2*n; ++j) {

            int x;
            scanf("%d", &x);
            H[i][j] = x;
        }
    }
    for (int i = 0; i < m; ++i) {
        sort(all(H[i]));
    }
    auto calc = [&](ll l, ll r, ll h) {
        if (h < l) return l - h;
        if (h > r) return h-r;
        return (ll) 0;
    };
    ll ans = 0;
    int prev_ty = 0;
    for (int part = 0; part < n; ++part) {
        ll res = 1e18;
        vector<ll> items(2*m);
        for (int j = 0; j < m; ++j) {
            items[2*j] = H[j][2*part];
            items[2*j+1] = H[j][2*part + 1];
        }
        sort(all(items));
        vector<int> pref(2*m+1);
        for (int i = 0; i < 2*m; ++i) {
            pref[i+1] = pref[i] + items[i];
        }
        for (int ty = prev_ty; ty < k; ++ty) {
            ll score = 0;
            //for (ll x : items) {
            //    score += calc(S[ty].first, S[ty].second, x);
            //}
            auto it1 = lower_bound(all(items), S[ty].first);
            auto it2 = upper_bound(all(items), S[ty].second);
            int k1 = it1 - items.begin();
            int k2 = it2-items.begin();
            //for (int i = 0; i < k1; ++i) {
            //    score += S[ty].first - items[i];
            //}
            score = k1 * S[ty].first - pref[k1];
            for (int i = k2; i < 2*m; ++i) {
                score += items[i] - S[ty].second;
            }
            if (relmin(res, score)) {
                prev_ty = ty;
            }

            //res = min(res, score);
        }
        ans += res;
    }
    printf("%lld\n", ans);
}