#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct desk {
    int l, r;
    desk (int l_, int r_) : l(l_), r(r_) {}
    desk () {}
};

vector<vector<int>> groups;

int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, n, k;
    cin >> m >> n >> k;

    groups.resize(m, vector<int>(2*n));
    vector<desk> desks(k);

    for (int i = 0; i < k; i++) {
        cin >> desks[i].l >> desks[i].r;
    }

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < 2*n; j++) {
            cin >> groups[i][j];
        }
    }

    ll p = 1e18;

    for (int it = 0; it < k; it++) {
        int l = desks[it].l, r = desks[it].r;
        ll cur_p = 0;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < 2*n; j++) {
                int h = groups[i][j];
                if (l <= h && h <= r) {
                    continue;
                }
                cur_p += min(abs(l - h), abs(r - h));
            }
        }
        p = min(p, cur_p);
    }

    cout << p;

    return 0;
}
