#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll mod = 998244353;

vector<vector<int>> matr;
vector<vector<pair<int,int>>> ans;
vector<vector<char>> isV;

void dfs(int x, int y) {
    if (isV[x][y]) {
        ans[x][y].first = matr[x][y];
        ans[x][y].second = matr[x][y];
        return;
    }
    dfs(x+1, y);
    dfs(x, y+1);
        ans[x][y].first = min(ans[x+1][y].second, ans[x][y+1].second);

        ans[x][y].second = max(ans[x+1][y].first, ans[x][y+1].first);
}

int main() {

    int n, m, k;
    cin >> n >> m >> k;

    matr.resize(n+1, vector<int>(m+1));
    ans.resize(n+1, vector<pair<int,int>>(m+1, {-1, -1}));
    isV.resize(n+1, vector<char>(m+1));
    for (int i = 0; i < k; i++) {
        int x, y, v;
        cin >> x >> y >> v;
        matr[x-1][y-1] = v;
        isV[x-1][y-1] = 1;
    }

    for (int i = 0; i < n; i++) {
        isV[i][m] = 1;
        ans[i][m] = {0, 0};
    }
    for (int j = 0; j < m; j++) {
        isV[n][j] = 1;
        ans[n][j] = {0,0};
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (ans[i][j].first == -1) {
                dfs(i, j);
            }
        }
    }

    ll p = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            p += ans[i][j].first;
//            cout << ans[i][j].first << " ";
        }
//        cout << endl;
    }

    cout << (p + mod * (ll)1e9) % mod;

    return 0;
}
