#include <string>
#include <vector>
#include <iostream>
#include <map>
#include <algorithm>

using namespace std;

#define int long long
#define all(s) s.begin(), s.end()
typedef pair<int, int> pii;


const int N = 5e5 + 5;
int pref[N];
vector <int> poses;

signed main()
{
	//freopen("true.txt", "r", stdin);
	int n;
	string s;

	cin >> n >> s;
	int f = count(all(s), '0');

	poses.push_back(-1);
	for (int i = 0; i < s.size(); ++i)
	{
		if (s[i] == '0') pref[i]++;
		if (i) pref[i] += pref[i - 1];
		if (s[i] == '1')
			poses.push_back(i);
	}
	poses.push_back(n);
	pref[n] = pref[n - 1];

	auto get = [&](int k) -> int
	{
		int cur = 0;
		int s = 0;
		while (poses[cur] < n)
		{
			int l = 0, r = poses.size();
			while (r - l > 1)
			{
				int mid = (l + r) / 2;
				if (mid <= cur)
				{
					l = mid;
					continue;
				}
				int sm = pref[poses[mid]] - pref[poses[cur]];
				if (sm >= k)
				{
					r = mid;
				}
				else
				{
					l = mid;
				}
			}
			if (r >= poses.size()) break;
			s++;
			cur = r;
		}
		return s - 1;
	};

	int ans = 0, opt;

	for (int i = 0; i <= f; ++i)
	{
		int fnc = get(i);
		if (fnc == 0) continue;
		if ((fnc+1)*i + fnc > ans)
		{
			ans = (fnc + 1)*i + fnc;
			opt = i;
		}
	}
	
	cout << ans << '\n';

	auto erkin = [](string s, int cnt0) -> int
	{
		int cur = 0;
		int res = 0;
		for (int i = 0; i < s.size(); ++i)
		{
			if (s[i] == '0')
			{
				cur++;
			}
			else
			{
				if (cur >= cnt0)
				{
					res++;
					cur = 0;
				}
			}
		}
		if (res == 0)
			return 0;
		if (cur < cnt0)
		{
			res--;
		}
		return res;
	};


	int t = erkin(s, opt);
	for (int i = 0; i < t; ++i)
	{
		for (int j = 0; j < opt; ++j)
			cout << 0;
		cout << 1;
		if (i == t - 1)
		{
			for (int j = 0; j < opt; ++j)
				cout << 0;
		}
	}

	return 0;
}