#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll f(pair<ll, ll> t, ll x) {
    if (t.first <= x && x <= t.second) {
        return 0;
    }
    return min(abs(t.first - x), abs(t.second - x));
}

int main() {
    int m, n, k;
    cin >> m >> n >> k;
    vector<pair<ll, ll>> t(k);
    for (int i = 0; i < k; ++i) {
        cin >> t[i].first >> t[i].second;
    }
    sort(t.begin(), t.end());
    vector<vector<ll>> v(m, vector<ll>(2 * n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 2 * n; ++j) {
            cin >> v[i][j];
        }
        sort(v[i].begin(), v[i].end());
    }

    ll ans = 1e18;
    for (int i = 0; i <= n; ++i) {
        ll cans = 0;
        int rest = 2 * i;
        for (int j = 0; j < m; ++j) {
            for (int l = 0; l < 2 * n; ++l) {
                if (rest > 0) {
                    cans += f(t[0], v[j][l]);
                    rest--;

                }
                else {
                    cans += f(t[1], v[j][l]);
                }
            }
        }
        ans = min(ans, cans);
    }
    cout << ans << endl;
}