#include <iostream>
using namespace std;

long long h_s[(int)1e6 + 1];
//long long h_p[(int)1e5 + 1];
long long xp[(int)1e6 + 2];

const int prime = 239;
const int mod = 1e9 + 7;

long long get_hash(long long h[], int a, int b){  /// [a, b], 1-indexation
    long long ans = h[b] - h[a - 1] * xp[b - a + 1];
    ans %= mod;
    if(ans < 0)
        ans += mod;
    return ans;
}
int main(){
    int m, n;
    cin >> m >> n;
    string p;
    cin >> p;
    string s;
    for(int i=0; i<n; i++){
        int type;
        cin >> type;
        if(type == 1){
            string w;
            cin >> w;
            s += w;
        }
        else{
            int pos, len;
            cin >> pos >> len;
            pos--;
            for(int i=pos; i< pos+len; i++){
                s += s[i];
            }
        }
    }

    h_s[0] = 0;
    for(int i=1; i<=s.size(); i++)
        h_s[i] = (h_s[i - 1] * prime + (s[i - 1] - 'a' + 1)) % mod;

    long long h_p = 0;
    for(int i=0; i<p.size(); i++)
        h_p = (h_p * prime + (p[i] - 'a' + 1)) % mod;

    xp[0] = 1;
    for(int i=1; i<(int)1e6 + 2; i++){
        xp[i] = (xp[i - 1] * prime) % mod;
    }
    int ans = 0;
    for(int i=0; i<=(int)s.size()-(int)p.size(); i++){
        if(get_hash(h_s, i + 1, i + p.size()) == h_p){
            ans++;
            //cout << "i = " << i << endl;
        }
    }
    cout << ans;
    return 0;
}
