#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <map>
#include <set>
using namespace std;

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,tune=native")
#pragma GCC optimize("unroll-loops")

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long m, n, k;
    cin >> m >> n >> k;
    vector<pair<long long, long long> > a(k);
    for(long long i = 0; i<k; i++)
        cin >> a[i].first >> a[i].second;
    vector<vector<long long> > b(m, vector<long long>(2*n));
    for(long long i = 0; i<m; i++){
        for(long long j = 0; j<2*n; j++)
            cin >> b[i][j];
        sort(b[i].begin(), b[i].end());
    }
    long long ans = 0;
    for(long long i = 0; i<n; i++){
        long long ans1 = 1000000000000000000;
        for(long long j = 0; j<k; j++){
            long long ans2 = 0;
            for(long long y = 0; y<m; y++){
                if(!(a[j].first<=b[y][2*i]&&b[y][2*i]<=a[j].second))
                    ans2 += min(abs(b[y][2*i]-a[j].first), abs(b[y][2*i]-a[j].second));
                if(!(a[j].first<=b[y][2*i+1]&&b[y][2*i+1]<=a[j].second))
                    ans2 += min(abs(b[y][2*i+1]-a[j].first), abs(b[y][2*i+1]-a[j].second));
            }
            ans1 = min(ans1, ans2);
        }
        ans += ans1;
    }
    cout << ans;

    return 0;
}
