import java.io.PrintWriter;
import java.util.*;

class point implements Comparator<point> {
    int x, y;
    point(int x,int y) {
        this.x = x;
        this.y = y;
    }
    point() {}

    @Override
    public int compare(point o1, point o2) {
        return Integer.compare(o1.x, o2.x) * 2 + Integer.compare(o1.y, o2.y);
    }
}
public class Main {
    static int inf = (int) 1e9 + 7;
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);
        int n = sc.nextInt();
        int m = sc.nextInt();
        int k = sc.nextInt();
        TreeMap<point, Integer> a = new TreeMap<>(new point());
        for(int i = 0;i < k;i++) {
            point temp = new point(sc.nextInt() - 1, sc.nextInt() - 1);
            int c = sc.nextInt();
            a.put(temp, c);
        }
        int dp[][] = new int [n][m];
        long ans = 0;
        for(int i = n - 1;i >= 0;i--) {
            for(int j = m - 1;j >= 0;j--) {
                point u = new point(i, j);
                point u1 = new point(i + 1, j);
                point u2 = new point (i, j + 1);
                if (a.containsKey(u)) dp[i][j] = a.get(u);
                else{
                    if (a.containsKey(u1)) {
                        dp[i][j] = a.get(u1);
                    }else{
                        if (i + 2 < n) dp[i][j] = dp[i + 2][j];
                        dp[i][j] = Math.max(dp[i][j], i + 1 < n && j + 1 < m ? dp[i + 1][j + 1] : 0);
                    }
                    if (a.containsKey(u2)) {
                        dp[i][j] = Math.min(dp[i][j], a.get(u2));
                    }else{
                        int t = 0;
                        if (j + 2 < m) t = dp[i][j + 2];
                        t = Math.max(t, i + 1 < n && j + 1 < m ? dp[i + 1][j + 1] : 0);
                        dp[i][j] = Math.min(dp[i][j], t);
                    }
                }
                ans += dp[i][j];
            }
        }
        int mod = 998244353;
        pw.println((ans % mod + mod) % mod);
        pw.close();
    }
}