#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <cassert>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <random>
#include <ctime>
#include <fstream>
#include <deque>

#pragma warning(4996:disable)
#pragma comment(linker, "/STACK:512000000")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()

const int inf = 2e9;
const ll llinf = 1e18, mod = 998'244'353;
const char el = '\n';

mt19937 rnd(time(NULL));

struct biba {
	int r, c;
};
bool operator <(const biba & a, const biba & b) {
	return a.r + a.c > b.r + b.c || (a.r + a.c == b.r + b.c && a.r < b.r);
}
map<biba, int> q, w;
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	forn(i, k) {
		int r, c, v;
		cin >> r >> c >> v;
		r--; c--;
		q[biba{ r, c }] = v;
		w[biba{ r, c }] = v;
		forn(j, r + 1)
			for (int k = max(0, c - n); k <= c; ++k)
				if (q.find({ j, k }) == q.end()) q[{ j, k }] = inf;
	}
	int ans = 0;
	for (auto to : q) {
		if (to.x.c < m && to.x.r < n && to.y == inf) {
			int tmp1 = max(q[{to.x.r + 2, to.x.c}], q[{to.x.r + 1, to.x.c + 1}]);
			if (w.find({ to.x.r + 1, to.x.c }) != w.end())
				tmp1 = w[{to.x.r + 1, to.x.c}];
			int tmp2 = max(q[{to.x.r, to.x.c + 2}], q[{to.x.r + 1, to.x.c + 1}]);
			if (w.find({ to.x.r, to.x.c + 1 }) != w.end())
				tmp2 = w[{to.x.r, to.x.c + 1}];
			q[to.x] = min(tmp1, tmp2);
		}
	}
	
	for (auto to : q)
		ans = (ans + to.y) % mod;
	ans = (ans % mod + mod) % mod;
	cout << ans;
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}