#define REL
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <random>
#include <bitset>
#include <cassert>

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;

const ll N = 8;
const ll MOD = 998244353;

ll n, m, k;
map<pair<ll, ll>, ll> lov, dp0, dp1, used;
ll ans = 0;

bool est(map<pair<ll, ll>, ll> &mep, pair<ll, ll> a) {
	if (mep.find(a) == mep.end()) return false;
	return true;
}

void dyn(ll indi, ll indj) {
	for (ll i = n; i >= max(1ll, indi - N); i--) {
		for (ll j = min(indj + 2, m); j >= max(1ll, indj - N); j--) {
			if (est(lov, mp(i, j))) {
				dp0[mp(i, j)] = lov[mp(i, j)];
				dp1[mp(i, j)] = lov[mp(i, j)];
				goto ext;
			}
			if (i < n) {
				if (j < m) {
					dp0[mp(i, j)] = min(dp1[mp(i + 1, j)], dp1[mp(i, j + 1)]);
					dp1[mp(i, j)] = max(dp0[mp(i + 1, j)], dp0[mp(i, j + 1)]);
				}
				else {
					dp0[mp(i, j)] = min(dp1[mp(i + 1, j)], 0ll);
					dp1[mp(i, j)] = max(dp0[mp(i + 1, j)], 0ll);
				}
			}
			else {
				if (j < m) {
					dp0[mp(i, j)] = min(dp1[mp(i, j + 1)], 0ll);
					dp1[mp(i, j)] = max(dp0[mp(i, j + 1)], 0ll);
				}
				else {
					dp0[mp(i, j)] = dp1[mp(i, j)] = 0ll;
				}
			}
			ext:;
			if (est(used, mp(i, j)) == false) {
				ans = ans + dp0[mp(i, j)];
				while (ans < 0) { ans += MOD; }
				ans %= MOD;
				used[mp(i, j)] = 1;
			}
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> k;
	ll r, c, x;
	for (ll i = 0; i < k; i++) {
		cin >> r >> c >> x;
		lov[mp(r, c)] = x;
	}
	for (auto e : lov) {
		dyn(e.first.first, e.first.second);
	}
	cout << ans;
}