#include<iostream>
#include<cstdlib>
#include<string>
#include<vector>
#include<algorithm>
#include<numeric>
#include<fstream>
#include<tuple>
#include<cassert>

using namespace std;
using nagai = long long;

const int N = 200200;
const nagai oo = 0x3f3f3f3f3f3f3f3f;
vector<pair<int, int>>mem[N];
pair<int, int>desks[N];
pair<nagai, nagai>d1[N];
int score(int x, pair<int, int>dsk) {
	if (dsk.first <= x && x <= dsk.second)return 0;
	return min(abs(x - dsk.first), abs(x - dsk.second));
}
nagai ansich[N];
int m, n, k;
vector<nagai>cs;
int t[2 * N];
nagai s[2 * N];
void ad(int x, int y) {
	x += N;
	t[x] += y;
	s[x] += y * cs[x-N];
	while (x > 1)t[x >> 1] = t[x] + t[x ^ 1], s[x >> 1] = s[x] + s[x ^ 1], x >>= 1;
}
pair<int,nagai>get(int l, int r) {
	nagai anss = 0;
	int anst = 0;
	l += N;
	r += N;
	while (l < r) {
		if (l & 1)anss += s[l], anst += t[l++];
		if (r & 1)anss += s[r - 1], anst += t[--r];
		l /= 2, r /= 2;
	}
	return make_pair(anst, anss);
}
void init(int i) {
	for (int j = 0; j < m; ++j)
		ad(mem[i][j].first, 1), ad(mem[i][j].second, 1);
}
void finish(int i) {
	for (int j = 0; j < m; ++j)
		ad(mem[i][j].first, -1), ad(mem[i][j].second, -1);
}
nagai sscore(int desk) {
	auto ri = get(desks[desk].second, N);
	auto le = get(0, desks[desk].first);
	nagai ans = ri.second - ri.first*d1[desk].second;
	ans += d1[desk].first * le.first - le.second;
	return ans;
}
nagai score(int i, int desk) {
	nagai kek = 0;
	for (int j = 0; j < m; ++j)
		kek += score(mem[i][j].first, desks[desk]),
		kek += score(mem[i][j].second, desks[desk]);
	return kek;
}
void solve(int l, int r, int optl, int optr) {
	if (l == r)return;
	int M = (l + r) / 2;
	nagai mn = oo;
	int opt = -1;
	init(M);
	for (int i = optl; i <= optr; ++i) {
		nagai kek = sscore(i);
		if (kek <= mn)mn = kek, opt = i;
	}
	finish(M);
	ansich[M] = mn;
	if (r - l == 1)return;
	solve(l, M, optl, opt);
	solve(M, r, opt, optr);
}
int main() {
#ifdef _DEBUG
	ifstream cin("input.txt");
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> m >> n >> k;
	for (int i = 0; i < k; ++i)cin >> desks[i].first >> desks[i].second;//, cs.push_back(desks[i].first), cs.push_back(desks[i].second);
	sort(desks, desks + k, [&](pair<int, int>a, pair<int, int>b) {
		return a.second < b.second;
	});
	for (int i = 0; i < m; ++i) {
		vector<int>h(2 * n);
		for (int&x : h)cin >> x, cs.push_back(x);
		sort(h.begin(), h.end());
		for (int i = 0; i < n; ++i)
			mem[i].emplace_back(h[2 * i], h[2 * i + 1]);
	}
	sort(cs.begin(), cs.end());
	cs.erase(unique(cs.begin(), cs.end()), cs.end());
	for (int i = 0; i < n; ++i)
		for (auto& p : mem[i])
			p.first = lower_bound(cs.begin(), cs.end(), p.first) - cs.begin(),
			p.second = lower_bound(cs.begin(), cs.end(), p.second) - cs.begin();
	for (int i = 0; i < k; ++i) {
		auto&p = desks[i];
		d1[i] = desks[i];
		p.first = lower_bound(cs.begin(), cs.end(), p.first) - cs.begin(),
		p.second = lower_bound(cs.begin(), cs.end(), p.second) - cs.begin();
	}
	solve(0, n, 0, k-1);
	nagai ans = 0;
	for (int i = 0; i < n; ++i)ans += ansich[i];
	/*
	for (int i = 0; i < n; ++i) {
		nagai mn = oo;
		for (int d = 0; d < k; ++d) {
			nagai ansich = 0;
			for (int j = 0; j < m; ++j)
				ansich += score(mem[i][j].first, desks[d]),
				ansich += score(mem[i][j].second, desks[d]);
			mn = min(mn, ansich);
		}
		ans += mn;
	}
	*/
	cout << ans << '\n';
	system("pause");
}