#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

int _dist(int a, int b, int h) {
    if (h < a) return a - h;
    if (h > b) return h - b;
    return 0;
}

int dist(int a, int b, int h1, int h2) {
    return _dist(a, b, h1) + _dist(a, b, h2);
}

const int N = 2e5 + 10;
vector<int> xx[N];
vector<int> p[N];
vector<int> pp[N];
int l[N], r[N];

signed main() {
    fast();
    int m, n, k;
    cin >> m >> n >> k;
    for (int i = 0; i < k; i++) {
        cin >> l[i] >> r[i];
    }
    int answ = 0;
    for (int i = 0; i < m; i++) {
        vector<int> temp(2 * n);
        for (int j = 0; j < 2 * n; j++) {
            cin >> temp[j];
        }
        sort(temp.begin(), temp.end());
        for (int j = 0; j < 2 * n; j += 2) {
            xx[j / 2].push_back(temp[j]);
            xx[j / 2].push_back(temp[j + 1]);
        }
    }
    for (int i = 0; i < n; i++) {
        sort(xx[i].begin(), xx[i].end());
        p[i].resize(2 * m);
        pp[i].resize(2 * m);
        p[i][0] = xx[i][0];
        pp[i][2 * m - 1] = xx[i][2 * m - 1];
        for (int j = 1; j < 2 * m; j++) {
            p[i][j] = p[i][j - 1] + xx[i][j];
            pp[i][2 * m - 1 - j] = pp[i][2 * m - j] + xx[i][2 * m - 1 - j];
        }
    }

    for (int i = 0; i < n; i++) {
        int c = 1e18;
        for (int j = 0; j < k; j++) {
            int cur = 0;
            int i1 = lower_bound(xx[i].begin(), xx[i].end(), l[j]) - xx[i].begin() - 1;
            if (i1 >= 0) cur += l[j] * (i1 + 1) - p[i][i1];
            i1 = upper_bound(xx[i].begin(), xx[i].end(), r[j]) - xx[i].begin();
            if (i1 < 2 * m) {
                cur += pp[i][i1] - (2 * m - i1) * r[j];
            }
            c = min(c, cur);
        }
        answ += c;
    }
    cout << answ;
    return 0;
}