#include <iostream>
#include <vector>
#define int long long

using namespace std;

const int INF = 1e18;

signed main() {
	ios_base :: sync_with_stdio(0);
	cin.tie(0);
	int m, n, k;
	cin >> m >> n >> k;
	pair <int, int> lr[k];
	for (int i = 0; i < k; i++) cin >> lr[i].first >> lr[i].second;
	vector <int> sch[m];
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			int x;
			cin >> x;
			sch[i].push_back(x);
		}
	}
	int ans = INF;
	for (int i = 0; i < k; i++) {
		int cur = 0;
		int l = lr[i].first, r = lr[i].second;
		for (int j = 0; j < m; j++) {
			for (int elem : sch[j]) {
				if (elem >= l && elem <= r) continue;
				cur += min(abs(l - elem), abs(elem - r));
			}
		}
		ans = min(ans, cur);
	}
	cout << ans << endl;
}
