#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

const int INF = 1e18, MAX_N = 2e5 + 7;
pair <int, int> lr[MAX_N];
vector <int> sch[MAX_N];
pair <int, int> s[MAX_N];
int m, n, k;
int cur_k = 0;

bool cmp(pair <int, int> a, pair <int, int> b) {
	if (a.first != b.first) return (a.first < b.first);
	return (a.second > b.second);
}

/*int calc0(vector <int> d, int kk) {
	int cur = 0;
	int l = lr[kk].first, r = lr[kk].second;
	for (int elem : d) {
		if (l <= elem && elem <= r) continue;
		cur += min(abs(elem - l), abs(elem - r));
	}
	return cur;
}*/

int calc(vector <int> d) {
	for (int i = 0; i < k; i++) s[i] = {0, 0};
	sort(d.begin(), d.end());
	int l = 0;
	int s_beg = 0;
	int c = 0;
	for (int i = 0; i < k; i++) {
		while (l < d.size() && d[l] < lr[i].first) {
			s_beg += d[l];
			c++;
			l++;
		}
		s[i].first = lr[i].first * c - s_beg;
	}
	int r = d.size() - 1;
	s_beg = 0;
	c = 0;
	for (int i = k - 1; i >= 0; i--) {
		while (r >= 0 && d[r] > lr[i].second) {
			s_beg += d[r];
			c++;
			r--;
		}
		s[i].second = s_beg - lr[i].second * c;
	}
	int maxi = INF;
	for (int i = 0; i < k; i++) maxi = min(maxi, s[i].first + s[i].second);
	return maxi;
}

signed main() {
	//freopen("Desktop/input.txt", "r", stdin);
	ios_base :: sync_with_stdio(0);
	cin.tie(0);
	cin >> m >> n >> k;
	for (int i = 0; i < k; i++) cin >> lr[i].first >> lr[i].second;
	vector <int> sch[m];
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < 2 * n; j++) {
			int x;
			cin >> x;
			sch[i].push_back(x);
		}
		sort(sch[i].begin(), sch[i].end());
	}
	sort(lr, lr + k, cmp);
	vector <pair <int, int>> lr2;
	lr2.push_back(lr[0]);
	for (int i = 1; i < k; i++) {
		if (lr[i].second > lr2.back().second) lr2.push_back(lr[i]);
	}
	k = lr2.size();
	for (int i = 0; i < k; i++) lr[i] = lr2[i];
	int ans = 0;
	for (int i = 0; i < 2 * n; i += 2) {
		vector <int> now;
		for (int j = 0; j < m; j++) {
			now.push_back(sch[j][i]);
			now.push_back(sch[j][i + 1]);
		}
		ans += calc(now);
	}
	cout << ans << endl;
	return 0;
}
