#include <iostream>
#include <vector>
#include <deque>
#define int long long

using namespace std;

const int MM = 1e7 + 7;

vector <int> calc(string s, string t) { // t in s
	string new_s = t + "$" + s; 
	int n = new_s.size();
	vector <int> z;
	z.resize(n + 1);
	z[0] = n;
	int l = -1, r = -1;
	int res = 0;
	vector <int> now;
	for (int i = 1; i < n; i++) {
		int len = 0;
		if (i < r) {
			len = min(z[i - l], r - i);
		}
		while (i + len < n && new_s[len] == new_s[i + len]) len++;
		z[i] = len;
		if (i + len > r) {
			l = i;
			r = i + len;
		}
		if (z[i] == t.size()) {
			now.push_back(i - (t.size() + 1));
		}
	}
	return now;
}

signed main() {
	deque <char> now;
	int m, n;
	cin >> m >> n;
	string p;
	cin >> p;
	string s = "";
	int ans = 0;
	vector <int> poses;
	for (int i = 0; i < n; i++) {
		int t, pos, len;
		cin >> t;
		if (t == 1) {
			string w;
			cin >> w;
			if (s.length() < MM) {
				s += w;
				if (s.length() >= MM) {
					poses = calc(s, p);
					ans += poses.size();
				}
			} else {
				string cur = "";
				for (char elem : now) cur += elem;
				for (int i = 0; i < cur.size(); i++) {
					string t = "";
					for (int j = i; j < cur.size(); j++) t += cur[j];
					if (t.size() == m) continue;
					int x = 0;
					while (x < w.size() && t.size() < m) {
						t += w[x];
						x++;
					}
					if (t.size() == m && t == p) ans++;
				}
				ans += calc(w, p).size();
			}
			if (w.size() > m) {
				now.clear();
				for (int i = (int) w.length() - m; i < w.length(); i++) {
					now.push_back(w[i]);		
				}
			} else {
				for (int i = 0; i < w.length(); i++) {
					now.push_back(w[i]);
					if (now.size() > m) now.pop_front();
				}
			}
		} else {
			int pos, len;
			cin >> pos >> len;
			if (s.length() < MM) {
				int c = 0;
				for (int i = pos - 1; c < len; i++, c++) {
					s += s[i];
				}
				if (s.length() >= MM) {
					poses = calc(s, p);
					ans += poses.size();
				}
			} else {
				int left = -1, right = poses.size(), mid;
				while (right - left > 1) {
					mid = (left + right) / 2;
					if (poses[mid] + m - 1 < len) left = mid;
					else right = mid;
				}
				ans += (left + 1);
				string cur = "";
				for (char elem : now) cur += elem;
				for (int i = 0; i < cur.size(); i++) {
					string t = "";
					for (int j = i; j < cur.size(); j++) t += cur[j];
					if (t.size() == m) continue;
					int x = 0;
					while (x < len && t.size() < m) {
						t += s[x];
						x++;
					}
					if (t.size() == m && t == p) ans++;
				}
			}
			if (len > m) {
				now.clear();
				for (int i = 0; i < m; i++) now.push_back(s[i]);
			} else {
				for (int i = 0; i < len; i++) {
					now.push_back(s[i]);
					if (now.size() > m) now.pop_front();
				}
			}
		}
	}
	if (s.length() < MM) ans += calc(s, p).size();
	cout << ans << endl;
	return 0;
}
