﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map> 

using namespace std;
#define int long long
#define double long double
int n;
string s;
void read() {
	cin >> n >> s;
}

string ans = "";

void gen_first_zero() {
	//cout << "with 0" << endl;
	for (int i = 0; i <= n; i++) {
		string fans = "";
		int len = 0;
		int cnt = 0;
		for (int j = 0; j < n; j++) {
			if (s[j] == '0') {
				if (len < i) {
					fans += '0';
					len++;
				}
			}
			else {
				if (len == i) {
					fans += '1';
					len = 0;
					cnt++;
				}
			}
		}

		if (len != i) {
			while (!fans.empty() && fans.back() != '1') {
				fans.pop_back();
			}
		}

		if (fans.size() > 0 && len != i) {
			fans.pop_back();
			cnt--;
		}
		if (!cnt)
			break;

		//cout << fans.size() << " " << fans << endl;
		if (fans.size() > ans.size() && cnt > 0) {
			ans = fans;
		}
	}
	//cout << endl;
}


bool help_try(int cnt, int len) {
	string help = s;
	int help_len = len;
	while (!help.empty() && help_len > 0) {
		if (help.back() != '1') {
			help_len--;
		}
		help.pop_back();
	}

	int sz = help.length();
	for (int i = 0; i < sz; i++) {
		if (help[i] == '1') {
			if (help_len == len) {
				cnt--;
				help_len = 0;
			}
		}
		else {
			help_len++;
		}
	}
	return cnt <= 0;
}

void fast_solution() {
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		if (s[i] == '1')
			cnt++;
	}
	int l = cnt, r = n + 1;
	while (l < r - 1) {
		int mid = (l + r) / 2;
		bool flag = false;
		for (int i = 2; i < 51; i++) {
			if (i > mid)
				break;
			if ((mid + 1) % i == 0) {
				if (help_try(i - 1, (mid + 1) / i - 1)) {
					flag = true;
					break;
				}
			}
		}
		if (flag) {
			l = mid;
		}
		else {
			r = mid;
		}
	}
	int mid = l;
	for (int i = 2; i < 51; i++) {
		if (i > mid)
			break;
		if ((mid + 1) % i == 0) {
			if (help_try(i - 1, (mid + 1) / i - 1)) {
				ans = "";
				string help_ans = "";
				for (int j = 0; j < (mid + 1) / i - 1; j++) {
					help_ans += "0";
				}
				for (int j = 0; j < i - 1; j++) {
					ans += help_ans;
					ans += "1"; 
				}
				ans += help_ans;
				break;
			}
		}
	}
}


void run() {
	gen_first_zero();
}

void write() {
	cout << ans.size() << endl;
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}