﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map> 

using namespace std;
#define int long long
#define double long double
int n, m;
string s;
void read() {
	cin >> m >> n >> s;
}

int ans = 0;

int get_ans(string have, string s) {
	int cnt = 0;
	int sz1 = have.size();
	int sz2 = s.size();
	int sz = sz1 - sz2;
	for (int i = 0; i <= sz; i++) {
		bool flag = true;
		for (int j = 0; j < s.length(); j++) {
			if (have[i + j] != s[j]) {
				flag = false;
				break;
			}
		}
		if (flag)
			cnt++;
	}
	return cnt;
}

vector <int> z_function(string s) {
	int n = s.length();
	vector <int> z(n);
	int l = 0, r = 0;
	for (int i = 1; i < n; i++) {
		if (i <= r)
			z[i] = min(r - i + 1, z[i - l]);
		while (z[i] + i < n && s[z[i]] == s[z[i] + i])
			z[i]++;
		if (i + z[i] - 1 > r)
			l = i, r = i + z[i] - 1;
	}
	return z;
}

int get_ans_smart(string have, string s) {
	have = s + "#" + have;
	auto fans = z_function(have);
	int cnt = 0;
	for (int i = s.length() + 1; i < fans.size(); i++) {
		if (fans[i] == s.length())
			cnt++;
	}
	return cnt;
}

void third_group() {
	string have = "";
	int type;
	cin >> type;
	cin >> have;


	int full_cnt = 1;
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >>type >> a >> b;
		full_cnt += b;
	}

	if (full_cnt * (int)have.size() < 1e8) {
		string help = "";
		for (int i = 0; i < full_cnt; i++) {
			help += have;
		}
		ans = get_ans_smart(help, s);
		return;
	}

	string fhelp = have;
	while ((int)fhelp.size() < (int)s.size() * 10) {
		fhelp += have;
		full_cnt--;
	}

	fhelp = s + "#" + have;

	vector <int> help = z_function(fhelp);

	int sz1 = have.size();
	int sz2 = s.size();
	int cnt_start = 0;

	for (int i = sz2; i < sz1 + sz2; i++) {
		if (help[i] == sz2) {
			cnt_start++;
		}
	}

	int help_cnt = 0;
	for (int i = sz2; i < help.size(); i++) {
		if (help[i] == sz2)
			help_cnt++;
	}

	ans = help_cnt + cnt_start * full_cnt;
}

void run() {
	third_group();
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	run();
	write();
	return 0;
}