#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <math.h>
#include <iomanip>

#define ll long long
#define ld long double
#define ep emplace_back
#define F first
#define L second

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

int n;
string ans, s, cur;

bool ok(){
	int m = cur.size(), j = 0;
	for (int i = 0; i < n; i++)
		if (j < m && s[i] == cur[j])
			j++;
	if (j != m)
		return false;

	int cnt = 0;
	int mn = m;
	bool ed = false;
	for (int i = 0; i < m; i++){
		if (cur[i] == '0')
			cnt++;
		else{
			ed = true;
			mn = min(mn, cnt);
			cnt = 0;
		}
	}
	mn = min(mn, cnt);
	if (!ed)
		return false;

	cnt = 0;
	for (int i = 0; i < m; i++){
		if (cur[i] == '0')
			cnt++;
		else{
			if (mn != cnt)
				return false;
			cnt = 0;
		}
	}

	return (mn == cnt);
}

void gen(int len){
	if (ok() && cur.size() > ans.size())
		ans = cur;
	if (len == n)
		return;

	cur += '0';
	gen(len + 1);
	cur.pop_back();
	cur += '1';
	gen(len + 1);
	cur.pop_back();
}

int main(){
	ios::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> n >> s;

	gen(0);
	cout << ans.size() << '\n' << ans;
}