#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
//#define int ll

vector <int> nm;

struct comp
{
	bool operator () (int a, int b) const
	{
		int f = min(nm[a - 1], nm[a + 1]);
		int s = min(nm[b - 1], nm[b + 1]);
		if (f != s)
			return f < s;
		return a < b;
	}
};

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	vector <pair<int, int>> a;
	for (int i = 0; i < n; i++)
	{
		char x;
		cin >> x;
		x -= '0';
		if (x == 1)
		{
			if (a.size() == 0 || a.back().first == 1)
			{
				a.push_back({ 0, 0 });
			}
			a.push_back({ 1, 1 });
		}
		else
		{
			if (a.size() == 0 || a.back().first == 1)
			{
				a.push_back({ 0, 1 });
			}
			else
			{
				a.back().second++;
			}
		}
	}
	if(a.back().first == 1)
		a.push_back({ 0, 0 });
	for (int i = 0; i < a.size(); i++)
	{
		cout << a[i].first << "  " << a[i].second << endl;
	}

	nm.resize(a.size());
	for (int i = 0; i < a.size(); i++)
		nm[i] = a[i].second;

	set <int, comp> ans;

	for (int i = 1; i < nm.size(); i += 2)
		ans.insert(i);

	while (ans.size() != 0)
	{
		int ind = *ans.begin();
		ans.erase(ind);
		if (nm[ind - 1] == nm[ind + 1])
			continue;

		int f = min(nm[ind - 1], nm[ind + 1]);
		if (ind - 2 >= 0)
		{
			ans.erase(ind - 2);
		}

		nm[ind - 1] = f;

		if (ind - 2 >= 0)
		{
			ans.insert(ind - 2);
		}

 		if (ind + 2 < a.size())
		{
			ans.erase(ind + 2);
		}
		nm[ind + 1] = f;
		if (ind + 2 < a.size())
		{
			ans.insert(ind + 2);
		}

	}
	string fin = "";
	for (int i = 0; i < nm.size(); i++)
	{
		char symb = i % 2 + '0';
		fin += string(nm[i], symb);
	}
	cout << fin.size() << endl;
	cout << fin << endl;
	return 0;

}