#include "pch.h"
#include <iostream>
#include <string>
#include <ctime>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll mod = 998244353ll;

ll n, m;
ll c;

ll arr[1001][1001];
ll gn[1001][1001];
ll ga[1001][1001];
bool tr[1001][1001];

ll x, y, cs;

ll ans = 0;

int main() {
	cin >> n >> m >> c;
	for (int i = 0; i < c; i++) {
		cin >> x >> y >> cs;
		arr[x][y] = cs;
		ga[x][y] = cs;
		gn[x][y] = cs;
		tr[x][y] = 1;
	}
	for (int i = m - 1; i > 0; i--) {
		if (tr[n][i]) continue;
		ga[n][i] = max(0ll, gn[n][i + 1]);
		gn[n][i] = min(0ll, ga[n][i + 1]);
	}
	for (int i = n - 1; i > 0; i--) {
		if (tr[i][m]) continue;
		ga[i][m] = max(0ll, gn[i + 1][m]);
		gn[i][m] = min(0ll, ga[i + 1][m]);
	}
	for(int i = n - 1; i > 0; i--){
		for (int j = m - 1; j > 0; j--) {
			if (tr[i][j]) continue;
			gn[i][j] = min(ga[i + 1][j], ga[i][j + 1]);
			ga[i][j] = max(gn[i + 1][j], gn[i][j + 1]);
		}
	}
	for (int i = 0; i < 1001; i++) {
		for (int j = 0; j < 1001; j++) {
			ans += gn[i][j];
			ans = (ans + mod) % mod;
		}
	}
	cout << (ans + mod) % mod;
	return 0;
}


/*

15
010010101100101110001000110001

19
*/