#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define int long long

const int inf = 1e18 + 7;
const ld eps = 1e-9;

struct Table
{
	int l;
	int r;
};

int unc(int l, int r, int h)
{
	if (h < l)
		return l - h;
	if (h > r)
		return h - r;
	return 0;
}

signed main()
{
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int m, n, k;
	cin >> m >> n >> k;

	vector<Table> tab(k);
	for (int i = 0; i < k; i++)
	{
		cin >> tab[i].l >> tab[i].r;
	}

	vector<vector<int>> gr(m, vector<int>(2 * n));
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++)
		{
			cin >> gr[i][j];
		}
	}

	for (int i = 0; i < m; i++)
	{
		sort(gr[i].begin(), gr[i].end());
	}

	int ans = 0;
	for (int j = 0; j < 2 * n; j += 2)
	{
		int uncom = inf;
		for (int p = 0; p < k; p++)
		{
			int bad = 0;
			for (int i = 0; i < m; i++)
			{
				bad += unc(tab[p].l, tab[p].r, gr[i][j]);
				bad += unc(tab[p].l, tab[p].r, gr[i][j + 1]);
			}
			uncom = min(uncom, bad);
		}
		ans += uncom;
	}

	cout << ans << endl;

	

	//system("pause");
	return 0;
}