#include<bits/stdc++.h>

#define pb push_back
#define ll long long
#define is insert
#define er erase
#define pii pair<int, int>
#define mp make_pair
#define X first
#define Y second
#define sz(a) (int)a.size()

using namespace std;

const int MAX_N = 5e5 + 5;

int solve();

int main()
{
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}

int n;

char c[MAX_N];

int suf[MAX_N];

int pref[2][MAX_N];

int ask(int b, int l, int r)
{
    return pref[b][r] - pref[b][l - 1];
}

pii get(int x)
{
    int l = 1;
    pii res = mp(0, 0);
    for (; l <= n; )
    {
        //cerr << l << '\n';
        if (ask(0, l, n) < x)
        {
            break;
        }
        int lg = l - 1;
        int rg = n + 1;
        while (rg - lg > 1)
        {
            int mg = (lg + rg) / 2;
            if (ask(0, l, mg) >= x)
            {
                rg = mg;
            }
            else
            {
                lg = mg;
            }
        }
        res.X += x;
        if (suf[rg] != n + 1 && ask(0, suf[rg], n) >= x)
        {
            res.Y++;
        }
        l = suf[rg] + 1;
    }
    return res;
}

int solve()
{
    cin >> n;
    for (int i = 1; i <= n; ++i)
    {
        cin >> c[i];
    }
    pref[0][0] = pref[1][0] = 0;
    for (int i = 1; i <= n; ++i)
    {
        pref[0][i] = pref[0][i - 1];
        pref[1][i] = pref[1][i - 1];
        pref[(int)c[i] - (int)'0'][i]++;
    }
    suf[n + 1] = n + 1;
    for (int i = n; i >= 1; --i)
    {
        suf[i] = suf[i + 1];
        if (c[i] == '1')
        {
            suf[i] = i;
        }
    }
    int best = 0;
    pii ans = get(0);
    for (int i = 1; i <= n; ++i)
    {
        pii cur = get(i);
        if (cur.Y > 0 && cur.X + cur.Y > ans.X + ans.Y)
        {
            best = i;
            ans = cur;
        }
    }
    cout << ans.X + ans.Y << '\n';
    for (int i = 1; i <= ans.Y + 1; ++i)
    {
        for (int j = 1; j <= best; ++j)
        {
            cout << '0';
        }
        if (i != ans.Y + 1)
        {
            cout << '1';
        }
    }
    return 0;
}
