#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unrool-loops")

typedef long long   ll;
typedef long double ld;
typedef pair <ll, ll> pll;

const ll kk=1000;
const ll ml=kk*kk;
const ll mod=ml*kk+7;
const long long inf=ml*ml*ml+7;

ll i,j, n, m, k;
vector <pll> p;
vector <vector <ll> > ch, gr, sum, rsum;
bool viv=false;

void read()
{
cin>>m>>n>>k;
for (ll i=0; i<k; i++)
  {
  ll a, b;
  cin>>a>>b;
  p.push_back({a, b});
  }
ch.resize(m);
for (ll i=0; i<m; i++)
  for (ll j=0; j<2*n; j++)
    {
    ll a;
    cin>>a;
    ch[i].push_back(a);
    }
gr.resize(n);
sum.resize(n);
rsum.resize(n);
for(ll i=0; i<m; i++)
  {
  sort(ch[i].begin(), ch[i].end());
  for (ll j=0; j<2*n; j++)
    gr[j/2].push_back(ch[i][j]);
  }
for (ll i=0; i<n; i++)
  {
  sort(gr[i].begin(), gr[i].end());
  sum[i].push_back(0);
  for (ll j=0; j<gr[i].size(); j++)
    sum[i].push_back(sum[i].back()+gr[i][j]-gr[i][0]);
  rsum[i].push_back(0);
  for (ll j=gr[i].size()-1; j>=0; j--)
    rsum[i].push_back(rsum[i].back()+(gr[i].back()-gr[i][j]));
  reverse(rsum[i].begin(), rsum[i].end());
  }
}

ll count (vector <ll> &v, vector <ll> &sum, vector <ll> &rsum, pll p)
{
if (viv)
  {
  cout<<"     ";
  cout<<"Solve: "<<p.F<<' '<<p.S<<endl;
  cout<<"     ";
  for (auto i:v)
    cout<<i<<' ';
  cout<<endl;
  cout<<"     ";
  for (auto i:sum)
    cout<<i<<' ';
  cout<<endl;
  cout<<"     ";
  for (auto i:rsum)
    cout<<i<<' ';
  cout<<endl;
  }
ll ans=0;
ll l=p.F;
ll r=p.S;
ll z=lower_bound(v.begin(), v.end(), l)-v.begin();
z--;
if (z>=0)
  {
  ans+=(z+1)*(l-v[z]);
  ans+=sum[z+1];
  }
z=lower_bound(v.begin(), v.end(), r)-v.begin();
if (z>=0)
  {
  ans+=(v.size()-z)*(v[z]-r);
  ans+=rsum[z+1];
  }
if (viv)
  {
  cout<<"     ";
  cout<<"and have "<<ans<<endl;
  }
return ans;
}

void solve_nmk()
{
ll ans=0;
for (ll u=0; u<n; u++)
  {
  ll lans=inf;
  for (ll i=0; i<k; i++)
    lans=min(lans, count(gr[u], sum[u], rsum[u], p[i]));
  ans+=lans;
  }
cout<<ans<<endl;
}

int main()
{
//viv=true;
ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
read();
solve_nmk();




    return 0;
}
/**
1 2 2
5 25
50 90
60 5 10 40

2 3 3
200 400
300 500
100 600
300 330 440 40 30 300
150 250 350 450 550 300

1 3 4
10 100
200 200
10 100
300 1000
5 10 20 15 200 90



**/


