#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;

template<typename T1, typename T2> 
inline void chkmax(T1 &x, const T2 &y) {
	if (x < y) x = y;
}

template<typename T1, typename T2> 
inline void chkmin(T1 &x, const T2 &y) {
	if (x > y) x = y;
}

typedef pair<int, int> point;

const int N = 2e5 + 1;

int n, m, k;

pair<int, int> w[N];
vector<int> who[N];

int f(pair<int, int> &a, int b) {
	if (a.x <= b) return b <= a.y ? 0 : b - a.y;
	return a.x - b;
}

int main() {
	ios::sync_with_stdio(false);
	while (cin >> m >> n >> k) {
		for (int i = 0; i < k; ++i) {
			cin >> w[i].x >> w[i].y;
		}
		sort(w, w + k);
		for (int i = 1; i < k; ++i) {
			chkmax(w[i].y, w[i - 1].x);
		}
		for (int i = 0; i < m; ++i) {
			who[i].resize(n * 2);
			for (auto &j: who[i]) {
				cin >> j;
			}
			sort(who[i].begin(), who[i].end());
		}
		long long ans = 0;
		for (int i = 0; i < n * 2; i += 2) {
			long long min_val = 1e18;
			long long sum = 0;
			vector<int> cur_who;
			for (int q = 0; q < m; ++q) {
				cur_who.pb(who[q][i]);
				cur_who.pb(who[q][i + 1]);
			}
			sort(cur_who.begin(), cur_who.end());
			for (auto q : cur_who) sum += q;
			long long sumL = 0, sumR = 0;
			int L = 0, R = 0; 
			for (int j = 0; j < k; ++j) {
				long long cur_val = 0;
				while (L < cur_who.size() && cur_who[L] <= w[j].x) {
					sumL += cur_who[L];
					++L;
				}
				while (R < cur_who.size() && cur_who[R] <= w[j].y) {
					sumR += cur_who[R];
					++R;
				}
				cur_val = (1LL * w[j].x * L - sumL) + ((sum - sumR) - 1LL * w[j].y * (cur_who.size() - R));
				chkmin(min_val, cur_val);
			}
			ans += min_val;
		}
		cout << ans << '\n';
	}
}
	