#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;

template<typename T1, typename T2> 
inline void chkmax(T1 &x, const T2 &y) {
	if (x < y) x = y;
}

template<typename T1, typename T2> 
inline void chkmin(T1 &x, const T2 &y) {
	if (x > y) x = y;
}

typedef pair<int, int> point;

const int N = 2e5 + 1;
const int p = 998244353;

int n, m, k;
bool have[1001][1001];
int ans[1001][1001];
int dp[1001][1001][2];

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> m >> k;
	for (int i = 0; i < k; ++i) {
		int a = 0, b = 0, c = 0;
		cin >> a >> b >> c;
		--a, --b;
		ans[a][b] = c;
		have[a][b] = true;
	}
	for (int i = 0; i <= n; ++i) {
		ans[i][m] = 0;
		have[i][m] = true;
	}
	for (int i = 0; i <= m; ++i) {
		ans[n][i] = 0;
		have[n][i] = true;
	}
	for (int i = n; i >= 0; --i) {
		for (int j = m; j >= 0; --j) {
			if (have[i][j]) {
				dp[i][j][0] = dp[i][j][1] = ans[i][j];
			} else {
				dp[i][j][0] = min(dp[i][j + 1][1], dp[i + 1][j][1]);
				dp[i][j][1] = max(dp[i][j + 1][0], dp[i + 1][j][0]);
			}
		}
	}
	long long ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			ans += dp[i][j][0];
		}
	}
	ans = ((ans % p) + p) % p;
	cout << ans << '\n';
}
	