#include "bits/stdc++.h"

#define len(v) ((int)v.size())
#define pb push_back
#define int long long
using namespace std;

#define en aosnetuhaosentuhtaos

int n;
string s;

vector<int> up;
vector<int> tsize;
vector<int> L, R;
vector<bool> en;
int _cnt = 0;
int _sum = 0;
int get_root(int i) {
	if (up[i] == i) return i;
	return up[i] = get_root(up[i]);
}

void disable(int i) {
	i = get_root(i);
	if (!en[i]) return;
	// cout << "DIS" << " " << i << endl;
	_cnt--;
	_sum -= tsize[i];
	en[i] = false;
}

void enable(int i) {
	i = get_root(i);
	if (en[i]) return;
	// cout << "EN" << " " << i << endl;
	_cnt++;
	_sum += tsize[i];
	en[i] = true;
}

void merge(int a, int b) {
	a = get_root(a);
	b = get_root(b);
	if (a == b) return;
	// cout << "MERGE" << " " << a << " " << b << endl;
	disable(a);
	disable(b);
	up[a] = b;
	tsize[b] += tsize[a];
	L[b] = min(L[b], L[a]);
	R[b] = max(R[b], R[a]);
	enable(a);
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	cin >> s;
	int cnt = 0;
	vector<int> z;
	for (char c : s) {
		if (c == '1') {
			z.pb(cnt);
			cnt = 0;
		} else cnt++;
	}
	z.pb(cnt);
	up.resize(len(z));
	L.resize(len(z));
	R.resize(len(z));
	tsize.resize(len(z));
	en.resize(len(z), true);
	_cnt = len(up);
	vector<vector<int>> comps(n + 1);
	for (int i = 0; i < len(z); i++) {
		comps[z[i]].pb(i);
	}
	for (int i = 0; i < len(up); i++) {
		L[i] = R[i] = up[i] = i;
		tsize[i] = z[i];
		_sum += z[i];
	}
	for (int x : z) {
		// cout << x << " ";
	}
	// cout << endl;
	int best = -1e9;
	int x = 0, y = 0;
	for (int g = 0; g < len(comps); g++) {
		if (g - 1 >= 0)
		for (int sub : comps[g - 1]) {
			if (tsize[get_root(sub)] < g) {
				for (int near : vector<int>{L[get_root(sub)] - 1, R[get_root(sub)] + 1}) {
					if (0 <= near && near < len(up)) {
						if (tsize[get_root(near)] < g && tsize[get_root(sub)] < g) {
							merge(near, sub);
							if (g - 1 != tsize[get_root(near)]) {
								comps[tsize[get_root(near)]].pb(near);
							}
						}
						if (tsize[get_root(near)] < g) {
							disable(near);
						}
					}
				}
			}
		}
		if (g - 1 >= 0)
		for (int sub : comps[g - 1]) {
			if (tsize[get_root(sub)] < g) {
				disable(sub);
			}
		}
		// cout << g << " " << _cnt << endl;
		if (_cnt > 1 && best < _cnt * g + _cnt - 1) {
			best = _cnt * g + _cnt - 1;
			x = g;
			y = _cnt;
			// cout << _cnt << endl;
		}
	}
	string rez = "";
	for (int i = 0; i < y; i++) {
		rez += string(x, '0') + '1';
	}
	rez.pop_back();
	cout << len(rez) << endl;
	cout << rez << endl;
}