#include "bits/stdc++.h"

#define len(v) ((int)v.size())
#define pb push_back
#define int long long
using namespace std;

#define en aosnetuhaosentuhtaos

int n;
string s;

vector<int> up;
vector<int> tsize;
vector<int> L, R;
vector<bool> en;
int _cnt = 0;
int _sum = 0;
int get_root(int i) {
	if (up[i] == i) return i;
	return up[i] = get_root(up[i]);
}

void disable(int i) {
	i = get_root(i);
	if (!en[i]) return;
	// cout << "DIS" << " " << i << endl;
	_cnt--;
	_sum -= tsize[i];
	en[i] = false;
}

void enable(int i) {
	i = get_root(i);
	if (en[i]) return;
	// cout << "EN" << " " << i << endl;
	_cnt++;
	_sum += tsize[i];
	en[i] = true;
}

void merge(int a, int b) {
	a = get_root(a);
	b = get_root(b);
	if (a == b) return;
	// cout << "MERGE" << " " << a << " " << b << endl;
	disable(a);
	disable(b);
	up[a] = b;
	tsize[b] += tsize[a];
	L[b] = min(L[b], L[a]);
	R[b] = max(R[b], R[a]);
	enable(a);
}


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	cin >> s;
	vector<int> one(n + 1, n);
	vector<int> pr(n + 1, 0);
	for (int i = 0; i < n; i++) {
		pr[i + 1] = pr[i] + (s[i] == '0');
	}
	for (int i = n - 1; i > -1; i--) {
		if (s[i] == '1') {
			one[i] = i;
		} else {
			one[i] = one[i + 1];
		}
	}
	int _ones = 0;
	for (char c : s) {
		if (c == '1') {
			_ones++;
		}
	}
	int best = _ones, x = 0, y = _ones + 1;
	for (int g = 1; g <= n; g++) {
		int cnt = 0;
		int i = 0;
		while (i < n) {
			if (g == 1) {
				// cout << i << endl;
			}
			int l = i - 1;
			int r = n - 1;
			while (r - l > 1) {
				int m = (l + r) / 2;
				if (pr[m + 1] - pr[i] >= g) {
					r = m;
				} else {
					l = m;
				}
			}
			int pref = i;
			i = r;
			if (pr[i + 1] - pr[pref] < g) break;
			cnt++;
			i = one[i];
		}
		if (cnt > 1 && best < cnt * g + cnt - 1) {
			best = cnt * g + cnt - 1;
			y = cnt;
			x = g;
		}
	}
	string rez = "";
	for (int i = 0; i < y; i++) {
		rez += string(x, '0') + '1';
	}
	rez.pop_back();
	cout << len(rez) << endl;
	cout << rez << endl;
}