#include <stdio.h>
#include <algorithm>
#include <vector>

const int mod = 998244353;

struct enot {
	int r, c, v;
	
	bool operator <(const enot &e) const {
		if (r != e.r) {
			return r < e.r;
		}
		return c < e.c;
	}
};

void recount(int **dp, int **dp1, int n, std::vector<enot> &kek) {
	int ind = kek.size() - 1;
	dp[0][n] = dp[1][n] = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (ind > -1 && kek[ind].c - 1 == i) {
			dp[0][i] = dp[1][i] = kek[ind].v;
			ind--;
		} else {
			dp[0][i] = std::min(dp[1][i + 1], dp1[1][i]);
			dp[1][i] = std::max(dp[0][i + 1], dp1[0][i]);
		}
	}
}

void recount(int **dp, int **dp1, int n) {
	dp[0][n] = dp[1][n] = 0;
	for (int i = n - 1; i >= 0; i--) {
		dp[0][i] = std::min(dp[1][i + 1], dp1[1][i]);
		dp[1][i] = std::max(dp[0][i + 1], dp1[0][i]);
	}
}

int main() {
	int n, m, k;
	scanf("%d%d%d", &n, &m, &k);
	enot arr[k];
	for (int i = 0; i < k; i++) {
		scanf("%d%d%d", &arr[i].c, &arr[i].r, &arr[i].v);
	}
	std::sort(arr, arr + k);
	int lol = 0;
	for (int i = 1; i < k; i++) {
		if (arr[i].r != arr[i - 1].r) {
			lol++;
		}
	}
	std::vector<enot> kek[lol + 1];
	lol = 0;
	for (int i = 0; i < k; i++) {
		if (i > 0 && arr[i].r != arr[i - 1].r) {
			lol++;
		}
		kek[lol].push_back(arr[i]);
	}
	int **dp = new int*[2];
	int **dp1 = new int*[2];
	dp1[0] = new int[n]();
	dp1[1] = new int[n]();
	dp[0] = new int[n];
	dp[1] = new int[n];
	long long ans = 0;
	int ind = lol, azaz = 0;
	for (int i = m - 1; i >= 0; i--) {
		if (ind > -1 && kek[ind][0].r - 1 == i) {
			recount(dp, dp1, n, kek[ind]);
			ind--;
			for (int j = 0; j < n; j++) {
				ans += dp[0][j];
				ans %= mod;
			}
			std::swap(dp, dp1);
			azaz = 0;
		} else {
			if (azaz < n) {
				recount(dp, dp1, n);
				for (int j = 0; j < n; j++) {
					ans += dp[0][j];
					ans %= mod;
				}
				std::swap(dp, dp1);
				azaz++;
			} else {
				int in = ind > -1 ? kek[ind][0].r - 1 : -1;
				long long sum = 0;
				for (int j = 0; j < n; j++) {
					sum += dp1[0][j];
					sum %= mod;
				}
				ans += (sum * (i - in)) % mod;
				ans %= mod;
				i = in + 1;
			}
		}
	}
	printf("%lld", (ans + mod) % mod);
	return 0;
}
