#include <bits/stdc++.h>

using namespace std;

#define int long long

signed main() {
	int m, n;
	cin >> m >> n;

	string p;
	cin >> p;

	vector< pair<int, int> > ops;
	vector<string> str_storage;
	for(int i = 0; i < n; i++) {
		int q;
		cin >> q;
		if(q == 1) {
			str_storage.emplace_back();
			cin >> str_storage.back();
			ops.emplace_back(-1, str_storage.size() - 1);
		} else {
			int pos, len;
			cin >> pos >> len;
			pos--;
			ops.emplace_back(pos, len);
		}
	}

	vector<int> pref(p.size());
	for(int i = 1; i < p.size(); i++) {
		int k = pref[i - 1];
		while(k > 0 && p[k] != p[i]) {
			k = pref[k - 1];
		}
		if(p[k] == p[i]) {
			k++;
		}
		pref[i] = k;
	}

	vector< vector<int> > go(p.size() + 1, vector<int>(26));
	for(int i = 0; i <= p.size(); i++) {
		for(char c = 'a'; c <= 'z'; c++) {
			if(i < p.size() && p[i] == c) {
				go[i][c - 'a'] = i + 1;
			} else if(i == 0) {
				go[i][c - 'a'] = 0;
			} else {
				go[i][c - 'a'] = go[pref[i - 1]][c - 'a'];
			}
		}
	}

	if(n > 1) {
		// Simple task

		vector< vector< vector< pair<int, int> > > > jump(p.size() + 1, vector< vector< pair<int, int> > >(26, vector< pair<int, int> >(50)));
		for(int i = 0; i < p.size() + 1; i++) {
			for(char c = 'a'; c <= 'z'; c++) {
				jump[i][c - 'a'][0] = make_pair(go[i][c - 'a'], 0);
				if(go[i][c - 'a'] == p.size()) {
					jump[i][c - 'a'][0].second++;
				}
			}
		}
		for(int k = 1; k < 50; k++) {
			for(int i = 0; i < p.size() + 1; i++) {
				for(char c = 'a'; c <= 'z'; c++) {
					int j = jump[i][c - 'a'][k - 1].first;
					int l = jump[i][c - 'a'][k - 1].second;
					jump[i][c - 'a'][k] = jump[j][c - 'a'][k - 1];
					jump[i][c - 'a'][k].second += l;
				}
			}
		}

		int k = 0, ans = 0;
		char lastchr = '\0';
		for(auto q: ops) {
			if(q.first == -1) {
				string w = str_storage[0];
				for(char c: w) {
					k = go[k][c - 'a'];
					if(k == p.size()) {
						ans++;
					}
				}
				lastchr = w.back();
			} else {
				int len = q.second;

				for(int i = 0; i < 50; i++) {
					if(len & (1LL << i)) {
						auto p = jump[k][lastchr - 'a'][i];
						k = p.first;
						ans += p.second;
						len ^= (1LL << i);
					}
				}

				assert(len == 0);
			}
		}

		cout << ans;
		return 0;
	}

	string t;
	for(int i = 0; i < n; i++) {
		if(ops[i].first == -1) {
			string w = str_storage[ops[i].second];
			t += w;
		} else {
			int pos = ops[i].first;
			int len = ops[i].second;
			while(len--) {
				t += t[pos++];
			}
		}
	}

	int k = 0, ans = 0;
	for(char c: t) {
		k = go[k][c - 'a'];
		if(k == p.size()) {
			ans++;
		}
	}
	cout << ans;

	return 0;
}
