#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
using namespace std;

void re() {
	system("pause");
	exit(0);
}
#define re re();

typedef long long ll;
typedef pair<int, int> pii;

ll mod = 998244353;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector < vector <int> > used(n, vector <int>(m));
	vector < vector < vector <int> > > dp(2, vector < vector <int> >(n + 1, vector <int>(m + 1)));
	for (int i = 0; i < k; i++) {
		int x, y, v;
		cin >> x >> y >> v;
		x--, y--;
		used[x][y] = 1;
		dp[0][x][y] = dp[1][x][y] = v;
	}
	ll ans = 0;
	for (int i = n - 1; i >= 0 && i >= n - 4; i--) {
		for (int j = m - 1; j >= 0 && j >= m - 4; j--) {
			if (!used[i][j]) {
				dp[0][i][j] = min(dp[1][i + 1][j], dp[1][i][j + 1]);
				dp[1][i][j] = max(dp[0][i + 1][j], dp[0][i][j + 1]);
			}
			ans += dp[0][i][j];
			ans = (ans % mod + mod) % mod;
		}
	}
	for (int i = 0; i <= n - 4; i++) {
		ans += dp[0][i][m - 4] * i;
		ans = (ans % mod + mod) % mod;
	}
	for (int j = 0; j < m - 4; j++) {
		ans += dp[0][n - 4][j] * j;
		ans = (ans % mod + mod) % mod;
	}
	cout << ans << '\n';
	/*for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++)
			cout << dp[0][i][j] << '\t';
		cout << '\n';
	}

	cout << '\n';
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++)
			cout << dp[1][i][j] << '\t';
		cout << '\n';
	}*/
	re
}