#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void gen2(vector<int>& a, vector<int>& b, int num, long long& t, vector<bool>& used, int k, vector<int>& group, vector<pair<int, int> >& table)
{
    if (num == k)
    {
        long long q = 0;
        for (int i = 0; i < k; i++)
        {
            if (group[2 * i] > table[a[b[i]]].second)
            {
                q += group[2 * i] - table[a[b[i]]].second;
            }
            if (group[2 * i] < table[a[b[i]]].first)
            {
                q += table[a[b[i]]].first - group[2 * i];
            }
            if (group[2 * i + 1] > table[a[b[i]]].second)
            {
                q += group[2 * i + 1] - table[a[b[i]]].second;
            }
            if (group[2 * i + 1] < table[a[b[i]]].first)
            {
                q += table[a[b[i]]].first - group[2 * i + 1];
            }
        }
        t = min(t, q);
    }
    for (int i = 0; i < k; i++)
    {
        if (!used[i])
        {
            b[num] = i;
            used[i] = true;
            gen2(a, b, num + 1, t, used, k, group, table);
            used[i] = false;
        }
    }
}

void gen(int k, vector<int>& a, int num, int m, long long& answer, vector<vector<int> >& groups, vector<pair<int, int> >& table)
{
    if (num == a.size())
    {
        long long res = 0;
        for (int i = 0; i < m; i++)
        {
            long long t = 1000000000000000;
            vector<int> b(k);
            vector<bool> used(k, false);
            gen2(a, b, 0, t, used, k, groups[i], table);
            res += t;
        }
        answer = min(answer, res);
        return;
    }
    for (int i = 0; i < k; i++)
    {
        a[num] = i;
        gen(k, a, num + 1, m, answer, groups, table);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m, n, k;
    cin >> m >> n >> k;
    vector<pair<int, int> > table(k);
    for (int i = 0; i < k; i++)
    {
        cin >> table[i].first >> table[i].second;
    }
    vector<vector<int> > groups(m, vector<int>(2 * n));
    for (int i = 0; i < m; i++)
    {
        for (int j = 0; j < 2 * n; j++)
        {
            cin >> groups[i][j];
        }
    }
    if (n == 1)
    {
        long long answer = 1000000000000000000;
        for (int i = 0; i < k; i++)
        {
            long long res = 0;
            for (int j = 0; j < m; j++)
            {
                if (groups[j][0] > table[i].second)
                {
                    res += groups[j][0] - table[i].second;
                }
                if (groups[j][0] < table[i].first)
                {
                    res += table[i].first - groups[j][0];
                }
                if (groups[j][1] > table[i].second)
                {
                    res += groups[j][1] - table[i].second;
                }
                if (groups[j][1] < table[i].first)
                {
                    res += table[i].first - groups[j][1];
                }
            }
            answer = min(answer, res);
        }
        cout << answer;
        return 0;
    }
    if (m == 1)
    {
        sort(groups[0].begin(), groups[0].end());
        long long answer = 0;
        for (int i = 0; i < 2 * n - 1; i += 2)
        {
            long long res = 1000000000000000;
            for (int j = 0; j < k; j++)
            {
                long long t = 0;
                if (groups[0][i] > table[j].second)
                {
                    t += groups[0][i] - table[j].second;
                }
                if (groups[0][i] < table[j].first)
                {
                    t += table[j].first - groups[0][i];
                }
                if (groups[0][i + 1] > table[j].second)
                {
                    t += groups[0][i + 1] - table[j].second;
                }
                if (groups[0][i + 1] < table[j].first)
                {
                    t += table[j].first - groups[0][i + 1];
                }
                res = min(res, t);
            }
            answer += res;
        }
        cout << answer;
        return 0;
    }
    if (k <= 3)
    {
        long long answer = 1000000000000000;
        for (int i = 0; i < m; i++)
        {
            sort(groups[i].begin(), groups[i].end());
        }
        vector<int> a(k);
        gen(k, a, 0, m, answer, groups, table);
        cout << answer;
    }

    return 0;
}
