#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 1010;
const int mod = 998244353;

map <pair <int, int>, int > M1;
map <pair <int, int>, int > M2;
ll res = 0;

inline void upd(ll x) {
    res = (res + x) % mod;
    res = (res + mod) % mod;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < k; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        int t;
        cin >> t;
        M1[{x,y}] = M2[{x,y}] = t;
        upd(t);
    }
    for (int i = n - 2; i >= max(0, n - 5); i--) {
        for (int j = m - 2; j >= 0; j--) {
            M1[{i,j}] = min(M1[{i + 1,j}], M1[{i,j + 1}]);
            M2[{i,j}] = max(M2[{i,j + 1}], M2[{i + 1,j}]);
            upd(M1[{i,j}]);
        }
    }
    for (int i = n - 2; i >= 0; i--) {
        for (int j = m - 2; j >= max(0, n - 5); j--) {
            M1[{i,j}] = min(M1[{i + 1,j}], M1[{i,j + 1}]);
            M2[{i,j}] = max(M2[{i,j + 1}], M2[{i + 1,j}]);
            if (i < n - 5)
                upd(M1[{i,j}]);
        }
    }
    if (n - 6 < 0 || m - 6 < 0) {
        cout << res;
        return 0;
    }
    for (int i = 0; i <= n - 5; i++) {
        upd((ll)M1[{i,m - 5}] * min(m - 5, i));
    }
    for (int i = 0; i <= m - 6; i++) {
        upd((ll)M1[{n - 5,i}] * min(n - 5, i));
    }
    cout << res;
    return 0;
}
