#include <bits/stdc++.h>

using namespace std;

#define ft first
#define sd second
#define pb push_back
#define sz(s) signed(s.size())
#define all(s) s.begin(),s.end()
#define rall(s) s.rbegin(),s.rend()
#define int long long

const int INF = 1e18;

int n, m, k;
vector< pair<int, int> > tables;  
vector< vector<int> > students;

int get(int x, int L, int R) {
	if (x >= L && x <= R) return 0;
	if (x < L) return L - x;
	return x - R;
}

vector< vector<int> > dp;

int get(int pos, int tot) {
	if (dp[pos][tot] != -1) { return dp[pos][tot]; } 
	if (tot == n) { return dp[pos][tot] = 0; }
	if (pos == k) { return dp[pos][tot] = INF; }
	int ans = get(pos + 1, tot), now = 0;
	for (int i = 1; tot + i <= n; ++i) {
		for (int j = 0; j < m; ++j) {
			now += get(students[j][(tot + i) * 2 - 2], tables[pos].ft, tables[pos].sd); 
			now += get(students[j][(tot + i) * 2 - 1], tables[pos].ft, tables[pos].sd);
		}
		ans = min(ans, now + get(pos + 1, tot + i));
	}
	return dp[pos][tot] = ans;
}

void solve() {
	cin >> m >> n >> k;
	dp.resize(k + 1, vector<int>(n + 1, -1));
	tables.resize(k);
	for (auto& x : tables) cin >> x.ft >> x.sd;
	sort(all(tables), [](auto a, auto b) { return a.sd < b.sd; });
	students.resize(m);
	for (int i = 0; i < m; ++i) {
		students[i].resize(2 * n);
		for (int& x : students[i]) cin >> x;
		sort(all(students[i]));
	}
	cout << get(0, 0) << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}