#include<bits/stdc++.h>
#define p pair<int, int>

using namespace std;

vector<vector<int>> sequences(int n, int k){
    vector<vector<int>> a;
    for (int q = 0; q < pow(k, n); ++q) {
        vector<int> s;
        int q2 = q;
        for (int q1 = 0; q1 < n; ++q1) {
            s.push_back(q2 % k);
            q2 /= k;
        }
        a.push_back(s);
    }
    return a;
}

int main(){
    int n, m, k;
    cin >> m >> n >> k;
    vector<p> s;
    for (int q = 0; q < k; ++q) {
        int w1, w2;
        cin >> w1 >> w2;
        s.push_back({w1, w2});
    }
    vector<vector<int>> a;
    for (int q = 0; q < m; ++q) {
        a.push_back({});
        for (int q1 = 0; q1 < 2 * n; ++q1) {
            int w;
            cin >> w;
            a[q].push_back(w);
        }
        sort(a[q].begin(), a[q].end());
    }
    vector<vector<int>> seq = sequences(n, k);
    long long int min1 = 100000000000000000;
    for (auto q: seq) {
        vector<p> part;
        for (int q1 = 0; q1 < q.size(); ++q1) {
            part.push_back(s[q[q1]]);
        }
        sort(part.begin(), part.end());
        long long int bad = 0;
        for (int q1 = 0; q1 < m; ++q1) {
            for (int q2 = 0; q2 < 2 * n; q2 += 2) {
                if (a[q1][q2] < part[q1/2].first){
                    bad += part[q1/2].first-a[q1][q2];
                }else if (a[q1][q2] > part[q1/2].second){
                    bad += a[q1][q2]-part[q1/2].second;
                }
                if (a[q1][q2+1] < part[q1/2].first){
                    bad += part[q1/2].first-a[q1][q2+1];
                }else if (a[q1][q2+1] > part[q1/2].second){
                    bad += a[q1][q2+1]-part[q1/2].second;
                }
            }
        }
        if (bad < min1){
            min1 = bad;
        }
    }
    cout << min1 << endl;
    return 0;
}
