//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,tune=native")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

#define add push_back
#define del pop_back
#define ins insert
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const ll INF = (ll)1e9 + 2019;
const ll MOD = 998244353;

const int N = 5e6 + 100;
pair <pii, int> tr[N];
map <int, int> mp;
ll dp[10][N][2], v[10][N];
bool f[10][N];

int compress(int k) {
	for (int i = 0; i < k; i++) {
		for (int j = tr[i].f.s, kk = 0; j > 0 && kk < 15; j--, kk++) {
			mp[j] = 0;
		}
	}
	int res = 0;
	for (auto &it : mp) {
		it.s = ++res;
	}
	return res;
}

void mane() {
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		cin >> tr[i].f.f >> tr[i].f.s >> tr[i].s;
	}
	int mm = compress(k);
	for (int i = 0; i < k; i++) {
		v[mp[tr[i].f.f]][mp[tr[i].f.s]] = tr[i].s;
		f[mp[tr[i].f.f]][mp[tr[i].f.s]] = 1;
	}
	for (int i = n; i > 0; i--) {
		for (int j = mm; j > 0; j--) {
			if (f[i][j]) {
				dp[i][j][0] = dp[i][j][1] = v[i][j];
				continue;
			}
			dp[i][j][0] = min(dp[i + 1][j][1], dp[i][j + 1][1]);
			dp[i][j][1] = max(dp[i + 1][j][0], dp[i][j + 1][0]);
		}
	}
	ll ans = 0;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= mm; j++) {
			ans += (dp[i][j][0] + MOD * 2ll) % MOD;
			ans %= MOD;
			//cerr << dp[i][j][0] << " ";
		}
		//cerr << endl;
	}
	cout << ans;
}

int main() {
	ios::sync_with_stdio(0);
#ifdef osss
	freopen("input.txt", "r", stdin);
#endif
	mane();
}