#include <iostream>
#include <algorithm>

using namespace std;

#define int long long

const int MAXN = 4e5 + 5;

int m, n, k, res;

pair<int, int> desk[MAXN];
int h[MAXN];

int get(pair<int, int> d, pair<int, int> a) {
	int res = 0;
	if (a.first > d.second) {
		res += a.first - d.second;
	}
	else if (a.first < d.first) {
		res += d.first - a.first;
	}

	if (a.second > d.second) {
		res += a.second - d.second;
	}
	else if (a.second < d.first) {
		res += d.first - a.second;
	}

	return res;
}

signed main() {
	cin >> m >> n >> k;
	for (int i = 0; i < k; ++i) {
		int l, r;
		cin >> l >> r;
		desk[i] = { l, r };
	}

	sort(desk, desk + k);

	for (int q = 0; q < m; ++q) {
		for (int i = 0; i < n; ++i) {
			cin >> h[2 * i] >> h[2 * i + 1];
		}
		sort(h, h + 2 * n);
		int total = 0;

		for (int i = 0; i < n; ++i) {
			int best = 1e18;
			for (int j = 0; j < k; ++j) {
				if (best > get(desk[j], { h[2 * i], h[2 * i + 1] })) {
					best = get(desk[j], { h[2 * i], h[2 * i + 1] });
				}
			}
			total += best;
		}

		res += total;
	}
	cout << res << "\n";
	return 0;
}