#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("sse3,sse4")
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

pair <int, int> otr[200005], seg[200005];
int optimum[200005];
ll answer[200005];
vector <vector <int> > spis;
int n, m, k;

bool cmp(pair <int, int> A, pair <int, int> B)
{
    return (A.x < B.x) || (A.x == B.x && A.y > B.y);
}

void find_optimum(int lef, int rig, int grl, int grr)
{
    if (lef > rig || grl > grr) return;

    int mid = (lef + rig) / 2;
    for (int i = grl; i <= grr; i++)
    {
        pair <int, int> A = seg[i];
        ll tek = 0;
        for (int z = 0; z < m; z++)
        {
            if (spis[z][2 * mid] < A.x) tek += (ll) (A.x - spis[z][2 * mid]);
            if (spis[z][2 * mid] > A.y) tek += (ll) (spis[z][2 * mid] - A.y);
            if (spis[z][2 * mid + 1] < A.x) tek += (ll) (A.x - spis[z][2 * mid + 1]);
            if (spis[z][2 * mid + 1] > A.y) tek += (ll) (spis[z][2 * mid + 1] - A.y);
        }
        if (answer[mid] == -1) optimum[mid] = i, answer[mid] = tek;
        else
        {
            if (tek < answer[mid]) answer[mid] = tek, optimum[mid] = i;
        }
    }
    for (int i = lef; i <= rig; i++)
    {
        pair <int, int> A = seg[optimum[mid]];
        ll tek = 0;
        for (int z = 0; z < m; z++)
        {
            if (spis[z][2 * i] < A.x) tek += (ll) (A.x - spis[z][2 * i]);
            if (spis[z][2 * i] > A.y) tek += (ll) (spis[z][2 * i] - A.y);
            if (spis[z][2 * i + 1] < A.x) tek += (ll) (A.x - spis[z][2 * i + 1]);
            if (spis[z][2 * i + 1] > A.y) tek += (ll) (spis[z][2 * i + 1] - A.y);
        }
        if (answer[i] == -1) answer[i] = tek, optimum[i] = optimum[mid];
        else
        {
            if (tek < answer[i]) answer[i] = tek, optimum[i] = optimum[mid];
        }
    }

    find_optimum(lef, mid - 1, grl, optimum[mid] - 1);
    find_optimum(mid + 1, rig, optimum[mid] + 1, grr);
    return;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> m >> n >> k;

    for (int i = 1; i <= k; i++) cin >> otr[i].x >> otr[i].y;
    sort(otr + 1, otr + k + 1, cmp);
    seg[1] = otr[1];
    int last = otr[1].y, tail = 1;

    for (int i = 2; i <= k; i++)
        if (otr[i].y > last)
        {
            tail++;
            seg[tail] = otr[i];
            last = otr[i].y;
        }

    spis.resize(m);
    for (int i = 0; i < m; i++)
    {
        spis[i].resize(2 * n);
        for (int j = 0; j < 2 * n; j++) cin >> spis[i][j];
        sort(spis[i].begin(), spis[i].end());
    }

    for (int i = 0; i < n; i++) answer[i] = -1;
    find_optimum(0, n - 1, 1, tail);

    ll ans = 0;
    for (int i = 0; i < n; i++) ans += answer[i];
    cout << ans;
    return 0;
}

