#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define vi vector<int>
#define pb push_back
#define printvi(arr) for(int x: arr) cout << x << " "; cout << endl;
#define pii pair<int, int>
#define F first
#define S second
#define vpii vector<pii>
#define ll long long
#define vll vector<ll>
#define pll pair<ll, ll>
#define vpll vector<pll>

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
}

int n, k;
vpll b;

int main() {
    init();
    int m;
    cin >> m >> n >> k;
    b.resize(k);
    for (int i = 0; i < k; ++i) cin >> b[i].F >> b[i].S;
    ll ans = 0;
    for (int i = 0; i < m; ++i){
        ll x, y;
        cin >> x >> y;
        ll add = 1e15;
        for (int j = 0; j < k; ++j){
            ll add1 = 0, add2 = 0;
            if (x < b[j].F) add1 = b[j].F - x;
            if (x > b[j].S) add1 = x - b[j].S;
            if (y < b[j].F) add2 = b[j].F - y;
            if (y > b[j].S) add2 = y - b[j].S;
            add = min(add, add1 + add2);
        }
        ans += add;
    }
    cout << ans << endl;
    return 0;
}
