#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

void solve();

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

/*--------------------------------------------------------------------*/

int check(string &s, int k) {
	int cnt = 0, q = 0;
	for (auto &i : s) {
		if (cnt != -1 && i == '0') {
			++cnt;
		}
		if (cnt == k) cnt = -1;
		if (cnt == -1 && i == '1') {
			cnt = 0;
			++q;
		}
	}
	if (cnt != -1) return q - 1;
	return q;
}

void solve() {
	int n;
	string s;
	cin >> n >> s;
	int ans = 0, cnt1 = 0, len = 0;
	multiset<int> s1;
	int last = -1;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == 1) {
			s1.emplace(i - last - 1);
			last = i;
		}
	}
	s1.emplace(s.size() - last);
	while (!s1.empty()) {
		if (ans < *s1.begin() * (s1.size() - 1) + s1.size() - 2) {
			ans = *s1.begin() * (s1.size() - 1) + s1.size() - 2;
			cnt1 = s1.size() - 2;
			len = *s1.begin();
		}
		s1.erase(s1.begin());
	}
	cout << ans << "\n";
	int cnt = 0, q = 0;
	string a;
	for (auto &i : s) {
		if (cnt == len) cnt = -1;
		if (cnt != -1 && i == '0' && a.size() < ans) {
			++cnt;
			a.push_back('0');
		}
		if (cnt == len) cnt = -1;
		if (cnt == -1 && i == '1' && a.size() < ans) {
			cnt = 0;
			++q;
			a.push_back('1');
		}
	}
	cout << a;
}