#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;



vector<int> a;


int f(int x) {
    int cnt = 0;
    int left = x;
    for (int c : a) {
        if (c >= left) {
            left = x;
            ++cnt;
        } else {
            left -= c;
        }
    }

    return cnt * x + cnt - 1;
}


string build(int x) {
    int cnt = 0;
    int left = x;
    for (int c : a) {
        if (c >= left) {
            left = x;
            ++cnt;
        } else {
            left -= c;
        }
    }

    string res;
    for (int i = 0; i < cnt - 1; ++i) {
        for (int j = 0; j < x; ++j) {
            res += '0';
        }

        res += '1';
    }

    for (int j = 0; j < x; ++j) {
        res += '0';
    }

    return res;
}


int main() {
    int n;
    cin >> n;

    string s;
    cin >> s;
    int cnt = 0;
    for (char c : s) {
        if (c == '0') {
            ++cnt;
        } else {
            a.push_back(cnt);
            cnt = 0;
        }
    }

    a.push_back(cnt);

    int low = 0, high = n;
    while (high - low > 2) {
        int d = (high - low) / 3;

        int m1 = low + d;
        int m2 = m1 + d;

        int f1 = f(m1);
        int f2 = f(m2);

        if (f1 < f2) {
            low = m1;
        } else {
            high = m2;
        }
    }

    int answ = 0;
    string res;
    for (int i = low - 100; i < high + 100; ++i) {
        int cur = f(i);

        if (cur > answ) {
            answ = cur;
            res = build(i);
        }
    }

    cout << answ << '\n' << res;

    return 0;
}


/*

10
0100100000

3
111

7
0100101

*/