#include <bits/stdc++.h>
using namespace std;

struct bomb
{
    long long x;
    long long y;
    long long val;

    bomb(long long X, long long Y, long long VAL)
    {
        x = X;
        y = Y;
        val = VAL;
    }
};

const long long p = 31;
const long long mod = 998244353;

int main()
{
    long long n, m, k;
    cin >> n >> m >> k;
    vector<bomb*> b(k);
    for (long long i = 0; i < k; i++) {
        long long x, y, val;
        cin >> x >> y >> val;
        b[i] = new bomb(x, y, val);
    }

    vector<vector<long long> > one(n + 1, vector<long long> (m + 1, 1e9));
    vector<vector<long long> > two(n + 1, vector<long long> (m + 1, 1e9));
    for (long long i = 0; i < n; i++) {
        one[i][m] = 0;
        two[i][m] = 0;
    }
    for (long long i = 0; i < m; i++) {
        one[n][i] = 0;
        two[n][i] = 0;
    }
    for (long long i = n - 1; i >= 0; i--){
        for (long long j = m - 1; j >= 0; j--) {
            for (long long bo = 0; bo < k; bo++) {
                if (b[bo]->x == i + 1 && b[bo]->y == j + 1) {
                    one[i][j] = b[bo]->val;
                    two[i][j] = b[bo]->val;
                }
            }
            if (one[i][j] != 1e9) {
                continue;
            }

            one[i][j] = min(two[i][j + 1], two[i + 1][j]);
            two[i][j] = max(one[i][j + 1], one[i + 1][j]);
        }
    }
    //cout << endl;
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            ans += (1000000 * mod + one[i][j]) % mod;
            ans %= mod;
            //cout << one[i][j] << ' ';
        }
        //cout << endl;
    }
    /*cout << endl;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cout << two[i][j] << ' ';
        }
        cout << endl;
    }*/
    cout << ans;
    return 0;
}
