#include <bits/stdc++.h>
#define int long long
#define pb push_back
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
typedef long long ll;
std::vector<int> kek_function(std::string s) {
	int l = 0, r = 1;
	int n = s.size();
	std::vector<int> z(n);
	z[0] = n;
	for (int i = 1; i < n; ++i) {
		if (i < r) {
			z[i] = std::min(z[i - l], r - i);
		}
		while (i + z[i] < n && s[z[i]] == s[z[i] + i]) {
			++z[i];
		}
		if (i + z[i] > r) {
			r = i + z[i];
			l = i;
		}
	}
	return z;
}
std::vector<int> prefix_function(std::string s) {
	int n = s.size();
	std::vector<int> pi(n);
	pi[0] = 0;
	for (int i = 1; i < n; ++i) {
		int j = pi[i - 1];
		while (j > 0 && s[j] != s[i]) {
			j = pi[j - 1];
		}
		if (s[i] == s[j]) ++j;
		pi[i] = j;
	}
	return pi;
}
void upd_prefix(std::string &s, int pos, std::vector<int> &pref) {
	if (pos == 0) return;
	int j = pref[pos - 1];
	while (j > 0 && s[j] != s[pos]) {
		j = pref[j - 1];
	}
	if (s[pos] == s[j]) ++j;
	pref[pos] = j;
}
ll cntEq(std::string a, std::string b) {
	std::string t = b + "#" + a;
	auto d = kek_function(t);
	ll answ = 0;
	// debug(a << ' ' << b);
	for (int i = b.size(); i < (int)t.size(); ++i) {
		// debug(d[i])
		answ += d[i] >= (int)b.size();
	}
	return answ;
}
const int N = 100 + 10;
int dp[N];
  
signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    int n, m;
    std::cin >> n >> m;
    std::string s;
    std::cin >> s;
    std::string suf = "", t = "";
    t = s + "#";
    ll answ = 0, sz = t.size();
    std::vector<int> pref(N);
    FOR(i, (int)t.size()) {
    	upd_prefix(t, i, pref);
    }
    int N1 = s.size() + 1;
    FOR(i, m) {
    	int type;
    	std::cin >> type;
    	if (type == 1) {
    		std::string q;
    		std::cin >> q;

    		answ += cntEq(suf + q, s);
    		t += q;
    		while (t.size() > N + s.size()) {
    			t.pop_back();
    		}
    		for (int j = sz; j < (int)t.size(); ++j) {
    			upd_prefix(t, j, pref);
    			dp[j - N1] = ((j - N1) == 0 ? 0 : dp[j - N1 - 1]) + (pref[j] >= (int)s.size()); 
    		}
    		sz = t.size();

    		suf += q;
    	}
    	else {
    		int pos, len;
    		std::cin >> pos >> len;
    		for (int j = 0; j < len && t.size() < N + s.size(); ++j) {
    			t.pb(t[j + N1]);
    			upd_prefix(t, sz, pref);
    			dp[sz - N1] = ((sz - N1) == 0 ? 0 : dp[sz - N1 - 1]) + (pref[sz] >= (int)s.size()); 
    			sz++;
    		}
    		std::string pref = "";
    		for (int j = 0; j < std::min(len, (int)s.size() - 1); ++j) {
    			pref.pb(t[j + N1]);
    		}
    		answ += dp[len] + cntEq(suf + pref, s);
    		std::string s2 = "";
    		for (int j = len - 1; j >= 0; --j) {
    			s2.pb(t[j + N1]);
    			if (s2.size() >= s.size()) {
    				break;
    			}
    		}
    		suf += s2;
    	}
    	if (suf.size() >= s.size()) {
    		int start = suf.size() - s.size() + 1;
    		std::string t1 = "";
    		for (int j = start; j < (int)suf.size(); ++j) {
    			t1.push_back(suf[j]);
    		}
    		suf = t1;
    	}
    	// debug(suf)
    }
    // for (auto e : prefix_naive(s)) {
    // 	std::cout << e << ' ';
    // }
    // std::cout << '\n';
    // for (auto e : prefix_function(s)) {
    // 	std::cout << e << ' ';
    // }
    // std::cout << '\n';
    std::cout << answ;
}