#include<set>
#include<vector>
#include<utility>
#include<iostream>
#include<algorithm>
#include<unordered_map>
using namespace std;

unordered_map<int, pair<int, int>> f_t;

void f_t_upd(int p, int x, int l)
{
	while (p <= 1e9)
	{
		if (x > f_t[p].first)
		{
			f_t[p] = { x, l };
		}
		else if (x == f_t[p].first)
		{
			f_t[p].second = min(f_t[p].second, l);
		}
		p |= (p + 1);
	}
}

pair<int, int> get_f_t(int p)
{
	int res = 0;
	int l = 1e9;
	while (p >= 0)
	{
		if (f_t[p].first > res)
		{
			res = f_t[p].first;
			l = f_t[p].second;
		}
		else if (f_t[p].first == res)
		{
			l = min(l, f_t[p].second);
		}
		p = (p & (p + 1)) - 1;
	}
	return { res, l };
}

int main()
{
	int n, m, k;
	cin >> m >> n >> k;
	vector<vector<int>> h(m, vector<int>(2 * n));
	for (int i = 0; i < k; i++)
	{
		int l, r;
		cin >> l >> r;
		f_t_upd(l, r, l);
	}

	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < 2 * n; j++) cin >> h[i][j];
		sort(h[i].begin(), h[i].end());
		reverse(h[i].begin(), h[i].end());
	}

	vector<long long> dp(2 * n + 1);
	dp[0] = 0;
	long long ans = 0;

	for (int i = 0; i < m; i++)
	{
		for (int j = 1; j < 2 * n; j++)
		{
			if (get_f_t(h[i][j]).first >= h[i][j - 1])
			{
				dp[j + 1] = dp[j - 1];
			}
			else
			{
				long long ans = 2e9;
				long long l = 0, r = h[i][0];
				while (l != r)
				{
					long long m = (l + r) / 2;

					if (get_f_t(m).first >= h[i][j - 1])
					{
						r = m;
					}
					else
					{
						pair<int, int> p = get_f_t(m);
						int x = p.first;
						int l_p = p.second;
						if (x != 0)
						{
							long long cur_ans = 0;
							if (l_p > h[i][j] || h[i][j] > x) cur_ans += min(abs(l_p - h[i][j]), abs(h[i][j] - x));
							if (x < h[i][j - 1] || h[i][j - 1] < l_p) cur_ans += min(abs(h[i][j - 1] - x), abs(h[i][j - 1] - l_p));
							ans = min(ans, cur_ans);
						}
						
						l = m + 1;
					}
				}
				long long x = get_f_t(l).first;
				long long cur_ans = 0;
				if (l > h[i][j] || h[i][j] > x) cur_ans += min(abs(l - h[i][j]), abs(h[i][j] - x));
				if (x < h[i][j - 1] || h[i][j - 1] < l) cur_ans += min(abs(h[i][j - 1] - x), abs(h[i][j - 1] - l));
				ans = min(ans, cur_ans);
				dp[j + 1] = dp[j - 1] + ans;
			}
		}

		ans += dp[2 * n];
		for (int j = 0; j < 2 * n + 1; j++) dp[j] = 0;
	}

	cout << ans;
}