#include <bits/stdc++.h>

using namespace std;

//#define cerr if (false) cerr

#define int long long

const int INF = 1e18 + 239;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);	

	#ifdef LOCAL
	assert(freopen("input.txt", "r", stdin));
	#endif
	
	int m, n, k;
	cin >> m >> n >> k;
	vector<pair<int, int>> a(k);
	for (auto &t : a) {
		cin >> t.first >> t.second;
	}
	vector<vector<int>> gr(m);
	for (auto &t : gr) {
		t.resize(2 * n);
		for (auto &x : t) {
			cin >> x;
		}
	}
	for (auto &t : gr) {
		sort(t.rbegin(), t.rend());
	}
	{
		sort(a.begin(), a.end(), [](pair<int, int> f, pair<int, int> s) {
			if (f.first != s.first) {
				return f.first < s.first;
			} else {
				return f.second > s.second;
			}
		});
		int mx = -1;
		vector<pair<int, int>> ra;
		for (auto t : a) {
			if (t.second > mx) {
				ra.push_back(t);
				mx = t.second;
			}
		}
		a = ra;
	} 
	auto solve_1 = [](pair<int, int> tmp, int h) {
		if (tmp.first <= h && h <= tmp.second) return (int)0;
		else return min(abs(h - tmp.first), abs(h - tmp.second));
	};
	vector<vector<int>> to(n);
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			to[j].push_back(gr[i][2 * j]);
			to[j].push_back(gr[i][2 * j + 1]);
		}	
	}
	for (auto &t : to) {
		sort(t.begin(), t.end());
	}
	reverse(to.begin(), to.end());
	for (int i = 0; i + 1 < (int)to.size(); i++) {
		for (int j = 0; j < (int)to[i].size(); j++) assert(to[i][j] <= to[i + 1][j]);
	}
	int ans = 0;
	int last = 0;
	for (auto t : to) {
		int best = INF;
		int ps = -1;
		for (int i = last; i < (int)a.size(); i++) {
			int cur = 0;
			for (auto x : t) cur += solve_1(a[i], x);
			if (best >= cur) {
				best = cur;
				ps = i;
			} else {
				break;
			}
		}	
		ans += best;
		last = ps;
	}
	cout << ans;
}