#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>
#include <random>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;
#define np nullptr

const ll md = 998244353;

bool l[1010][1010];
pair<ll, ll> mas[1010][1010];

int main() {
#ifdef LOCAL 
	freopen("In.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll m, n, k;
	cin >> n >> m >> k;
	ll r, c, v;
	for (int i = 0; i < k; i++) {
		cin >> r >> c >> v;
		r--;
		c--;
		mas[r][c] = { v, v };
		l[r][c] = true;
	}
	ll sum = 0;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			if (!l[i][j]) {
				mas[i][j].first = min(mas[i + 1][j].second, mas[i][j + 1].second);
				mas[i][j].second = max(mas[i + 1][j].first, mas[i][j + 1].first);
			}
			sum += mas[i][j].first + (ll)10 * md;
			sum %= md;
		}
	}
	cout << sum;
	return 0;
}