#include <bits/stdc++.h>

//#define __LOCAL

using namespace std;

using ll = long long int;

const ll LL_INF = (ll)2e18;
const ll mod = 998244353;

void fastio()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

const int MAX_N = 1007;

ll dp1[MAX_N][MAX_N], dp2[MAX_N][MAX_N];
bool trap[MAX_N][MAX_N];
int n, m, k;

void solve()
{
	cin >> n >> m >> k;

	if(n > 1000 || m > 1000)
		return;

	for(int i = 0; i < k; ++i)
	{
		int r, c;
		ll v;

		cin >> r >> c >> v;
		--r, --c;

		dp1[r][c] = dp2[r][c] = v;
		trap[r][c] = true;
	}

	for(int i = n - 1; i >= 0; --i)
	{
		for(int j = m - 1; j >= 0; --j)
		{
			if(trap[i][j])
				continue;

			dp1[i][j] = LL_INF;
			dp2[i][j] = -LL_INF;

			if(i == n - 1)
				dp1[i][j] = min(dp1[i][j], 0LL);
			else
				dp1[i][j] = min(dp1[i][j], dp2[i + 1][j]);

			if(i == n - 1)
				dp2[i][j] = max(dp2[i][j], 0LL);
			else
				dp2[i][j] = max(dp2[i][j], dp1[i + 1][j]);

			if(j == m - 1)
				dp1[i][j] = min(dp1[i][j], 0LL);
			else
				dp1[i][j] = min(dp1[i][j], dp2[i][j + 1]);

			if(j == m - 1)
				dp2[i][j] = max(dp2[i][j], 0LL);
			else
				dp2[i][j] = max(dp2[i][j], dp1[i][j + 1]);

		}
	}

#ifdef __LOCAL

	for(int i = 0; i < n; ++i)
	{
		for(int j = 0; j < m; ++j)
		{
			cout << dp1[i][j] << ' ';
		}

		cout << endl;
	}

#endif

	ll answ = 0;

	for(int i = 0; i < n; ++i)
		for(int j = 0; j < m; ++j)
			answ = ((mod + answ + dp1[i][j]) % mod + mod) % mod;

	cout << answ << endl;
}

int main()
{
	fastio();
	solve();

	return 0;
}