#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

struct Str {
    ll x;
    int type, num;
    Str() {}
    Str(ll xx, int tt, int n) {
        x = xx;
        type = tt;
        num = n;
    }
};

bool cmp(Str a, Str b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.type > b.type;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int m, n, k;
    cin >> m >> n >> k;
    vector<Str> a(2 * k);
    for (int i = 0; i < k; i++) {
        cin >> a[2 * i].x >> a[2 * i + 1].x;
        a[2 * i].type = 1;
        a[2 * i + 1].type = -1;
        a[2 * i].num = i;
        a[2 * i + 1].num = i;
    }
    vector<vector<ll> > h(m);
    for (int i = 0; i < m; i++) {
        h[i].resize(2 * n);
        for (int j = 0; j < 2 * n; j++) {
            cin >> h[i][j];
        }
        stable_sort(h[i].begin(), h[i].end());
    }
    ll an = 0;
    for (int i = 0; i < n; i++) {
        vector<Str> tmp(2 * m);
        for (int j = 0; j < m; j++) {
            tmp[2 * j].x = h[j][2 * i];
            tmp[2 * j + 1].x = h[j][2 * i + 1];
            tmp[2 * j].type = 0;
            tmp[2 * j + 1].type = 0;
        }
        for (int j = 0; j < 2 * k; j++) {
            tmp.push_back(a[j]);
        }
        stable_sort(tmp.begin(), tmp.end(), cmp);
        vector<ll> ans(k, 0);
        int sz = tmp.size();
        ll sum = 0, kol = 0;
        for (int j = 0; j < sz; j++) {
            if (tmp[j].type == -1) {
                tmp[j].type = 1;
                tmp[j].x = 1e9 - tmp[j].x;
                continue;
            }
            if (tmp[j].type == 1) {
                tmp[j].type = -1;
                ans[tmp[j].num] += kol * tmp[j].x - sum;
                tmp[j].x = 1e9 - tmp[j].x;
                continue;
            }
            sum += tmp[j].x;
            kol++;
            tmp[j].x = 1e9 - tmp[j].x;
        }
        stable_sort(tmp.begin(), tmp.end(), cmp);
        sum = 0;
        kol = 0;
        for (int j = 0; j < sz; j++) {
            if (tmp[j].type == -1) {
                tmp[j].type = 1;
                tmp[j].x = 1e9 - tmp[j].x;
                continue;
            }
            if (tmp[j].type == 1) {
                tmp[j].type = -1;
                ans[tmp[j].num] += kol * tmp[j].x - sum;
                tmp[j].x = 1e9 - tmp[j].x;
                continue;
            }
            sum += tmp[j].x;
            kol++;
            tmp[j].x = 1e9 - tmp[j].x;
        }
        ll mn = 1e18;
        for (int j = 0; j < k; j++) {
            mn = min(mn, ans[j]);
        }
        an += mn;
    }
    cout << an;
    return 0;
}
