#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    //freopen("a.in", "r", stdin);
    int m, n, k;
    cin >> m >> n >> k;
    vector <int> l(k), r(k);
    for (int i = 0; i < k; i++)
    {
        cin >> l[i] >> r[i];
    }
    vector <vector <pair <int, int> > > groups(n);
    for (int i = 0; i < m; i++)
    {
        vector <int> h(2 * n);
        for (int &x : h) cin >> x;
        sort(h.begin(), h.end());
        for (int i = 0; i < 2 * n; i += 2)
        {
            groups[i / 2].push_back({h[i], h[i + 1]});
        }
    }
    auto cost = [&] (int l, int r, int x)
    {
        if (l <= x && x <= r) return 0;
        if (x < l) return l - x;
        return x - r;
    };
    ll ans = 0;
    vector <pair <int, int> > segs;
    for (int i = 0; i < k; i++)
    {
        segs.push_back({l[i], r[i]});
    }
    sort(segs.begin(), segs.end());
    vector <pair <int, int> > e;
    for (int i = 0; i < (int) segs.size(); i++)
    {
        if (e.empty() || segs[i].second > e.back().second) e.push_back(segs[i]);
    }
    vector <pair <int, int> > trash;
    for (auto c : e)
    {
        trash.push_back({c.second, c.first});
    }
    sort(trash.begin(), trash.end());
    for (int i = 0; i < n; i++) {
        vector<int> gays;
        for (auto c : groups[i]) gays.push_back(c.first), gays.push_back(c.second);
        sort(gays.begin(), gays.end());
        vector <pair <int, int> > my_segs;
        for (int i = 0; i < (int) gays.size(); i++)
        {
            int ind = lower_bound(e.begin(), e.end(), make_pair(gays[i], gays[i])) - e.begin();
            for (int x = max(0, ind - 60); x <= ind + 60 && x < (int) e.size(); x++)
                my_segs.push_back(e[x]);
            ind = lower_bound(trash.begin(), trash.end(), make_pair(gays[i], gays[i])) - trash.begin();
            for (int x = max(0, ind - 60); x <= ind + 60 && x < (int) trash.size(); x++)
                my_segs.push_back(trash[x]);
        }
        if (m > n)
        {
            my_segs = e;
        }
        vector<ll> pref_l(gays.size());
        vector<int> cnt_l(gays.size());
        vector<ll> suf_r(gays.size());
        vector<int> cnt_r(gays.size());
        for (int i = 0; i < (int) gays.size(); i++) {
            pref_l[i] += gays[i];
            cnt_l[i]++;
            if (i) pref_l[i] += pref_l[i - 1], cnt_l[i] += cnt_l[i - 1];
        }
        for (int i = (int) gays.size() - 1; i >= 0; i--) {
            suf_r[i] += gays[i];
            cnt_r[i]++;
            if (i != (int) gays.size() - 1) suf_r[i] += suf_r[i + 1], cnt_r[i] += cnt_r[i + 1];
        }
        ll cur = 1e18;
        for (auto c : my_segs)
        {
            int l = c.first, r = c.second;
            int ind = upper_bound(gays.begin(), gays.end(), l) - gays.begin() - 1;
            ll val = 0;
            if (ind >= 0) val += l * (ll) cnt_l[ind] - pref_l[ind];
            ind = upper_bound(gays.begin(), gays.end(), r) - gays.begin();
            if (ind < (int) gays.size()) val += suf_r[ind] - r * (ll) cnt_r[ind];
            cur = min(cur, val);
        }
        ans += cur;
    }
    cout << ans << endl;
}