#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vint;
typedef string str;
#define pb push_back
#define int long long
#define rep(a, l, r) for (int a = l; a < r; a++)
#define sz(a) (int) a.size()
#define fs first
#define sc second

const long long inf = 1000000000000000000;

const int base = 29;
const int mod = 1e9 + 7;

void run() {
    int m, n;
    cin >> m >> n;

    string p;
    cin >> p;

    str T;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            string w;
            cin >> w;
            T += w;
        } else {
            int pos, len;
            cin >> pos >> len;
            pos--;
            for (int i = 0; i < len; i++)
                T += T[pos + i];
        }
    }

    m = sz(T);
    int powOfBase[m];
    powOfBase[0] = 1;
    for (int i = 1; i < m; i++)
        powOfBase[i] = (powOfBase[i - 1] * base) % mod;

    int hsh[m];
    rep(i, 0, m)
        hsh[i] = ((i ? (hsh[i - 1] * base) % mod : 0) + T[i] - 'a' + 1) % mod;
    int H = 0;
    rep(i, 0, sz(p))
        H = ((H * base) % mod + p[i] - 'a' + 1) % mod;

    if (sz(p) < m) { cout << 0; return; }
    int ans = hsh[sz(p) - 1] == H;
    rep(i, sz(p), m)
        ans += (((hsh[i] - (hsh[i - sz(p)] * powOfBase[sz(p)]) % mod) + mod) % mod) == H;
    cout << ans;
}

signed main() { ios::sync_with_stdio(0); cin.tie(0); run(); }
